VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AnchorObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Anchors
' Class: AnchorObject
' By neophile (n_e_o_p_h_i_l_e@yahoo.com)
' 5/28/2002
' -----------------------------------------------
' MODIFIED JANUARY 2006 TO ALLOW FOR DIFFERENT ANCHOR TYPES
' JEFF JENNESS (jeffj@jennessent.com)
'

Option Explicit

Private mCtl As Control    ' Control reference
Private mX As Anchor       ' X anchor
Private mY As Anchor       ' Y anchor
Private mX2 As Anchor      ' X2 anchor
Private mY2 As Anchor      ' Y2 anchor
Private mWidth As Anchor   ' Width anchor
Private mHeight As Anchor  ' Height anchor
'Private mWindowPos As IWindowPosition  ' FOR ESRI MODELESS FRAMES

'Public Property Set WindowPos(pWindowPos As IWindowPosition)
'  Set mWindowPos = pWindowPos
'End Property


Public Property Let Control(vData As Object)
27:    Set mCtl = vData  ' Set reference
End Property
Public Property Get Control() As Object
30:    Set Control = mCtl  ' Return reference
End Property

Public Property Get X() As Anchor
34:    Set X = mX  ' Return X anchor
End Property

Public Property Get Y() As Anchor
38:    Set Y = mY  ' Return Y anchor
End Property

Public Property Get X2() As Anchor
42:    Set X2 = mX2  ' Return X anchor
End Property

Public Property Get Y2() As Anchor
46:    Set Y2 = mY2  ' Return Y anchor
End Property

Public Sub SetAnchors(Optional ByVal lngX As Long, Optional ByVal lngY As Long)
  ' MODIFIED FOR IMODELESS FRAMES
'  MsgBox mWindowPos.Width & "    x    " & mWindowPos.Height
   

'   X.AnchorType = XType  ' Set X anchor type
'   Select Case XType  ' X anchor
'      Case enumNone        ' Avenue Fastener ( - , - , - )
'        mX.Value = mCtl.Left / mWindowPos.Width
'        mWidth.Value = mCtl.Width / mWindowPos.Width
'      Case enumStart       ' Avenue Fastener (Left, - , - )   DON'T ADJUST X AT ALL!
'        mX.Value = mCtl.Left
'        mWidth.Value = (mCtl.Width / mWindowPos.Width)
''        Debug.Print mCtl.Width
''        Debug.Print mCtl.Container.Width
''        Debug.Print (mCtl.Width / mCtl.Container.Width)
''        Debug.Print mWidth.Value
'      Case enumStartSize   ' Avenue Fastener (Left, Width/, - )
'        mX.Value = mCtl.Left
'        mWidth.Value = mCtl.Width
'      Case enumStartEnd    ' Avenue Fastener (Left, - , Right )
'        mX.Value = mCtl.Left
'        mWidth.Value = mWindowPos.Width - mCtl.Width
'      Case enumSize        ' Avenue Fastener ( - , Width, - )
'        mX.Value = ((mCtl.Left + (mCtl.Width / 2)) / mWindowPos.Width)
'        mX2.Value = mCtl.Width / 2
'        mWidth.Value = mCtl.Width
'      Case enumSizeEnd     ' Avenue Fastener ( - , Width, Right)
'        mX.Value = mWindowPos.Width - mCtl.Left
'        mWidth.Value = mCtl.Width
'      Case enumEnd         ' Avenue Fastener ( - , - , Right)
'        mX.Value = mCtl.Width / mWindowPos.Width
'        mX2.Value = mWindowPos.Width - mCtl.Width - mCtl.Left
'        mWidth.Value = mCtl.Width / mWindowPos.Width
'   End Select
'   Y.AnchorType = YType  ' Set Y anchor type
'   Select Case YType  ' Y anchor
'      Case enumNone        ' Avenue Fastener ( - , - , - )
'        mY.Value = mCtl.Top / mWindowPos.Height
'        mHeight.Value = mCtl.Height / mWindowPos.Height
'      Case enumStart       ' Avenue Fastener (Top, - , - )   DON'T ADJUST Y AT ALL!
'        mY.Value = mCtl.Top
'        mHeight.Value = mCtl.Height / mWindowPos.Height
'      Case enumStartSize   ' Avenue Fastener (Top, Height, - )
'        mY.Value = mCtl.Top
'      Case enumStartEnd    ' Avenue Fastener (Top, - , Bottom )
'        mY.Value = mCtl.Top
'        mHeight.Value = mWindowPos.Height - mCtl.Height
'      Case enumSize        ' Avenue Fastener ( - , Height, - )
'        mY.Value = ((mCtl.Top + (mCtl.Height / 2)) / mWindowPos.Height)
'        mY2.Value = mCtl.Height / 2
'      Case enumSizeEnd     ' Avenue Fastener ( - , Height, Bottom)
'        mY.Value = mWindowPos.Height - mCtl.Top
'      Case enumEnd         ' Avenue Fastener ( - , - , Bottom)
'        mY.Value = mCtl.Height / mWindowPos.Height
'        mY2.Value = mWindowPos.Height - mCtl.Height - mCtl.Top
'        mHeight.Value = mCtl.Height / mWindowPos.Height
'   End Select


'

  ' MODIFICATION TO TRY TO FIX VB6 BUG
  ' ORIGINAL SUB CALL AS FOLLOWS:
  ' Public Sub SetAnchors(Optional ByVal XType As AnchorTypes, Optional ByVal YType As AnchorTypes)
  ' MODIFIED SUB CALL AS FOLLOWS
  ' Public Sub SetAnchors(Optional ByVal lngX As long, Optional ByVal lngY  As long)

  Dim XType As AnchorTypes
  Dim YType As AnchorTypes
  
120:   XType = lngX
121:   YType = lngY

123:    X.AnchorType = XType  ' Set X anchor type
   Select Case XType  ' X anchor
      Case enumNone        ' Avenue Fastener ( - , - , - )
126:         mX.Value = mCtl.Left / mCtl.Container.Width
127:         mWidth.Value = mCtl.Width / mCtl.Container.Width
      Case enumStart       ' Avenue Fastener (Left, - , - )   DON'T ADJUST X AT ALL!
129:         mX.Value = mCtl.Left
130:         mWidth.Value = (mCtl.Width / mCtl.Container.Width)
'        Debug.Print mCtl.Width
'        Debug.Print mCtl.Container.Width
'        Debug.Print (mCtl.Width / mCtl.Container.Width)
'        Debug.Print mWidth.Value
      Case enumStartsize   ' Avenue Fastener (Left, Width/, - )
136:         mX.Value = mCtl.Left
137:         mWidth.Value = mCtl.Width
      Case enumStartEnd    ' Avenue Fastener (Left, - , Right )
139:         mX.Value = mCtl.Left
140:         mWidth.Value = mCtl.Container.Width - mCtl.Width
      Case enumSize        ' Avenue Fastener ( - , Width, - )
142:         mX.Value = ((mCtl.Left + (mCtl.Width / 2)) / mCtl.Container.Width)
143:         mX2.Value = mCtl.Width / 2
144:         mWidth.Value = mCtl.Width
      Case enumSizeEnd     ' Avenue Fastener ( - , Width, Right)
146:         mX.Value = mCtl.Container.Width - mCtl.Left
147:         mWidth.Value = mCtl.Width
      Case enumEnd         ' Avenue Fastener ( - , - , Right)
149:         mX.Value = mCtl.Width / mCtl.Container.Width
150:         mX2.Value = mCtl.Container.Width - mCtl.Width - mCtl.Left
151:         mWidth.Value = mCtl.Width / mCtl.Container.Width
152:    End Select
153:    Y.AnchorType = YType  ' Set Y anchor type
   Select Case YType  ' Y anchor
      Case enumNone        ' Avenue Fastener ( - , - , - )
156:         mY.Value = mCtl.Top / mCtl.Container.Height
157:         mHeight.Value = mCtl.Height / mCtl.Container.Height
      Case enumStart       ' Avenue Fastener (Top, - , - )   DON'T ADJUST Y AT ALL!
159:         mY.Value = mCtl.Top
160:         mHeight.Value = mCtl.Height / mCtl.Container.Height
      Case enumStartsize   ' Avenue Fastener (Top, Height, - )
162:         mY.Value = mCtl.Top
      Case enumStartEnd    ' Avenue Fastener (Top, - , Bottom )
164:         mY.Value = mCtl.Top
165:         mHeight.Value = mCtl.Container.Height - mCtl.Height
      Case enumSize        ' Avenue Fastener ( - , Height, - )
167:         mY.Value = ((mCtl.Top + (mCtl.Height / 2)) / mCtl.Container.Height)
168:         mY2.Value = mCtl.Height / 2
      Case enumSizeEnd     ' Avenue Fastener ( - , Height, Bottom)
170:         mY.Value = mCtl.Container.Height - mCtl.Top
      Case enumEnd         ' Avenue Fastener ( - , - , Bottom)
172:         mY.Value = mCtl.Height / mCtl.Container.Height
173:         mY2.Value = mCtl.Container.Height - mCtl.Height - mCtl.Top
174:         mHeight.Value = mCtl.Height / mCtl.Container.Height
175:    End Select
   
   
   
   
'   Select Case YType  ' Y anchor
'      Case atPosition  ' Get position
'         mY.Value = mCtl.Container.Height - mCtl.Top  ' Control's top relative to form's bottom
'      Case atSize  ' Get size
'         mY.Value = mCtl.Container.Height - mCtl.Height  ' Control's bottom relative to form's bottom
'   End Select
End Sub

Public Sub DoAnchors()
   On Error Resume Next  ' Ignore errors
   
   
'
'   Select Case mX.AnchorType  ' X anchor
'      Case enumNone        ' Avenue Fastener ( - , - , - )
'   ' MODIFIED FOR ESRI MODELESS FRAMES
'        mCtl.Left = mWindowPos.Width * mX.Value
'        mCtl.Width = mWindowPos.Width * mWidth.Value
''         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
''         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
'      Case enumStart       ' Avenue Fastener (Left, - , - )   DON'T ADJUST Y AT ALL!
''        mCtl.Left = mX.Value
'        mCtl.Width = mWindowPos.Width * mWidth.Value
''         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
''         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
'      Case enumStartSize   ' Avenue Fastener (Left, Width, - )
''        mCtl.Left = mX.Value
''         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
''         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
'      Case enumStartEnd    ' Avenue Fastener (Left, - , Right )
''        mCtl.Left = mX.Value
'        mCtl.Width = mWindowPos.Width - mWidth.Value
''         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
''         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
'      Case enumSize        ' Avenue Fastener ( - , Width, - )
'        mCtl.Left = (mWindowPos.Width * mX.Value) - mX2.Value
''         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
''         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
'      Case enumSizeEnd     ' Avenue Fastener ( - , Width, Right)
'        mCtl.Left = mWindowPos.Width - mX.Value
''         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
''         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
'      Case enumEnd         ' Avenue Fastener ( - , - , Right)
'        mCtl.Left = mWindowPos.Width - (mWindowPos.Width * mX.Value) - mX2.Value
'        mCtl.Width = mWindowPos.Width * mWidth.Value
''         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
''         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
'   End Select
'   Select Case mY.AnchorType  ' Y anchor
'      Case enumNone        ' Avenue Fastener ( - , - , - )
'        mCtl.Top = mWindowPos.Height * mY.Value
'        mCtl.Height = mWindowPos.Height * mHeight.Value
''         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
''         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
'      Case enumStart       ' Avenue Fastener (Top, - , - )   DON'T ADJUST Y AT ALL!
''        mCtl.Top = mY.Value
'        mCtl.Height = mWindowPos.Height * mHeight.Value
''         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
''         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
'      Case enumStartSize   ' Avenue Fastener (Top, Height, - )
''        mCtl.Top = mY.Value
''         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
''         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
'      Case enumStartEnd    ' Avenue Fastener (Top, - , Bottom )
''        mCtl.Top = mY.Value
'        mCtl.Height = mWindowPos.Height - mHeight.Value
''         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
''         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
'      Case enumSize        ' Avenue Fastener ( - , Height, - )
'        mCtl.Top = (mWindowPos.Height * mY.Value) - mY2.Value
''         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
''         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
'      Case enumSizeEnd     ' Avenue Fastener ( - , Height, Bottom)
'        mCtl.Top = mWindowPos.Height - mY.Value
''         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
''         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
'      Case enumEnd         ' Avenue Fastener ( - , - , Bottom)
'        mCtl.Top = mWindowPos.Height - (mWindowPos.Height * mY.Value) - mY2.Value
'        mCtl.Height = mWindowPos.Height * mHeight.Value
''         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
''         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
'   End Select


   Select Case mX.AnchorType  ' X anchor
      Case enumNone        ' Avenue Fastener ( - , - , - )
266:         mCtl.Left = mCtl.Container.Width * mX.Value
267:         mCtl.Width = mCtl.Container.Width * mWidth.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
      Case enumStart       ' Avenue Fastener (Left, - , - )   DON'T ADJUST Y AT ALL!
'        mCtl.Left = mX.Value
272:         mCtl.Width = mCtl.Container.Width * mWidth.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
      Case enumStartsize   ' Avenue Fastener (Left, Width, - )
'        mCtl.Left = mX.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
      Case enumStartEnd    ' Avenue Fastener (Left, - , Right )
'        mCtl.Left = mX.Value
281:         mCtl.Width = mCtl.Container.Width - mWidth.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
      Case enumSize        ' Avenue Fastener ( - , Width, - )
285:         mCtl.Left = (mCtl.Container.Width * mX.Value) - mX2.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
      Case enumSizeEnd     ' Avenue Fastener ( - , Width, Right)
289:         mCtl.Left = mCtl.Container.Width - mX.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
      Case enumEnd         ' Avenue Fastener ( - , - , Right)
293:         mCtl.Left = mCtl.Container.Width - (mCtl.Container.Width * mX.Value) - mX2.Value
294:         mCtl.Width = mCtl.Container.Width * mWidth.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit
297:    End Select
   Select Case mY.AnchorType  ' Y anchor
      Case enumNone        ' Avenue Fastener ( - , - , - )
300:         mCtl.Top = mCtl.Container.Height * mY.Value
301:         mCtl.Height = mCtl.Container.Height * mHeight.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
      Case enumStart       ' Avenue Fastener (Top, - , - )   DON'T ADJUST Y AT ALL!
'        mCtl.Top = mY.Value
306:         mCtl.Height = mCtl.Container.Height * mHeight.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
      Case enumStartsize   ' Avenue Fastener (Top, Height, - )
'        mCtl.Top = mY.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
      Case enumStartEnd    ' Avenue Fastener (Top, - , Bottom )
'        mCtl.Top = mY.Value
315:         mCtl.Height = mCtl.Container.Height - mHeight.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
      Case enumSize        ' Avenue Fastener ( - , Height, - )
319:         mCtl.Top = (mCtl.Container.Height * mY.Value) - mY2.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
      Case enumSizeEnd     ' Avenue Fastener ( - , Height, Bottom)
323:         mCtl.Top = mCtl.Container.Height - mY.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
      Case enumEnd         ' Avenue Fastener ( - , - , Bottom)
327:         mCtl.Top = mCtl.Container.Height - (mCtl.Container.Height * mY.Value) - mY2.Value
328:         mCtl.Height = mCtl.Container.Height * mHeight.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit
331:    End Select


   On Error GoTo 0  ' Stop ignoring errors
End Sub


Private Sub Class_Initialize()
339:    Set mX = New Anchor       ' Create new anchor instance
340:    Set mY = New Anchor       ' Create new anchor instance
341:    Set mX2 = New Anchor      ' Create new anchor instance
342:    Set mY2 = New Anchor      ' Create new anchor instance
343:    Set mWidth = New Anchor   ' Create new anchor instance
344:    Set mHeight = New Anchor  ' Create new anchor instance
'   Set mWindowPos = New ModelessFrame
End Sub

Private Sub Class_Terminate()
349:    Set mX = Nothing       ' Discard anchor instance
350:    Set mY = Nothing       ' Discard anchor instance
351:    Set mX2 = Nothing      ' Discard anchor instance
352:    Set mY2 = Nothing      ' Discard anchor instance
353:    Set mWidth = Nothing   ' Discard anchor instance
354:    Set mHeight = Nothing  ' Discard anchor instance
'   Set mWindowPos = Nothing
End Sub

