VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CollectionMod"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Dim m_collection As Collection
Dim m_Keys() As String

'Public Property Set Collection(colSet As Collection)
'  Set m_collection = colSet
'End Property

'Public Property Get Collection() As Collection
'  Set IntCollection = m_collection
'End Property


Public Property Get Count() As Long
16:   Count = m_collection.Count
End Property

Public Property Get ReturnKeys() As String()

  Dim strReturnKeys() As String
22:   strReturnKeys = m_Keys
23:   ReturnKeys = strReturnKeys

End Property

'Public Function HasKeyUsingError(strkey As String) As Boolean
'On Error GoTo ErrorHandler
'
'  HasKeyUsingError = True
'  Dim varTest As Variant
'  varTest = m_collection.Item(strkey)
'
'  Exit Function
'ErrorHandler
'  HasKeyUsingError = False
'End Function

Public Function HasKey(strKey As String) As Boolean
  
41:   HasKey = False
  Dim lngCounter As Long
43:   For lngCounter = 0 To UBound(m_Keys)
44:     If m_Keys(lngCounter) = strKey Then
45:       HasKey = True
46:       Exit For
47:     End If
48:   Next lngCounter

End Function

Public Function AddObject(aValue As IUnknown, strKey As String, ShouldReplace As Boolean) As Boolean
  Dim HasVal As Variant
54:   AddObject = False
55:   HasVal = Not GetObject(strKey) Is Nothing
56:   If HasVal Then           ' ALREADY AN ITEM AVAILABLE
57:     If ShouldReplace Then
58:       Me.SetOrReplace aValue, strKey
59:       AddObject = True
60:     End If
61:   Else
62:     m_collection.Add aValue, strKey
63:     AddObject = True
64:     AddKey strKey
65:   End If

End Function
Public Function AddVariable(aValue As Variant, strKey As String, ShouldReplace As Boolean) As Boolean
  Dim HasVal As Variant
70:   AddVariable = False
71:   HasVal = GetVariable(strKey)
72:   If Not IsNull(HasVal) Then          ' ALREADY AN ITEM AVAILABLE
73:     If ShouldReplace Then
74:       Me.SetOrReplace aValue, strKey
75:       AddVariable = True
76:     End If
77:   Else
78:     m_collection.Add aValue, strKey
79:     AddVariable = True
80:     AddKey strKey
81:   End If

End Function

Private Sub AddKey(strKey As String)
  ReDim Preserve m_Keys(m_collection.Count - 1)
87:   m_Keys(m_collection.Count - 1) = strKey
End Sub

Private Sub RemoveKey(strKey As String)

  Dim strTestKey As String
  Dim strTemp() As String
  Dim FoundKey As Boolean
95:   FoundKey = False
  ReDim strTemp(UBound(m_Keys))
  
  Dim lngCounter As Long
99:   lngCounter = -1
  Dim lngIndex As Long
  
102:   For lngIndex = 0 To UBound(m_Keys)
103:     strTestKey = m_Keys(lngIndex)
104:     If Not strTestKey = strKey Then
105:       lngCounter = lngCounter + 1
106:       strTemp(lngCounter) = strTestKey
107:     Else
108:       FoundKey = True
109:     End If
110:   Next lngIndex
  
112:   If FoundKey Then
    ReDim Preserve strTemp(UBound(m_Keys) - 1)
114:     m_Keys = strTemp
115:   End If
  
End Sub

Public Sub RemoveWithoutError(strKey As String)

  On Error Resume Next
122:   m_collection.Remove strKey
123:   RemoveKey strKey

End Sub
Public Sub SetOrReplace(aValue As Variant, strKey As String)

  On Error Resume Next
129:   m_collection.Remove strKey
130:   RemoveKey strKey
131:   m_collection.Add aValue, strKey
132:   AddKey strKey
  
End Sub

Public Function GetVariable(strKey As String) As Variant
  Dim IsNil As Boolean
138:   IsNil = True
139:   err.Clear
  
  Dim varResponseVal As Variant
  On Error GoTo FoundError

'  If VarType(m_collection.Item(strKey) = 13) Then
'    Set varResponseVal = m_collection.Item(strKey)
'  Else
147:     varResponseVal = m_collection.Item(strKey)
'  End If
  
  ' SHOULD SKIP NEXT LINE IF INDEX DID NOT EXIST (TRIGGERING AN ERROR)
151:   IsNil = False
152:   GetVariable = varResponseVal
  Exit Function
  
FoundError:
'  Debug.Print Err.Description & ",   " & Err.Number

158:   If IsNil Then varResponseVal = Null
159:   GetVariable = varResponseVal

End Function
Public Function GetObject(strKey As String) As IUnknown
  Dim IsNil As Boolean
164:   IsNil = True
165:   err.Clear
  
  Dim pResponseVal As IUnknown
  On Error GoTo FoundError

'  If VarType(m_collection.Item(strKey) = 13) Then
'    Set varResponseVal = m_collection.Item(strKey)
'  Else
173:     Set pResponseVal = m_collection.Item(strKey)
'  End If
  
  ' SHOULD SKIP NEXT LINE IF INDEX DID NOT EXIST (TRIGGERING AN ERROR)
177:   IsNil = False
178:   Set GetObject = pResponseVal
  Exit Function
  
FoundError:
'  Debug.Print Err.Description & ",   " & Err.Number

184:   If IsNil Then Set GetObject = Nothing

End Function
Private Sub Class_Initialize()
'  Dim m_collection As Collection
189:   Set m_collection = New Collection
  ReDim m_Keys(0)
  
End Sub

Private Sub Class_Terminate()

196:   Set m_collection = Nothing
End Sub

