VERSION 5.00
Begin VB.Form frmSelScreen 
   Caption         =   "Form1"
   ClientHeight    =   3540
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5355
   BeginProperty Font 
      Name            =   "Times New Roman"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmSelScreen.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3540
   ScaleWidth      =   5355
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdAccept 
      Caption         =   "Accept"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   675
      Left            =   4320
      TabIndex        =   2
      Top             =   1170
      Width           =   945
   End
   Begin VB.ListBox lbxThemes 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1815
      Left            =   75
      TabIndex        =   1
      Top             =   60
      Width           =   4110
   End
   Begin VB.TextBox txtCoords 
      BackColor       =   &H8000000F&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1275
      Left            =   195
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "frmSelScreen.frx":058A
      Top             =   2100
      Width           =   4305
   End
   Begin VB.Image imgIcon 
      Height          =   945
      Left            =   4320
      Picture         =   "frmSelScreen.frx":059A
      ToolTipText     =   "Click to visit CorridorDesign.org"
      Top             =   135
      Width           =   945
   End
   Begin VB.Image imgToolDisable 
      Height          =   360
      Left            =   4695
      Picture         =   "frmSelScreen.frx":128D
      ToolTipText     =   "Click to Select Polygon..."
      Top             =   2580
      Width           =   360
   End
   Begin VB.Image imgToolOut 
      Height          =   360
      Left            =   4695
      Picture         =   "frmSelScreen.frx":1334
      ToolTipText     =   "Click to Select Polygon..."
      Top             =   2580
      Width           =   360
   End
   Begin VB.Image imgToolIn 
      Height          =   360
      Left            =   4695
      Picture         =   "frmSelScreen.frx":14EB
      Top             =   2580
      Width           =   360
   End
   Begin VB.Image imgBoundaryBox 
      BorderStyle     =   1  'Fixed Single
      Height          =   1530
      Left            =   75
      Top             =   1965
      Width           =   5235
   End
End
Attribute VB_Name = "frmSelScreen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_pMxDoc As esriArcMapUI.IMxDocument
'Private m_Command As esriSystemUI.ICommand
Private m_pApp As IApplication
Private m_Frame As IModelessFrame
Private m_ExtensionConfig As IExtensionConfig
Private m_SearchMessage As String
Private m_ToolEnable As Boolean
Private m_strNameArray() As String
Private m_intNameCount As Integer
Private m_colPolygons As Collection
Private m_PolygonPurpose As String
Private m_pPolygon As IPolygon

Const conHwndTopmost = -1
Const conHwndNoTopmost = -2
Const conSwpNoActivate = &H10
Const conSwpShowWindow = &H40
  
Private Declare Function ShellExecute Lib "shell32.dll" Alias _
           "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, _
           ByVal lpFile As String, ByVal lpParameters As String, _
           ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
           
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\frmSelScreen.frm"

Public Property Set thePolygon(pPolygon As IPolygon)
25:   Set m_pPolygon = pPolygon
End Property

Public Property Let PolygonPurpose(strPurpose As String)
29:   m_PolygonPurpose = strPurpose
End Property
Public Property Let NameList(strNameArray() As String)
32:   m_strNameArray = strNameArray
End Property
Public Property Set NameCollection(colNames As Collection)
35:   Set m_colPolygons = colNames
End Property
Public Property Get GetNameCollection() As Collection
38:   Set GetNameCollection = m_colPolygons
End Property
Public Property Let NameCount(intNameCount As Long)
41:   m_intNameCount = intNameCount
End Property

Public Property Let EnableTool(booEnable As Boolean)
45:   m_ToolEnable = booEnable
End Property

Public Sub SetToolEnabled()
  
'  MsgBox m_ToolEnable & vbCrLf & "Starting SetToolEnabled Function" & vbCrLf & lbxThemes.ListIndex
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
53:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
54:   cmdAccept.Enabled = False
  
56:   If (lbxThemes.ListIndex = -1) Then
57:     imgToolOut.Visible = False
58:     imgToolIn.Visible = False
59:     imgToolDisable.Visible = True
60:   Else
61:     If (m_ToolEnable) Then
62:       imgToolOut.Visible = False
63:       imgToolIn.Visible = True
64:       imgToolDisable.Visible = False
65:     Else
66:       imgToolOut.Visible = True
67:       imgToolIn.Visible = False
68:       imgToolDisable.Visible = False
69:     End If
70:   End If
  
72:   Me.Refresh

End Sub

Public Property Let SearchMessage(strMessage As String)

78:   m_SearchMessage = strMessage

End Property

Public Property Set ArcApplication(ByVal theApplication As IApplication)
  On Error GoTo ErrorHandler

85:   Set m_pApp = theApplication

  Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
Public Function Frame() As IModelessFrame
  On Error GoTo ErrorHandler

94:   If m_Frame Is Nothing Then
95:     Set m_Frame = New ModelessFrame

97:     m_Frame.Create Me
98:   End If

100:   Set Frame = m_Frame

  Exit Function
ErrorHandler:
  HandleError True, "Frame " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Property Set Doc(pDoc As esriArcMapUI.IMxDocument)
  On Error GoTo ErrorHandler

109:   Set m_pMxDoc = pDoc

  Exit Property
ErrorHandler:
  HandleError True, "Doc " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Private Sub cmdAccept_Click()
  
118:   If m_pPolygon Is Nothing Then
119:     MsgBox "Error identifying selected polygon!  Please click on desired polygon again and try this button one more time...", _
       vbOKOnly, "Unexpected Problem:"
    Exit Sub
122:   End If
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New UID
126:   pUID.Value = "Linkages.toolReturnCoords"
    
  Dim ext As Linkages.Extension
129:   Set ext = m_ExtensionConfig
130:   ext.EnableSelTool = False
  
  Select Case m_PolygonPurpose
    Case "Wildland1"
134:       Set ext.PolyWildland1 = m_pPolygon
    Case "Wildland2"
136:       Set ext.PolyWildland2 = m_pPolygon
    Case "Corridor"
138:       Set ext.PolyCorridor = m_pPolygon
139:   End Select
  
141:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
142:   Set m_pApp.CurrentTool = Nothing
  
  Dim pCommandItem As ICommandItem
145:   Set pCommandItem = pCommand
  
147:   pCommandItem.Refresh
  
149:   Set ext.aSelForm = Nothing
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
152:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
  
154:   Unload Me

  
End Sub

Private Sub ClickOnScreen()
On Error GoTo ErrorHandler


  
164:   If (m_ExtensionConfig Is Nothing) Then
165:     MsgBox "Unexpected error!  'm_ExtensionConfig' set to nothing..."
    Exit Sub
167:   End If
  
  
  Dim ext As Linkages.Extension
171:   Set ext = m_ExtensionConfig
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New UID
175:   pUID.Value = "Linkages.toolReturnCoords"
  
177:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
178:   ext.EnableSelTool = True
    
  Dim pCommandItem As ICommandItem
181:   Set pCommandItem = pCommand

183:   pCommandItem.Refresh
  
185:   Set m_pApp.CurrentTool = pCommandItem

  Exit Sub
ErrorHandler:
  HandleError True, "Command1_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub



Private Sub Form_Initialize()
  On Error GoTo ErrorHandler

'  Set m_Command = New Linkages.toolReturnCoords


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Text1_Change()
  On Error GoTo ErrorHandler



  Exit Sub
ErrorHandler:
  HandleError False, "Text1_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
216:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
  
  Dim newUid As New UID
219:   newUid.Value = "Linkages.Extension"
220:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  
  Dim ext As Linkages.Extension
223:   Set ext = m_ExtensionConfig
224:   Set ext.aSelForm = Me
  
226:   m_ToolEnable = False
  
  Dim anIndex As Integer
229:   For anIndex = 0 To m_intNameCount
230:     lbxThemes.AddItem m_strNameArray(anIndex)
231:   Next anIndex
  
  Dim strInstructions As String
234:   strInstructions = _
    "INSTRUCTIONS:" & vbCrLf & _
    "1) Select the appropriate layer from the list above." & vbCrLf & _
    "2) Enable the Polygon Selection tool by clicking the crosshair button ---->" & vbCrLf & _
    "3) Click on the map to select your " & m_SearchMessage & " polygon."
  
240:   txtCoords.Text = strInstructions
  
242:   cmdAccept.Enabled = False
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
245:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")

End Sub


Private Sub Form_Unload(Cancel As Integer)
'  Set m_Command = Nothing
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New UID
255:   pUID.Value = "Linkages.toolReturnCoords"
  
  Dim ext As Linkages.Extension
258:   Set ext = m_ExtensionConfig
259:   ext.EnableSelTool = False
  
261:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
262:   Set m_pApp.CurrentTool = Nothing
  
  Dim pCommandItem As ICommandItem
265:   Set pCommandItem = pCommand
  
267:   pCommandItem.Refresh
  
269:   Set ext.aSelForm = Nothing
  
271:   Set pCommand = Nothing
272:   Set pCommandItem = Nothing
273:   Set ext = Nothing
274:   Set m_pApp = Nothing
275:   Set m_pMxDoc = Nothing
276:   Set m_Frame = Nothing
277:   Set m_ExtensionConfig = Nothing
278:   Set m_colPolygons = Nothing
279:   Set m_pPolygon = Nothing
End Sub

Private Sub imgIcon_Click()

    Call ShellExecute(0, vbNullString, "http://www.corridordesign.org/", vbNullString, "", 1)
    
End Sub

Private Sub imgToolIn_Click()
283:   m_ToolEnable = False
284:   Call SetToolEnabled
    
  Dim ext As Linkages.Extension
287:   Set ext = m_ExtensionConfig
288:   ext.EnableSelTool = False
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New UID
292:   pUID.Value = "Linkages.toolReturnCoords"
  
294:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
295:   Set m_pApp.CurrentTool = Nothing
  
  Dim pCommandItem As ICommandItem
298:   Set pCommandItem = pCommand
  
300:   pCommandItem.Refresh
  
End Sub

Private Sub imgToolOut_Click()
305:   m_ToolEnable = True
306:   Call SetToolEnabled
307:   Call ClickOnScreen
End Sub

Private Sub lbxThemes_Click()
311:   m_ToolEnable = False
312:   Call SetToolEnabled
End Sub

Public Property Get zzz() As Variant

End Property

Public Property Let zzz(ByVal vNewValue As Variant)

End Property
