VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCombineAreas"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit


Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_ExtensionConfig As IExtensionConfig
Private m_pThisExt As Linkages.clsExtension

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\clsCombineAreas.cls"
Implements ICommand
  
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

16:   Set m_bitmap = LoadResPicture(118, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

26:   Set m_bitmap = Nothing
27:   Set m_pMxDoc = Nothing
28:   Set m_pApp = Nothing
29:   Set m_ExtensionConfig = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
39:   If (Not m_ExtensionConfig Is Nothing) Then
40:     If (m_ExtensionConfig.State = esriESEnabled) Then
41:       ICommand_Enabled = True
42:     End If
43:   Else
44:     ICommand_Enabled = False
45:   End If
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
56:   ICommand_Checked = False
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
67:   ICommand_Name = "CorridorDesigner_CombineAreas"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
78:   ICommand_Caption = "Combine Regions"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
89:   ICommand_Tooltip = "Combine Regions"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
100:   ICommand_Message = "Create a raster indicating how many polygons, corridors or patches exist at any location..."
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
111:   ICommand_HelpFile = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
122:   ICommand_HelpContextID = 0
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
133:   ICommand_Bitmap = m_bitmap.Handle
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
144:   ICommand_Category = "Corridor Designer Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here

156:   Set m_pApp = hook
157:   Set m_pMxDoc = m_pApp.Document
  
  Dim newUid As New uID
160:   newUid.Value = "Linkages.clsExtension"
161:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
162:   Set m_pThisExt = m_ExtensionConfig
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
 
  Dim pParams As esriSystem.IVariantArray
174:   Set pParams = New esriSystem.VarArray
175:   pParams.Add m_pApp
176:   pParams.Add m_pMxDoc
177:   pParams.Add m_pThisExt
  
  Dim pForm As Linkages.frmCombineLayerID
180:   Set pForm = New Linkages.frmCombineLayerID
181:   Set pForm.ArcApplication = pParams
  
183:   pForm.Show vbModal
184:   Set pForm = Nothing

186:   If m_pThisExt.ShouldContinue = False Then
  '  MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
    Exit Sub
189:   End If

  Dim pReturnArray As esriSystem.IVariantArray
192:   Set pReturnArray = m_pThisExt.frmCombineLayerIDReturn
  
194:   m_pApp.RefreshWindow
195:   DoEvents
  
  Dim strReport As String
198:   strReport = Linkages.LinkagesFunctions2.CombineLayers(pParams, pReturnArray)

 ' Dim frmReportForm As New Linkages.frmReport_modal
'  frmReportForm.txtReport.TextRTF = strReport
'  frmReportForm.Show vbModal
'  Set frmReportForm = Nothing

  ' CLEAR MEMORY
206:   Set m_pThisExt.frmCombineLayerIDReturn = Nothing

  Dim pDirty As IDocumentDirty
209:   Set pDirty = m_pMxDoc
210:   pDirty.SetDirty
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

