VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdBottleneckBatch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_pThisExt As Linkages.clsExtension
Private m_ExtensionConfig As IExtensionConfig

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\cmdBottleneck.cls"
Implements ICommand
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler


15:   Set m_bitmap = LoadResPicture(122, vbResBitmap)


  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler


27:   Set m_bitmap = Nothing
28:   Set m_pApp = Nothing
29:   Set m_pMxDoc = Nothing
30:   Set m_ExtensionConfig = Nothing
31:   Set m_pThisExt = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
41:   If (Not m_ExtensionConfig Is Nothing) Then
42:     If (m_ExtensionConfig.State = esriESEnabled) Then
43:       ICommand_Enabled = True
44:     End If
45:   Else
46:     ICommand_Enabled = False
47:   End If
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
58:   ICommand_Checked = False
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
69:   ICommand_Name = "CorridorDesigner_BottleneckStats_Batch"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
80:   ICommand_Caption = "Calculate Bottleneck Statistics, Batch Mode"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
91:   ICommand_Tooltip = "Bottleneck Statistics, Batch Mode"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
102:   ICommand_Message = "Calculate Bottleneck Statistics in Batch Mode, where analysis parameters are read from a table."
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
113:   ICommand_HelpFile = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
124:   ICommand_HelpContextID = 0
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
135:   ICommand_Bitmap = m_bitmap.Handle
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
146:   ICommand_Category = "Corridor Designer Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here

158:   Set m_pApp = hook
159:   Set m_pMxDoc = m_pApp.Document
  
  Dim newUid As New uID
162:   newUid.Value = "Linkages.clsExtension"
163:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
164:   Set m_pThisExt = m_ExtensionConfig
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
    ' ---------------------------------------------------------------------
'  MsgBox "<-- Code in development -->" & vbCrLf & vbCrLf & _
         "The following dialogs behave as they will when the code is finished, but will not actually " & _
         "perform the bottleneck analysis.  The 'Bottleneck Results' dialog has full functionality, " & _
         "but will display a sample dataset." & vbCrLf & vbCrLf & _
         "Please check http://www.corridordesign.org for updates...", , "Function Not Implemented Yet:"
     
  Dim pVarArray As esriSystem.IVariantArray
184:   Set pVarArray = New VarArray

  ' ADD APPLICATION, EXTENSION, MXDOC
187:   pVarArray.Add m_pApp
188:   pVarArray.Add m_pThisExt
189:   pVarArray.Add m_pMxDoc

  Dim pForm As Linkages.frmBatchBottleneckLayerID
192:   Set pForm = New Linkages.frmBatchBottleneckLayerID
193:   Set pForm.ArcApplication = pVarArray
194:   pForm.Show vbModal
195:   Set pForm = Nothing

197:   If m_pThisExt.ShouldContinue = False Then
   ' MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
    Exit Sub
200:   End If

  Dim pReturnArray As esriSystem.IVariantArray
203:   Set pReturnArray = m_pThisExt.frmBatchBottleneckLayerIDReturn
  
205: '  MsgBox "OnClick:  pReturnArray is nothing = " & CStr(pReturnArray Is Nothing)
  
  Dim strReport As String
208:   strReport = Linkages.BatchFunctions.PerformBatchBottleneckAnalysis(pVarArray, pReturnArray)

  Dim frmReportForm As Linkages.frmReport_modal
211:   Set frmReportForm = New Linkages.frmReport_modal

  ' SHOW NORMAL TEXT REPORT
214:   frmReportForm.txtReport.TextRTF = strReport
215:   frmReportForm.txtReport.Locked = False
216:   frmReportForm.Caption = "Batch Bottleneck Analysis Complete:"
217:   frmReportForm.Show vbModal

  ' CLEAR MEMORY
220:   Set frmReportForm = Nothing
221:   Set m_pThisExt.frmRasterExportLayerIDReturn = Nothing
222:   Set pVarArray = Nothing

  Dim pDirty As IDocumentDirty
225:   Set pDirty = m_pMxDoc
226:   pDirty.SetDirty
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub



