VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdHabSuitStats"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_ExtensionConfig As IExtensionConfig
Private m_pThisExt As Linkages.clsExtension

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\cmdHabSuitStats.cls"
Implements ICommand
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler


15:   Set m_bitmap = LoadResPicture(115, vbResBitmap)



  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler


28:   Set m_bitmap = Nothing
29:   Set m_pThisExt = Nothing
30:   Set m_pApp = Nothing
31:   Set m_pMxDoc = Nothing
32:   Set m_ExtensionConfig = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
42:   If (Not m_ExtensionConfig Is Nothing) Then
43:     If (m_ExtensionConfig.State = esriESEnabled) Then
44:       ICommand_Enabled = True
45:     End If
46:   Else
47:     ICommand_Enabled = False
48:   End If
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
59:   ICommand_Checked = False
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
70:   ICommand_Name = "CorridorDesigner_HabitatSuitabilityStats"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
81:   ICommand_Caption = "Habitat Suitability Statistics"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
92:   ICommand_Tooltip = "Habitat Suitability Statistics"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
103:   ICommand_Message = "Calculate Habitat Suitability Statistics"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
114:   ICommand_HelpFile = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
125:   ICommand_HelpContextID = 0
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
136:   ICommand_Bitmap = m_bitmap.Handle
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
147:   ICommand_Category = "Corridor Designer Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here

159:   Set m_pApp = hook
160:   Set m_pMxDoc = m_pApp.Document
  
  Dim newUid As New uID
163:   newUid.Value = "Linkages.clsExtension"
164:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  
166:   Set m_pThisExt = m_ExtensionConfig
  
' 153:   SetWindowLong m_frm1.hwnd, GWL_HWNDPARENT, m_pApp.hwnd
'  m_frm1.Frame
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
  ' MODIFIED JUNE 2009 TO USE NEW HISTOGRAM TOOL
  Dim pValsArray As esriSystem.IArray
181:   Set pValsArray = New esriSystem.Array
'  pValsArray.Add pHistData
    
  Dim pIntroData As esriSystem.IVariantArray
185:   Set pIntroData = New esriSystem.VarArray
186:   pIntroData.Add m_pApp
187:   pIntroData.Add m_pMxDoc
188:   pIntroData.Add m_pThisExt
189:   pIntroData.Add pValsArray
190:   pIntroData.Add " Histogram Statistics:"
  
  Dim frmGraph As Linkages.frmHistogram
193:   Set frmGraph = New Linkages.frmHistogram
194:   Set frmGraph.IntroData = pIntroData
195:   frmGraph.Show vbModal
  
  Dim pDocDirty As IDocumentDirty
198:   Set pDocDirty = m_pMxDoc
199:   pDocDirty.SetDirty
  
''  MsgBox "First Line of Code; Click Event about to start (Step 1)..."  ' ************************************************************
'
'  On Error GoTo ErrorHandler
'
'  Dim pRaster As IRaster
'  Dim pRasterLayer As IRasterLayer
'  Dim pRasterBand As IRasterBand
'  Dim pRasterBandCollection As IRasterBandCollection
'  Dim booHasTable As Boolean
'
'  Dim pSelItem As IUnknown
'  Dim pSelRaster As IRasterLayer
'  Set pSelItem = m_pMxDoc.SelectedItem
'  If Not pSelItem Is Nothing Then
'    If TypeOf pSelItem Is IRasterLayer Then
'      Set pSelRaster = pSelItem
'    Else
'      Set pSelItem = Nothing
'    End If
'  End If
'  Dim pLayer As ILayer
'
'  ' MAKE COLLECTION OF VALID FEATURE/RASTER LAYERS AND STANDALONE TABLES
'  Dim pLayerArray As esriSystem.IVariantArray
'  Set pLayerArray = New esriSystem.VarArray
'
'  Dim pEnumLayer As IEnumLayer
'
''  MsgBox "Finished dimensioning Variables (Step 2)..."  ' ************************************************************
'
'  If (m_pMxDoc.FocusMap.LayerCount = 0) Then
'    MsgBox "No continuous grid layers available in map!  This function requires a continuous grid with " & _
'      "values ranging between 0 and 100.  Bailing out...", , "Missing Data:"
'    Exit Sub
'  End If
'
'  Set pEnumLayer = m_pMxDoc.FocusMap.Layers(, True)
'  pEnumLayer.Reset
'  Set pLayer = pEnumLayer.Next
'
''  MsgBox "Step 3"  ' ************************************************************
'
'  Dim anIndex As Long
'  Dim intIndex As Long
'  intIndex = -1
'  Dim booFoundRaster As Boolean
'  booFoundRaster = False
'
'  Dim pRasterProps As IRasterProps
'
'  ' MAKE COLLECTION OF VALID FEATURE AND RASTER LAYERS
'
'  Do While Not pLayer Is Nothing
'    If pLayer.Valid = True Then
'      If TypeOf pLayer Is IRasterLayer Then
'        Set pRasterLayer = pLayer
'        Set pRaster = pRasterLayer.Raster
'        Set pRasterProps = pRaster
'        Set pRasterBandCollection = pRaster
'        Set pRasterBand = pRasterBandCollection.Item(0)
''        pRasterBand.HasTable booHasTable
'      '  MsgBox "Raster is " & pRasterLayer.Name & vbCrLf & "Has Table? " & booHasTable
''        If Not booHasTable Then
'        If Not pRasterProps.IsInteger Then
'          booFoundRaster = True
'          pLayerArray.Add pRasterLayer
'        End If
'      End If
'    End If
'    Set pLayer = pEnumLayer.Next
'  Loop
'
'  If (Not booFoundRaster) Then
'    MsgBox "No continuous grid layers available in map!  This function requires a continuous grid with " & _
'      "values ranging between 0 and 100.  Bailing out...", , "Missing Data:"
'    Exit Sub
'  End If
'
''  MsgBox "Step 5"  ' ************************************************************
'
''  MsgBox "Step 6"  ' ************************************************************
'
''  MsgBox "Step 7"  ' ************************************************************
'
'  Dim pSumForm As frmHabSuitStats
'  Set pSumForm = New frmHabSuitStats
'
''  MsgBox "Step 8"  ' ************************************************************
'
'  Set pSumForm.theRasterLayers = pLayerArray
'
''  MsgBox "Step 9"  ' ************************************************************
'
''  MsgBox "Step 10"  ' ************************************************************
'
'  Set pSumForm.theCurrentSelected = pSelItem
' ' MsgBox "Step 11"  ' ************************************************************
'
'  Set pSumForm.ArcApp = m_pApp
''  MsgBox "Step 12"  ' ************************************************************
''  MsgBox "Before Show"
'
'  pSumForm.Show vbModal
'
''  MsgBox "After Show"
'  Set pSumForm = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

