VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdTestCode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit


Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_ExtensionConfig As IExtensionConfig

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\cmdTestCode.cls"
Implements ICommand
  
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

15:   Set m_bitmap = LoadResPicture(103, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

25:   Set m_bitmap = Nothing
26:   Set m_pMxDoc = Nothing
27:   Set m_pApp = Nothing
28:   Set m_ExtensionConfig = Nothing
  
  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
38:   ICommand_Enabled = True

  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
50:   ICommand_Checked = False
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
61:   ICommand_Name = "CorridorDesigner_TestTools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
72:   ICommand_Caption = "Test Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
83:   ICommand_Tooltip = "Test Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
94:   ICommand_Message = "Test Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
105:   ICommand_HelpFile = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
116:   ICommand_HelpContextID = 0
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
127:   ICommand_Bitmap = m_bitmap.Handle
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
138:   ICommand_Category = "Corridor Designer Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here

150:   Set m_pApp = hook
151:   Set m_pMxDoc = m_pApp.Document
  
  Dim newUid As New uID
154:   newUid.Value = "Linkages.clsExtension"
155:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
  Dim pExt As Linkages.clsExtension
166:   Set pExt = m_ExtensionConfig
  
  ' TODO: Add your implementation here
169:   MyGeneralOperations.DeleteGraphicsByName m_pMxDoc, "test_matrix"
170:   MyGeneralOperations.DeleteGraphicsByName m_pMxDoc, "DeleteMatrix"
171:   MyGeneralOperations.DeleteGraphicsByName m_pMxDoc, "Route_Graphics"
172:   MyGeneralOperations.DeleteGraphicsByName m_pMxDoc, "test_order"
  
  ' GET INTERNAL NODES - FROM ORIGINAL TEST CODE
  Dim pStartArray As IArray
176:   Set pStartArray = New esriSystem.Array
177:   Set pStartArray = MyGeneralOperations.ReturnGraphicsByName(m_pMxDoc, "Internal", False)
  
  ' GET START AND END NODES - FROM ORIGINAL TEST CODE
  Dim pStartPolygon As IPolygon
  Dim pEndPolygon As IPolygon
182:   Set pStartPolygon = MyGeneralOperations.ReturnGraphicsByName(m_pMxDoc, "Start", False).Element(0)
183:   Set pEndPolygon = MyGeneralOperations.ReturnGraphicsByName(m_pMxDoc, "End", False).Element(0)
  
185:   pStartArray.Insert 0, pStartPolygon
186:   pStartArray.Add pEndPolygon
  
  Dim pClone As IClone
  
  ' GET CORRIDOR - FROM ORIGINAL TEST CODE
  Dim pCorridorArray As IArray
192:   Set pCorridorArray = MyGeneralOperations.ReturnGraphicsByName(m_pMxDoc, "Corridor", False)
  Dim pCorPolygon As IPolygon
194:   Set pCorPolygon = pCorridorArray.Element(0)
  
  ' PROGRESS METER STUFF ------------------------------------------------------------------
  Dim frmProgress As New frmJenProgressPercent
  Dim theTimeBegan As Date
  Dim theDetailedDescription As String
  
201:   frmProgress.SetExpanded = pExt.ProgressDialogSetExpanded
202:   frmProgress.SetAutoClose = pExt.ProgressDialogAutoClose
  
204:   theTimeBegan = Now
205:   frmProgress.ShouldContinue = True
206:   frmProgress.ProgBeginTime = Now
207:   frmProgress.ProgRecCount = 0
208:   frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
209:   frmProgress.lblBeginTime.Caption = "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd")

211:   theDetailedDescription = "Analyzing Patch Connectors..." & vbCrLf & _
      "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd") & vbCrLf & _
      "-------------------------------------------" & vbCrLf
214:   frmProgress.txtDetails.Text = theDetailedDescription

216:   frmProgress.Frame.Caption = "Current Status:"
217:   frmProgress.Frame.Visible = True

'   theProgressTimeCheck = CDate(50000)
  Dim theDescription As String
221:   theDescription = "Analyzing Patch Connectors..."
  ' PROGRESS METER STUFF ------------------------------------------------------------------
  
224:   CorridorAnalysisFunctions.ImplementKruskall m_pMxDoc, pStartPolygon, pEndPolygon, _
      pStartArray, pCorPolygon, frmProgress, m_ExtensionConfig, Nothing, pExt
  
227:   pExt.ProgressDialogAutoClose = (frmProgress.chkClose.Value = 1)
228:   pExt.ProgressDialogSetExpanded = (frmProgress.SetExpanded)
  
230:   If frmProgress.chkClose.Value = 1 Then
231:     Unload frmProgress
232:     Set frmProgress = Nothing
233:   End If

  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

