VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmAddHistogramLayer 
   Caption         =   " Add Layer to Histogram:"
   ClientHeight    =   8700
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5475
   Icon            =   "frmAddHistogramLayer.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   8700
   ScaleWidth      =   5475
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frmRasters 
      BorderStyle     =   0  'None
      Caption         =   "Frame1"
      Height          =   3300
      Left            =   45
      TabIndex        =   16
      Top             =   5340
      Width           =   5280
      Begin VB.CommandButton cmdCalculate 
         Height          =   360
         Left            =   4680
         Picture         =   "frmAddHistogramLayer.frx":038A
         Style           =   1  'Graphical
         TabIndex        =   7
         ToolTipText     =   "Suggested Sample Size"
         Top             =   2145
         Width           =   405
      End
      Begin VB.TextBox txtSampleSize 
         Alignment       =   2  'Center
         BackColor       =   &H8000000F&
         Height          =   285
         Left            =   1710
         Locked          =   -1  'True
         TabIndex        =   24
         Text            =   "Sample Size at 100% = 1000000000"
         Top             =   2190
         Width           =   2910
      End
      Begin MSComctlLib.Slider sldSampleSize 
         Height          =   300
         Left            =   165
         TabIndex        =   8
         Top             =   2505
         Width           =   4785
         _ExtentX        =   8440
         _ExtentY        =   529
         _Version        =   393216
         LargeChange     =   50
         Min             =   1
         Max             =   1000
         SelStart        =   1
         TickFrequency   =   100
         Value           =   1
      End
      Begin VB.ListBox lbxRasters 
         Height          =   1620
         Left            =   90
         TabIndex        =   6
         Top             =   390
         Width           =   5085
      End
      Begin VB.Label lblHasTable2 
         AutoSize        =   -1  'True
         Caption         =   "<-- No subsampling necessary -->"
         Height          =   195
         Left            =   540
         TabIndex        =   26
         Top             =   2700
         Width           =   2340
      End
      Begin VB.Label lblHasTable1 
         AutoSize        =   -1  'True
         Caption         =   "Raster has Attribute Table..."
         Height          =   195
         Left            =   540
         TabIndex        =   25
         Top             =   2430
         Width           =   1980
      End
      Begin VB.Label lbl0Percent 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "1 %"
         Height          =   195
         Left            =   255
         TabIndex        =   23
         Top             =   2880
         Width           =   255
      End
      Begin VB.Label lbl25 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "25 %"
         Height          =   195
         Left            =   1320
         TabIndex        =   22
         Top             =   2880
         Width           =   345
      End
      Begin VB.Label lbl50 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "50 %"
         Height          =   195
         Left            =   2430
         TabIndex        =   21
         Top             =   2880
         Width           =   345
      End
      Begin VB.Label lbl100 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "100 %"
         Height          =   195
         Left            =   4650
         TabIndex        =   20
         Top             =   2880
         Width           =   435
      End
      Begin VB.Label lbl75 
         Alignment       =   1  'Right Justify
         AutoSize        =   -1  'True
         Caption         =   "75 %"
         Height          =   195
         Left            =   3540
         TabIndex        =   19
         Top             =   2880
         Width           =   345
      End
      Begin VB.Label lblSubSample 
         AutoSize        =   -1  'True
         Caption         =   "Sub-Sample Raster:"
         Height          =   195
         Left            =   210
         TabIndex        =   18
         Top             =   2235
         Width           =   1410
      End
      Begin VB.Image imgRasterBack 
         BorderStyle     =   1  'Fixed Single
         Height          =   3255
         Left            =   0
         Top             =   0
         Width           =   5250
      End
      Begin VB.Image imgRastOptions 
         BorderStyle     =   1  'Fixed Single
         Height          =   1140
         Left            =   90
         Top             =   2040
         Width           =   5085
      End
      Begin VB.Label lblRasters 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         Caption         =   "-- Raster Layers --"
         Height          =   195
         Left            =   2002
         TabIndex        =   17
         Top             =   150
         Width           =   1260
      End
   End
   Begin VB.Frame frmFeatures 
      BorderStyle     =   0  'None
      Caption         =   "Frame1"
      Height          =   3300
      Left            =   135
      TabIndex        =   13
      Top             =   1440
      Width           =   5280
      Begin VB.CheckBox chkWeight 
         Caption         =   "Weight Features by Size"
         Height          =   330
         Left            =   585
         TabIndex        =   3
         Top             =   2115
         Width           =   4140
      End
      Begin VB.ListBox lbxLayers 
         Height          =   1620
         Left            =   75
         TabIndex        =   1
         Top             =   390
         Width           =   3225
      End
      Begin VB.ListBox lbxFields 
         Height          =   1620
         Left            =   3360
         TabIndex        =   2
         Top             =   390
         Width           =   1815
      End
      Begin VB.OptionButton optAll 
         Caption         =   "Convert All Records"
         Height          =   240
         Left            =   570
         TabIndex        =   4
         Top             =   2610
         Width           =   4335
      End
      Begin VB.OptionButton optSel 
         Caption         =   "Convert Selected Records"
         Height          =   240
         Left            =   570
         TabIndex        =   5
         Top             =   2895
         Width           =   4335
      End
      Begin VB.Image imgWeightBack 
         BorderStyle     =   1  'Fixed Single
         Height          =   450
         Left            =   90
         Top             =   2040
         Width           =   5085
      End
      Begin VB.Image imgFeatureBack 
         BorderStyle     =   1  'Fixed Single
         Height          =   3255
         Left            =   0
         Top             =   30
         Width           =   5250
      End
      Begin VB.Image imgBackMiddle 
         BorderStyle     =   1  'Fixed Single
         Height          =   705
         Left            =   90
         Top             =   2505
         Width           =   5085
      End
      Begin VB.Label lblLayer 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         Caption         =   "-- Feature Layers and Tables --"
         Height          =   195
         Left            =   600
         TabIndex        =   15
         Top             =   180
         Width           =   2160
      End
      Begin VB.Label lblFields 
         Alignment       =   2  'Center
         AutoSize        =   -1  'True
         Caption         =   "-- Select Value Field --"
         Height          =   195
         Left            =   3405
         TabIndex        =   14
         Top             =   180
         Width           =   1695
      End
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2212
      TabIndex        =   10
      Top             =   4830
      Width           =   1065
   End
   Begin VB.TextBox txtMessage 
      Height          =   960
      Left            =   75
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "frmAddHistogramLayer.frx":08ED
      Top             =   75
      Width           =   5415
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   3277
      TabIndex        =   11
      Top             =   4830
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1132
      TabIndex        =   9
      Top             =   4830
      Width           =   1065
   End
   Begin MSComctlLib.TabStrip TabStrip1 
      Height          =   3705
      Left            =   45
      TabIndex        =   12
      Top             =   1095
      Width           =   5415
      _ExtentX        =   9551
      _ExtentY        =   6535
      _Version        =   393216
      BeginProperty Tabs {1EFB6598-857C-11D1-B16A-00C0F0283628} 
         NumTabs         =   2
         BeginProperty Tab1 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
            Caption         =   "Raster Layers"
            ImageVarType    =   2
         EndProperty
         BeginProperty Tab2 {1EFB659A-857C-11D1-B16A-00C0F0283628} 
            Caption         =   "Feature Layers and Tables"
            ImageVarType    =   2
         EndProperty
      EndProperty
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   5250
      Picture         =   "frmAddHistogramLayer.frx":08FC
      Top             =   4950
      Width           =   225
   End
End
Attribute VB_Name = "frmAddHistogramLayer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pThisExt As Linkages.clsExtension
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pLayerArray As esriSystem.IVariantArray
Private m_pRasterBandArray As esriSystem.IVariantArray
Private m_pLayerFields As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_FieldTypeOption As JenFieldTypes
Private m_booIncludeNoIDField As Boolean
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
Private m_booRasterHasTable As Boolean
Private m_lngRasterCellCount As Long
Private m_dblRasterSampleProportion As Double
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\test_graph_form\frmAddHistogramLayer.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
31:   Set m_pApp = pParams.Element(0)
32:   m_ShapeTypeOption = pParams.Element(1)
33:   Set m_pThisExt = pParams.Element(2)
34:   m_FieldTypeOption = pParams.Element(3)

36:   Set m_pMxDoc = m_pApp.Document
 
  Dim pSelItem As IUnknown
39:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As ILayer
  Dim pStandaloneTable As IStandaloneTable
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

45:   m_strSelLayerName = ""
 
47:   If Not pSelItem Is Nothing Then
48:     If TypeOf pSelItem Is ILayer Then
49:       Set pLayer = pSelItem
50:       m_strSelLayerName = pLayer.Name
51:     ElseIf TypeOf pSelItem Is IStandaloneTable Then
52:       Set pStandaloneTable = pSelItem
53:       m_strSelLayerName = pStandaloneTable.Name
54:     End If
55:   End If

57:   m_pThisExt.ShouldContinue = False
58:   m_booSelToggle = False

  ' FILL FEATURE LAYER AND TABLE ARRAY AND LISTBOX
61:   lbxLayers.Clear
62:   lbxFields.Clear
  Dim lngStartSel As Long
64:   lngStartSel = 0
  Dim strShapeType As String
  Dim pFClass As IFeatureClass
  Dim pTempArray As esriSystem.IVariantArray
  Dim pFLayer As IFeatureLayer
  
70:   Set pTempArray = Linkages.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, m_ShapeTypeOption)
71:   Set m_pLayerArray = New esriSystem.VarArray
  
73:   If pTempArray.Count > 0 Then
74:     For lngIndex = 0 To pTempArray.Count - 1
75:       Set pUnknown = pTempArray.Element(lngIndex)
76:       If TypeOf pUnknown Is IFeatureLayer Then
77:         Set pFLayer = pUnknown
78:         If pFLayer.Valid Then
79:           Set pFClass = pFLayer.FeatureClass
          Select Case pFClass.ShapeType
            Case 1
82:               strShapeType = "POINTS"
            Case 2
84:               strShapeType = "MULTIPOINTS"
            Case 3
86:               strShapeType = "POLYLINES"
            Case 4
88:               strShapeType = "POLYGONS"
            Case Else
90:               strShapeType = "FEATURES"
91:           End Select
92:           lbxLayers.AddItem pFLayer.Name & " ...... " & strShapeType
93:           If pFLayer.Name = m_strSelLayerName Then lngStartSel = lngIndex
94:           m_pLayerArray.Add pFLayer
95:         End If
96:       ElseIf TypeOf pUnknown Is IStandaloneTable Then
97:         Set pStandaloneTable = pUnknown
98:         If pStandaloneTable.Valid Then
99:           lbxLayers.AddItem pStandaloneTable.Name & " ...... TABLE"
100:           If pStandaloneTable.Name = m_strSelLayerName Then lngStartSel = lngIndex
101:           m_pLayerArray.Add pStandaloneTable
102:         End If
103:       End If
104:     Next lngIndex
105:     lbxLayers.ListIndex = lngStartSel
106:   End If
  
  
  ' FILL RASTER LAYER ARRAY AND LISTBOX
110:   Set m_pRasterBandArray = New esriSystem.VarArray
111:   Set pTempArray = Linkages.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, ENUM_jenRasterLayers)
112:   lbxRasters.Clear
  
  Dim pRastBandColl As IRasterBandCollection
  Dim pRastBand As IRasterBand
  Dim pRaster As IRaster
  Dim pRasterLayer As IRasterLayer
  Dim lngIndex2 As Long
  
120:   If pTempArray.Count > 0 Then
    
122:     For lngIndex = 0 To pTempArray.Count - 1
123:       Set pUnknown = pTempArray.Element(lngIndex)
      
125:       If TypeOf pUnknown Is IRasterLayer Then
126:         Set pRasterLayer = pUnknown
        
128:         If pRasterLayer.Valid Then
129:           Set pRaster = pRasterLayer.Raster
130:           Set pRastBandColl = pRaster
          
132:           For lngIndex2 = 0 To pRastBandColl.Count - 1
133:             Set pRastBand = pRastBandColl.Item(lngIndex2)
134:             m_pRasterBandArray.Add pRastBand
135:             If pRastBandColl.Count = 1 Then
136:               lbxRasters.AddItem pRasterLayer.Name
137:             Else
138:               lbxRasters.AddItem pRasterLayer.Name & ".....[Band " & CStr(lngIndex2 + 1) & "]"
139:             End If
140:           Next lngIndex2
141:         End If
142:       End If
143:     Next lngIndex
144:   End If
  
146:   lbxRasters.ListIndex = -1
147:   lblSubSample.Visible = False
148:   txtSampleSize.Visible = False
149:   cmdCalculate.Visible = False
150:   sldSampleSize.Visible = False
151:   lbl0Percent.Visible = False
152:   lbl25.Visible = False
153:   lbl50.Visible = False
154:   lbl75.Visible = False
155:   lbl100.Visible = False
156:   lblHasTable1.Visible = True
157:   lblHasTable2.Visible = False
  
159:   If m_pRasterBandArray.Count > 0 Then
160:     lblHasTable1.Caption = "Please select raster or raster band from list..."
161:   Else
162:     lblHasTable1.Caption = "No rasters available in map..."
163:   End If
  Dim strBaseString As String
165:   strBaseString = "This tool will add data from either a table, raster layer or vector layer to your histogram.  If you select a floating-point raster that has no attribute table available, then you will have the option to subsample the raster to speed up the processing.  If you select a multipoint, polyline or polygon feature layer, then you will have the option to weight the feature values based on the size of those features."
166:   txtMessage.Text = strBaseString
  
168:   If m_pLayerArray.Count = 0 Then
169:     optAll.Value = True
170:   End If

  ' CLEAR INITIAL SELECTION
173:   Set m_pThisExt.frmAddHistogramLayerReturn = Nothing

175:   CheckEnable
 
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
185:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub UpdateSelName()
  On Error GoTo ErrorHandler
 
  Exit Sub
ErrorHandler:
  HandleError False, "UpdateSelName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 

 


Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  Dim strPath As String
208:   strPath = App.Path & "\help"
  
210:   Call Linkages.MyGeneralOperations.OpenDoc("Histogram_Statistics_Subdocument.pdf", strPath)
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdSelFields_Click()
  On Error GoTo ErrorHandler
 
  Dim lngIndex As Long
221:   For lngIndex = 0 To lbxFields.ListCount - 1
222:     lbxFields.Selected(lngIndex) = Not m_booSelToggle
223:   Next lngIndex
 
225:   lbxFields.ListIndex = 0
226:   lbxFields.Refresh
 
228:   m_booSelToggle = Not m_booSelToggle
229:   Call UpdateSelName
230:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError False, "cmdSelFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

240:   m_pThisExt.ShouldContinue = False
241:   Set m_pThisExt.frmAddHistogramLayerReturn = Nothing
242:   Set m_pReturnArray = Nothing
243:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  Dim pUnknown As IUnknown
254:   Set m_pReturnArray = New esriSystem.VarArray
  
  ' RETURN ARRAY:
  ' 0) LONG; 1 FOR RASTER, 2 FOR FEATURE
  '  --> IF 1:
  '   1) SELECTED RASTER BAND
  '   2) NAME OF SELECTED RASTER BAND
  '   3) BOOLEAN; WHETHER RASTER BAND HAS ATTRIBUTE TABLE
  '   4) DOUBLE; RASTER SUB-SAMPLE PROPORTION
  '  --> IF 2:
  '   1) SELECTED FEATURE LAYER OR TABLE
  '   2) SELECTED VALUE FIELD
  '   3) DATA NAME, MADE OF [LAYER NAME]:[FIELD NAME]
  '   4) BOOLEAN; WHETHER TO WEIGHT FEATURES BY SIZE
  '   5) BOOLEAN; WHETHER TO DO ALL RECORDS
  
  ' DETERMINE WHETHER ADDING RASTER OR VECTOR
  Dim lngTabIndex As Long
272:   lngTabIndex = TabStrip1.SelectedItem.Index
273:   m_pReturnArray.Add lngTabIndex
  
  Select Case lngTabIndex
    Case 1   ' ADDING A RASTER BAND
      Dim pRastBand As IRasterBand
278:       Set pRastBand = m_pRasterBandArray.Element(lbxRasters.ListIndex)
279:       m_pReturnArray.Add pRastBand
280:       m_pReturnArray.Add lbxRasters.List(lbxRasters.ListIndex)
281:       m_pReturnArray.Add m_booRasterHasTable
282:       If m_booRasterHasTable Then
283:         m_pReturnArray.Add 100
284:       Else
285:         m_pReturnArray.Add m_dblRasterSampleProportion
286:       End If
      
    Case 2
289:       Set pUnknown = m_pLayerArray.Element(lbxLayers.ListIndex)
      Dim pField As IField
      Dim booWeightFeature As Boolean
      
293:       If TypeOf pUnknown Is IFeatureLayer Then
        Dim pFLayer As IFeatureLayer
        Dim pFClass As IFeatureClass
        
297:         Set pFLayer = pUnknown
298:         Set pFClass = pFLayer.FeatureClass
        
        Select Case pFClass.ShapeType
          Case 1              ' POINT
302:             booWeightFeature = False
          Case 2              ' MULTIPOINT
304:             booWeightFeature = CBool(chkWeight.Value = 1)
          Case 3              ' POLYLINE
306:             booWeightFeature = CBool(chkWeight.Value = 1)
          Case 4              ' POLYGON
308:             booWeightFeature = CBool(chkWeight.Value = 1)
          Case Else
310:             booWeightFeature = False
311:         End Select
        
313:         m_pReturnArray.Add pFLayer
        
315:         Set pField = m_pLayerFields.Element(lbxFields.ListIndex)
316:         m_pReturnArray.Add pField
        
318:         If pField.AliasName = "" Then
319:           m_pReturnArray.Add pFLayer.Name & ":" & pField.Name
320:         Else
321:           m_pReturnArray.Add pFLayer.Name & ":" & pField.AliasName
322:         End If
        
324:       Else
      
        Dim pStTable As IStandaloneTable
327:         Set pStTable = pUnknown
328:         m_pReturnArray.Add pStTable
        
330:         Set pField = m_pLayerFields.Element(lbxFields.ListIndex)
331:         m_pReturnArray.Add pField
        
333:         If pField.AliasName = "" Then
334:           m_pReturnArray.Add pStTable.Name & ":" & pField.Name
335:         Else
336:           m_pReturnArray.Add pStTable.Name & ":" & pField.AliasName
337:         End If
338:         booWeightFeature = False
339:       End If
      
341:       m_pReturnArray.Add booWeightFeature
342:       m_pReturnArray.Add optAll.Value
    Case 3

345:   End Select
 
347:   m_pThisExt.ShouldContinue = True

  Dim pSaveArray As esriSystem.IVariantArray
350:   Set pSaveArray = New esriSystem.VarArray
  Dim lngIndex As Long
352:   For lngIndex = 0 To m_pReturnArray.Count - 1
353:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
354:   Next lngIndex
355:   Set m_pThisExt.frmAddHistogramLayerReturn = pSaveArray
356:   Unload Me
      
'  Me.Visible = False
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
368:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
369:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
370:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
372:   lngTopBar = Me.Height - Me.ScaleHeight
373:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
  
375:   frmRasters.Top = frmFeatures.Top
376:   frmRasters.Left = frmFeatures.Left
377:   Set Anchors = New AnchorObjectList  ' Create new instance
378:    With Anchors
379:       With .Item(cmdCalculate)
380:          .SetAnchors enumSizeEnd, enumSizeEnd
381:       End With
382:       With .Item(cmdCancel)
383:          .SetAnchors enumSizeEnd, enumSizeEnd
384:       End With
385:       With .Item(cmdManual)
386:          .SetAnchors enumSizeEnd, enumSizeEnd
387:       End With
388:       With .Item(cmdOK)
389:          .SetAnchors enumSizeEnd, enumSizeEnd
390:       End With
391:       With .Item(frmFeatures)
392:          .SetAnchors enumStartEnd, enumStartEnd
393:       End With
394:       With .Item(frmRasters)
395:          .SetAnchors enumStartEnd, enumStartEnd
396:       End With
397:       With .Item(TabStrip1)
398:          .SetAnchors enumStartEnd, enumStartEnd
399:       End With
400:       With .Item(imgBackMiddle)
401:          .SetAnchors enumStartEnd, enumSizeEnd
402:       End With
403:       With .Item(imgCornerBars)
404:          .SetAnchors enumSizeEnd, enumSizeEnd
405:       End With
406:       With .Item(imgFeatureBack)
407:          .SetAnchors enumStartEnd, enumStartEnd
408:       End With
409:       With .Item(imgRasterBack)
410:          .SetAnchors enumStartEnd, enumStartEnd
411:       End With
412:       With .Item(chkWeight)
413:          .SetAnchors enumStartEnd, enumSizeEnd
414:       End With
415:       With .Item(imgWeightBack)
416:          .SetAnchors enumStartEnd, enumSizeEnd
417:       End With
418:       With .Item(imgRastOptions)
419:          .SetAnchors enumStartEnd, enumSizeEnd
420:       End With
421:       With .Item(lbl0Percent)
422:          .SetAnchors enumSize, enumSizeEnd
423:       End With
424:       With .Item(lbl100)
425:          .SetAnchors enumSize, enumSizeEnd
426:       End With
427:       With .Item(lbl25)
428:          .SetAnchors enumSize, enumSizeEnd
429:       End With
430:       With .Item(lbl50)
431:          .SetAnchors enumSize, enumSizeEnd
432:       End With
433:       With .Item(lbl75)
434:          .SetAnchors enumSize, enumSizeEnd
435:       End With
436:       With .Item(lblFields)
437:          .SetAnchors enumSize, enumStartsize
438:       End With
439:       With .Item(lblHasTable1)
440:          .SetAnchors enumStartsize, enumSizeEnd
441:       End With
442:       With .Item(lblHasTable2)
443:          .SetAnchors enumStartsize, enumSizeEnd
444:       End With
445:       With .Item(lblLayer)
446:          .SetAnchors enumSize, enumStartsize
447:       End With
448:       With .Item(lblRasters)
449:          .SetAnchors enumSize, enumStartsize
450:       End With
451:       With .Item(lblSubSample)
452:          .SetAnchors enumStartsize, enumSizeEnd
453:       End With
454:       With .Item(lbxFields)
455:          .SetAnchors enumNone, enumStartEnd
456:       End With
457:       With .Item(lbxLayers)
458:          .SetAnchors enumNone, enumStartEnd
459:       End With
460:       With .Item(lbxRasters)
461:          .SetAnchors enumStartEnd, enumStartEnd
462:       End With
463:       With .Item(optAll)
464:          .SetAnchors enumSize, enumSizeEnd
465:       End With
466:       With .Item(optSel)
467:          .SetAnchors enumSize, enumSizeEnd
468:       End With
469:       With .Item(txtMessage)
470:          .SetAnchors enumStartEnd, enumStartsize
471:       End With
472:       With .Item(txtSampleSize)
473:          .SetAnchors enumStartEnd, enumSizeEnd
474:       End With
475:       With .Item(sldSampleSize)
476:          .SetAnchors enumStartEnd, enumSizeEnd
477:       End With
478:       .Form = Me  ' Set form reference (suggested to be last step)
479:    End With


482:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
492:   Set m_pMxDoc = Nothing
493:   Set m_pApp = Nothing
494:   Set Anchors = Nothing
495:   Set m_pLayerArray = Nothing
496:   Set m_pLayerFields = Nothing
497:   Set m_pThisExt = Nothing
498:   Set m_pReturnArray = Nothing
499:   Set m_pRasterBandArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxFields_Click()
  On Error GoTo ErrorHandler
 
509:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError True, "lbxFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxLayers_Click()
  On Error GoTo ErrorHandler

  Dim pUnknown As IUnknown
520:   Set pUnknown = m_pLayerArray.Element(lbxLayers.ListIndex)
  Dim pFields As IFields
  Dim pField As IField
  Dim pFieldInfo As IFieldInfo
  Dim pTableFields As ITableFields
  Dim pTable As ITable
  
  Dim strShapeType As String
  
529:   If TypeOf pUnknown Is IFeatureLayer Then
    Dim pFeatureLayer As IFeatureLayer
531:     Set pFeatureLayer = m_pLayerArray.Element(lbxLayers.ListIndex)

    Dim pFeatureClass As IFeatureClass
534:     Set pFeatureClass = pFeatureLayer.FeatureClass

    ' UPDATE FIELD LISTBOX
537:     Set pTableFields = pFeatureLayer
538:     Set pFields = pFeatureClass.Fields
    
    Select Case pFeatureClass.ShapeType
      Case 1
542:         strShapeType = "Points"
543:         chkWeight.Enabled = False
544:         chkWeight.Caption = "Unable to weight points by size..."
      Case 2
546:         strShapeType = "Multipoints"
547:         chkWeight.Enabled = True
548:         chkWeight.Caption = "Weight Multipoints by Point Count"
      Case 3
550:         strShapeType = "Polylines"
551:         chkWeight.Enabled = True
552:         chkWeight.Caption = "Weight Polylines by Length"
      Case 4
554:         strShapeType = "Polygons"
555:         chkWeight.Enabled = True
556:         chkWeight.Caption = "Weight Polygons by Area"
      Case Else
558:         strShapeType = "Features"
559:         chkWeight.Enabled = False
560:         chkWeight.Caption = "Unable to weight features..."
561:     End Select
    
563:   ElseIf TypeOf pUnknown Is IStandaloneTable Then
    Dim pStTab As IStandaloneTable
565:     Set pStTab = m_pLayerArray.Element(lbxLayers.ListIndex)

567:     Set pTable = pStTab.Table

    ' UPDATE FIELD LISTBOX
570:     Set pTableFields = pStTab
571:     Set pFields = pTable.Fields
    
573:     strShapeType = "Records"
574:     chkWeight.Enabled = False
575:     chkWeight.Caption = "Unable to weight table records..."
    
577:   End If

579:   lbxFields.Clear

  Dim pTempFields As esriSystem.IVariantArray
582:   Set pTempFields = Linkages.MyGeneralOperations.ReturnFieldsByType(pFields, m_FieldTypeOption)
583:   Set m_pLayerFields = New esriSystem.VarArray

  Dim lngIndex As Long
  Dim strName As String
  Dim strAlias As String
588:   For lngIndex = 0 To pTempFields.Count - 1
589:     Set pField = pTempFields.Element(lngIndex)
'    If Not StrComp(pField.Name, "Shape_Length", vbTextCompare) = 0 And _
         Not StrComp(pField.Name, "Shape_Area", vbTextCompare) = 0 Then
'      Set pFieldInfo = pTableFields.FieldInfo(pTableFields.FindField(pField.Name))
'      lbxFields.AddItem pFieldInfo.Alias
594:       strName = pField.Name
595:       strAlias = pField.AliasName
596:       If StrComp(strName, strAlias, vbTextCompare) = 0 Then
597:         lbxFields.AddItem strName
598:       Else
599:         lbxFields.AddItem pField.AliasName & "   [aka " & strName & "]"
600:       End If
601:       m_pLayerFields.Add pField
'    End If
603:   Next lngIndex

605:   lbxFields.ListIndex = -1

607:   m_booSelToggle = False
608:   Call UpdateSelName
 
  ' UPDATE CONVERSION OPTIONS
  Dim lngNumRecs As Long
  Dim lngSelRecs As Long
 
  Dim pSelSet As ISelectionSet

616:   If TypeOf pUnknown Is IFeatureLayer Then
617:     lngNumRecs = pFeatureClass.FeatureCount(Nothing)
    Dim pFeatSel As IFeatureSelection
619:     Set pFeatSel = pFeatureLayer
620:     Set pSelSet = pFeatSel.SelectionSet
621:   ElseIf TypeOf pUnknown Is IStandaloneTable Then
    Dim pStTable As IStandaloneTable
623:     Set pStTable = pUnknown
624:     Set pTable = pStTable.Table
625:     lngNumRecs = pTable.RowCount(Nothing)
    Dim pTableSel As ITableSelection
627:     Set pTableSel = pStTable
628:     Set pSelSet = pTableSel.SelectionSet
629:   End If

631:   If Not pSelSet Is Nothing Then
632:     lngSelRecs = pSelSet.Count
633:     optAll.Value = lngSelRecs = 0
634:     optAll.Enabled = True
635:     optSel.Enabled = Not lngSelRecs = 0
636:     optSel.Value = Not lngSelRecs = 0
637:     optAll.Caption = "Analyze All " & strShapeType & " (n = " & CStr(lngNumRecs) & ")"
638:     optSel.Caption = "Analyze Only Selected " & strShapeType & " (n = " & CStr(lngSelRecs) & ")"
639:   Else
640:     optAll.Value = True
641:     optAll.Enabled = True
642:     optAll.Caption = "Analyze All " & strShapeType & " (n = " & CStr(lngNumRecs) & ")"
643:     optSel.Value = False
644:     optSel.Enabled = False
645:     optSel.Caption = "Unable to get selection..."
646:   End If
 
648:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 


Private Sub optAll_Click()
  On Error GoTo ErrorHandler
 
660:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError True, "optAll_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub optSel_Click()
  On Error GoTo ErrorHandler
 
670:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError True, "optSel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmAddHistogramLayerReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmAddHistogramLayerReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmAddHistogramLayerReturn(pfrmAddHistogramLayerReturn As esriSystem.IVariantArray)
  '  Set m_pfrmAddHistogramLayerReturn = pfrmAddHistogramLayerReturn
  'End Property
  '
  'Public Property Get frmAddHistogramLayerReturn() As esriSystem.IVariantArray
  '  Set frmAddHistogramLayerReturn = m_pfrmAddHistogramLayerReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenPointLayers + ENUM_jenPolylineLayers + ENUM_jenPolygonLayers + ENUM_jenStandaloneTables
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmAddHistogramLayerReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    Dim pFieldTypes As JenFieldTypes
'    pFieldTypes =  ENUM_FieldNumber
'    pVarArray.Add pFieldTypes
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As Linkages.frmAddHistogramLayer
'    Set pForm = New Linkages.frmAddHistogramLayer
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmAddHistogramLayerReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'
'    ' SELECTED FIELD OR FIELDS
'    Dim pSelFields As esriSystem.IVariantArray
'    Set pSelFields = pReturnArray.Element(1)
'    strReport = strReport & CStr(pSelFields.Count) & " fields selected..." & vbNewLine
'
'    Dim pField As IField
'    Set pField = pSelFields.Element(0)
'    strReport = strReport & "First Selected Field is named '" & pField.Name & "'" & vbNewLine
'
'    ' OPTION TO DO ALL OR SELECTED
'    Dim booDoAll As Boolean
'    booDoAll = pReturnArray.Element(2)
'    strReport = strReport & "Do All Records = " & UCase(CStr(booDoAll)) & vbNewLine
'


'  ' CODE SNIPPET TO USE pFieldNamePairs TO TRANSFER ATTRIBUTE DATA FROM OLD SOURCE TO NEW SOURCE
'  ' MAKE IVariantArray OF FIELD NAME INDICES
'  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
'  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
'  '                     1) ORIGINAL FCLASS FIELD INDEX
'  '                     2) NEW FCLASS FIELD NAME
'  '                     3) NEW FCLASS FIELD INDEX
'  Dim pFieldNamePairs As esriSystem.IVariantArray
'  Set pFieldNamePairs = pOutputArray.Element(9)
'  Dim pFieldNameData As esriSystem.IVariantArray
'  Set pFieldNameData = Linkages.MyGeneralOperations.MakeFieldNameVarArray(pFeatureClass, pNewFClass, pFieldNamePairs, True)
'  Dim lngFieldIndex As Long
'  Dim pFieldSubArray As esriSystem.IVariantArray
'  ' ROTATE THROUGH ALL FEATURES / ROWS
'    ' TRANSFER ATTRIBUTE DATA; ASSUMES pBuffer ALREADY EXISTS
'    For lngFieldIndex = 0 To pFieldNameData.Count - 1
'      Set pFieldSubArray = pFieldNameData.Element(lngFieldIndex)
'      pBuffer.Value(pFieldSubArray.Element(3)) = pFeature.Value(pFieldSubArray.Element(1))
'    Next lngFieldIndex
'  ' LOOP

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub

Private Sub lbxRasters_Click()
  On Error GoTo ErrorHandler

  
959:   If m_pRasterBandArray.Count = 0 Then

961:     lblSubSample.Visible = False
962:     txtSampleSize.Visible = False
963:     cmdCalculate.Visible = False
964:     sldSampleSize.Visible = False
965:     lbl0Percent.Visible = False
966:     lbl25.Visible = False
967:     lbl50.Visible = False
968:     lbl75.Visible = False
969:     lbl100.Visible = False
970:     lblHasTable1.Visible = True
971:     lblHasTable2.Visible = False
972:     lblHasTable1.Caption = "No rasters available in map..."
  
974:   Else
    Dim pRasterBand As IRasterBand
    Dim pTable As ITable
977:     Set pRasterBand = m_pRasterBandArray.Element(lbxRasters.ListIndex)
978:     Set pTable = pRasterBand.AttributeTable
979:     m_booRasterHasTable = Not pTable Is Nothing
  '  pRasterBand.HasTable (m_booRasterHasTable)

982:     lblSubSample.Visible = Not m_booRasterHasTable
983:     txtSampleSize.Visible = Not m_booRasterHasTable
984:     cmdCalculate.Visible = Not m_booRasterHasTable
985:     sldSampleSize.Visible = Not m_booRasterHasTable
986:     lbl0Percent.Visible = Not m_booRasterHasTable
987:     lbl25.Visible = Not m_booRasterHasTable
988:     lbl50.Visible = Not m_booRasterHasTable
989:     lbl75.Visible = Not m_booRasterHasTable
990:     lbl100.Visible = Not m_booRasterHasTable
991:     lblHasTable1.Visible = m_booRasterHasTable
992:     lblHasTable2.Visible = m_booRasterHasTable
993:     lblHasTable1.Caption = "Raster has Attribute Table..."
    
995:     If Not m_booRasterHasTable Then
    
      Dim pRastProps As IRasterProps
998:       Set pRastProps = pRasterBand
999:       m_lngRasterCellCount = pRastProps.Height * pRastProps.Width
1000:       cmdCalculate_Click
1001:     End If
1002:   End If
  
1004:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxRasters_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCalculate_Click()
  On Error GoTo ErrorHandler

  
1015:   m_dblRasterSampleProportion = Round(25000000 / m_lngRasterCellCount, 1)
  
1017:   If m_dblRasterSampleProportion < 0.1 Then
1018:     m_dblRasterSampleProportion = 0.1
1019:   End If
  
1021:   If m_dblRasterSampleProportion > 100 Then
1022:     m_dblRasterSampleProportion = 100
1023:   End If
  
1025:   sldSampleSize.Value = m_dblRasterSampleProportion * 10
1026:   SetSampleSizeText
  
1028:   CheckEnable
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCalculate_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub SetSampleSizeText()
  On Error GoTo ErrorHandler


1040:   txtSampleSize.Text = "Sample Size at " & CStr(Format(m_dblRasterSampleProportion, "0.0")) & "% = " & _
      CStr(Format((m_lngRasterCellCount * m_dblRasterSampleProportion / 100), "#,##0"))
      

  Exit Sub
ErrorHandler:
  HandleError False, "SetSampleSizeText " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub sldSampleSize_Click()
  On Error GoTo ErrorHandler

1052:   m_dblRasterSampleProportion = sldSampleSize.Value / 10
1053:   SetSampleSizeText

  Exit Sub
ErrorHandler:
  HandleError True, "sldSampleSize_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub sldSampleSize_Scroll()
  On Error GoTo ErrorHandler


1064:   m_dblRasterSampleProportion = sldSampleSize.Value / 10
1065:   SetSampleSizeText

  Exit Sub
ErrorHandler:
  HandleError True, "sldSampleSize_Scroll " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub TabStrip1_Click()
  On Error GoTo ErrorHandler

  Select Case TabStrip1.SelectedItem.Index
    Case 1
1077:       frmFeatures.Visible = False
1078:       frmRasters.Visible = True
    Case 2
1080:       frmFeatures.Visible = True
1081:       frmRasters.Visible = False
    Case 3

1084:   End Select
1085:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "TabStrip1_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
 
  Select Case TabStrip1.SelectedItem.Index
    Case 1
1096:       cmdOK.Enabled = lbxRasters.SelCount > 0
    Case 2
1098:       cmdOK.Enabled = lbxLayers.SelCount > 0 And lbxFields.SelCount > 0
    Case 3

1101:   End Select
  
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
