VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmBottleneck 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Describe Bottlenecks:"
   ClientHeight    =   4485
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9945
   Icon            =   "frmBottleneck.frx":0000
   LinkTopic       =   "frmBottleneck"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4485
   ScaleWidth      =   9945
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdManual 
      Caption         =   "Open Manual"
      Height          =   345
      Left            =   495
      TabIndex        =   13
      Top             =   4125
      Width           =   1335
   End
   Begin RichTextLib.RichTextBox rtbHelp 
      Height          =   2460
      Left            =   30
      TabIndex        =   12
      Top             =   1635
      Width           =   5700
      _ExtentX        =   10054
      _ExtentY        =   4339
      _Version        =   393217
      ScrollBars      =   2
      TextRTF         =   $"frmBottleneck.frx":038A
   End
   Begin VB.CommandButton cmdSelLink 
      Caption         =   "Select"
      Height          =   255
      Left            =   4830
      TabIndex        =   5
      Top             =   1185
      Width           =   750
   End
   Begin VB.ComboBox cbxCorridor 
      Height          =   315
      Left            =   2325
      Style           =   2  'Dropdown List
      TabIndex        =   4
      Top             =   1155
      Width           =   2400
   End
   Begin VB.CommandButton cmdSel2 
      Caption         =   "Select"
      Height          =   255
      Left            =   4830
      TabIndex        =   3
      Top             =   720
      Width           =   750
   End
   Begin VB.ComboBox cbxHab2 
      Height          =   315
      Left            =   1875
      Style           =   2  'Dropdown List
      TabIndex        =   2
      Top             =   690
      Width           =   2850
   End
   Begin VB.CommandButton cmdSel1 
      Caption         =   "Select"
      Height          =   255
      Left            =   4830
      TabIndex        =   1
      Top             =   255
      Width           =   750
   End
   Begin VB.ComboBox cbxHab1 
      Height          =   315
      Left            =   1875
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   225
      Width           =   2850
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Show Help >>"
      Height          =   345
      Left            =   3945
      TabIndex        =   8
      Top             =   4125
      Width           =   1275
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   345
      Left            =   2835
      TabIndex        =   7
      Top             =   4125
      Width           =   1095
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1845
      TabIndex        =   6
      Top             =   4125
      Width           =   975
   End
   Begin VB.Image imgUnCheckSpCorr 
      Height          =   375
      Left            =   90
      Picture         =   "frmBottleneck.frx":0415
      Top             =   1110
      Width           =   375
   End
   Begin VB.Image imgUnCheckWB2 
      Height          =   375
      Left            =   90
      Picture         =   "frmBottleneck.frx":0489
      Top             =   645
      Width           =   375
   End
   Begin VB.Image imgUnCheckWB1 
      Height          =   375
      Left            =   90
      Picture         =   "frmBottleneck.frx":04FD
      Top             =   180
      Width           =   375
   End
   Begin VB.Image imgHelp 
      Height          =   4380
      Left            =   5760
      Picture         =   "frmBottleneck.frx":0571
      Top             =   60
      Width           =   4155
   End
   Begin VB.Image imgCheckSpCorr 
      Height          =   375
      Left            =   90
      Picture         =   "frmBottleneck.frx":3BAB5
      Top             =   1110
      Width           =   375
   End
   Begin VB.Image imgCheckWB2 
      Height          =   375
      Left            =   90
      Picture         =   "frmBottleneck.frx":3BBCC
      Top             =   645
      Width           =   375
   End
   Begin VB.Image imgCheckWB1 
      Height          =   375
      Left            =   90
      Picture         =   "frmBottleneck.frx":3BCE3
      Top             =   180
      Width           =   375
   End
   Begin VB.Shape boxTop 
      Height          =   1560
      Left            =   45
      Top             =   60
      Width           =   5670
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Wildland Block #1:"
      Height          =   195
      Left            =   480
      TabIndex        =   11
      Top             =   255
      Width           =   1365
   End
   Begin VB.Label lbl_cbxCorridor 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Species Corridor Polygon:"
      Height          =   195
      Left            =   480
      TabIndex        =   10
      Top             =   1170
      Width           =   1830
   End
   Begin VB.Label lbl_cbxHab2 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Wildland Block #2:"
      Height          =   195
      Left            =   480
      TabIndex        =   9
      Top             =   720
      Width           =   1365
   End
End
Attribute VB_Name = "frmBottleneck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
' PUT IN GENERAL DECLARATIONS SECTION
Private Anchors As AnchorObjectList  ' Main anchor control object
Const conHwndTopmost = -1
Const conHwndNoTopmost = -2
Const conSwpNoActivate = &H10
Const conSwpShowWindow = &H40

Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_Frame As IModelessFrame
'Private m_WindowPos As IWindowPosition
Private m_ExtensionConfig As IExtensionConfig
Private m_strNameArray() As String
Private m_intNameCount As Integer
Private m_colPolygons As Collection
Private m_booHelpToggle As Boolean
Private m_IntHelpCategory As Integer
Private m_colFieldNames As Collection
Public m_lngWB1Count As Long
Public m_lngWB2Count As Long
Public m_lngCorrCount As Long
Public m_booIsDemo As Boolean

Const c_sModuleFileName As String = "...\frmBottleneck.frm"

Public Property Let IsDemo(booIsDemo As Boolean)
  On Error GoTo ErrorHandler

30:   m_booIsDemo = booIsDemo

  Exit Property
ErrorHandler:
  HandleError True, "IsDemo " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set ArcApplication(ByVal theApplication As IApplication)
  On Error GoTo ErrorHandler


41:   Set m_pApp = theApplication


  Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Function Frame() As IModelessFrame
  On Error GoTo ErrorHandler

52:   If m_Frame Is Nothing Then
53:     Set m_Frame = New ModelessFrame
54:     m_Frame.Create Me
'    Set m_WindowPos = m_Frame
'    MsgBox m_WindowPos.Width & "    x    " & m_WindowPos.Height
57:   End If

59:   Set Frame = m_Frame

  Exit Function
ErrorHandler:
  HandleError True, "Frame " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Property Set Doc(pDoc As esriArcMapUI.IMxDocument)
  On Error GoTo ErrorHandler

69:   Set m_pMxDoc = pDoc

  Exit Property
ErrorHandler:
  HandleError True, "Doc " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Sub cbxCorridor_Click()
  On Error GoTo ErrorHandler
    
  Dim ext As Linkages.clsExtension
80:   Set ext = m_ExtensionConfig
  
  Dim lngIndex As Long
83:   lngIndex = cbxCorridor.ListIndex
  
85:   Set ext.PolyCorridor = Nothing
  
87:   If lngIndex >= 2 Then
    Dim strLayerName As String
89:     strLayerName = cbxCorridor.List(lngIndex)
    
    Dim pFeatureLayer As IFeatureLayer
92:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
    
    Dim pFeatureCursor As IFeatureCursor
95:     Set pFeatureCursor = pFeatureLayer.Search(Nothing, True)
    
    Dim pFeature As IFeature
98:     Set pFeature = pFeatureCursor.NextFeature
    
    Dim pGeometry As IGeometry
101:     Set pGeometry = pFeature.ShapeCopy
    
103:     If TypeOf pGeometry Is IPolygon Then
      
      Dim pPolygon As IPolygon
106:       Set pPolygon = pGeometry
      
108:       Set ext.PolyCorridor = pPolygon
109:       m_lngCorrCount = pFeatureLayer.FeatureClass.FeatureCount(Nothing)
110:     End If
111:   End If
112:   cbxCorridor.BackColor = vbWhite
113:   Call UpdateCheckmarks
114:   Call UpdateSelectButtons
115:   Call EnableOKButton

  Exit Sub
ErrorHandler:
  HandleError True, "cbxCorridor_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxCorridor_GotFocus()
  On Error GoTo ErrorHandler


126:   m_IntHelpCategory = 1
127:   Call UpdateHelpScreen

  Exit Sub
ErrorHandler:
  HandleError True, "cbxCorridor_GotFocus " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxHab1_Click()
  On Error GoTo ErrorHandler
136:   m_IntHelpCategory = 1
137:   Call UpdateHelpScreen
    
  Dim ext As Linkages.clsExtension
140:   Set ext = m_ExtensionConfig
  
  Dim lngIndex As Long
143:   lngIndex = cbxHab1.ListIndex
  
145:   Set ext.PolyWildland1 = Nothing
  
147:   If lngIndex >= 2 Then
    Dim strLayerName As String
149:     strLayerName = cbxHab1.List(lngIndex)
    
    Dim pFeatureLayer As IFeatureLayer
152:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
    
    Dim pFeatureCursor As IFeatureCursor
155:     Set pFeatureCursor = pFeatureLayer.Search(Nothing, True)
    
    Dim pFeature As IFeature
158:     Set pFeature = pFeatureCursor.NextFeature
    
    Dim pGeometry As IGeometry
161:     Set pGeometry = pFeature.ShapeCopy
    
163:     If TypeOf pGeometry Is IPolygon Then

      Dim pPolygon As IPolygon
166:       Set pPolygon = pGeometry
      
168:       Set ext.PolyWildland1 = pPolygon
169:       m_lngWB1Count = pFeatureLayer.FeatureClass.FeatureCount(Nothing)
170:     End If
    
172:   End If
173:   cbxHab1.BackColor = vbWhite
174:   Call UpdateCheckmarks
175:   Call UpdateSelectButtons
176:   Call EnableOKButton

  Exit Sub
ErrorHandler:
  HandleError True, "cbxHab1_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxHab1_GotFocus()
  On Error GoTo ErrorHandler

186:   m_IntHelpCategory = 1
187:   Call UpdateHelpScreen

  Exit Sub
ErrorHandler:
  HandleError True, "cbxHab1_GotFocus " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxHab2_Click()
  On Error GoTo ErrorHandler
    
  Dim ext As Linkages.clsExtension
198:   Set ext = m_ExtensionConfig
  
  Dim lngIndex As Long
201:   lngIndex = cbxHab2.ListIndex
  
203:   Set ext.PolyWildland2 = Nothing
  
205:   If lngIndex >= 2 Then
    Dim strLayerName As String
207:     strLayerName = cbxHab2.List(lngIndex)
    
    Dim pFeatureLayer As IFeatureLayer
210:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
    
    Dim pFeatureCursor As IFeatureCursor
213:     Set pFeatureCursor = pFeatureLayer.Search(Nothing, True)
    
    Dim pFeature As IFeature
216:     Set pFeature = pFeatureCursor.NextFeature
    
    Dim pGeometry As IGeometry
219:     Set pGeometry = pFeature.ShapeCopy
    
221:     If TypeOf pGeometry Is IPolygon Then

      Dim pPolygon As IPolygon
224:       Set pPolygon = pGeometry
      
226:       Set ext.PolyWildland2 = pPolygon
227:       m_lngWB2Count = pFeatureLayer.FeatureClass.FeatureCount(Nothing)
228:     End If
229:   End If
230:   cbxHab2.BackColor = vbWhite
231:   Call UpdateCheckmarks
232:   Call UpdateSelectButtons
233:   Call EnableOKButton

  Exit Sub
ErrorHandler:
  HandleError True, "cbxHab2_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cbxHab2_GotFocus()
  On Error GoTo ErrorHandler


244:   m_IntHelpCategory = 1
245:   Call UpdateHelpScreen

  Exit Sub
ErrorHandler:
  HandleError True, "cbxHab2_GotFocus " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

  '  ORIGINAL AVENUE CODE
  '  ' Jennessent.CompareParametersCancel
  '
  '  self.GetDialog.SetModalResult(nil)
  '  self.GetDialog.Close
260:   Unload Me
  
  '

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdHelp_Click()
  On Error GoTo ErrorHandler

  Dim ext As Linkages.clsExtension
273:   Set ext = m_ExtensionConfig
  Dim booHelpToggle As Boolean
275:   booHelpToggle = ext.HelpToggle1
  Dim pWindowPosition As IWindowPosition
277:   Set pWindowPosition = m_Frame
  
279:   If booHelpToggle = False Then
280:     booHelpToggle = True
281:     ext.HelpToggle1 = True
282:     cmdHelp.Caption = "<< Hide Help"
283:     pWindowPosition.Width = 669
284:     pWindowPosition.Height = 323
285:     cmdManual.Top = 4125
286:     cmdCancel.Top = 4125
287:     cmdOK.Top = 4125
288:     cmdHelp.Top = 4125
289:   Else
290:     booHelpToggle = False
291:     ext.HelpToggle1 = False
292:     cmdHelp.Caption = "Show Help >>"
293:     pWindowPosition.Width = 390
294:     pWindowPosition.Height = 160
295:     cmdManual.Top = 1665
296:     cmdCancel.Top = 1665
297:     cmdOK.Top = 1665
298:     cmdHelp.Top = 1665
299:   End If
  
301:   Call UpdateHelpScreen
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdHelp_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub SetBackColorsWhite()
  On Error GoTo ErrorHandler

311:   cbxHab1.BackColor = vbWhite
312:   cbxHab2.BackColor = vbWhite
313:   cbxCorridor.BackColor = vbWhite

  Exit Sub
ErrorHandler:
  HandleError False, "SetBackColorsWhite " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler


  Dim strPath As String
325:   strPath = App.Path & "\help"
  
327:   Call Linkages.MyGeneralOperations.OpenDoc("Bottleneck_Subdocument.pdf", strPath)

  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler
  
337:   Call SetBackColorsWhite
  
  Dim lngIndex As Long
  Dim strLayerName As String
  Dim strLayerName2 As String
  Dim pFeatureLayer As IFeatureLayer
  Dim pFeatureLayer2 As IFeatureLayer
  Dim intHab1Index As Integer
  Dim intHab2Index As Integer
  Dim intCorrIndex As Integer
  Dim strHab1Name As String
  Dim strHab2Name As String
  Dim strCorrName As String
  
351:   intHab1Index = cbxHab1.ListIndex
352:   intHab2Index = cbxHab2.ListIndex
353:   intCorrIndex = cbxCorridor.ListIndex
  
  Dim pRelOp As IRelationalOperator
  Dim ext As Linkages.clsExtension
357:   Set ext = m_ExtensionConfig
  
  Dim pHabPoly1 As IPolygon
360:       Set pHabPoly1 = ext.PolyWildland1
  Dim pHabPoly2 As IPolygon
362:       Set pHabPoly2 = ext.PolyWildland2
  Dim pCorrPoly As IPolygon
364:       Set pCorrPoly = ext.PolyCorridor
  
  Dim boo1And2 As Boolean           '  SHOULD BE FALSE
  Dim boo1AndCorr As Boolean        '  SHOULD BE TRUE
  Dim boo2AndCorr As Boolean        '  SHOULD BE TRUE
  
  ' FIRST PUT ALL 3 POLYGONS INTO SAME SPATIAL REFERENCE AS pCorrPoly
  Dim pSpRefHab1 As ISpatialReference
372:   Set pSpRefHab1 = pHabPoly1.SpatialReference
  Dim pSpRefHab2 As ISpatialReference
374:   Set pSpRefHab2 = pHabPoly2.SpatialReference
  Dim pSpRefCorr As ISpatialReference
376:   Set pSpRefCorr = pCorrPoly.SpatialReference
  
378:   If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRefCorr, pSpRefHab1) Then
379:     pHabPoly1.Project pSpRefCorr
380:     Set ext.PolyWildland1 = pHabPoly1
381:   End If
  
383:   If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRefCorr, pSpRefHab2) Then
384:     pHabPoly2.Project pSpRefCorr
385:     Set ext.PolyWildland2 = pHabPoly2
386:   End If
  
'  MsgBox "pHabPoly1 is nothing? " & CStr(pHabPoly1 Is Nothing) & vbCrLf & _
      "      Length? " & CStr(pHabPoly1.length) & vbCrLf & _
      "      SR? " & pHabPoly1.SpatialReference.Name & vbCrLf & _
      "pHabPoly2 is nothing? " & CStr(pHabPoly2 Is Nothing) & vbCrLf & _
      "      Length? " & CStr(pHabPoly2.length) & vbCrLf & _
      "      SR? " & pHabPoly2.SpatialReference.Name & vbCrLf & _
      "pCorrPoly is nothing? " & CStr(pCorrPoly Is Nothing) & vbCrLf & _
      "      Length? " & CStr(pCorrPoly.length) & vbCrLf & _
      "      SR? " & pCorrPoly.SpatialReference.Name

398:   Set pRelOp = pHabPoly1
399:   boo1And2 = Not pRelOp.Disjoint(pHabPoly2) ' (pRelOp.Touches(pHabPoly2)) Or (pRelOp.Overlaps(pHabPoly2))
400:   boo1AndCorr = Not pRelOp.Disjoint(pCorrPoly) ' (pRelOp.Touches(pCorrPoly)) Or (pRelOp.Overlaps(pCorrPoly))
  
402:   Set pRelOp = pHabPoly2
403:   boo2AndCorr = Not pRelOp.Disjoint(pCorrPoly) ' (pRelOp.Touches(pCorrPoly)) Or (pRelOp.Overlaps(pCorrPoly))
  
'  MsgBox boo1And2 & vbCrLf & boo1AndCorr & vbCrLf & boo2AndCorr
  
  ' ERROR CHECKING CODE ------------------------------------------------------------
  ' CHECK FOR THEMES WITH MULTIPLE POLYGONS
409:   If m_lngWB1Count = 0 Then
410:     cbxHab1.BackColor = vbYellow
411:     MsgBox "Unable to find a polygon for Wildland Block #1!" & vbCrLf & vbCrLf & _
      "Please re-select your polygon..." _
      , vbOKOnly, "Error Found in Input Data:"
414:     cbxHab1.SetFocus
    Exit Sub
416:   ElseIf m_lngWB1Count > 1 Then
417:     cbxHab1.BackColor = vbYellow
418:     lngIndex = cbxHab1.ListIndex
419:     strLayerName = cbxHab1.List(lngIndex)
420:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
421:     MsgBox "Multiple polygons (" & CStr(m_lngWB1Count) & ") found in Wildland Block #1 Layer '" & _
        pFeatureLayer.Name & "'!" & vbCrLf & vbCrLf & _
       "Please use the ""Select"" button to select a single " & _
       "polygon from this layer...", vbOKOnly, "Error Found in Input Data:"
425:     cbxHab1.SetFocus
    Exit Sub
427:   ElseIf m_lngWB2Count = 0 Then
428:     cbxHab2.BackColor = vbYellow
429:     MsgBox "Unable to find a polygon for Wildland Block #2!" & vbCrLf & vbCrLf & _
      "Please re-select your polygon..." _
      , vbOKOnly, "Error Found in Input Data:"
432:     cbxHab2.SetFocus
    Exit Sub
434:   ElseIf m_lngWB2Count > 1 Then
435:     cbxHab2.BackColor = vbYellow
436:     lngIndex = cbxHab2.ListIndex
437:     strLayerName = cbxHab2.List(lngIndex)
438:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
439:     MsgBox "Multiple polygons (" & CStr(m_lngWB2Count) & ") found in Wildland Block #2 Layer '" & _
        pFeatureLayer.Name & "'!" & vbCrLf & vbCrLf & _
        "Please use the ""Select"" button to select a single " & _
        "polygon from this layer...", vbOKOnly, "Error Found in Input Data:"
443:     cbxHab2.SetFocus
    Exit Sub
445:   ElseIf m_lngCorrCount = 0 Then
446:     cbxCorridor.BackColor = vbYellow
447:     MsgBox "Unable to find a polygon for the Species Corridor Polygon!" & vbCrLf & vbCrLf & _
      "Please re-select your polygon..." _
      , vbOKOnly, "Error Found in Input Data:"
450:     cbxCorridor.SetFocus
    Exit Sub
452:   ElseIf m_lngCorrCount > 1 Then
453:     cbxCorridor.BackColor = vbYellow
454:     lngIndex = cbxCorridor.ListIndex
455:     strLayerName = cbxCorridor.List(lngIndex)
456:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
457:     MsgBox "Multiple polygons (" & CStr(m_lngCorrCount) & ") found in Species Corridor Polygon Layer '" & _
        pFeatureLayer.Name & "'!" & vbCrLf & vbCrLf & _
        "Please use the ""Select"" button to select a single " & _
        "polygon from this layer...", vbOKOnly, "Error Found in Input Data:"
461:     cbxCorridor.SetFocus
    Exit Sub
  
  ' CHECK FOR SAME LAYER SELECTED
465:   ElseIf (intHab1Index > 1) And (intHab2Index > 1) And (intHab1Index = intHab2Index) Then
466:     cbxHab1.BackColor = vbYellow
467:     cbxHab2.BackColor = vbYellow
468:     lngIndex = cbxHab1.ListIndex
469:     strLayerName = cbxHab1.List(lngIndex)
470:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
471:     MsgBox "Both selected Wildland Habitat Block Layers point to the same layer! ('" & _
        pFeatureLayer.Name & "')!" & vbCrLf & vbCrLf & _
        "Please select different layers for each wildland habitat block...", _
        vbOKOnly, "Error Found in Input Data:"
475:     cbxHab1.SetFocus
    Exit Sub
477:   ElseIf (intHab1Index > 1) And (intCorrIndex > 1) And (intHab1Index = intCorrIndex) Then
478:     cbxHab1.BackColor = vbYellow
479:     cbxCorridor.BackColor = vbYellow
480:     lngIndex = cbxHab1.ListIndex
481:     strLayerName = cbxHab1.List(lngIndex)
482:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
483:     MsgBox "Both the Wildland Habitat Block #1 layer and the Species Corridor layer " & _
        "point to the same layer! ('" & _
        pFeatureLayer.Name & "')!" & vbCrLf & vbCrLf & _
        "Please select different layers for these two polygon sources...", _
        vbOKOnly, "Error Found in Input Data:"
488:     cbxHab1.SetFocus
    Exit Sub
490:   ElseIf (intHab2Index > 1) And (intCorrIndex > 1) And (intHab2Index = intCorrIndex) Then
491:     cbxHab2.BackColor = vbYellow
492:     cbxCorridor.BackColor = vbYellow
493:     lngIndex = cbxHab2.ListIndex
494:     strLayerName = cbxHab2.List(lngIndex)
495:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
496:     MsgBox "Both the Wildland Habitat Block #2 layer and the Species Corridor layer " & _
        "point to the same layer! ('" & _
        pFeatureLayer.Name & "')!" & vbCrLf & vbCrLf & _
        "Please select different layers for these two polygon sources...", _
        vbOKOnly, "Error Found in Input Data:"
501:     cbxHab2.SetFocus
    Exit Sub
    
  ' CHECK FOR INTERSECTING POLYGONS
505:   ElseIf boo1And2 Then
506:     cbxHab1.BackColor = vbYellow
507:     cbxHab2.BackColor = vbYellow
508:     lngIndex = cbxHab1.ListIndex
509:     If lngIndex = 1 Then
510:       strHab1Name = "Selected Graphic"
511:     Else
512:       strLayerName = cbxHab1.List(lngIndex)
513:       Set pFeatureLayer = m_colPolygons.Item(strLayerName)
514:       strHab1Name = pFeatureLayer.Name
515:     End If
516:     lngIndex = cbxHab2.ListIndex
517:     If lngIndex = 1 Then
518:       strHab1Name = "Selected Graphic"
519:     Else
520:       strLayerName2 = cbxHab2.List(lngIndex)
521:       Set pFeatureLayer2 = m_colPolygons.Item(strLayerName2)
522:       strHab2Name = pFeatureLayer2.Name
523:     End If

525:     MsgBox "Your Wildland Habitat Block #1 layer ('" & strHab1Name & "') intersects " & _
        "your Wildland Habitat Block #2 layer ('" & strHab2Name & "')!  If this is true, " & _
        "there is no need for a Species Corridor..." & vbCrLf & vbCrLf & _
        "Please select different layers for these two polygon sources...", _
        vbOKOnly, "Error Found in Input Data:"
530:     cbxHab1.SetFocus
    Exit Sub
    
533:   ElseIf Not boo1AndCorr Then
534:     cbxHab1.BackColor = vbYellow
535:     cbxCorridor.BackColor = vbYellow
536:     lngIndex = cbxHab1.ListIndex
537:     If lngIndex = 1 Then
538:       strHab1Name = "Selected Graphic"
539:     Else
540:       strLayerName = cbxHab1.List(lngIndex)
541:       Set pFeatureLayer = m_colPolygons.Item(strLayerName)
542:       strHab1Name = pFeatureLayer.Name
543:     End If

545:     lngIndex = cbxCorridor.ListIndex
546:     If lngIndex = 1 Then
547:       strCorrName = "Selected Graphic"
548:     Else
549:       strLayerName2 = cbxCorridor.List(lngIndex)
550:       Set pFeatureLayer2 = m_colPolygons.Item(strLayerName2)
551:       strCorrName = pFeatureLayer2.Name
552:     End If

554:     MsgBox "Your Wildland Habitat Block #1 layer ('" & strHab1Name & "') does not intersect " & _
        "your Species Corridor layer ('" & strCorrName & "')!  If this is true, " & _
        "then the species corridor polygon cannot connect your two wildland habitat blocks..." & vbCrLf & vbCrLf & _
        "Please select different layers for these two polygon sources...", _
        vbOKOnly, "Error Found in Input Data:"
559:     cbxHab1.SetFocus
    Exit Sub
    
562:   ElseIf Not boo2AndCorr Then
563:     cbxHab2.BackColor = vbYellow
564:     cbxCorridor.BackColor = vbYellow
565:     lngIndex = cbxHab2.ListIndex
566:     If lngIndex = 1 Then
567:       strHab2Name = "Selected Graphic"
568:     Else
569:       strLayerName = cbxHab2.List(lngIndex)
570:       Set pFeatureLayer = m_colPolygons.Item(strLayerName)
571:       strHab2Name = pFeatureLayer.Name
572:     End If

574:     lngIndex = cbxCorridor.ListIndex
575:     If lngIndex = 1 Then
576:       strCorrName = "Selected Graphic"
577:     Else
578:       strLayerName2 = cbxCorridor.List(lngIndex)
579:       Set pFeatureLayer2 = m_colPolygons.Item(strLayerName2)
580:       strCorrName = pFeatureLayer2.Name
581:     End If
582:     MsgBox "Your Wildland Habitat Block #2 layer ('" & strHab2Name & "') does not intersect " & _
        "your Species Corridor layer ('" & strCorrName & "')!  If this is true, " & _
        "then the species corridor polygon cannot connect your two wildland habitat blocks..." & vbCrLf & vbCrLf & _
        "Please select different layers for these two polygon sources...", _
        vbOKOnly, "Error Found in Input Data:"
587:     cbxHab2.SetFocus
    Exit Sub
  
590:   End If
    
592:   If m_booIsDemo Then
593:     Me.Frame.Visible = False
594:     Call Linkages.CorridorAnalysisFunctions.BottleneckAnalysisDemo(m_pApp)
595:     Me.Frame.Visible = True
596:     Unload Me
597:   Else
598:     Call CheckSavedValues
599:   End If
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub CheckSavedValues()
  On Error GoTo ErrorHandler

  Dim ext As Linkages.clsExtension
610:   Set ext = m_ExtensionConfig
  
  Dim pArea1 As IArea
  Dim pPoly1 As IPolygon
  Dim pArea2 As IArea
  Dim pPoly2 As IPolygon
  Dim pArea3 As IArea
  Dim pPoly3 As IPolygon
  
619:   Set pPoly1 = ext.PolyWildland1
620:   Set pArea1 = pPoly1
  
622:   Set pPoly2 = ext.PolyWildland2
623:   Set pArea2 = pPoly2
  
625:   Set pPoly3 = ext.PolyCorridor
626:   Set pArea3 = pPoly3
  
'  Dim strReport As String
'  strReport = "Wildland Block #1 Area = " & CStr(pArea1.Area) & vbCrLf & _
'              "Wildland Block #2 Area = " & CStr(pArea2.Area) & vbCrLf & _
'              "Corridor Area = " & CStr(pArea3.Area)
'  MsgBox strReport
  

  ' GET START AND END NODES - FROM ORIGINAL TEST CODE
  Dim pStartPolygon As IPolygon
  Dim pEndPolygon As IPolygon
638:   Set pStartPolygon = ext.PolyWildland1
639:   Set pEndPolygon = ext.PolyWildland2
  
  Dim pClone As IClone
  
  ' GET CORRIDOR - FROM ORIGINAL TEST CODE
  Dim pCorPolygon As IPolygon
645:   Set pCorPolygon = ext.PolyCorridor
  
  ' ---------------------------------------------------------------------
'  MsgBox "<-- Code in development -->" & vbCrLf & _
         "Please check http://www.corridordesign.org for updates...", , "Function Not Implemented Yet:"
  
  ' PROGRESS METER STUFF ------------------------------------------------------------------
  Dim frmProgress As New frmJenProgressPercent
  Dim theTimeBegan As Date
  Dim theDetailedDescription As String

'  frmProgress.SetExpanded = ext.ProgressDialogSetExpanded
657:   frmProgress.SetExpanded = True
658:   frmProgress.SetAutoClose = ext.ProgressDialogAutoClose

660:   theTimeBegan = Now
661:   frmProgress.ShouldContinue = True
662:   frmProgress.ProgBeginTime = Now
663:   frmProgress.ProgRecCount = 0
664:   frmProgress.lblCurrentTime.Caption = Format(Now, "ttttt")
665:   frmProgress.lblBeginTime.Caption = "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd")

667:   theDetailedDescription = "Analyzing Bottlenecks..." & vbCrLf & _
      "Began Job: " & Format(theTimeBegan, "ttttt,  ddddd") & vbCrLf & _
      "-------------------------------------------" & vbCrLf
670:   frmProgress.txtDetails.Text = theDetailedDescription

672:   frmProgress.Frame.Caption = "Current Status:"
673:   frmProgress.Frame.Visible = True
674:   frmProgress.cmdDetails.Visible = False
675:   frmProgress.cmdStop.Visible = False
  
677:   Me.Frame.Visible = False

'   theProgressTimeCheck = CDate(50000)
  Dim theDescription As String
681:   theDescription = "Analyzing Bottlenecks..."
  ' PROGRESS METER STUFF ------------------------------------------------------------------
  
  Dim pParamDetails As esriSystem.IVariantArray
685:   Set pParamDetails = New esriSystem.VarArray
  
  Dim strLayerName As String
  Dim pFeatureLayer As IFeatureLayer
  Dim lngIndex As Long
   
  ' WILDLAND BLOCK 1
692:   If cbxHab1.ListIndex < 2 Then
693:     pParamDetails.Add "Selected Specific Polygon from Map..."
694:   Else
695:     strLayerName = cbxHab1.List(cbxHab1.ListIndex)
696:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
697:     pParamDetails.Add pFeatureLayer.Name
698:   End If
  
  ' WILDLAND BLOCK 2
701:   If cbxHab2.ListIndex < 2 Then
702:     pParamDetails.Add "Selected Specific Polygon from Map..."
703:   Else
704:     strLayerName = cbxHab2.List(cbxHab2.ListIndex)
705:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
706:     pParamDetails.Add pFeatureLayer.Name
707:   End If
  
  ' CORRIDOR POLYGON
710:   If cbxCorridor.ListIndex < 2 Then
711:     pParamDetails.Add "Selected Specific Polygon from Map..."
712:   Else
713:     strLayerName = cbxCorridor.List(cbxCorridor.ListIndex)
714:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
715:     pParamDetails.Add pFeatureLayer.Name
716:   End If

718:   ext.ProgressDialogAutoClose = (frmProgress.chkClose.Value = 1)
719:   ext.ProgressDialogSetExpanded = (frmProgress.SetExpanded)
  
'  Exit Sub
  
  ' CALL ANALYSIS MODULE
724:   Linkages.CorridorAnalysisFunctions.BottleneckAnalysis pParamDetails, m_pMxDoc, m_pApp, _
      pCorPolygon, pStartPolygon, pEndPolygon, frmProgress

'  If frmProgress.chkClose.Value = 1 Then
'    Unload frmProgress
'    Set frmProgress = Nothing
'  End If
  
732:   Me.Frame.Visible = True

734:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckSavedValues " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdSel1_Click()
  On Error GoTo ErrorHandler

  Dim frmSelect As Linkages.frmSelScreen
    
  Dim ext As Linkages.clsExtension
747:   Set ext = m_ExtensionConfig
  
  Dim theFormObject As Object
750:   Set theFormObject = ext.aSelForm
  
752:   If (theFormObject Is Nothing) Then
753:     Set frmSelect = New Linkages.frmSelScreen
  
    ' IDENTIFY POLYGON THEMES AND GRAPHICS
    Dim pMxDoc As IMxDocument
757:     Set pMxDoc = m_pMxDoc
  
    Dim colPolygonLayers As New Collection
    Dim strNameArray() As String
    
    Dim theMap As IMap
    Dim pEnumLayer As IEnumLayer
    Dim pFeatureLayer As IFeatureLayer
    Dim pLayer As IUnknown
    Dim anIndex As Long
    Dim strPolyName As String
    Dim intKey As Integer
    
    Dim pFeatureClass As IFeatureClass
    Dim pGeometryType As esriGeometryType
    
773:     intKey = -1
    
775:     Set theMap = pMxDoc.FocusMap
    
    ' CHECK IF GRAPHICS LAYER IS AVAILABLE
    Dim pGraphicsContainer As IGraphicsContainer
779:     Set pGraphicsContainer = theMap
    
    Dim pEnvelope As IEnvelope
782:     Set pEnvelope = pMxDoc.ActiveView.FullExtent
    Dim pEnumElement As IEnumElement
    
785:     Set pEnumElement = pGraphicsContainer.LocateElementsByEnvelope(pEnvelope)
'    MsgBox (pEnumElement Is Nothing)
    
    Dim booHasPolygon As Boolean
789:     booHasPolygon = True
    
'    ReDim strNameArray(theMap.LayerCount)
    
    ReDim strNameArray(Linkages.MyGeneralOperations.TrueLayerCount(theMap))
    
795:     If (booHasPolygon) Then
796:       intKey = intKey + 1
797:       strPolyName = "1] <-- Select or Draw Graphic Polygon -->"
798:       colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
799:       strNameArray(intKey) = strPolyName
800:     End If
            
    Dim pFeatureLayerForValid As IFeatureLayer
    
804:     If (theMap.LayerCount > 0) Then
805:       Set pEnumLayer = theMap.Layers(, True)
806:       pEnumLayer.Reset
      
808:       Set pLayer = pEnumLayer.Next
809:       Do Until pLayer Is Nothing
810:         If TypeOf pLayer Is IFeatureLayer Then
811:           Set pFeatureLayerForValid = pLayer
          ' CHECK IF FEATURE LAYER IS VALID
813:           If pFeatureLayerForValid.Valid Then
            ' CHECK IF POLYGON LAYER
815:             Set pFeatureClass = pFeatureLayerForValid.FeatureClass
816:             pGeometryType = pFeatureClass.ShapeType
817:             If (pGeometryType = esriGeometryPolygon) Then
818:               intKey = intKey + 1
819:               Set pFeatureLayer = pLayer
820:               strPolyName = CStr(intKey + 1) & "] " & pFeatureLayer.Name
821:               colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
822:               strNameArray(intKey) = strPolyName
823:             End If
824:           End If
825:         End If
826:         Set pLayer = pEnumLayer.Next
827:       Loop
828:     End If
           
'    Dim theReport As String
'    For anIndex = 0 To intKey
'      theReport = theReport & strNameArray(anIndex) & vbCrLf
'    Next anIndex
'    MsgBox theReport
    
836:     Set frmSelect.ArcApplication = m_pApp
837:     Set frmSelect.Doc = m_pMxDoc
838:     frmSelect.NameList = strNameArray
839:     frmSelect.NameCount = intKey
840:     Set frmSelect.NameCollection = colPolygonLayers
841:     frmSelect.PolygonPurpose = "Bottleneck_Wildland1"
842:     frmSelect.SearchMessage = "Wildland Block #1"

844:     frmSelect.EnableTool = False
845:     frmSelect.SetSelToolEnabled
846:     Load frmSelect

848:     frmSelect.Frame.Caption = "Select Wildland Block #1..."
849:     frmSelect.Frame.Visible = True
850:   Else
851:     Set frmSelect = theFormObject
852:   End If
  
854:   cbxHab1.BackColor = vbWhite

'  frmSelect.Show vbModeless
857:   frmSelect.Frame.Visible = True
858:   Me.Frame.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "cmdSel1_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdSel2_Click()
  On Error GoTo ErrorHandler
867:   m_IntHelpCategory = 1
868:   Call UpdateHelpScreen

  Dim frmSelect As Linkages.frmSelScreen
    
  Dim ext As Linkages.clsExtension
873:   Set ext = m_ExtensionConfig
  
  Dim theFormObject As Object
876:   Set theFormObject = ext.aSelForm
  
878:   If (theFormObject Is Nothing) Then
879:     Set frmSelect = New Linkages.frmSelScreen
  
    ' IDENTIFY POLYGON THEMES AND GRAPHICS
    Dim pMxDoc As IMxDocument
883:     Set pMxDoc = m_pMxDoc
  
    Dim colPolygonLayers As New Collection
    Dim strNameArray() As String
    
    Dim theMap As IMap
    Dim pEnumLayer As IEnumLayer
    Dim pFeatureLayer As IFeatureLayer
    Dim pLayer As IUnknown
    Dim anIndex As Long
    Dim strPolyName As String
    Dim intKey As Integer
    
    Dim pFeatureClass As IFeatureClass
    Dim pGeometryType As esriGeometryType
    
899:     intKey = -1
    
901:     Set theMap = pMxDoc.FocusMap
    
    ' CHECK IF GRAPHICS LAYER IS AVAILABLE
    Dim pGraphicsContainer As IGraphicsContainer
905:     Set pGraphicsContainer = theMap
    
    Dim pEnvelope As IEnvelope
908:     Set pEnvelope = pMxDoc.ActiveView.FullExtent
    Dim pEnumElement As IEnumElement
    
911:     Set pEnumElement = pGraphicsContainer.LocateElementsByEnvelope(pEnvelope)
'    MsgBox (pEnumElement Is Nothing)
    
    Dim booHasPolygon As Boolean
'    booHasPolygon = False
916:     booHasPolygon = True
'
'    If (Not pEnumElement Is Nothing) Then
'      pEnumElement.Reset
'
'      Dim pElement As IElement
'      Set pElement = pEnumElement.Next
'
'      Dim pGeometry As IGeometry
'
'      Do Until pElement Is Nothing
'        Set pGeometry = pElement.Geometry
'        If TypeOf pGeometry Is IPolygon Then
'          booHasPolygon = True
'          Exit Do
'        End If
'        Set pElement = pEnumElement.Next
'      Loop
'    End If
    
'    MsgBox booHasPolygon
    
'    ReDim strNameArray(theMap.LayerCount)
    ReDim strNameArray(Linkages.MyGeneralOperations.TrueLayerCount(theMap))
    
941:     If (booHasPolygon) Then
942:       intKey = intKey + 1
943:       strPolyName = "1] <-- Select or Draw Graphic Polygon -->"
944:       colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
945:       strNameArray(intKey) = strPolyName
946:     End If
            
    Dim pFeatureLayerForValid As IFeatureLayer
    
950:     If (theMap.LayerCount > 0) Then
951:       Set pEnumLayer = theMap.Layers(, True)
952:       pEnumLayer.Reset
      
954:       Set pLayer = pEnumLayer.Next
955:       Do Until pLayer Is Nothing
956:         If TypeOf pLayer Is IFeatureLayer Then
957:           Set pFeatureLayerForValid = pLayer
          ' CHECK IF FEATURE LAYER IS VALID
959:           If pFeatureLayerForValid.Valid Then
            ' CHECK IF POLYGON LAYER
961:             Set pFeatureClass = pFeatureLayerForValid.FeatureClass
962:             pGeometryType = pFeatureClass.ShapeType
963:             If (pGeometryType = esriGeometryPolygon) Then
964:               intKey = intKey + 1
965:               Set pFeatureLayer = pLayer
966:               strPolyName = CStr(intKey + 1) & "] " & pFeatureLayer.Name
967:               colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
968:               strNameArray(intKey) = strPolyName
969:             End If
970:           End If
971:         End If
972:         Set pLayer = pEnumLayer.Next
973:       Loop
974:     End If
           
'    Dim theReport As String
'    For anIndex = 0 To intKey
'      theReport = theReport & strNameArray(anIndex) & vbCrLf
'    Next anIndex
'    MsgBox theReport
    
982:     Set frmSelect.ArcApplication = m_pApp
983:     Set frmSelect.Doc = m_pMxDoc
984:     frmSelect.NameList = strNameArray
985:     frmSelect.NameCount = intKey
986:     Set frmSelect.NameCollection = colPolygonLayers
987:     frmSelect.PolygonPurpose = "Bottleneck_Wildland2"
988:     frmSelect.SearchMessage = "Wildland Block #2"

990:     frmSelect.EnableTool = False
991:     frmSelect.SetSelToolEnabled
992:     Load frmSelect

994:     frmSelect.Frame.Caption = "Select Wildland Block #2..."
995:     frmSelect.Frame.Visible = True
996:   Else
997:     Set frmSelect = theFormObject
998:   End If
  
1000:   cbxHab2.BackColor = vbWhite
  
'  frmSelect.Show vbModeless
1003:   frmSelect.Frame.Visible = True
1004:   Me.Frame.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "cmdSel2_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdSelLink_Click()
  On Error GoTo ErrorHandler

1014:   m_IntHelpCategory = 1
1015:   Call UpdateHelpScreen
  Dim frmSelect As Linkages.frmSelScreen
    
  Dim ext As Linkages.clsExtension
1019:   Set ext = m_ExtensionConfig
  
  Dim theFormObject As Object
1022:   Set theFormObject = ext.aSelForm
  
1024:   If (theFormObject Is Nothing) Then
1025:     Set frmSelect = New Linkages.frmSelScreen
  
    ' IDENTIFY POLYGON THEMES AND GRAPHICS
    Dim pMxDoc As IMxDocument
1029:     Set pMxDoc = m_pMxDoc
  
    Dim colPolygonLayers As New Collection
    Dim strNameArray() As String
    
    Dim theMap As IMap
    Dim pEnumLayer As IEnumLayer
    Dim pFeatureLayer As IFeatureLayer
    Dim pLayer As IUnknown
    Dim anIndex As Long
    Dim strPolyName As String
    Dim intKey As Integer
    
    Dim pFeatureClass As IFeatureClass
    Dim pGeometryType As esriGeometryType
    
1045:     intKey = -1
    
1047:     Set theMap = pMxDoc.FocusMap
    
    ' CHECK IF GRAPHICS LAYER IS AVAILABLE
    Dim pGraphicsContainer As IGraphicsContainer
1051:     Set pGraphicsContainer = theMap
    
    Dim pEnvelope As IEnvelope
1054:     Set pEnvelope = pMxDoc.ActiveView.FullExtent
    Dim pEnumElement As IEnumElement
    
1057:     Set pEnumElement = pGraphicsContainer.LocateElementsByEnvelope(pEnvelope)
'    MsgBox (pEnumElement Is Nothing)
    
    Dim booHasPolygon As Boolean
1061:     booHasPolygon = True
'    booHasPolygon = False
'
'    If (Not pEnumElement Is Nothing) Then
'      pEnumElement.Reset
'
'      Dim pElement As IElement
'      Set pElement = pEnumElement.Next
'
'      Dim pGeometry As IGeometry
'
'      Do Until pElement Is Nothing
'        Set pGeometry = pElement.Geometry
'        If TypeOf pGeometry Is IPolygon Then
'          booHasPolygon = True
'          Exit Do
'        End If
'        Set pElement = pEnumElement.Next
'      Loop
'    End If
    
'    MsgBox booHasPolygon
    
'    ReDim strNameArray(theMap.LayerCount)
    ReDim strNameArray(Linkages.MyGeneralOperations.TrueLayerCount(theMap))
    
1087:     If (booHasPolygon) Then
1088:       intKey = intKey + 1
1089:       strPolyName = "1] <-- Select or Draw Graphic Polygon -->"
1090:       colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
1091:       strNameArray(intKey) = strPolyName
1092:     End If
            
    Dim pFeatureLayerForValid As IFeatureLayer
    
1096:     If (theMap.LayerCount > 0) Then
1097:       Set pEnumLayer = theMap.Layers(, True)
1098:       pEnumLayer.Reset
      
1100:       Set pLayer = pEnumLayer.Next
1101:       Do Until pLayer Is Nothing
1102:         If TypeOf pLayer Is IFeatureLayer Then
1103:           Set pFeatureLayerForValid = pLayer
          ' CHECK IF FEATURE LAYER IS VALID
1105:           If pFeatureLayerForValid.Valid Then
            ' CHECK IF POLYGON LAYER
1107:             Set pFeatureClass = pFeatureLayerForValid.FeatureClass
1108:             pGeometryType = pFeatureClass.ShapeType
1109:             If (pGeometryType = esriGeometryPolygon) Then
1110:               intKey = intKey + 1
1111:               Set pFeatureLayer = pLayer
1112:               strPolyName = CStr(intKey + 1) & "] " & pFeatureLayer.Name
1113:               colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
1114:               strNameArray(intKey) = strPolyName
1115:             End If
1116:           End If
1117:         End If
1118:         Set pLayer = pEnumLayer.Next
1119:       Loop
1120:     End If
           
'    Dim theReport As String
'    For anIndex = 0 To intKey
'      theReport = theReport & strNameArray(anIndex) & vbCrLf
'    Next anIndex
'    MsgBox theReport
    
1128:     Set frmSelect.ArcApplication = m_pApp
1129:     Set frmSelect.Doc = m_pMxDoc
1130:     frmSelect.NameList = strNameArray
1131:     frmSelect.NameCount = intKey
1132:     Set frmSelect.NameCollection = colPolygonLayers
1133:     frmSelect.PolygonPurpose = "Bottleneck_Corridor"
1134:     frmSelect.SearchMessage = "Species Corridor"

1136:     frmSelect.EnableTool = False
1137:     frmSelect.SetSelToolEnabled
1138:     Load frmSelect

1140:     frmSelect.Frame.Caption = "Select Species Corridor Polygon..."
1141:     frmSelect.Frame.Visible = True
1142:   Else
1143:     Set frmSelect = theFormObject
1144:   End If
  
1146:   cbxCorridor.BackColor = vbWhite
'  frmSelect.Show vbModeless
1148:   frmSelect.Frame.Visible = True
1149:   Me.Frame.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "cmdSelLink_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub UpdateCheckmarks()
  On Error GoTo ErrorHandler

  Dim ext As Linkages.clsExtension
1160:   Set ext = m_ExtensionConfig
  
  Dim pHab1Polygon As IPolygon
  Dim pHab2Polygon As IPolygon
  Dim pCorPolygon As IPolygon
  
1166:   Set pHab1Polygon = ext.PolyWildland1
1167:   Set pHab2Polygon = ext.PolyWildland2
1168:   Set pCorPolygon = ext.PolyCorridor
  
1170:   imgCheckWB1.Visible = (Not ext.PolyWildland1 Is Nothing)
1171:   imgCheckWB2.Visible = (Not ext.PolyWildland2 Is Nothing)
1172:   imgCheckSpCorr.Visible = (Not ext.PolyCorridor Is Nothing)
1173:   imgUnCheckWB1.Visible = Not imgCheckWB1.Visible
1174:   imgUnCheckWB2.Visible = Not imgCheckWB2.Visible
1175:   imgUnCheckSpCorr.Visible = Not imgCheckSpCorr.Visible

  Exit Sub
ErrorHandler:
  HandleError True, "UpdateCheckmarks " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler
1184:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
  '  ORIGINAL AVENUE CODE
  '  ' Jennessent.CompareParametersOpen
  '
  '  AVUpperLeft = av.ReturnOrigin
  '  AVCenter = avUpperLeft + (av.ReturnExtent / (2@2))
  '  halfDialogWidthHeight = Self.ReturnExtent.ReturnSize / (2@2)
  '  MovePoint = AVCenter - halfDialogWidthHeight
  '  Self.MoveTo(MovePoint.GetX, MovePoint.GetY)
  '
  '  theDialog = self
  '  cmdOK = theDialog.FindByName("cmdOK")
  '  cmdCancel = theDialog.FindByName("cmdCancel")
  '
'  NOTES ON CONTROLS:
'  Remember to reset label autosize to true, if desired.
'   --> Contains Control Panels:  Make sure to cut and paste nested controls
'          if you want them to be properly nested in the Form Frame.
'   --> Contains Control Panels:  Make sure to cut and paste nested controls
'          if you want them to be properly nested in the Form Frame.
'   --> Contains Control Panels:  Make sure to cut and paste nested controls
'          if you want them to be properly nested in the Form Frame.
'   --> icon_CornerBars: Original Image = jennessent_bars.gif
1207:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
1208:   Me.Left = (Screen.Width / 3) - (Me.Width / 2)
1209:   Me.Top = (Screen.Height / 2) - (Me.Height / 2)
  
  Dim lngTopBar As Long
1212:   lngTopBar = Me.Height - Me.ScaleHeight
1213:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar

1215:   If m_Frame Is Nothing Then
1216:     Set m_Frame = New ModelessFrame
1217:     m_Frame.Create Me
'    Set m_WindowPos = m_Frame
'    MsgBox m_WindowPos.Width & "    x    " & m_WindowPos.Height
1220:   End If
  
  ' CLEAR ANY SAVED EXTENSION POLYGONS
  Dim newUid As New uID
1224:   newUid.Value = "Linkages.clsExtension"
1225:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  Dim ext As Linkages.clsExtension
1227:   Set ext = m_ExtensionConfig
  
1229:   Set ext.PolyWildland1 = Nothing
1230:   Set ext.PolyWildland2 = Nothing
1231:   Set ext.PolyCorridor = Nothing
1232:   Set ext.frmStep1 = Me
  
  ' CHECK HELP WINDOW STATUS
1235:   m_booHelpToggle = ext.HelpToggle1
    
    ' IDENTIFY POLYGON THEMES
  Dim pMxDoc As IMxDocument
1239:   Set pMxDoc = m_pMxDoc

  Dim colPolygonLayers As New Collection
  Dim strNameArray() As String
  
  Dim theMap As IMap
  Dim pEnumLayer As IEnumLayer
  Dim pFeatureLayer As IFeatureLayer
  Dim pLayer As IUnknown
  Dim anIndex As Long
  Dim strPolyName As String
  Dim intKey As Integer
  
  Dim pFeatureClass As IFeatureClass
  Dim pGeometryType As esriGeometryType
  
1255:   intKey = 1
  
1257:   Set theMap = pMxDoc.FocusMap
  
  ' ReDim strNameArray(theMap.LayerCount + 2)
            
  ReDim strNameArray(2 + Linkages.MyGeneralOperations.TrueLayerCount(theMap))
          
1263:   colPolygonLayers.Add "placeholder_FirstLine", "FirstLine"
1264:   strNameArray(0) = "FirstLine"
  
1266:   colPolygonLayers.Add "placeholder_SelFromView", "SelFromView"
1267:   strNameArray(1) = "SelFromView"
            
  Dim pFeatureLayerForValid As IFeatureLayer
  
1271:   If (theMap.LayerCount > 0) Then
1272:     Set pEnumLayer = theMap.Layers(, True)
1273:     pEnumLayer.Reset
    
1275:     Set pLayer = pEnumLayer.Next
1276:     Do Until pLayer Is Nothing
1277:       If TypeOf pLayer Is IFeatureLayer Then
1278:         Set pFeatureLayerForValid = pLayer
        ' CHECK IF FEATURE LAYER IS VALID
1280:         If pFeatureLayerForValid.Valid Then
          ' CHECK IF POLYGON LAYER
1282:           Set pFeatureClass = pFeatureLayerForValid.FeatureClass
1283:           pGeometryType = pFeatureClass.ShapeType
1284:           If (pGeometryType = esriGeometryPolygon) Then
1285:             intKey = intKey + 1
1286:             Set pFeatureLayer = pLayer
1287:             strPolyName = CStr(intKey - 1) & "] " & pFeatureLayer.Name
1288:             colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
1289:             strNameArray(intKey) = strPolyName
1290:           End If
1291:         End If
1292:       End If
1293:       Set pLayer = pEnumLayer.Next
1294:     Loop
1295:   End If
  
1297:   m_strNameArray = strNameArray
1298:   Set m_colPolygons = colPolygonLayers
  
  ' FILL LISTBOXES WITH POLYGON SOURCE OPTIONS
  
  Dim strWB1Array() As String
  ReDim strWB1Array(intKey)
1304:   strWB1Array(0) = "Wildland Block #1 Source..."
1305:   strWB1Array(1) = "<-- Select by clicking on map -->"
  
  Dim strWB2Array() As String
  ReDim strWB2Array(intKey)
1309:   strWB2Array(0) = "Wildland Block #2 Source..."
1310:   strWB2Array(1) = "<-- Select by clicking on map -->"
  
  Dim strCorArray() As String
  ReDim strCorArray(intKey)
1314:   strCorArray(0) = "Species Corridor Source..."
1315:   strCorArray(1) = "<-- Select by clicking on map -->"
  
  
'  Dim theReport As String
'  theReport = "Upper bound of 'm_strNameArray' = " & CStr(UBound(m_strNameArray)) & vbCrLf & _
'      "Value = " & m_strNameArray(UBound(m_strNameArray))
'  For anIndex = LBound(m_strNameArray) To UBound(m_strNameArray)
'    theReport = theReport & "Index " & CStr(anIndex) & " --> " & m_strNameArray(anIndex) _
'        & vbCrLf
'  Next anIndex
'
'  MsgBox theReport
  
1328:   For anIndex = 2 To UBound(m_strNameArray)
1329:     If Not m_strNameArray(anIndex) = "" Then
1330:       strWB1Array(anIndex) = m_strNameArray(anIndex)
1331:       strWB2Array(anIndex) = m_strNameArray(anIndex)
1332:       strCorArray(anIndex) = m_strNameArray(anIndex)
1333:     End If
1334:   Next anIndex
  
1336:   cbxHab1.Clear
1337:   cbxHab2.Clear
1338:   cbxCorridor.Clear
  
1340:   For anIndex = 0 To UBound(strWB1Array)
1341:     cbxHab1.AddItem (strWB1Array(anIndex))
1342:     cbxHab2.AddItem (strWB2Array(anIndex))
1343:     cbxCorridor.AddItem (strCorArray(anIndex))
1344:   Next anIndex
  
1346:   cbxHab1.ListIndex = 0
1347:   cbxHab2.ListIndex = 0
1348:   cbxCorridor.ListIndex = 0
  
  ' SET CHECKMARKS AND UPDATE BUTTONS
1351:   Call UpdateCheckmarks
1352:   Call UpdateSelectButtons
  
  ' UPDATE HELP SCREEN POSITION
  Dim booHelpToggle As Boolean
1356:   booHelpToggle = ext.HelpToggle1
  Dim pWindowPosition As IWindowPosition
1358:   Set pWindowPosition = m_Frame

1360:   If booHelpToggle = False Then
1361:     cmdHelp.Caption = "Show Help >>"
1362:     pWindowPosition.Width = 390
1363:     pWindowPosition.Height = 168
1364:     cmdManual.Top = 1665
1365:     cmdCancel.Top = 1665
1366:     cmdOK.Top = 1665
1367:     cmdHelp.Top = 1665
1368:   Else
1369:     cmdHelp.Caption = "<< Hide Help"
1370:     pWindowPosition.Width = 669
1371:     pWindowPosition.Height = 331
1372:     cmdManual.Top = 4125
1373:     cmdCancel.Top = 4125
1374:     cmdOK.Top = 4125
1375:     cmdHelp.Top = 4125
1376:   End If

1378:   m_IntHelpCategory = 1
1379:   Call UpdateHelpScreen
  
  ' MAKE SURE BACK COLORS ARE WHITE
1382:   Call SetBackColorsWhite
  
1384:   Me.Refresh

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub UpdateHelpScreen()
  On Error GoTo ErrorHandler

  Dim ext As Linkages.clsExtension
1395:   Set ext = m_ExtensionConfig
  Dim booHelpToggle As Boolean
1397:   booHelpToggle = ext.HelpToggle1
  
1399:   imgHelp.Visible = booHelpToggle
1400:   rtbHelp.Visible = booHelpToggle
  
  Dim strHelpText As String
1403:   strHelpText = Linkages.modHelpStrings.BottleneckHelp
1404:   rtbHelp.TextRTF = strHelpText

1406:   rtbHelp.SelStart = 0
1407:   rtbHelp.Locked = True

  Exit Sub
ErrorHandler:
  HandleError False, "UpdateHelpScreen " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub UpdateSelectButtons()
  On Error GoTo ErrorHandler


1418:   cmdSel1.Enabled = (cbxHab1.ListIndex = 1)
1419:   cmdSel2.Enabled = (cbxHab2.ListIndex = 1)
1420:   cmdSelLink.Enabled = (cbxCorridor.ListIndex = 1)


  Exit Sub
ErrorHandler:
  HandleError False, "UpdateSelectButtons " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler

  '  ORIGINAL AVENUE CODE
  '  ' Jennessent.CompareParametersClose
  '
  '  self.SetObjectTag(nil)
  '  self.FindByName("cmdOK").SetObjectTag(nil)
  '  self.FindByName("cmdCancel").SetObjectTag(nil)
  '
    ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
1439:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New uID
1443:   pUID.Value = "Linkages.toolReturnCoords"
  
  Dim ext As Linkages.clsExtension
1446:   Set ext = m_ExtensionConfig
1447:   ext.EnableSelTool = False
1448:   ext.EnableDrawTool = False
1449:   Set ext.PolyCorridor = Nothing
1450:   Set ext.PolyWildland1 = Nothing
1451:   Set ext.PolyWildland2 = Nothing
1452:   Set ext.frmStep1 = Nothing
  
  ' UNLOAD SELECTION FORM IF IT IS OPEN
1455:   If (Not ext.aSelForm Is Nothing) Then
    Dim pSelForm As Linkages.frmSelScreen
1457:     Set pSelForm = ext.aSelForm
1458:     Unload pSelForm
1459:     Set ext.aSelForm = Nothing
1460:   End If
  
1462:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
1463:   If pCommand.Checked Then
1464:     Set m_pApp.CurrentTool = Nothing

    Dim pCommandItem As ICommandItem
1467:     Set pCommandItem = pCommand
    
1469:     pCommandItem.Refresh
1470:   End If
  
1472:   Set pCommand = Nothing
1473:   Set pCommandItem = Nothing
1474:   Set ext = Nothing
1475:   Set m_pApp = Nothing
1476:   Set m_pMxDoc = Nothing
1477:   Set m_Frame = Nothing
1478:   Set m_ExtensionConfig = Nothing
1479:   Set m_colPolygons = Nothing
'  Set m_WindowPos = Nothing
  
  

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Label1_Click()
  On Error GoTo ErrorHandler

1492:   m_IntHelpCategory = 1
1493:   Call UpdateHelpScreen


  Exit Sub
ErrorHandler:
  HandleError True, "Label1_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbl_cbxCorridor_Click()
  On Error GoTo ErrorHandler


1505:   m_IntHelpCategory = 1
1506:   Call UpdateHelpScreen

  Exit Sub
ErrorHandler:
  HandleError False, "lbl_cbxCorridor_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbl_cbxHab2_Click()
  On Error GoTo ErrorHandler

1516:   m_IntHelpCategory = 1
1517:   Call UpdateHelpScreen


  Exit Sub
ErrorHandler:
  HandleError False, "lbl_cbxHab2_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub EnableOKButton()
  On Error GoTo ErrorHandler


  Dim booPolysOK As Boolean
1530:   booPolysOK = imgCheckWB1.Visible And imgCheckWB2.Visible And imgCheckSpCorr.Visible
  
  
1533:   cmdOK.Enabled = booPolysOK
  
'  MsgBox "optUseAll.Value = " & optUseAll.Value & vbCrLf & _
'         "(cbxPatchField.ListIndex > 1) = " & (cbxPatchField.ListIndex > 1) & vbCrLf & _
'         "(txtValue.Text <> "") = " & (txtValue.Text <> "") & vbCrLf & _
'         "((optUseAll.Value) Or ((cbxPatchField.ListIndex > 1) And (txtValue.Text <> ..))) = " & _
'         ((optUseAll.Value) Or ((cbxPatchField.ListIndex > 1) And (txtValue.Text <> ""))) & vbCrLf
         
  

  Exit Sub
ErrorHandler:
  HandleError True, "EnableOKButton " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
