VERSION 5.00
Begin VB.Form frmCircuitscapeLayerID 
   Caption         =   " Select Feature Layer and Value Field:"
   ClientHeight    =   3825
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5250
   Icon            =   "frmCircuitscapeLayerID.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3825
   ScaleWidth      =   5250
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   345
      Left            =   2098
      TabIndex        =   4
      Top             =   3480
      Width           =   1065
   End
   Begin VB.TextBox txtMessage 
      Height          =   960
      Left            =   75
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "frmCircuitscapeLayerID.frx":0E42
      Top             =   75
      Width           =   5055
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   3171
      TabIndex        =   5
      Top             =   3480
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1015
      TabIndex        =   3
      Top             =   3480
      Width           =   1065
   End
   Begin VB.ListBox lbxFields 
      Height          =   2010
      Left            =   2595
      TabIndex        =   2
      Top             =   1305
      Width           =   2535
   End
   Begin VB.ListBox lbxLayers 
      Height          =   2010
      Left            =   75
      TabIndex        =   1
      Top             =   1305
      Width           =   2400
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   5025
      Picture         =   "frmCircuitscapeLayerID.frx":0E51
      Top             =   3600
      Width           =   225
   End
   Begin VB.Label lblFields 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Cell Value Field --"
      Height          =   195
      Left            =   2925
      TabIndex        =   7
      Top             =   1095
      Width           =   1875
   End
   Begin VB.Label lblLayer 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Feature Layer --"
      Height          =   195
      Left            =   420
      TabIndex        =   6
      Top             =   1095
      Width           =   1710
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   3390
      Left            =   15
      Top             =   15
      Width           =   5220
   End
End
Attribute VB_Name = "frmCircuitscapeLayerID"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pLayerArray As esriSystem.IVariantArray
Private m_pLayerFields As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As Linkages.clsExtension
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_FieldTypeOption As JenFieldTypes
Private m_booIncludeNoIDField As Boolean
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\frmCircuitscapeLayerID.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
27:   Set m_pApp = pParams.Element(0)
28:   m_ShapeTypeOption = pParams.Element(1)
29:   Set m_pThisExt = pParams.Element(2)
30:   m_FieldTypeOption = pParams.Element(3)
31:   m_booIncludeNoIDField = pParams.Element(4)
32:   m_booOutputIsFClass = pParams.Element(5)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS

34:   Set m_pMxDoc = m_pApp.Document
 
  Dim pSelItem As IUnknown
37:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As ILayer
  Dim pStandaloneTable As IStandaloneTable
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

43:   m_strSelLayerName = ""
 
45:   If Not pSelItem Is Nothing Then
46:     If TypeOf pSelItem Is ILayer Then
47:       Set pLayer = pSelItem
48:       m_strSelLayerName = pLayer.Name
49:     ElseIf TypeOf pSelItem Is IStandaloneTable Then
50:       Set pStandaloneTable = pSelItem
51:       m_strSelLayerName = pStandaloneTable.Name
52:     End If
53:   End If

55:   m_pThisExt.ShouldContinue = False
56:   m_booSelToggle = False

  ' FILL LAYER ARRAY AND LISTBOX
59:   lbxLayers.Clear
  Dim lngStartSel As Long
61:   lngStartSel = 0
62:   Set m_pLayerArray = Linkages.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, m_ShapeTypeOption)
63:   If m_pLayerArray.Count > 0 Then
64:     For lngIndex = 0 To m_pLayerArray.Count - 1
65:       Set pUnknown = m_pLayerArray.Element(lngIndex)
66:       If TypeOf pUnknown Is ILayer Then
67:         Set pLayer = m_pLayerArray.Element(lngIndex)
68:         If pLayer.Valid Then
69:           lbxLayers.AddItem pLayer.Name
70:           If pLayer.Name = m_strSelLayerName Then lngStartSel = lngIndex
71:         End If
72:       ElseIf TypeOf pUnknown Is IStandaloneTable Then
73:         Set pStandaloneTable = m_pLayerArray.Element(lngIndex)
74:         If pStandaloneTable.Valid Then
75:           lbxLayers.AddItem pStandaloneTable.Name
76:           If pStandaloneTable.Name = m_strSelLayerName Then lngStartSel = lngIndex
77:         End If
78:       End If
79:     Next lngIndex
80:     lbxLayers.ListIndex = lngStartSel
81:   End If

83:   txtMessage.Text = "Select Feature Layer and Numeric Attribute Field to convert to a raster.  The feature class attribute values will be transferred to the raster cells."

  ' CLEAR INITIAL SELECTION
86:   Set m_pThisExt.frmCircuitscapeLayerIDReturn = Nothing

88:   Call UpdateSelName
 
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
98:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub UpdateSelName()
  On Error GoTo ErrorHandler
 
  Exit Sub
ErrorHandler:
  HandleError False, "UpdateSelName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
 
116:   cmdOK.Enabled = lbxLayers.SelCount > 0 And lbxFields.SelCount > 0
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  Dim strPath As String
127:   strPath = App.Path & "\help"
  
  ' CHANGE AS APPROPRIATE
130:   Call Linkages.MyGeneralOperations.OpenDoc("Circuitscape Export Tool.pdf", strPath)
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdSelFields_Click()
  On Error GoTo ErrorHandler
 
  Dim lngIndex As Long
141:   For lngIndex = 0 To lbxFields.ListCount - 1
142:     lbxFields.Selected(lngIndex) = Not m_booSelToggle
143:   Next lngIndex
 
145:   lbxFields.ListIndex = 0
146:   lbxFields.Refresh
 
148:   m_booSelToggle = Not m_booSelToggle
149:   Call UpdateSelName
150:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError False, "cmdSelFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

160:   m_pThisExt.ShouldContinue = False
161:   Set m_pThisExt.frmCircuitscapeLayerIDReturn = Nothing
162:   Set m_pReturnArray = Nothing
163:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

173:   Set m_pReturnArray = New esriSystem.VarArray
    
  ' SELECTED FEATURE LAYER
  Dim pUnknown As IUnknown
177:   Set pUnknown = m_pLayerArray.Element(lbxLayers.ListIndex)
178:   m_pReturnArray.Add pUnknown
 
  Dim lngIndex As Long
  ' SELECTED FIELDS
  Dim pSelFields As esriSystem.IVariantArray
183:   Set pSelFields = New esriSystem.VarArray
 
  Dim pSelField As Variant
186:   For lngIndex = 0 To lbxFields.ListCount - 1
187:     If lbxFields.Selected(lngIndex) Then
188:       Set pSelField = m_pLayerFields.Element(lngIndex)
189:       pSelFields.Add pSelField
190:     End If
191:   Next lngIndex
192:   m_pReturnArray.Add pSelFields
 
 
195:    m_pThisExt.ShouldContinue = True

  Dim pSaveArray As esriSystem.IVariantArray
198:   Set pSaveArray = New esriSystem.VarArray
199:   For lngIndex = 0 To m_pReturnArray.Count - 1
200:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
201:   Next lngIndex
202:   Set m_pThisExt.frmCircuitscapeLayerIDReturn = pSaveArray
203:   Unload Me
      
'  Me.Visible = False
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
215:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
216:   Me.Left = (Screen.Width / 3) - (Me.Width / 3)
217:   Me.Top = (Screen.Height / 2) - (Me.Height / 2)
  Dim lngTopBar As Long
219:   lngTopBar = Me.Height - Me.ScaleHeight
220:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
 
222:   Set Anchors = New AnchorObjectList  ' Create new instance
223:    With Anchors
224:       With .Item(cmdCancel)
225:          .SetAnchors enumStartsize, enumSizeEnd
226:       End With
227:       With .Item(cmdManual)
228:          .SetAnchors enumStartsize, enumSizeEnd
229:       End With
230:       With .Item(cmdOK)
231:          .SetAnchors enumStartsize, enumSizeEnd
232:       End With
233:       With .Item(imgBackTop)
234:          .SetAnchors enumStartEnd, enumStartEnd
235:       End With
236:       With .Item(imgCornerBars)
237:          .SetAnchors enumSizeEnd, enumSizeEnd
238:       End With
239:       With .Item(lblFields)
240:          .SetAnchors enumSize, enumStartsize
241:       End With
242:       With .Item(lblLayer)
243:          .SetAnchors enumSize, enumStartsize
244:       End With
245:       With .Item(lbxFields)
246:          .SetAnchors enumNone, enumStartEnd
247:       End With
248:       With .Item(lbxLayers)
249:          .SetAnchors enumNone, enumStartEnd
250:       End With
251:       With .Item(txtMessage)
252:          .SetAnchors enumStartEnd, enumStartsize
253:       End With
      
255:       .Form = Me  ' Set form reference (suggested to be last step)
256:    End With

258:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
268:   Set m_pMxDoc = Nothing
269:   Set m_pApp = Nothing
270:   Set Anchors = Nothing
271:   Set m_pLayerArray = Nothing
272:   Set m_pLayerFields = Nothing
273:   Set m_pThisExt = Nothing
274:   Set m_pReturnArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxFields_Click()
  On Error GoTo ErrorHandler
 
284:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError True, "lbxFields_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxLayers_Click()
  On Error GoTo ErrorHandler

  Dim pUnknown As IUnknown
295:   Set pUnknown = m_pLayerArray.Element(lbxLayers.ListIndex)
  Dim pFields As IFields
  Dim pField As IField
  Dim pFieldInfo As IFieldInfo
  Dim pTableFields As ITableFields

301:   If TypeOf pUnknown Is IFeatureLayer Then
    Dim pFeatureLayer As IFeatureLayer
303:     Set pFeatureLayer = m_pLayerArray.Element(lbxLayers.ListIndex)

    Dim pFeatureClass As IFeatureClass
306:     Set pFeatureClass = pFeatureLayer.FeatureClass

    ' UPDATE FIELD LISTBOX
309:     Set pTableFields = pFeatureLayer
310:     Set pFields = pFeatureClass.Fields
    
312:   ElseIf TypeOf pUnknown Is IStandaloneTable Then
    Dim pStTab As IStandaloneTable
314:     Set pStTab = m_pLayerArray.Element(lbxLayers.ListIndex)

    Dim pTable As ITable
317:     Set pTable = pStTab.Table

    ' UPDATE FIELD LISTBOX
320:     Set pTableFields = pStTab
321:     Set pFields = pTable.Fields
322:   End If

324:   lbxFields.Clear

  Dim pTempFields As esriSystem.IVariantArray
327:   Set pTempFields = Linkages.MyGeneralOperations.ReturnFieldsByType(pFields, m_FieldTypeOption)
328:   Set m_pLayerFields = New esriSystem.VarArray

  Dim lngIndex As Long
331:   For lngIndex = 0 To pTempFields.Count - 1
332:     Set pField = pTempFields.Element(lngIndex)
333:     If Not StrComp(pField.Name, "Shape_Length", vbTextCompare) = 0 And _
         Not StrComp(pField.Name, "Shape_Area", vbTextCompare) = 0 Then
'      Set pFieldInfo = pTableFields.FieldInfo(pTableFields.FindField(pField.Name))
'      lbxFields.AddItem pFieldInfo.Alias
      ' ONLY CONSIDER INTEGER FIELDS
  '    If pField.Type = esriFieldTypeSmallInteger Or pField.Type = esriFieldTypeInteger Or _
          pField.Type = esriFieldTypeOID Then
340:         lbxFields.AddItem pField.AliasName
341:         m_pLayerFields.Add pField
  '    End If
343:     End If
344:   Next lngIndex

346:   If m_booIncludeNoIDField Then
347:     m_pLayerFields.Insert 0, "<-- No ID Field -->"
348:     lbxFields.AddItem "<-- No ID Field -->", 0
349:   End If
350:   lbxFields.ListIndex = -1

352:   m_booSelToggle = False
353:   Call UpdateSelName
 
355:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmCircuitscapeLayerIDReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmCircuitscapeLayerIDReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmCircuitscapeLayerIDReturn(pfrmCircuitscapeLayerIDReturn As esriSystem.IVariantArray)
  '  Set m_pfrmCircuitscapeLayerIDReturn = pfrmCircuitscapeLayerIDReturn
  'End Property
  '
  'Public Property Get frmCircuitscapeLayerIDReturn() As esriSystem.IVariantArray
  '  Set frmCircuitscapeLayerIDReturn = m_pfrmCircuitscapeLayerIDReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenPointLayers + ENUM_jenPolylineLayers + ENUM_jenPolygonLayers + ENUM_jenMultipointLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmCircuitscapeLayerIDReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    Dim pFieldTypes As JenFieldTypes
'    pFieldTypes =  ENUM_FieldNumber
'    pVarArray.Add pFieldTypes
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As Linkages.frmCircuitscapeLayerID
'    Set pForm = New Linkages.frmCircuitscapeLayerID
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmCircuitscapeLayerIDReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'
'    ' SELECTED FIELD OR FIELDS
'    Dim pSelFields As esriSystem.IVariantArray
'    Set pSelFields = pReturnArray.Element(1)
'    strReport = strReport & CStr(pSelFields.Count) & " fields selected..." & vbNewLine
'
'    Dim pField As IField
'    Set pField = pSelFields.Element(0)
'    strReport = strReport & "First Selected Field is named '" & pField.Name & "'" & vbNewLine
'


'  ' CODE SNIPPET TO USE pFieldNamePairs TO TRANSFER ATTRIBUTE DATA FROM OLD SOURCE TO NEW SOURCE
'  ' MAKE IVariantArray OF FIELD NAME INDICES
'  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
'  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
'  '                     1) ORIGINAL FCLASS FIELD INDEX
'  '                     2) NEW FCLASS FIELD NAME
'  '                     3) NEW FCLASS FIELD INDEX
'  Dim pFieldNamePairs As esriSystem.IVariantArray
'  Set pFieldNamePairs = pOutputArray.Element(9)
'  Dim pFieldNameData As esriSystem.IVariantArray
'  Set pFieldNameData = Linkages.MyGeneralOperations.MakeFieldNameVarArray(pFeatureClass, pNewFClass, pFieldNamePairs, True)
'  Dim lngFieldIndex As Long
'  Dim pFieldSubArray As esriSystem.IVariantArray
'  ' ROTATE THROUGH ALL FEATURES / ROWS
'    ' TRANSFER ATTRIBUTE DATA; ASSUMES pBuffer ALREADY EXISTS
'    For lngFieldIndex = 0 To pFieldNameData.Count - 1
'      Set pFieldSubArray = pFieldNameData.Element(lngFieldIndex)
'      pBuffer.Value(pFieldSubArray.Element(3)) = pFeature.Value(pFieldSubArray.Element(1))
'    Next lngFieldIndex
'  ' LOOP

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub
 

