VERSION 5.00
Begin VB.Form frmClip 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Clip Data to Corridor:"
   ClientHeight    =   5190
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7920
   Icon            =   "frmClip.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5190
   ScaleWidth      =   7920
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   345
      Left            =   6480
      TabIndex        =   11
      Top             =   3015
      Width           =   1095
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   360
      Left            =   7080
      Picture         =   "frmClip.frx":038A
      Style           =   1  'Graphical
      TabIndex        =   7
      ToolTipText     =   "Browse for Output Folder..."
      Top             =   4410
      Width           =   555
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   840
      Locked          =   -1  'True
      TabIndex        =   6
      Text            =   "Text1"
      Top             =   4425
      Width           =   5985
   End
   Begin VB.ListBox lbxClipLayers 
      Height          =   2310
      Left            =   840
      Style           =   1  'Checkbox
      TabIndex        =   5
      Top             =   1590
      Width           =   5055
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   6480
      TabIndex        =   4
      Top             =   2595
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   345
      Left            =   6480
      TabIndex        =   3
      Top             =   3435
      Width           =   1095
   End
   Begin VB.ComboBox cbxCorridor 
      Height          =   315
      Left            =   2655
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   480
      Width           =   3465
   End
   Begin VB.CommandButton cmdSelLink 
      Caption         =   "Select from Map"
      Height          =   315
      Left            =   6270
      TabIndex        =   0
      Top             =   495
      Width           =   1365
   End
   Begin VB.Image imgCheckPathname 
      Height          =   375
      Left            =   300
      Picture         =   "frmClip.frx":0400
      Top             =   4410
      Width           =   375
   End
   Begin VB.Image imgUncheckPathname 
      Height          =   375
      Left            =   300
      Picture         =   "frmClip.frx":0517
      Top             =   4410
      Width           =   375
   End
   Begin VB.Image imgCorrIcon 
      Height          =   855
      Left            =   6555
      Picture         =   "frmClip.frx":058B
      Top             =   1455
      Width           =   945
   End
   Begin VB.Image Image3 
      Appearance      =   0  'Flat
      BorderStyle     =   1  'Fixed Single
      Height          =   1110
      Left            =   105
      Top             =   4035
      Width           =   7770
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Identify Layers to Clip:"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   225
      TabIndex        =   13
      Top             =   1245
      Width           =   2220
   End
   Begin VB.Image Image2 
      Appearance      =   0  'Flat
      BorderStyle     =   1  'Fixed Single
      Height          =   2895
      Left            =   105
      Top             =   1155
      Width           =   5985
   End
   Begin VB.Label lblStep1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Identify Corridor Polygon:"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   225
      TabIndex        =   12
      Top             =   165
      Width           =   2520
   End
   Begin VB.Image Image1 
      Appearance      =   0  'Flat
      BorderStyle     =   1  'Fixed Single
      Height          =   1110
      Left            =   105
      Top             =   60
      Width           =   7770
   End
   Begin VB.Image imgUncheckClipLayers 
      Height          =   375
      Left            =   300
      Picture         =   "frmClip.frx":308F
      Top             =   1575
      Width           =   375
   End
   Begin VB.Image imgUnCheckSpCorr 
      Height          =   375
      Left            =   300
      Picture         =   "frmClip.frx":3103
      Top             =   465
      Width           =   375
   End
   Begin VB.Label lblWorking 
      AutoSize        =   -1  'True
      Caption         =   "Working..."
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   2640
      TabIndex        =   10
      Top             =   2625
      Width           =   1245
   End
   Begin VB.Image imgIcon 
      Height          =   855
      Left            =   4350
      Picture         =   "frmClip.frx":3177
      Top             =   2340
      Width           =   945
   End
   Begin VB.Label lblWorkspaceComment 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "(Clipped datasets will be named by their existing name appended with ""_clip"")"
      Height          =   195
      Left            =   1095
      TabIndex        =   9
      Top             =   4815
      Width           =   5445
   End
   Begin VB.Label lblWorkspace 
      AutoSize        =   -1  'True
      Caption         =   "Specify Output Workspace:"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   225
      TabIndex        =   8
      Top             =   4125
      Width           =   2655
   End
   Begin VB.Image imgCheckClipLayers 
      Height          =   375
      Left            =   300
      Picture         =   "frmClip.frx":5C7B
      Top             =   1575
      Width           =   375
   End
   Begin VB.Image imgCheckSpCorr 
      Height          =   375
      Left            =   300
      Picture         =   "frmClip.frx":5D92
      Top             =   465
      Width           =   375
   End
   Begin VB.Label lbl_cbxCorridor 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Species Corridor Polygon:"
      Height          =   195
      Left            =   810
      TabIndex        =   2
      Top             =   555
      Width           =   1830
   End
End
Attribute VB_Name = "frmClip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Anchors As AnchorObjectList  ' Main anchor control object
Const conHwndTopmost = -1
Const conHwndNoTopmost = -2
Const conSwpNoActivate = &H10
Const conSwpShowWindow = &H40

Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_Frame As IModelessFrame
'Private m_WindowPos As IWindowPosition
Private m_ExtensionConfig As IExtensionConfig
Private m_strNameArray() As String
Private m_intNameCount As Integer
Private m_colPolygons As Collection
Private m_ColClipLayers As Collection
Public m_lngCorrCount As Long
Private m_IntHelpCategory As Integer

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\frmClip.frm"


Public Property Set ArcApplication(ByVal theApplication As IApplication)
  On Error GoTo ErrorHandler


28:   Set m_pApp = theApplication


  Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Function Frame() As IModelessFrame
  On Error GoTo ErrorHandler

39:   If m_Frame Is Nothing Then
40:     Set m_Frame = New ModelessFrame
41:     m_Frame.Create Me
'    Set m_WindowPos = m_Frame
'    MsgBox m_WindowPos.Width & "    x    " & m_WindowPos.Height
44:   End If

46:   Set Frame = m_Frame

  Exit Function
ErrorHandler:
  HandleError True, "Frame " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Property Set Doc(pDoc As esriArcMapUI.IMxDocument)
  On Error GoTo ErrorHandler

56:   Set m_pMxDoc = pDoc

  Exit Property
ErrorHandler:
  HandleError True, "Doc " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Sub cbxCorridor_Click()
  On Error GoTo ErrorHandler

66:   Call SetBackColorsWhite
  
  Dim ext As Linkages.clsExtension
69:   Set ext = m_ExtensionConfig
  
  Dim lngIndex As Long
72:   lngIndex = cbxCorridor.ListIndex
  
74:   Set ext.PolyCorridor = Nothing
  
76:   If lngIndex >= 2 Then
    Dim strLayerName As String
78:     strLayerName = cbxCorridor.List(lngIndex)
    
    Dim pFeatureLayer As IFeatureLayer
81:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
    
    Dim pFeatureCursor As IFeatureCursor
84:     Set pFeatureCursor = pFeatureLayer.Search(Nothing, True)
    
    Dim pFeature As IFeature
87:     Set pFeature = pFeatureCursor.NextFeature
    
    Dim pGeometry As IGeometry
90:     Set pGeometry = pFeature.ShapeCopy
    
92:     If TypeOf pGeometry Is IPolygon Then
      
      Dim pPolygon As IPolygon
95:       Set pPolygon = pGeometry
      
97:       Set ext.PolyCorridor = pPolygon
98:       m_lngCorrCount = pFeatureLayer.FeatureClass.FeatureCount(Nothing)
99:     End If
100:   End If
  
102:   Call UpdateCheckmarks
  
'  MsgBox cbxCorridor.ListIndex
105:   cmdSelLink.Enabled = (cbxCorridor.ListIndex = 1)
  
107:   Call EnableOKButton

  Exit Sub
ErrorHandler:
  HandleError True, "cbxCorridor_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
118:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
119:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors_orig")
  
  Dim ext As Linkages.clsExtension
122:   Set ext = m_ExtensionConfig
123:   Set ext.frmClipForm = Nothing
124:   Me.Frame.Visible = False
  
126:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetWorkspace_Click()
  On Error GoTo ErrorHandler

  
  Dim strDirPath As String
  Dim strUserName As String
  
140:   strDirPath = txtOutput.Text
141:   If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then strDirPath = strDirPath & "\"
142:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
143:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
144:     strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
145:   End If
  
  Dim boolWorkspaceExists As Boolean
  ' MODIFIED FEB 2008 TO ADD vbDirectory
149:   boolWorkspaceExists = Not Dir$(strDirPath, vbDirectory) = ""
  
151:   If Not boolWorkspaceExists Then
152:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.TempPathLocation)
153:   End If

  Dim pGxDialog As IGxDialog
156:   Set pGxDialog = New GxDialog
  
  Dim pGxDialogFilter As IGxObjectFilter
'  Set pGxDialogFilter = New GxFilterWorkspaces
160:   Set pGxDialogFilter = New GxFilterBasicTypes
'  pGxDialogFilter.Name = "Folders"
'  Set pGxDialogFilter = New GxFilterContainers      ' INCLUDED GRIDS AND COVERAGES
  
  Dim pGxObject As IGxObject
  Dim pGxSelection As IEnumGxObject
  
167:   With pGxDialog
168:     .AllowMultiSelect = False
169:     .StartingLocation = strDirPath
170:     .Title = "Please select (don't open!) folder to contain your clipped datasets:"
171:     Set .ObjectFilter = pGxDialogFilter
172:   End With
  
  Dim theFinalString As String
'  If Not pGxDialog.DoModalOpen(0, pEnumGx) Then
'Exit Sub 'Exit if user press Cancel
'End If
'MsgBox pEnumGx.Next.FullName
179:   If (pGxDialog.DoModalOpen(Me.hWnd, pGxSelection) = True) Then
    'Set pGxObject = pGxDialog.FinalLocation
181:     Set pGxObject = pGxSelection.Next
    
    Dim pGxFile As IGxFile
184:     Set pGxFile = pGxObject
    
186:     theFinalString = pGxObject.FullName
187:     If (Right(theFinalString, 1) <> "\") And (Right(theFinalString, 1) <> "/") Then theFinalString = theFinalString & "\"
    
'    If aml_func_mod.ExistFileDir(theFinalString) Then
'      theFinalString = aml_func_mod.MakeUniqueFilename(theFinalString)
'
'      MsgBox "Unable to overwrite the file '" & pGxDialog.Name & "'.  The new file will be saved to " & _
'        theFinalString & "..."
'    End If

196:     txtOutput.Text = theFinalString
    
198:   End If

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdHelp_Click()
  On Error GoTo ErrorHandler


  Dim strPath As String
210:   strPath = App.Path & "\help"
  
212:   Call Linkages.MyGeneralOperations.OpenDoc("Clip_Tool_Subdocument.pdf", strPath)
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdHelp_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

End Sub
Private Sub SetBackColorsWhite()
  On Error GoTo ErrorHandler

223:   cbxCorridor.BackColor = vbWhite

  Exit Sub
ErrorHandler:
  HandleError False, "SetBackColorsWhite " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

232:   Call SetBackColorsWhite
  
  ' CHECK FOR SINGLE CORRIDOR POLYGON
  Dim lngIndex As Long
  Dim strLayerName As String
  Dim pFeatureLayer As IFeatureLayer
  
239:   If m_lngCorrCount = 0 Then
240:     cbxCorridor.BackColor = vbYellow
241:     MsgBox "Unable to find a polygon for the Species Corridor Polygon!" & vbCrLf & vbCrLf & _
      "Please re-select your polygon..." _
      , vbOKOnly, "Error Found in Input Data:"
244:     cbxCorridor.SetFocus
    Exit Sub
246:   ElseIf m_lngCorrCount > 1 Then
247:     cbxCorridor.BackColor = vbYellow
248:     lngIndex = cbxCorridor.ListIndex
249:     strLayerName = cbxCorridor.List(lngIndex)
250:     Set pFeatureLayer = m_colPolygons.Item(strLayerName)
251:     MsgBox "Multiple polygons (" & CStr(m_lngCorrCount) & ") found in Species Corridor Polygon Layer '" & _
        pFeatureLayer.Name & "'!" & vbCrLf & vbCrLf & _
        "Please use the ""Select"" button to select a single " & _
        "polygon from this layer...", vbOKOnly, "Error Found in Input Data:"
255:     cbxCorridor.SetFocus
    Exit Sub
257:   End If
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
260:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
261:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors_orig")
  
  Dim ext As Linkages.clsExtension
264:   Set ext = m_ExtensionConfig
265:   Set ext.frmClipForm = Nothing
  Dim strWorkFolder As String
267:   strWorkFolder = txtOutput.Text
268:   If Right(strWorkFolder, 1) <> "\" And Right(strWorkFolder, 1) <> "/" Then
269:     strWorkFolder = strWorkFolder & "\"
270:   End If
271:   ext.ClipDirectoryPath = strWorkFolder
  
  ' MAKE DIALOG DISAPPEAR
  Dim pControl As Control
275:   For Each pControl In Me.Controls
276:    pControl.Visible = False
277:   Next pControl
278:   lblWorking.Visible = True
279:   imgIcon.Visible = True
280:   Me.Refresh
'  Me.Frame.Visible = False
'  m_pApp.RefreshWindow
'  Dim pEnvelope As IEnvelope
'  Me.Refresh
'  Set pEnvelope = m_pMxDoc.ActiveView.Extent
'  m_pMxDoc.ActiveView.Refresh
  
288:   DoEvents
  
  Dim pClone As IClone
  Dim pSendPolygon As IPolygon
  
  Dim anIndex As Integer
  Dim strName As String
  Dim pLayer As ILayer
  Dim pRasterLayer As IRasterLayer
  Dim pFeatureClass As IFeatureClass
  Dim pGeometryType As esriGeometryType
  Dim strShapeName As String
  
  Dim colWorkOrder As New Collection
  Dim strWorkOrder() As String
  ReDim strWorkOrder(lbxClipLayers.ListCount - 1)
  Dim intWorkIndex As Integer
305:   intWorkIndex = 0
  Dim strNewName As String
  
  ' GET POLYGON
  Dim pPolygon As IPolygon
310:   Set pPolygon = ext.PolyCorridor
  
  ' MAKE WORK ORDER COLLECTION
313:   For anIndex = 0 To lbxClipLayers.ListCount - 1
314:     If lbxClipLayers.Selected(anIndex) Then
315:       strName = lbxClipLayers.List(anIndex)
316:       Set pLayer = m_ColClipLayers.Item(strName)
      
318:       intWorkIndex = intWorkIndex + 1
319:       If TypeOf pLayer Is IFeatureLayer Then
320:         Set pFeatureLayer = pLayer
321:         Set pFeatureClass = pFeatureLayer.FeatureClass
322:         pGeometryType = pFeatureClass.ShapeType
323:         strShapeName = Linkages.aml_func_mod.ReturnShapeName(pGeometryType)
324:         strNewName = intWorkIndex & "] " & pLayer.Name & " (" & strShapeName & " Dataset)"
325:       Else
326:         strNewName = intWorkIndex & "] " & pLayer.Name & " (Raster Dataset)"
327:       End If
        
329:       colWorkOrder.Add m_ColClipLayers.Item(strName), strNewName
330:       strWorkOrder(intWorkIndex - 1) = strNewName
331:     End If
332:   Next anIndex
  
  Dim strReport As String
335:   strReport = "Clipped the following layers:" & vbCrLf & "-------------------------------------------------------" & vbCrLf
  
  Dim pClipFeatureLayer As IFeatureLayer
  Dim pClipRasterLayer As IRasterLayer
  Dim pClipLayer As ILayer
  Dim pDataset As IDataset
  Dim strClipName As String
  Dim lngFeatureCount As Long
  Dim pArea As IArea
  
  ' FOR RASTER CLIPS
  Dim pClipRaster As IRaster
  Dim pOrigRasterBandCollection As IRasterBandCollection
  Dim pOrigRasterBand As IRasterBand
'  Dim pOrigRasterDataset As IRasterDataset
  Dim pOrigFields As IFields
  Dim pOrigField As IField
  Dim pOrigTable As ITable

  Dim pNewRasterBandCollection As IRasterBandCollection
  Dim pNewRasterBand As IRasterBand
  Dim pNewRasterDataset As IRasterDataset
'  Dim pNewFields As IFields
  Dim pNewField As IField
  Dim pNewTable As ITable
  Dim booAddedFields As Boolean
  
  Dim pOrigCursor As ICursor
  Dim pOrigRow As IRow
  Dim pNewCursor As ICursor
  Dim pNewRow As IRow
  Dim pQueryFilter As IQueryFilter
367:   Set pQueryFilter = New QueryFilter
368:   pQueryFilter.AddField "Value"
  
  Dim lngValue As Long
  Dim lngOrigValField As Long
  Dim lngNewValField As Long
  Dim lngIndex2 As Long
  
  Dim pGridTableOp As IGridTableOp
376:   Set pGridTableOp = New GridTableOp
  Dim booOrigHasVAT As Boolean
  Dim booNewHasVAT As Boolean
  
  Dim intIndexArray() As Integer
  Dim intFieldIndex As Integer
  Dim intNewFieldIndex As Integer
383:   intNewFieldIndex = -1
        
385:   For anIndex = 0 To (intWorkIndex - 1)
386:     strName = strWorkOrder(anIndex)
387:     Set pClone = pPolygon
388:     Set pSendPolygon = pClone.Clone
389:     booAddedFields = False
    
 '   MsgBox "Index = " & CStr(anIndex) & vbCrLf & "Name = " & strName
392:     Set pLayer = colWorkOrder.Item(strName)
393:     If TypeOf pLayer Is IFeatureLayer Then  ' ------------------- CLIPPING FEATURE LAYER ---------------------
394:       Set pFeatureLayer = pLayer
395:       Set pClipFeatureLayer = Linkages.modClipFunctions.ClipFeatureLayer(pSendPolygon, pFeatureLayer, strWorkFolder, m_pApp)
396:       If pClipFeatureLayer Is Nothing Then
397:         strReport = strReport & strName & vbCrLf & "  --> No Intersecting Features Found:  No shapefile created... " & vbCrLf & vbCrLf
398:       Else
399:         Set pClipLayer = pClipFeatureLayer
400:         Set pDataset = pClipFeatureLayer
401:         strClipName = pDataset.BrowseName
402:         pClipLayer.Name = strClipName
403:         m_pMxDoc.AddLayer pClipLayer
404:         strReport = strReport & strName & vbCrLf & "  --> New Feature Count = " & pClipFeatureLayer.FeatureClass.FeatureCount(Nothing) & _
            vbCrLf & "  --> Saved to " & pDataset.Workspace.PathName & pDataset.Name & ".shp... " & vbCrLf & vbCrLf
406:       End If
407:     Else ' ------------------------------------------------------ CLIPPING RASTER LAYER -------------------------
408:       Set pRasterLayer = pLayer
409:       Set pClipRasterLayer = Linkages.modClipFunctions.ClipRasterLayer(pSendPolygon, pRasterLayer, strWorkFolder, m_pApp)
410:       If pClipRasterLayer Is Nothing Then
411:         strReport = strReport & strName & vbCrLf & "  --> Unable to intersect raster layer:  No clipped grid created... " & vbCrLf & vbCrLf
412:         Screen.MousePointer = vbDefault
413:       Else
        
415:         Set pRasterLayer = pLayer
        ' MAKE TABLE IF LAYER NEEDS IT
417:         Set pOrigRasterBandCollection = pRasterLayer.Raster
418:         Set pOrigRasterBand = pOrigRasterBandCollection.Item(0)
419:         pOrigRasterBand.HasTable booOrigHasVAT
420:         Set pNewRasterBandCollection = pClipRasterLayer.Raster
421:         Set pNewRasterBand = pNewRasterBandCollection.Item(0)
422:         Set pNewRasterDataset = pNewRasterBand
423:         pNewRasterBand.HasTable booNewHasVAT
        
        ' ONLY CONSIDER ADDING FIELDS TO TABLE IF BOTH ORIGINAL AND NEW GRIDS HAVE TABLES ALREADY
426:         If booOrigHasVAT And booNewHasVAT Then
427:           Set pOrigTable = pOrigRasterBand.AttributeTable
428:           Set pOrigFields = pOrigTable.Fields
429:           Set pNewTable = pNewRasterBand.AttributeTable
'          Set pNewFields = pNewTable.Fields
          ReDim intIndexArray(pOrigFields.FieldCount, 2)
          
433:           lngOrigValField = pOrigTable.FindField("Value")
434:           lngNewValField = pNewTable.FindField("Value")
                          
436:           For lngIndex = 0 To pOrigFields.FieldCount - 1
'            MsgBox CStr(lngIndex) & vbCrLf & "Field Count = " & CStr(pOrigFields.FieldCount) & vbCrLf & _
                CStr(pOrigFields Is Nothing) & vbCrLf & CStr(pNewTable Is Nothing) & vbCrLf & "Original Value Index = " & _
                CStr(lngOrigValField) & vbCrLf & "New Value Index = " & CStr(lngNewValField)
                
441:             Set pOrigField = pOrigFields.Field(lngIndex)
            ' CHECK IF FIELD ALREADY EXISTS IN TABLE (I.E. OID, VALUE OR COUNT). ONLY ADD NEW FIELDS
443:             If pNewTable.FindField(pOrigField.Name) = -1 And Not pOrigField.Type = esriFieldTypeOID Then
444:               booAddedFields = True
              
              ' FOR DEBUGGING
'              strReport = strReport & "Original Layer = " & pLayer.Name & vbCrLf
'              For lngIndex2 = 0 To pOrigFields.FieldCount - 1
'                strReport = strReport & "--> " & pOrigTable.Fields.Field(lngIndex2).Name & vbCrLf
'              Next lngIndex2
'              strReport = vbCrLf & strReport & "New Layer: " & vbCrLf
'              For lngIndex2 = 0 To pNewTable.Fields.FieldCount - 1
'                strReport = strReport & "--> " & pNewTable.Fields.Field(lngIndex2).Name & vbCrLf
'              Next lngIndex2
'
'              MsgBox "Found New Field: [" & pOrigField.Name & "]" & vbCrLf & strReport
              
              ' MAKE CLONE OF FIELD
459:               Set pClone = pOrigField
460:               Set pNewField = pClone.Clone
461:               pQueryFilter.AddField pOrigField.Name
              
              
              
              
              
              ' ADD FIELD TO NEW RASTER VAT
  '             MsgBox pNewField.Name
469:               pGridTableOp.AddField pNewRasterDataset, pNewField
470:               intNewFieldIndex = intNewFieldIndex + 1
              
              ' KEEP RECORD OF INDEX VALUES OF ORIGINAL VAT FIELD AND NEW VAT FIELD.  USE THESE TO TRANSFER VALUES LATER
473:               intIndexArray(intNewFieldIndex, 0) = pOrigTable.FindField(pOrigField.Name)                ' ORIGINAL VAT
474:               intIndexArray(intNewFieldIndex, 1) = pNewTable.FindField(pNewField.Name)              ' NEW VAT
475:             End If
476:           Next lngIndex
          
478:           If booAddedFields Then
            ' CURSOR WILL WORK THROUGH ROWS IN NEW DATASET, AND QUERY FOR ROWS IN ORIGINAL DATASET USING VALUES FROM [VALUE] FIELD.
480:             Set pNewCursor = pGridTableOp.Update(pNewRasterDataset, Nothing, False)
481:             Set pNewRow = pNewCursor.NextRow
482:             Do While Not pNewRow Is Nothing
483:               lngValue = pNewRow.Value(lngNewValField)
             
485:               pQueryFilter.WhereClause = """Value"" = " & CStr(lngValue)
486:               Set pOrigCursor = pOrigTable.Search(pQueryFilter, False)      ' QUERY FOR VALUE
487:               Set pOrigRow = pOrigCursor.NextRow
488:               If Not pOrigRow Is Nothing Then                           ' SHOULD NEVER BE "NOTHING"
489:                 For lngIndex = 0 To intNewFieldIndex
490:                   pNewRow.Value(intIndexArray(lngIndex, 1)) = pOrigRow.Value(intIndexArray(lngIndex, 0))
  '                Debug.Print lngValue & ":  Transferring Value '" & CStr(pOrigRow.Value(intIndexArray(lngIndex, 0))) _
                     & " to new field [" & pNewTable.Fields.Field(intIndexArray(lngIndex, 1)).Name & "]"
493:                 Next lngIndex
494:                 pNewRow.Store
495:                 pNewCursor.UpdateRow pNewRow
496:               End If
              
498:               Set pNewRow = pNewCursor.NextRow
              
500:             Loop ' LOOPING THROUGH ROWS OF NEW RASTER VAT
501:           End If ' DONE CHECKING IF NEW FIELDS WERE ADDED
502:         End If   ' DONE CHECKING IF BOTH ORIGINAL AND CLIPPED RASTER HAVE TABLES
        
        ' ADD LAYER TO MAP
505:         Set pClipLayer = pClipRasterLayer
506:         Set pDataset = pClipRasterLayer
507:         strClipName = pDataset.BrowseName
508:         pClipLayer.Name = strClipName
509:         m_pMxDoc.AddLayer pClipLayer
510:         strReport = strReport & strName & vbCrLf & _
            "  --> Saved to " & pDataset.Workspace.PathName & pDataset.Name & "... " & vbCrLf & vbCrLf
512:       End If
513:     End If
    
515:   Next anIndex
  
  ' IF POLYGON HAND-DRAWN OR SELECTED FROM GRAPHICS, ADD NEW CORRIDOR DESIGNER GRAPHIC TO SCREEN ILLUSTRATING CLIPPING AREA
518:   If ext.CorrPolygonIsDrawn Then
  
    'MAKE SPATIAL ELEMENT
    Dim pElement As IElement
    Dim pPolygonElement As IPolygonElement
    Dim pSpatialReference As ISpatialReference
    Dim pGraphicElement As IGraphicElement
    Dim pElementProperties As IElementProperties
    Dim pGraCont As IGraphicsContainer
    
    Dim pClonePoly As IPolygon
529:     Set pClone = ext.PolyCorridor
530:     Set pClonePoly = pClone.Clone
    
    'ADD GEOMETRY, NAME AND SPATIAL REFERENCE TO GRAPHIC ELEMENT
533:     Set pGraCont = m_pMxDoc.ActiveView
534:     Set pElement = New PolygonElement
535:     Set pClonePoly.SpatialReference = m_pMxDoc.ActiveView.FocusMap.SpatialReference
536:     pElement.Geometry = pClonePoly
537:     Set pGraphicElement = pElement
538:     Set pSpatialReference = pClonePoly.SpatialReference
539:     Set pGraphicElement.SpatialReference = pSpatialReference
540:     Set pElementProperties = pElement
541:     pElementProperties.Name = "delete_corridors"
    
    ' ADD CORRIDOR DESIGNER POLYGON SYMBOL
    Dim pFillShapeElement As IFillShapeElement
545:     Set pFillShapeElement = Linkages.CorridorAnalysisFunctions.ApplyCorridorSymbol(pElement)
    
    ' ADD GRAPHIC TO GRAPHICS CONTAINER
548:     pGraCont.AddElement pFillShapeElement, 0
  
   'Draw
551:     m_pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, pPolygon.Envelope
    
  
554:   End If
  
556:   m_pMxDoc.UpdateContents
  
'  MsgBox strReport
  Dim frmReportForm As New frmReport_modal
560:   frmReportForm.txtReport.Text = strReport
561:   frmReportForm.Show vbModal
  
563:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdSelLink_Click()
  On Error GoTo ErrorHandler

573:   m_IntHelpCategory = 1
'  Call UpdateHelpScreen
  Dim frmSelect As Linkages.frmSelScreen
    
  Dim ext As Linkages.clsExtension
578:   Set ext = m_ExtensionConfig
  
  Dim theFormObject As Object
581:   Set theFormObject = ext.aSelForm
  
583:   If (theFormObject Is Nothing) Then
584:     Set frmSelect = New Linkages.frmSelScreen
  
    ' IDENTIFY POLYGON THEMES AND GRAPHICS
    Dim pMxDoc As IMxDocument
588:     Set pMxDoc = m_pMxDoc
  
    Dim colPolygonLayers As New Collection
    Dim strNameArray() As String
    
    Dim theMap As IMap
    Dim pEnumLayer As IEnumLayer
    Dim pFeatureLayer As IFeatureLayer
    Dim pLayer As IUnknown
    Dim anIndex As Long
    Dim strPolyName As String
    Dim intKey As Integer
    
    Dim pFeatureClass As IFeatureClass
    Dim pGeometryType As esriGeometryType
    
604:     intKey = -1
    
606:     Set theMap = pMxDoc.FocusMap
    
    ' CHECK IF GRAPHICS LAYER IS AVAILABLE
    Dim pGraphicsContainer As IGraphicsContainer
610:     Set pGraphicsContainer = theMap
    
    Dim pEnvelope As IEnvelope
613:     Set pEnvelope = pMxDoc.ActiveView.FullExtent
    Dim pEnumElement As IEnumElement
    
616:     Set pEnumElement = pGraphicsContainer.LocateElementsByEnvelope(pEnvelope)
'    MsgBox (pEnumElement Is Nothing)
    
    Dim booHasPolygon As Boolean
620:     booHasPolygon = True
'    booHasPolygon = False
'
'    If (Not pEnumElement Is Nothing) Then
'      pEnumElement.Reset
'
'      Dim pElement As IElement
'      Set pElement = pEnumElement.Next
'
'      Dim pGeometry As IGeometry
'
'      Do Until pElement Is Nothing
'        Set pGeometry = pElement.Geometry
'        If TypeOf pGeometry Is IPolygon Then
'          booHasPolygon = True
'          Exit Do
'        End If
'        Set pElement = pEnumElement.Next
'      Loop
'    End If
    
'    MsgBox booHasPolygon
    
  '  ReDim strNameArray(theMap.LayerCount)
    
    ReDim strNameArray(Linkages.MyGeneralOperations.TrueLayerCount(theMap))
    
647:     If (booHasPolygon) Then
648:       intKey = intKey + 1
649:       strPolyName = "1] <-- Select or Draw Graphic Polygon -->"
650:       colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
651:       strNameArray(intKey) = strPolyName
652:     End If
            
    Dim pFeatureLayerForValid As IFeatureLayer
    
656:     If (theMap.LayerCount > 0) Then
657:       Set pEnumLayer = theMap.Layers(, True)
658:       pEnumLayer.Reset
      
660:       Set pLayer = pEnumLayer.Next
661:       Do Until pLayer Is Nothing
662:         If TypeOf pLayer Is IFeatureLayer Then
663:           Set pFeatureLayerForValid = pLayer
          ' CHECK IF FEATURE LAYER IS VALID
665:           If pFeatureLayerForValid.Valid Then
            ' CHECK IF POLYGON LAYER
667:             Set pFeatureClass = pFeatureLayerForValid.FeatureClass
668:             pGeometryType = pFeatureClass.ShapeType
669:             If (pGeometryType = esriGeometryPolygon) Then
670:               intKey = intKey + 1
671:               Set pFeatureLayer = pLayer
672:               strPolyName = CStr(intKey + 1) & "] " & pFeatureLayer.Name
673:               colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
674:               strNameArray(intKey) = strPolyName
675:             End If
676:           End If
677:         End If
678:         Set pLayer = pEnumLayer.Next
679:       Loop
680:     End If
           
'    Dim theReport As String
'    For anIndex = 0 To intKey
'      theReport = theReport & strNameArray(anIndex) & vbCrLf
'    Next anIndex
'    MsgBox theReport
    
688:     Set frmSelect.ArcApplication = m_pApp
689:     Set frmSelect.Doc = m_pMxDoc
690:     frmSelect.NameList = strNameArray
691:     frmSelect.NameCount = intKey
692:     Set frmSelect.NameCollection = colPolygonLayers
693:     frmSelect.PolygonPurpose = "Clip"
694:     frmSelect.SearchMessage = "Species Corridor"

696:     frmSelect.EnableTool = False
697:     frmSelect.SetSelToolEnabled
698:     Load frmSelect

700:     frmSelect.Frame.Caption = "Select Species Corridor Polygon..."
701:     frmSelect.Frame.Visible = True
702:   Else
703:     Set frmSelect = theFormObject
704:   End If
  
'  frmSelect.Show vbModeless
707:   frmSelect.Frame.Visible = True
708:   Me.Frame.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "cmdSelLink_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub UpdateCheckmarks()
  On Error GoTo ErrorHandler

  Dim ext As Linkages.clsExtension
718:   Set ext = m_ExtensionConfig
  
  Dim pCorPolygon As IPolygon
721:   Set pCorPolygon = ext.PolyCorridor
722:   imgCheckSpCorr.Visible = (Not ext.PolyCorridor Is Nothing)
723:   imgCheckClipLayers.Visible = lbxClipLayers.SelCount > 0
  
725:   imgUnCheckSpCorr.Visible = Not imgCheckSpCorr.Visible
726:   imgUncheckClipLayers.Visible = Not imgCheckClipLayers.Visible
  
  Dim strPathName As String
729:   strPathName = txtOutput.Text
  
731:   imgCheckPathname.Visible = Linkages.aml_func_mod.ExistFileDir(strPathName)
732:   imgUncheckPathname.Visible = Not imgCheckPathname.Visible
  
  Exit Sub
ErrorHandler:
  HandleError True, "UpdateCheckmarks " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler

742:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
743:   lblWorking.Visible = False
744:   imgIcon.Visible = False
745:   Me.Left = (Screen.Width / 3) - (Me.Width / 2)
746:   Me.Top = (Screen.Height / 2) - (Me.Height / 2)
  
748:   If m_Frame Is Nothing Then
749:     Set m_Frame = New ModelessFrame
750:     m_Frame.Create Me
'    Set m_WindowPos = m_Frame
'    MsgBox m_WindowPos.Width & "    x    " & m_WindowPos.Height
753:   End If
  
  ' CLEAR ANY SAVED EXTENSION POLYGONS
  Dim newUid As New uID
757:   newUid.Value = "Linkages.clsExtension"
758:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  Dim ext As Linkages.clsExtension
760:   Set ext = m_ExtensionConfig
  
762:   Set ext.PolyCorridor = Nothing
  
      ' IDENTIFY POLYGON THEMES
  Dim pMxDoc As IMxDocument
766:   Set pMxDoc = m_pMxDoc

  Dim colPolygonLayers As New Collection
  Dim colClipLayers As New Collection
  Dim strNameArray() As String
  
  Dim theMap As IMap
  Dim pEnumLayer As IEnumLayer
  Dim pFeatureLayer As IFeatureLayer
  Dim pRasterLayer As IRasterLayer
  Dim pLayer As IUnknown
  Dim anIndex As Long
  Dim strPolyName As String
  Dim intKey As Integer
  Dim intClipIndex As Integer
  
  Dim pFeatureClass As IFeatureClass
  Dim pGeometryType As esriGeometryType
  
785:   intKey = 1
786:   intClipIndex = 0
  
788:   Set theMap = pMxDoc.FocusMap
  
'  ReDim strNameArray(theMap.LayerCount + 2)
  
  ReDim strNameArray(2 + Linkages.MyGeneralOperations.TrueLayerCount(theMap))
            
794:   colPolygonLayers.Add "placeholder_FirstLine", "FirstLine"
795:   strNameArray(0) = "FirstLine"
  
797:   colPolygonLayers.Add "placeholder_SelFromView", "SelFromView"
798:   strNameArray(1) = "SelFromView"
  
  Dim strShapeName As String
  
  Dim pFeatureLayerForValid As IFeatureLayer
  
  Dim strClipNames() As String
'  ReDim strClipNames(theMap.LayerCount)
  
  ReDim strClipNames(Linkages.MyGeneralOperations.TrueLayerCount(theMap))
  
  Dim strClipName As String
  
811:   If (theMap.LayerCount > 0) Then
812:     Set pEnumLayer = theMap.Layers(, True)
813:     pEnumLayer.Reset
    
815:     Set pLayer = pEnumLayer.Next
816:     Do Until pLayer Is Nothing
817:       If TypeOf pLayer Is IFeatureLayer Then
818:         Set pFeatureLayerForValid = pLayer
        ' CHECK IF FEATURE LAYER IS VALID
820:         If pFeatureLayerForValid.Valid Then
          ' CHECK IF POLYGON LAYER
822:           Set pFeatureClass = pFeatureLayerForValid.FeatureClass
823:           pGeometryType = pFeatureClass.ShapeType
824:           strShapeName = Linkages.aml_func_mod.ReturnShapeName(pGeometryType)
825:           Set pFeatureLayer = pLayer
826:           If (pGeometryType = esriGeometryPolygon) Then
827:             intKey = intKey + 1
828:             strPolyName = CStr(intKey - 1) & "] " & pFeatureLayer.Name
829:             colPolygonLayers.Add pFeatureLayer, CStr(strPolyName)
830:             strNameArray(intKey) = strPolyName
831:           End If
          
          ' ADD TO CLIP LAYERS REGARDLESS OF SHAPE TYPE
834:           intClipIndex = intClipIndex + 1
835:           strClipName = CStr(intClipIndex) & "] " & pFeatureLayer.Name & "  (" & _
              strShapeName & " Dataset)"
837:           colClipLayers.Add pFeatureLayer, strClipName
838:           strClipNames(intClipIndex - 1) = strClipName
839:         End If
840:       ElseIf TypeOf pLayer Is IRasterLayer Then
841:         Set pRasterLayer = pLayer
842:         If pRasterLayer.Valid = True Then
843:           intClipIndex = intClipIndex + 1
844:           strClipName = CStr(intClipIndex) & "] " & pRasterLayer.Name & _
              " (Raster Dataset)"
846:           colClipLayers.Add pRasterLayer, strClipName
847:           strClipNames(intClipIndex - 1) = strClipName
848:         End If
849:       End If
850:       Set pLayer = pEnumLayer.Next
851:     Loop
852:   End If
  
854:   m_strNameArray = strNameArray
855:   Set m_colPolygons = colPolygonLayers
  
857:   Set m_ColClipLayers = colClipLayers
  
  ' FILL LISTBOXES WITH DATA SOURCE OPTIONS
  ' CORRIDOR POLYGON OPTIONS
  Dim strCorArray() As String
  ReDim strCorArray(intKey)
863:   strCorArray(0) = "Species Corridor Source..."
864:   strCorArray(1) = "<-- Select by clicking on map -->"
  
866:   If UBound(m_strNameArray) >= 2 Then
867:     For anIndex = 2 To UBound(m_strNameArray)
868:       If Not m_strNameArray(anIndex) = "" Then
869:         strCorArray(anIndex) = m_strNameArray(anIndex)
870:       End If
871:     Next anIndex
872:   End If
  
874:   cbxCorridor.Clear
  
876:   For anIndex = 0 To UBound(strCorArray)
877:     cbxCorridor.AddItem (strCorArray(anIndex))
878:   Next anIndex
    
880:   cbxCorridor.ListIndex = 0
  
  ' CLIP LAYERS
  ReDim Preserve strClipNames(intClipIndex)
884:   If intClipIndex > 0 Then
885:     For anIndex = 0 To intClipIndex - 1
886:       lbxClipLayers.AddItem strClipNames(anIndex)
887:     Next anIndex
888:   End If
889:   lbxClipLayers.ListIndex = -1
890:   cmdSelLink.Enabled = False
  
  ' WORKSPACE
  ' FIRST SEE IF IT HAS BEEN SAVED TO EXTENSION PROPERTIES.  THIS PROPERTY WILL BE EMPTY THE FIRST TIME THE DIALOG
  '      IS OPENED, BUT EACH TIME THEREAFTER IT WILL HAVE A VALUE.
  ' IF NOT IN EXTENSION PROPERTY, THEN CHECK ArcGIS LAST SAVE TO LOCATION
  ' IF THIS DOESN'T WORK, USE MxDoc PATH NAME.
  Dim strDirPath As String
  Dim strUserName As String
  
900:   strDirPath = ext.ClipDirectoryPath
901:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
902:     strDirPath = Linkages.aml_func_mod.ReturnArcGISGeneralDir(enumLastSaveToLocation)
903:   End If
904:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
905:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
906:     strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
907:   End If

909:   If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then
910:     strDirPath = strDirPath & "\"
911:   End If
  
913:   txtOutput.Text = strDirPath
  
  ' MAKE SURE BACK COLORS ARE WHITE
916:   Call SetBackColorsWhite
  
918:   Call UpdateCheckmarks

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub EnableOKButton()
  On Error GoTo ErrorHandler


  Dim booPolysOK As Boolean
929:   booPolysOK = imgCheckSpCorr.Visible
  
931:   cmdOK.Enabled = booPolysOK And lbxClipLayers.SelCount > 0
  
'  MsgBox "optUseAll.Value = " & optUseAll.Value & vbCrLf & _
'         "(cbxPatchField.ListIndex > 1) = " & (cbxPatchField.ListIndex > 1) & vbCrLf & _
'         "(txtValue.Text <> "") = " & (txtValue.Text <> "") & vbCrLf & _
'         "((optUseAll.Value) Or ((cbxPatchField.ListIndex > 1) And (txtValue.Text <> ..))) = " & _
'         ((optUseAll.Value) Or ((cbxPatchField.ListIndex > 1) And (txtValue.Text <> ""))) & vbCrLf
         
  

  Exit Sub
ErrorHandler:
  HandleError True, "EnableOKButton " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub Form_Unload(Cancel As Integer)

949:   Set m_pMxDoc = Nothing
950:   Set m_pApp = Nothing
951:   Set m_Frame = Nothing
952:   Set m_colPolygons = Nothing
953:   Set m_ColClipLayers = Nothing
954:   Set m_ExtensionConfig = Nothing
  
End Sub

Private Sub lbxClipLayers_Click()
  On Error GoTo ErrorHandler

961:   Call UpdateCheckmarks
962:   Call EnableOKButton

  Exit Sub
ErrorHandler:
  HandleError True, "lbxClipLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
