VERSION 5.00
Begin VB.Form frmCombineLayerID 
   Caption         =   " Create Cumulative Corridor Surface:"
   ClientHeight    =   6540
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5250
   Icon            =   "frmCombineLayerID.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6540
   ScaleWidth      =   5250
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkSetZero 
      Caption         =   "Set Zero Values to NoData"
      Height          =   435
      Left            =   240
      TabIndex        =   4
      Top             =   4575
      Width           =   4800
   End
   Begin VB.TextBox txtTransparency 
      Alignment       =   2  'Center
      Height          =   300
      Left            =   3405
      TabIndex        =   5
      Text            =   "txtTransparency"
      Top             =   4995
      Width           =   1305
   End
   Begin VB.TextBox txtLabels 
      Alignment       =   2  'Center
      Height          =   300
      Left            =   2783
      TabIndex        =   3
      Text            =   "txtLabels"
      Top             =   4230
      Width           =   2190
   End
   Begin VB.CheckBox chkUseSelected 
      Caption         =   "When adding polygon layers, restrict analysis to only selected polygons if any are selected."
      Height          =   435
      Left            =   240
      TabIndex        =   2
      Top             =   3750
      Width           =   4800
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   360
      Left            =   4590
      Picture         =   "frmCombineLayerID.frx":058A
      Style           =   1  'Graphical
      TabIndex        =   7
      ToolTipText     =   "Browse for Output Feature Class..."
      Top             =   5715
      Width           =   555
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   105
      TabIndex        =   6
      Text            =   "txtOutput"
      Top             =   5730
      Width           =   4425
   End
   Begin VB.CommandButton cmdManual 
      Caption         =   "Help"
      Height          =   345
      Left            =   2098
      TabIndex        =   9
      Top             =   6195
      Width           =   1065
   End
   Begin VB.TextBox txtMessage 
      Height          =   960
      Left            =   75
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      TabStop         =   0   'False
      Text            =   "frmCombineLayerID.frx":0600
      Top             =   75
      Width           =   5115
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   3171
      TabIndex        =   10
      Top             =   6195
      Width           =   1065
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   1015
      TabIndex        =   8
      Top             =   6195
      Width           =   1065
   End
   Begin VB.ListBox lbxLayers 
      Height          =   2085
      Left            =   75
      Style           =   1  'Checkbox
      TabIndex        =   1
      Top             =   1305
      Width           =   5115
   End
   Begin VB.Label lblPercent 
      AutoSize        =   -1  'True
      Caption         =   "%"
      Height          =   195
      Left            =   4800
      TabIndex        =   16
      Top             =   5040
      Width           =   120
   End
   Begin VB.Label lblTransparency 
      AutoSize        =   -1  'True
      Caption         =   "Output Raster LayerTransparency (0 - 100):"
      Height          =   195
      Left            =   285
      TabIndex        =   15
      Top             =   5040
      Width           =   3075
   End
   Begin VB.Label lblLabel 
      AutoSize        =   -1  'True
      Caption         =   "Output Raster Layer legend labels:"
      Height          =   195
      Left            =   278
      TabIndex        =   14
      Top             =   4275
      Width           =   2445
   End
   Begin VB.Label lblOptions 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Analysis Options --"
      Height          =   195
      Left            =   1920
      TabIndex        =   13
      Top             =   3510
      Width           =   1425
   End
   Begin VB.Image imgOptionsBack 
      BorderStyle     =   1  'Fixed Single
      Height          =   1965
      Left            =   15
      Top             =   3450
      Width           =   5220
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   5025
      Picture         =   "frmCombineLayerID.frx":060F
      Top             =   6315
      Width           =   225
   End
   Begin VB.Label lblOutputName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Output Raster:"
      Height          =   195
      Left            =   90
      TabIndex        =   12
      Top             =   5520
      Width           =   1035
   End
   Begin VB.Image imgBackBottom 
      BorderStyle     =   1  'Fixed Single
      Height          =   720
      Left            =   15
      Top             =   5430
      Width           =   5220
   End
   Begin VB.Label lblLayer 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      Caption         =   "-- Select Layers to Combine --"
      Height          =   195
      Left            =   1590
      TabIndex        =   11
      Top             =   1095
      Width           =   2070
   End
   Begin VB.Image imgBackTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   3420
      Left            =   15
      Top             =   15
      Width           =   5220
   End
End
Attribute VB_Name = "frmCombineLayerID"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pLayerArray As esriSystem.IVariantArray
Private m_pLayerFields As esriSystem.IVariantArray
Private m_strSelLayerName As String
Private m_booSelToggle As Boolean
Private m_pThisExt As Linkages.clsExtension
Private m_ShapeTypeOption As JenLayerTypes
Private m_pReturnArray As esriSystem.IVariantArray
Private m_strOutputWorkspace As String
Private m_strOutputBasename As String
Private m_lngOutputWSType As JenDatasetTypes
Private m_pOutputWS As IWorkspace
Private m_booOutputFeatDataset As Boolean
Private m_strOutputFeatDatasetName As String
Private m_booOutputIsFClass As Boolean         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
 
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\frmCombineLayerID.frm"
 
Public Property Set ArcApplication(ByVal pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
 
26:   Set m_pApp = pParams.Element(0)
27:   m_ShapeTypeOption = ENUM_jenPolygonLayers + ENUM_jenRasterLayers
28:   Set m_pThisExt = pParams.Element(2)

30:   Set m_pMxDoc = pParams.Element(1)
 
  Dim pSelItem As IUnknown
33:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pLayer As ILayer
  Dim pStandaloneTable As IStandaloneTable
  Dim lngIndex As Long
  Dim pUnknown As IUnknown

39:   m_strSelLayerName = ""
 
41:   If Not pSelItem Is Nothing Then
42:     If TypeOf pSelItem Is ILayer Then
43:       Set pLayer = pSelItem
44:       m_strSelLayerName = pLayer.Name
45:     ElseIf TypeOf pSelItem Is IStandaloneTable Then
46:       Set pStandaloneTable = pSelItem
47:       m_strSelLayerName = pStandaloneTable.Name
48:     End If
49:   End If

51:   m_pThisExt.ShouldContinue = False
52:   m_booSelToggle = False

  ' FILL LAYER ARRAY AND LISTBOX
55:   lbxLayers.Clear
  Dim lngStartSel As Long
57:   lngStartSel = 0
58:   Set m_pLayerArray = Linkages.MyGeneralOperations.ReturnLayersByType(m_pMxDoc.FocusMap, m_ShapeTypeOption)
59:   If m_pLayerArray.Count > 0 Then
60:     For lngIndex = 0 To m_pLayerArray.Count - 1
61:       Set pUnknown = m_pLayerArray.Element(lngIndex)
62:       If TypeOf pUnknown Is ILayer Then
63:         Set pLayer = m_pLayerArray.Element(lngIndex)
64:         If pLayer.Valid Then
65:           If TypeOf pLayer Is IFeatureLayer Then
66:             lbxLayers.AddItem pLayer.Name & " ......... Polygon Layer"
67:           ElseIf TypeOf pLayer Is IRasterLayer Then
68:             lbxLayers.AddItem pLayer.Name & " ......... Raster Layer"
69:           Else
70:             lbxLayers.AddItem pLayer.Name & " ......... Unknown Layer Type"
71:           End If
72:           If pLayer.Name = m_strSelLayerName Then lngStartSel = lngIndex
73:         End If
74:       ElseIf TypeOf pUnknown Is IStandaloneTable Then
75:         Set pStandaloneTable = m_pLayerArray.Element(lngIndex)
76:         If pStandaloneTable.Valid Then
77:           lbxLayers.AddItem pStandaloneTable.Name
78:           If pStandaloneTable.Name = m_strSelLayerName Then lngStartSel = lngIndex
79:         End If
80:       End If
81:     Next lngIndex
82:     lbxLayers.ListIndex = lngStartSel
83:   End If

85:   txtMessage.Text = "This tool will create a cumulative surface where each cell value reflects the total number of either polygons or non-null cell values at that point, drawn from the selected polygon and raster layers below.  Please make sure all selected rasters are in the same projection before running this tool. "

       
  ' FILL OUTPUT RASTER SECTION
  Dim strRasterName As String
90:   strRasterName = "corridors"
  
  ' WORKSPACE
  ' WE WILL ALWAYS START BY SUGGESTING A GRID IN THE CURRENT DOC DIRECTORY
  Dim strDirPath As String
  Dim strUserName As String
  Dim lngDatasetType As JenDatasetTypes
  
98:   lngDatasetType = ENUM_File_Raster
99:   m_lngOutputWSType = ENUM_File_Raster
  
101:   strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
102:   strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
  
  Dim pWsFact As IWorkspaceFactory2
  Dim pFeatWS As IWorkspace
  Dim strForTextbox As String
  Dim strWsPathname As String
  Dim strBaseName As String
            
110:   If Right(strDirPath, 1) = "\" Or Right(strDirPath, 1) = "/" Then
111:     strDirPath = Left(strDirPath, Len(strDirPath) - 1)
112:   End If
113:   Set pWsFact = New RasterWorkspaceFactory
'   MsgBox "strDirPath = " & strDirPath
'   MsgBox "Me.hWnd = " & CStr(Me.hWnd)
116:   Set pFeatWS = pWsFact.OpenFromFile(strDirPath, Me.hWnd)
117:   Set m_pOutputWS = pFeatWS
118:   strWsPathname = strDirPath
  
120:   If Right(strWsPathname, 1) = "\" Then strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
  
122:   m_strOutputWorkspace = m_pThisExt.WS_CumulativeCorridor
123:   If Right(m_strOutputWorkspace, 1) = "\" Then m_strOutputWorkspace = Left(m_strOutputWorkspace, Len(m_strOutputWorkspace) - 1)
124:   If m_strOutputWorkspace = "" Or Not Linkages.aml_func_mod.ExistFileDir(m_strOutputWorkspace) Then
125:     m_strOutputWorkspace = strWsPathname
126:   End If
  
128:   strRasterName = Linkages.MyGeneralOperations.MakeUniqueRasterName(ENUM_File_Raster, m_strOutputWorkspace, strRasterName, True)
129:   m_strOutputBasename = strRasterName
  
  ' PRESET ANALYSIS OPTIONS
132:   If m_pThisExt.WS_CumulativeUseSelected Then
133:     chkUseSelected.Value = 1
134:   Else
135:     chkUseSelected.Value = 0
136:   End If
  
  Dim lngTransparency As Long
139:   lngTransparency = Int(m_pThisExt.WS_CumulativeTransparency)
140:   If lngTransparency < 0 Or lngTransparency > 100 Then
141:     lngTransparency = 0
142:   End If
143:   txtTransparency.Text = CStr(lngTransparency)
144:   If m_pThisExt.WS_CumulativeLabel = "" Then
145:     txtLabels.Text = " Layers"
146:   Else
147:     txtLabels.Text = m_pThisExt.WS_CumulativeLabel
148:   End If
  
150:   If m_pThisExt.WS_ZeroToNoData Then
151:     chkSetZero.Value = 1
152:   Else
153:     chkSetZero.Value = 0
154:   End If
  
156:   txtOutput.Text = m_strOutputWorkspace & "\" & strRasterName
  

  ' CLEAR INITIAL SELECTION
160:   Set m_pThisExt.frmCombineLayerIDReturn = Nothing

 
 Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Public Property Get ReturnArray() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
 
171:   Set ReturnArray = m_pReturnArray
 
  Exit Property
ErrorHandler:
  HandleError True, "ReturnArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
 
181:   cmdOK.Enabled = lbxLayers.SelCount > 0 And txtOutput.Text <> ""
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdGetWorkspace_Click()
  On Error GoTo ErrorHandler

  Dim pGxDialog As IGxDialog

  ' SET DEFAULT NAME
  Dim strDefault As String
195:   If m_lngOutputWSType = ENUM_Shapefile Then
196:     strDefault = Linkages.MyGeneralOperations.MakeUniqueShapeFilename(txtOutput.Text)
197:   Else
198:     strDefault = txtOutput.Text
199:   End If

  ' SAMPLE CODE BELOW
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDatasetName As String
  Dim strCategory As String
  Dim strBaseName As String
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection
  Dim pCategory As JenDatasetTypes
  Dim lngReturn As VbMsgBoxResult
  Dim booValidDataset As Boolean

'  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName

223:   booValidDataset = False
  
  ' GET ARCGIS VERSION NUMBER
  Dim strVersion As String
227:   strVersion = aml_func_mod.ReturnArcGISVersion
  Dim str2() As String
229:   str2 = Split(strVersion, ".")
  Dim booIs92 As Boolean
231:   booIs92 = False
232:   If UBound(str2) > 1 Then
    Dim lngMajor As Long
    Dim lngMinor As Long
235:     If IsNumeric(str2(0)) And IsNumeric(str2(1)) Then
236:       lngMajor = CLng(str2(0))
237:       lngMinor = CLng(str2(1))
238:       booIs92 = (lngMajor = 9 And lngMinor >= 2) Or (lngMajor > 9)
239:     End If
240:   End If
  Dim pGxFilter1 As IGxObjectFilter
  Dim pGxFilter3 As IGxObjectFilter
  
  Dim booIs10 As Boolean
245:   booIs10 = Linkages.aml_func_mod.IsVersion10
  
247:   Do Until booValidDataset = True
  
249:     Set pGxDialog = New GxDialog
250:     Set pFilterCol = pGxDialog
    
    ' GRID FILTER
253:     If Not booIs10 Then
254:       Set pGxFilter1 = New RasterFormatGridFilter
255:       pFilterCol.AddFilter pGxFilter1, True
256:     End If
    
    ' ADD FILE GEODATABASE OPTION IF BETTER THAN 9.2
    ' AS OF APRIL 28, 2009:  UNABLE TO FIGURE OUT HOW TO CREATE FILE GEODATABASE RASTERS SUCCESSFULLY.  REMOVE THIS
    ' OPTION UNTIL I GET IT FIGURED OUT.
'    If booIs92 Then
'      ' FGDB RASTER FILTER
'      Ver92Functions.AddFileGDBFilter pFilterCol
'    End If
    
'    ' PERSONAL GDB RASTER FILTER
'    Set pGxFilter3 = New RasterFormatPGDBFilter
'    pFilterCol.AddFilter pGxFilter3, False
    
270:     With pGxDialog
271:       .AllowMultiSelect = False
272:       .StartingLocation = m_strOutputWorkspace
273:       .Title = "Enter the name of your new raster:"
274:       .Name = m_strOutputBasename
275:     End With
  
277:     If Not pGxDialog.DoModalSave(Me.hWnd) Then
      Exit Sub 'Exit if user press Cancel
279:     End If
    
281:     Set pGxObj = pGxDialog.FinalLocation
282:     strWsPathname = pGxObj.FullName
283:     strBaseName = pGxDialog.Name
    
285:     m_strOutputWorkspace = pGxObj.FullName
    
287:     booValidDataset = True
 '  MsgBox "WS = " & m_strflatareaWS & vbCrLf & "Name = " & m_strflatareaName & vbCrLf & "Category = " & pGxObj.Category
    
    ' FOR SAMPLE; GET CATEGORY
    Dim pWsFact As IWorkspaceFactory
292:     Set pWsFact = New RasterWorkspaceFactory
    Dim pRastWS As IRasterWorkspace
    Dim pRastWsEx As IRasterWorkspaceEx
'    Set pRastWS = pWSFact.OpenFromFile(strWsPathname, Me.hWnd)
    
297:     strCategory = pGxObj.Category
    Select Case strCategory
      Case "Shapefile", "Folder", "dBASE Table", "Raster Dataset"                               ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
300:         pCategory = ENUM_File_Raster
301:         booValidDataset = True
302:         strBaseName = Linkages.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
303:         Set pRastWS = pWsFact.OpenFromFile(strWsPathname, Me.hWnd)
304:         Set m_pOutputWS = pRastWS
      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table", _
           "File Geodatabase Raster Dataset"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
308:         Set pWsFact = New FileGDBWorkspaceFactory
309:         pCategory = ENUM_FileGDB
        ' REMOVE ".SHP" IF PRESENT
311:         If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
        
        ' MAKE SURE WE ARE REALLY IN A FILE GEODATABASE!
314:         If Not Right(strWsPathname, 4) = ".gdb" Then
315:           booValidDataset = False
316:           MsgBox "Problem: Workspace is not a File Geodatabase!" & vbCrLf & vbCrLf & strWsPathname & vbCrLf & vbCrLf & _
              "Please open an existing File Geodatabase to save this raster in..."
318:         Else
319:           booValidDataset = True
          ' REPLACE ODD CHARACTERS
321:           strBaseName = Linkages.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
322:           Set pRastWsEx = pWsFact.OpenFromFile(strWsPathname, Me.hWnd)
323:           Set m_pOutputWS = pRastWsEx
324:         End If
      Case Else
326:         lngReturn = MsgBox("Unexpected Raster Type (" & strCategory & ")!" & vbCrLf & _
            "This function will only create ESRI Grids or File Geodatabase Rasters.  Please click 'OK' to select a " & vbCrLf & _
            "new Raster Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Raster Type:")
329:         If lngReturn = vbOK Then
330:           booValidDataset = False
331:         Else
          Exit Sub
333:         End If
334:     End Select
335:   Loop
  
337:   m_strOutputBasename = strBaseName
338:   m_lngOutputWSType = pCategory

340:   txtOutput.Text = m_strOutputWorkspace & "\" & m_strOutputBasename
341:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 


Private Sub txtOutput_Change()
  On Error GoTo ErrorHandler
 
353:   txtOutput.BackColor = &H80000005

  
356:   CheckEnable
  
  Exit Sub
ErrorHandler:
  HandleError True, "txtOutput_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler

  Dim strPath As String
366:   strPath = App.Path & "\help"
  
368:   Call Linkages.MyGeneralOperations.OpenDoc("Cumulative_Surface_Subdocument.pdf", strPath)
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

378:   m_pThisExt.ShouldContinue = False
379:   Set m_pThisExt.frmCombineLayerIDReturn = Nothing
380:   Set m_pReturnArray = Nothing
381:   Unload Me
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

391:   Set m_pReturnArray = New esriSystem.VarArray
  
  ' RETURN ARRAY WILL CONTAIN        Crosstab_Subdocument.pdf
  ' 0) VARIANT ARRAY OF SELECTED LAYERS
  ' 1) SPATIAL REFERENCE OF EITHER FIRST RASTER LAYER OR FIRST LAYER
  '    NOTE: FUNCTION WILL EXIT IF ANY SPATIAL REFERENCES ARE UNKNOWN OR UNDEFINED, OR IF
  '          RASTERS ARE NOT ALL SAME PROJECTION
  ' 2) BOOLEAN:  WHETHER ANY RASTERS ARE PRESENT
  ' 3) BOOLEAN:  WHETHER TO USE ONLY SELECTED POLYGONS
  ' 4) STRING:  NEW RASTER LAYER LABELS
  ' 5) BOOLEAN: WHETHER TO SET OUTPUT "ZERO" VALUES TO "NODATA"
  ' 6) LONG:  NEW RASTER LAYER TRANSPARENCY
  ' 7) VARIANT ARRAY:  CONTAINS 4 ITEMS
  '     0) OUTPUT AREA RASTER NAME
  '     1) OUTPUT RASTER WORKSPACE PATH
  '     2) OUTPUT RASTER WORKSPACE OBJECT; EITHER IRasterWorkspace or IRasterWorkspaceEx
  '     3) OUTPUT RASTER WORKSPACE TYPE; SHOULD ONLY BE ENUM_FileGDB = 2 OR ENUM_File_Raster = 32
  
  ' SELECTED LAYERS AND GET SPATIAL REFERENCE FOR OUTPUT FEATURE CLASS
  Dim booHasRaster As Boolean
  Dim pSpRef As ISpatialReference
  Dim pTestSpRef As ISpatialReference
  Dim booAllSpRefsKnown As Boolean
  Dim pGeoDataset As IGeoDataset
  
  Dim booAllRasterSpRefsSame As Boolean
    
  Dim pLayers As esriSystem.IArray
  Dim pLayer As ILayer
  Dim lngIndex As Long
  
422:   booAllSpRefsKnown = True
423:   booAllRasterSpRefsSame = True
  
  Dim strRasterSpRefReport As String
  Dim strUnknownReport As String
  Dim lngUnknownCounter As Long
428:   lngUnknownCounter = 0
  
430:   Set pLayers = New esriSystem.Array
  Dim pFirstSpRef As ISpatialReference
  
433:   For lngIndex = 0 To lbxLayers.ListCount - 1
434:     If lbxLayers.Selected(lngIndex) Then
435:       Set pLayer = m_pLayerArray.Element(lngIndex)
436:       pLayers.Add pLayer
      
438:       If TypeOf pLayer Is IGeoDataset Then
439:         Set pGeoDataset = pLayer
440:         Set pTestSpRef = pGeoDataset.SpatialReference
441:         If pTestSpRef Is Nothing Then
442:           booAllSpRefsKnown = False
443:           lngUnknownCounter = lngUnknownCounter + 1
444:           strUnknownReport = strUnknownReport & "  " & CStr(lngUnknownCounter) & "] " & pLayer.Name & vbCrLf
445:         Else
446:           If TypeOf pTestSpRef Is IUnknownCoordinateSystem Then
447:             booAllSpRefsKnown = False
448:             lngUnknownCounter = lngUnknownCounter + 1
449:             strUnknownReport = strUnknownReport & "  " & CStr(lngUnknownCounter) & "] " & pLayer.Name & vbCrLf
450:           End If
451:         End If
        
453:         If pFirstSpRef Is Nothing Then
454:           Set pFirstSpRef = pTestSpRef
455:         End If
        
457:       End If
      
459:       If TypeOf pLayer Is IRasterLayer Then
460:         booHasRaster = True
        
462:         If pSpRef Is Nothing Then
463:           Set pSpRef = pTestSpRef
464:         Else
465:           If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pTestSpRef) Then
466:             booAllRasterSpRefsSame = False
467:           End If
468:         End If
        
470:         strRasterSpRefReport = strRasterSpRefReport & _
          "  --> " & pLayer.Name & vbCrLf & _
          "       Spatial Reference = " & pTestSpRef.Name & vbCrLf
        
474:       End If
475:     End If
476:   Next lngIndex
  
  ' IF NO RASTER LAYERS, THEN pSpRef WILL NOT BE SET. JUST USE FIRST SPATIAL REFERENCE IN THIS CASE.
479:   If pSpRef Is Nothing Then
480:     Set pSpRef = pFirstSpRef
481:   End If
  
  ' MAKE SURE ALL LAYERS HAVE A DEFINED SPATIAL REFERENCE
484:   If Not booAllSpRefsKnown Then
485:     MsgBox "The following layers have an unknown or undefined spatial reference!" & vbCrLf & _
           strUnknownReport & vbCrLf & vbCrLf & "Please set the spatial references of all " & _
           "layers before running this function...", , "Failed to Create Raster:"
    Exit Sub
489:   End If

  ' MAKE SURE ALL RASTER LAYERS HAVE THE SAME SPATIAL REFERENCE
492:   If Not booAllRasterSpRefsSame Then
493:     MsgBox "The selected raster layers have different spatial reference!" & vbCrLf & _
           strRasterSpRefReport & vbCrLf & vbCrLf & "Please make sure all raster layers have " & _
           "the same spatial reference before running this function...", , "Failed to Create Raster:"
    Exit Sub
497:   End If
  
  ' ADD DATA TO OUTPUT ARRAY
500:   m_pReturnArray.Add pLayers
501:   m_pReturnArray.Add pSpRef
502:   m_pReturnArray.Add booHasRaster
 
 
 ' ANALYSIS OPTIONS
  Dim booUseSelected As Boolean
  Dim strLabels As String
  Dim booSetNoData As Boolean
  Dim lngTransparency As Long
  
511:   booUseSelected = chkUseSelected.Value = 1
512:   strLabels = txtLabels.Text
513:   If strLabels = "" Then
514:     strLabels = " "
515:   End If
516:   booSetNoData = chkSetZero.Value = 1
517:   lngTransparency = CLng(txtTransparency.Text)
  
519:   m_pReturnArray.Add booUseSelected
520:   m_pReturnArray.Add strLabels
521:   m_pReturnArray.Add booSetNoData
522:   m_pReturnArray.Add lngTransparency
  
524:   m_pThisExt.WS_CumulativeUseSelected = booUseSelected
525:   m_pThisExt.WS_CumulativeLabel = strLabels
526:   m_pThisExt.WS_ZeroToNoData = booSetNoData
527:   m_pThisExt.WS_CumulativeTransparency = lngTransparency
  
  ' CHECK FOR VALID WORKSPACE
  
  Dim strFullPath As String
532:   strFullPath = txtOutput.Text
  Dim strFile As String
  Dim strDir As String
  
536:   strFile = Linkages.aml_func_mod.ReturnFilename(strFullPath)
537:   strDir = Linkages.aml_func_mod.ReturnDir(strFullPath)
  
539:   If Not Linkages.aml_func_mod.FileExists(strDir) Then
540:     txtOutput.BackColor = vbYellow
541:     MsgBox "The selected workspace does not exist!" & vbCrLf & _
           strDir & vbCrLf & vbCrLf & "Please choose an existing workspace " & _
           "before running this function...", , "Failed to Create Raster:"
    Exit Sub
545:   End If
  
547:   If Right(strDir, 1) = "\" Or Right(strDir, 1) = "/" Then
548:     strDir = Left(strDir, Len(strDir) - 1)
549:   End If

  ' FOR SAMPLE; GET CATEGORY
  Dim pWsFact As IWorkspaceFactory
553:   Set pWsFact = New RasterWorkspaceFactory
  Dim pRastWS As IRasterWorkspace
  Dim pRastWsEx As IRasterWorkspaceEx
  
557:   m_strOutputWorkspace = strDir
558:   m_strOutputBasename = strFile
  
560:   If Right(strDir, 4) = ".gdb" Then       ' IS A FILE GEODATABASE
561:     Set pWsFact = New FileGDBWorkspaceFactory
562:     m_lngOutputWSType = ENUM_FileGDB
563:     Set pRastWsEx = pWsFact.OpenFromFile(strDir, Me.hWnd)
564:     Set m_pOutputWS = pRastWsEx
'  ElseIf Right(strDir, 4) = ".mdb" Then   ' IS A PERSONAL GEODATABASE
'    m_lngFlatAreaType = ENUM_PersonalGDB
'    Set pRastWsEx = pWSFact.OpenFromFile(strDir, Me.hWnd)
'    Set m_pFlatAreaWS = pRastWsEx
569:   Else                                    ' TREAT AS GRID
570:     Set pWsFact = New RasterWorkspaceFactory
571:     m_lngOutputWSType = ENUM_File_Raster
572:     m_strOutputBasename = Linkages.MyGeneralOperations.ReplaceBadChars(strFile, True, True, True, True)
573:     Set pRastWS = pWsFact.OpenFromFile(strDir, Me.hWnd)
574:     Set m_pOutputWS = pRastWS
575:   End If
  
  
  Dim pOutputParams As esriSystem.IVariantArray
579:   If Not Linkages.aml_func_mod.ExistFileDir(m_strOutputWorkspace) Then
580:     MsgBox "Unable to create Feature Class:" & vbCrLf & _
           m_strOutputWorkspace & " is not a valid workspace...", , "Failed to Create Raster:"
582:     txtOutput.SetFocus
583:     txtOutput.BackColor = vbYellow
    Exit Sub
585:   End If
  
587:   Set pOutputParams = New esriSystem.VarArray
588:   pOutputParams.Add m_strOutputBasename
589:   pOutputParams.Add m_strOutputWorkspace
590:   pOutputParams.Add m_pOutputWS
591:   pOutputParams.Add m_lngOutputWSType
  
593:   m_pReturnArray.Add pOutputParams
  
595:   m_pThisExt.WS_CumulativeCorridor = m_strOutputWorkspace
596:   m_pThisExt.ShouldContinue = True

  Dim pSaveArray As esriSystem.IVariantArray
599:   Set pSaveArray = New esriSystem.VarArray
600:   For lngIndex = 0 To m_pReturnArray.Count - 1
601:     pSaveArray.Add m_pReturnArray.Element(lngIndex)
602:   Next lngIndex
603:   Set m_pThisExt.frmCombineLayerIDReturn = pSaveArray
604:   Unload Me
      
'  Me.Visible = False
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler
 
616:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
617:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
618:   Me.Top = (Screen.Height / 3) - (Me.Height / 3)
  Dim lngTopBar As Long
620:   lngTopBar = Me.Height - Me.ScaleHeight
621:   Me.Height = cmdOK.Top + cmdOK.Height + lngTopBar
 
623:    Set Anchors = New AnchorObjectList  ' Create new instance
624:    With Anchors
625:       With .Item(chkUseSelected)
626:          .SetAnchors enumStartEnd, enumSizeEnd
627:       End With
628:       With .Item(chkSetZero)
629:          .SetAnchors enumStartEnd, enumSizeEnd
630:       End With
631:       With .Item(cmdCancel)
632:          .SetAnchors enumStartsize, enumSizeEnd
633:       End With
634:       With .Item(cmdGetWorkspace)
635:          .SetAnchors enumSizeEnd, enumSizeEnd
636:       End With
637:       With .Item(cmdManual)
638:          .SetAnchors enumStartsize, enumSizeEnd
639:       End With
640:       With .Item(cmdOK)
641:          .SetAnchors enumStartsize, enumSizeEnd
642:       End With
643:       With .Item(imgBackBottom)
644:          .SetAnchors enumStartEnd, enumSizeEnd
645:       End With
646:       With .Item(imgBackTop)
647:          .SetAnchors enumStartEnd, enumStartEnd
648:       End With
649:       With .Item(imgCornerBars)
650:          .SetAnchors enumSizeEnd, enumSizeEnd
651:       End With
652:       With .Item(imgOptionsBack)
653:          .SetAnchors enumStartEnd, enumSizeEnd
654:       End With
655:       With .Item(lblLabel)
656:          .SetAnchors enumStartsize, enumSizeEnd
657:       End With
658:       With .Item(lblLayer)
659:          .SetAnchors enumSize, enumStartsize
660:       End With
661:       With .Item(lblOptions)
662:          .SetAnchors enumSize, enumSizeEnd
663:       End With
664:       With .Item(lblOutputName)
665:          .SetAnchors enumStartsize, enumSizeEnd
666:       End With
667:       With .Item(lblPercent)
668:          .SetAnchors enumSizeEnd, enumSizeEnd
669:       End With
670:       With .Item(lblTransparency)
671:          .SetAnchors enumStartsize, enumSizeEnd
672:       End With
673:       With .Item(lbxLayers)
674:          .SetAnchors enumNone, enumStartEnd
675:       End With
676:       With .Item(txtLabels)
677:          .SetAnchors enumStartEnd, enumSizeEnd
678:       End With
679:       With .Item(txtMessage)
680:          .SetAnchors enumStartEnd, enumStartsize
681:       End With
682:       With .Item(txtOutput)
683:          .SetAnchors enumStartEnd, enumSizeEnd
684:       End With
685:       With .Item(txtTransparency)
686:          .SetAnchors enumStartEnd, enumSizeEnd
687:       End With
688:       .Form = Me  ' Set form reference (suggested to be last step)
689:    End With


692:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
702:   Set m_pMxDoc = Nothing
703:   Set m_pApp = Nothing
704:   Set Anchors = Nothing
705:   Set m_pLayerArray = Nothing
706:   Set m_pLayerFields = Nothing
707:   Set m_pThisExt = Nothing
708:   Set m_pReturnArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxLayers_Click()
  On Error GoTo ErrorHandler
  
718:   CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "lbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub optAll_Click()
  On Error GoTo ErrorHandler
 
728:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError False, "optAll_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub optSel_Click()
  On Error GoTo ErrorHandler
 
738:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError False, "optSel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ExtraCodeRequired()
 
  '' PUT IN EXTENSION CLASS
  '
  'Private m_booShouldContinue As Boolean
  'Private m_strDirPath As String
  'Private m_pfrmCombineLayerIDReturn As esriSystem.IVariantArray
  'Private m_strDirType As String
  'Private m_booIsFeatDataset As Boolean
  'Private m_strFeatDatasetName As String
  '
  '' PUT IN EXTENSION SHUTDOWN EVENT
  ' Set m_pfrmCombineLayerIDReturn = Nothing
  '
  '' SET FOLLOWING PROPERTIES
  'Public Property Let FeatDatasetName(strFeatDatasetName As String)
  '  m_strFeatDatasetName = strFeatDatasetName
  'End Property
  'Public Property Get FeatDatasetName() As String
  '  FeatDatasetName = m_strFeatDatasetName
  'End Property
  'Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  '  m_booIsFeatDataset = booIsFeatDataset
  'End Property
  'Public Property Get IsFeatureDataset() As Boolean
  '  IsFeatureDataset = m_booIsFeatDataset
  'End Property
  'Public Property Let DirectoryType(strDirType As String)
  '  m_strDirType = strDirType
  'End Property
  'Public Property Get DirectoryType() As String
  '  DirectoryType = m_strDirType
  'End Property
  '
  'Public Property Set frmCombineLayerIDReturn(pfrmCombineLayerIDReturn As esriSystem.IVariantArray)
  '  Set m_pfrmCombineLayerIDReturn = pfrmCombineLayerIDReturn
  'End Property
  '
  'Public Property Get frmCombineLayerIDReturn() As esriSystem.IVariantArray
  '  Set frmCombineLayerIDReturn = m_pfrmCombineLayerIDReturn
  'End Property
  '
  'Public Property Let DirectoryPath(strPath As String)
  '  On Error GoTo ErrorHandler
  '  m_strDirPath = strPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get DirectoryPath() As String
  '  On Error GoTo ErrorHandler
  '  DirectoryPath = m_strDirPath
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Let ShouldContinue(booShouldContinue As Boolean)
  '  On Error GoTo ErrorHandler
  '  m_booShouldContinue = booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  'Public Property Get ShouldContinue() As Boolean
  '  On Error GoTo ErrorHandler
  '  ShouldContinue = m_booShouldContinue
  '  Exit Property
  'ErrorHandler:
  '  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
  'End Property
  '
  '' PUT IN EXTENSION STARTUP EVENT
  '  If m_strDirPath = "" Or m_strDirType = "" Then
  '    m_strDirType = "Shapefile"
  '    m_strDirPath = ""
  '    m_booIsFeatDataset = False
  '    m_strFeatDatasetName = ""
  '  End If
  '
  '===============================================================================================================
  '
' ' SAMPLE CODE
'
'  ' CHECK CURRENT SAVED WORKSPACE AND WORKSPACE TYPE.
'  ' IF EITHER WORKSPACE OR WORKSPACE TYPE = "", OR IF WORKSPACE IS INAPPROPRIATE FOR WORKSPACE
'  ' TYPE, THEN RESET WORKSPACE TO DOCUMENT LOCATION AND WORKSPACE TYPE TO "Shapefile"
'  On Error Resume Next
'  Dim strWsPathname As String
'
''  MsgBox "Before:" & vbCrLf & _
''       "DirectoryPath = " & m_pThisExt.DirectoryPath & vbCrLf & _
''       "DirectoryType = " & m_pThisExt.DirectoryType & vbCrLf & _
''       "IsFeatureDataset = " & m_pThisExt.IsFeatureDataset & vbCrLf & _
''       "FeatDatasetName = " & m_pThisExt.FeatDatasetName
'
'  strWsPathname = Linkages.aml_func_mod.ReturnDir _
'        (Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp)))
'  If Right(strWsPathname, 1 = "\") Then strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
'  If m_pThisExt.DirectoryPath = "" Or m_pThisExt.DirectoryType = "" Then
'    m_pThisExt.DirectoryPath = strWsPathname
'    m_pThisExt.DirectoryType = "Shapefile"
'    m_pThisExt.IsFeatureDataset = False
'    m_pThisExt.FeatDatasetName = ""
'  Else
'    ' CHECK IF VALID AND APPROPRIATE WORKSPACE
'    Dim pWsFact As IWorkspaceFactory
'    Dim pFeatWS As IFeatureWorkspace
'    Select Case m_pThisExt.DirectoryType
'      Case "Shapefile", ""
'        Set pWsFact = New ShapefileWorkspaceFactory
'      Case "File Geodatabase"
'        Set pWsFact = New FileGDBWorkspaceFactory
'      Case "Personal Geodatabase"
'        Set pWsFact = New AccessWorkspaceFactory
'      Case Else
'        m_pThisExt.DirectoryPath = strWsPathname
'        m_pThisExt.DirectoryType = "Shapefile"
'        m_pThisExt.IsFeatureDataset = False
'        m_pThisExt.FeatDatasetName = ""
'        Set pWsFact = New ShapefileWorkspaceFactory
'    End Select
'    If Not pWsFact.IsWorkspace(m_pThisExt.DirectoryPath) Then
'      m_pThisExt.DirectoryPath = strWsPathname
'      m_pThisExt.DirectoryType = "Shapefile"
'      m_pThisExt.IsFeatureDataset = False
'      m_pThisExt.FeatDatasetName = ""
'    End If
'  End If
'  On Error GoTo ErrorHandler
'
''    MsgBox "After:" & vbCrLf & _
''         "DirectoryPath = " & m_pThisExt.DirectoryPath & vbCrLf & _
''         "DirectoryType = " & m_pThisExt.DirectoryType & vbCrLf & _
''         "IsFeatureDataset = " & m_pThisExt.IsFeatureDataset & vbCrLf & _
''         "FeatDatasetName = " & m_pThisExt.FeatDatasetName
'
'    Dim pVarArray As esriSystem.IVariantArray
'    Set pVarArray = New VarArray
'
'    ' ADD APPLICATION
'    pVarArray.Add m_pApp
'
'    ' ADD DESIRED LAYER TYPES
'    Dim pLayerTypes As JenLayerTypes
'    pLayerTypes = ENUM_jenPolygonLayers + ENUM_jenRasterLayers
'    pVarArray.Add pLayerTypes
'
'    'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmCombineLayerIDReturn",
'    '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
'    pVarArray.Add m_pThisExt
'
'    ' ADD DESIRED FIELD TYPES
'    pVarArray.Add 0
'
'    ' ADD WHETHER TO INCLUDE ID FIELD
'    pVarArray.Add (False)
'
'    ' ADD WHETHER ANY OUTPUT WILL BE A FEATURE CLASS (TRUE) OR TABLE (FALSE)         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Dim booOutputIsFClass As Boolean                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    booOutputIsFClass = True                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    pVarArray.Add (booOutputIsFClass)                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Dim pForm As Linkages.frmCombineLayerID
'    Set pForm = New Linkages.frmCombineLayerID
'    Set pForm.ArcApplication = pVarArray
'    pForm.Show vbModal
'    Set pForm = Nothing
'
'    If m_pThisExt.ShouldContinue = False Then
'      MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'
'    Dim pReturnArray As esrisystem.IVariantArray
'    Set pReturnArray = m_pThisExt.frmCombineLayerIDReturn
 
'    ' OUTPUT
'    ' SELECTED TABLE OR LAYER
'    Dim pUnknown As IUnknown
'    Set pUnknown = pReturnArray.Element(0)
'
'    ' FOR DEBUGGING
'    Dim strReport As String
'    strReport = "Selected Items:" & vbNewLine
'
'    If TypeOf pUnknown Is ILayer Then
'      Dim pLayer As ILayer
'      Set pLayer = pUnknown
'      strReport = strReport & "Name:  " & pLayer.Name & vbNewLine
'    ElseIf TypeOf pUnknown Is IStandaloneTable Then
'      Dim pStTab As IStandaloneTable
'      Set pStTab = pUnknown
'      strReport = strReport & "Name:  " & pStTab.Name & vbNewLine
'    End If
'
'    ' OPTION TO DO ALL OR SELECTED
'    Dim booDoAll As Boolean
'    booDoAll = pReturnArray.Element(1)
'    strReport = strReport & "Do All Records = " & UCase(CStr(booDoAll)) & vbNewLine
'


'  ' CODE SNIPPET TO USE pFieldNamePairs TO TRANSFER ATTRIBUTE DATA FROM OLD SOURCE TO NEW SOURCE
'  ' MAKE IVariantArray OF FIELD NAME INDICES
'  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
'  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
'  '                     1) ORIGINAL FCLASS FIELD INDEX
'  '                     2) NEW FCLASS FIELD NAME
'  '                     3) NEW FCLASS FIELD INDEX
'  Dim pFieldNamePairs As esriSystem.IVariantArray
'  Set pFieldNamePairs = pOutputArray.Element(9)
'  Dim pFieldNameData As esriSystem.IVariantArray
'  Set pFieldNameData = Linkages.MyGeneralOperations.MakeFieldNameVarArray(pFeatureClass, pNewFClass, pFieldNamePairs, True)
'  Dim lngFieldIndex As Long
'  Dim pFieldSubArray As esriSystem.IVariantArray
'  ' ROTATE THROUGH ALL FEATURES / ROWS
'    ' TRANSFER ATTRIBUTE DATA; ASSUMES pBuffer ALREADY EXISTS
'    For lngFieldIndex = 0 To pFieldNameData.Count - 1
'      Set pFieldSubArray = pFieldNameData.Element(lngFieldIndex)
'      pBuffer.Value(pFieldSubArray.Element(3)) = pFeature.Value(pFieldSubArray.Element(1))
'    Next lngFieldIndex
'  ' LOOP

''  ' SAMPLE SNIPPET FOR FEATURE LAYERS:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pFeatureLayer As IFeatureLayer
''  Dim pFClass As IFeatureClass
''  Dim pFeatSel As IFeatureSelection
''  Dim pSelSet As ISelectionSet
''  Dim pCursor As IFeatureCursor
''  Dim lngCount As Long
''
''  Set pFClass = pFeatureLayer.FeatureClass
''  Set pFeatSel = pFeatureLayer
''  Set pSelSet = pFeatSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pCursor = pFClass.Search(Nothing, False)
''    lngCount = pFClass.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pCursor = pFClass.Search(Nothing, False)
''      lngCount = pFClass.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pFeature As IFeature
''  Set pFeature = pCursor.NextFeature
''  Do Until pFeature Is Nothing
''    ' DO ACTIONS
''    Set pFeature = pCursor.NextFeature
''  Loop
''
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO FEATURE CLASS USING BUFFER
''  Dim pBuffer As IFeatureBuffer
''  Set pBuffer = pFClass.CreateFeatureBuffer
''  Dim pNewFeatureCursor As IFeatureCursor
''  Set pNewFeatureCursor = pFClass.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    Set pBuffer.Shape = aGeometry
''    pBuffer.Value(lngFieldIndex) = aValue
''    pNewFeatureCursor.InsertFeature pBuffer
''  ' LOOP
''  pNewFeatureCursor.Flush

''  ' SAMPLE SNIPPET FOR TABLES:  ROTATE THROUGH ALL OR SELECTED RECORDS
''  Dim pStandaloneTable As IStandaloneTable
''  Dim pInputTable As ITable
''  Dim pTableSel As ITableSelection
''  Dim pSelSet As ISelectionSet
''  Dim pRowCursor As ICursor
''  Dim lngCount As Long
''
''  Set pInputTable = pStandaloneTable.Table
''  Set pTableSel = pStandaloneTable
''  Set pSelSet = pTableSel.SelectionSet
''
''  If pSelSet.Count = 0 Then
''    Set pRowCursor = pInputTable.Search(Nothing, False)
''    lngCount = pInputTable.FeatureCount(Nothing)
''  Else
''    If booDoAll = True Then
''      Set pRowCursor = pInputTable.Search(Nothing, False)
''      lngCount = pInputTable.FeatureCount(Nothing)
''    Else
''      pSelSet.Search Nothing, True, pRowCursor
''      lngCount = pSelSet.Count
''    End If
''  End If
''
''  Dim pRow As IRow
''  Set pRow = pRowCursor.NextRow
''  Do Until pRow Is Nothing
'''     DO ACTIONS
''    Set pRow = pRowCursor.NextFeature
''  Loop
 
''  ' SAMPLE CODE SNIPPET:  ADD RECORDS TO TABLE USING BUFFER
''  Dim pBuffer As IRowBuffer
''  Set pBuffer = pTable.CreateRowBuffer
''  Dim pTableCursor As ICursor
''  Set pTableCursor = pTable.Insert(True)
''  ' LOOP THROUGH WHATEVER STEPS ARE REQUIRED TO GATHER DATA FOR A SINGLE ROW
''    pBuffer.Value(lngFieldIndex) = aValue
''    pTableCursor.InsertRow pBuffer
''  ' LOOP
''  pTableCursor.Flush
'    ' OUTPUT FEATURE CLASS / TABLE DETAILS
'    Dim pOutputArray As esrisystem.IVariantArray
'    Set pOutputArray = pReturnArray.Element(2)
'
'  If booOutputIsFClass Then
'    Dim pSpRef As ISpatialReference
'    Set pSpRef = pOutputArray.Element(1)
'    strReport = strReport & "Output Details:" & vbCrLf & _
'              "  --> pGeomType = " & CStr(pOutputArray.Element(0)) & vbCrLf & _
'              "  --> Spatial Reference = " & pSpRef.Name & vbCrLf & _
'              "  --> strWsPathName = " & pOutputArray.Element(2) & vbCrLf & _
'              "  --> strBaseName = " & pOutputArray.Element(3) & vbCrLf & _
'              "  --> pCategory = " & CStr(pOutputArray.Element(4)) & vbCrLf & _
'              "  --> Fields Added = " & CStr(Not pOutputArray.Element(5) Is Nothing) & vbCrLf & _
'              "  --> GxDialogCaption = " & pOutputArray.Element(6) & vbCrLf & _
'              "  --> booHasFeatureDataset = " & CStr(pOutputArray.Element(7)) & vbCrLf & _
'              "  --> strFeatDatasetName = " & pOutputArray.Element(8) & vbCrLf
'
'  ' FOR SAMPLE, USE FOLLOWING CODE TO ACTUALLY CREATE FEATURE CLASS
'  ' REQUIRES "MyGeneralOperations", "aml_func_mod"
'    Dim pFClass As IFeatureClass
'    Set pFClass = Linkages.MyGeneralOperations.CreateGeneralFeatureClass(pOutputArray.Element(0), pOutputArray.Element(1), pOutputArray.Element(2), _
'            pOutputArray.Element(3), pOutputArray.Element(4), pOutputArray.Element(5), pOutputArray.Element(6), _
'            pOutputArray.Element(7), pOutputArray.Element(8), True, False, pExtent, lngCount)
'    If pFClass Is Nothing Then
'      MsgBox "No Feature Class Created:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'  Else
'    strReport = strReport & "Output Details:" & vbCrLf & _
'              "  --> strWsPathName = " & pOutputArray.Element(0) & vbCrLf & _
'              "  --> strBaseName = " & pOutputArray.Element(1) & vbCrLf & _
'              "  --> pCategory = " & CStr(pOutputArray.Element(2)) & vbCrLf & _
'              "  --> Fields Added = " & CStr(Not pOutputArray.Element(3) Is Nothing) & vbCrLf & _
'              "  --> GxDialogCaption = " & pOutputArray.Element(4) & vbCrLf
'    Dim pTable As ITable
'      Set pTable = Linkages.MyGeneralOperations.CreateGeneralTable(pOutputArray.Element(0), pOutputArray.Element(1), _
'            pOutputArray.Element(2), pOutputArray.Element(3), pOutputArray.Element(4))
'    If pTable Is Nothing Then
'      MsgBox "No Table Created:" & vbCrLf & "Bailing out..."
'      Exit Sub
'    End If
'  End If
'
'  ' ----------------------------------------------------------------------------------------------------
'  ' SNIPPET TO MAKE TABLE AND ADD TO MAP DOCUMENT
'  Dim pNewStandaloneTable As IStandaloneTable
'  Dim pTableWindow2 As ITableWindow2
'  Dim pStandaloneTableCollection As IStandaloneTableCollection
'
'  Set pNewStandaloneTable = New StandaloneTable
'  Set pNewStandaloneTable.Table = pTable
'
'  Set pTableWindow2 = New TableWindow
'
'  With pTableWindow2
'    Set .StandaloneTable = pNewStandaloneTable
'    Set .Application = pApp
'    .TableSelectionAction = esriSelectFeatures
'    .ShowAliasNamesInColumnHeadings = True
'    .ShowSelected = False
'    .Show True
'  End With
'  Set pStandaloneTableCollection = pMxDoc.FocusMap
'  pStandaloneTableCollection.AddStandaloneTable pNewStandaloneTable
'
'  pMxDoc.UpdateContents
'  ' ----------------------------------------------------------------------------------------------------
'    MsgBox strReport, vbOKOnly, "Test of LayerID Form:"
'
'  Dim pDocDirty As IDocumentDirty
'  Set pDocDirty = m_pMxDoc
'  pDocDirty.SetDirty
'

End Sub
 

Private Sub txtTransparency_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler


1139:   Call Linkages.MyGeneralOperations.CheckNumericIntegerPositive(KeyAscii, txtTransparency)

  Exit Sub
ErrorHandler:
  HandleError True, "txtTransparency_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
