VERSION 5.00
Begin VB.Form frmEsriSample 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Describe Corridor - Output Options (Step 2 of 2):"
   ClientHeight    =   3090
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8460
   Icon            =   "frmEsriSample.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3090
   ScaleWidth      =   8460
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGeneral 
      Caption         =   "General Statistics:"
      Height          =   750
      Left            =   5573
      TabIndex        =   4
      Top             =   1800
      Width           =   2580
   End
   Begin VB.CommandButton cmdBottleneck 
      Caption         =   "Bottleneck Statistics:"
      Height          =   750
      Left            =   2910
      TabIndex        =   3
      Top             =   1800
      Width           =   2580
   End
   Begin VB.CommandButton cmdPatchConnection 
      Caption         =   "Patch Connection Statistics:"
      Height          =   750
      Left            =   248
      TabIndex        =   2
      Top             =   1800
      Width           =   2580
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   375
      Left            =   7410
      TabIndex        =   1
      Top             =   2700
      Width           =   1050
   End
   Begin VB.TextBox Text1 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Trebuchet MS"
         Size            =   14.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1545
      Left            =   30
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "frmEsriSample.frx":038A
      Top             =   75
      Width           =   8400
   End
   Begin VB.Shape Shape1 
      Height          =   930
      Left            =   30
      Top             =   1710
      Width           =   8400
   End
End
Attribute VB_Name = "frmEsriSample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdBottleneck_Click()

  Dim pFrmIllustration As New Linkages.frmEsriIllustration
6:   pFrmIllustration.Caption = "Illustration of Bottleneck Statistics:"
  
8:   pFrmIllustration.imgPatch.Visible = False
9:   pFrmIllustration.imgBottleneck.Visible = True
10:   pFrmIllustration.imgGeneral.Visible = False
  
12:   pFrmIllustration.txtInstructions.Text = "The Bottleneck statistics describe the corridor " & _
      "in terms of how wide it is along its entire path.  Corridor width is defined as 2 times " & _
      "the distance from the centerline of the corridor to the edge of the corridor, measured " & _
      "perpendicular to the direction of the centerline.  Corridor width is calculated along " & _
      "the entire length of the corridor.  In cases of multiple-strand corridors, width is " & _
      "defined according to the strand with the least constricting bottleneck." & vbCrLf & _
      "     Statistics include the average corridor width and the minimum corridor width (i.e. the bottleneck).  " & _
      "Tools are included to set a width threshold and calculate the total length that lies below that threshold."
  
21:   pFrmIllustration.Show vbModal

End Sub

Private Sub cmdClose_Click()
26:   Unload Me
End Sub

Private Sub cmdGeneral_Click()

  Dim pFrmIllustration As New Linkages.frmEsriIllustration
32:   pFrmIllustration.Caption = "Illustration of General Statistics:"
  
34:   pFrmIllustration.imgPatch.Visible = False
35:   pFrmIllustration.imgBottleneck.Visible = False
36:   pFrmIllustration.imgGeneral.Visible = True
  
38:   pFrmIllustration.txtInstructions.Text = "General statistics are available " & _
      "for any vector or raster background layers of interest.  Statistics are " & _
      "calculated for proportions of attributes that lie within the corridor, and include " & _
      "general statistics such as means, standard deviations and histograms."
  
43:   pFrmIllustration.Show vbModal

End Sub

Private Sub cmdPatchConnection_Click()

  Dim pFrmIllustration As New Linkages.frmEsriIllustration
50:   pFrmIllustration.Caption = "Illustration of Patch Connection Statistics:"
  
52:   pFrmIllustration.imgPatch.Visible = True
53:   pFrmIllustration.imgBottleneck.Visible = False
54:   pFrmIllustration.imgGeneral.Visible = False
  
56:   pFrmIllustration.txtInstructions.Text = "The Patch Connection statistics describe the " & _
      "corridor in terms of how far an animal must travel between patches of good habitat.  " & _
      "Statistics include the overall path that minimizes the gap size between patches, " & _
      "the 3 longest gaps between patches, and the gap length along the best path."
  
61:   pFrmIllustration.Show vbModal

End Sub

Private Sub Form_Load()

67:   Me.Left = (Screen.Width / 3) - (Me.Width / 2)
68:   Me.Top = (Screen.Height / 2) - (Me.Height / 2)
End Sub
