VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmWidthGraph 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Bottleneck Results:"
   ClientHeight    =   5730
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8910
   Icon            =   "frmGraph.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5730
   ScaleWidth      =   8910
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.Slider slidThreshold 
      Height          =   2205
      Left            =   105
      TabIndex        =   0
      Top             =   60
      Width           =   300
      _ExtentX        =   529
      _ExtentY        =   3889
      _Version        =   393216
      Orientation     =   1
      LargeChange     =   1
      TickStyle       =   3
   End
   Begin VB.TextBox txtDistance 
      Height          =   315
      Left            =   4950
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   2820
      Width           =   1575
   End
   Begin VB.CommandButton cmdPoints 
      Caption         =   "Create Point Shapefile"
      Height          =   345
      Left            =   15
      TabIndex        =   2
      Top             =   5355
      Width           =   1815
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Create Segment Shapefile"
      Height          =   345
      Left            =   1860
      TabIndex        =   3
      Top             =   5355
      Width           =   2115
   End
   Begin VB.CommandButton cmdTables 
      Caption         =   "Create Tables"
      Height          =   345
      Left            =   4005
      TabIndex        =   4
      Top             =   5355
      Width           =   1290
   End
   Begin VB.CommandButton cmdLayout 
      Caption         =   "Add Graph to Layout"
      Height          =   345
      Left            =   5325
      TabIndex        =   5
      Top             =   5355
      Width           =   1680
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Close"
      Height          =   345
      Left            =   7035
      TabIndex        =   6
      Top             =   5355
      Width           =   720
   End
   Begin VB.CommandButton cmdMinimize 
      Caption         =   "<< Minimize"
      Height          =   345
      Left            =   7785
      TabIndex        =   7
      Top             =   5355
      Width           =   1095
   End
   Begin RichTextLib.RichTextBox rtbStats 
      Height          =   2130
      Left            =   105
      TabIndex        =   8
      Top             =   3150
      Width           =   2910
      _ExtentX        =   5133
      _ExtentY        =   3757
      _Version        =   393217
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmGraph.frx":038A
   End
   Begin RichTextLib.RichTextBox rtbAboveStats 
      Height          =   2130
      Left            =   3015
      TabIndex        =   9
      Top             =   3150
      Width           =   2895
      _ExtentX        =   5106
      _ExtentY        =   3757
      _Version        =   393217
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmGraph.frx":0415
   End
   Begin RichTextLib.RichTextBox rtbBelowStats 
      Height          =   2130
      Left            =   5910
      TabIndex        =   10
      Top             =   3150
      Width           =   2910
      _ExtentX        =   5133
      _ExtentY        =   3757
      _Version        =   393217
      ReadOnly        =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmGraph.frx":04AF
   End
   Begin VB.PictureBox pctBackColor 
      BorderStyle     =   0  'None
      Height          =   1380
      Left            =   0
      ScaleHeight     =   1380
      ScaleWidth      =   3435
      TabIndex        =   14
      Top             =   0
      Width           =   3435
   End
   Begin VB.Label lblStats 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Threshold Statistics:"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   1785
      TabIndex        =   11
      Top             =   2850
      Width           =   1905
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Threshold = "
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   3870
      TabIndex        =   12
      Top             =   2850
      Width           =   1080
   End
   Begin VB.Label lblUnits 
      BackStyle       =   0  'Transparent
      Caption         =   "units"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   240
      Left            =   6600
      TabIndex        =   13
      Top             =   2850
      Width           =   1080
   End
End
Attribute VB_Name = "frmWidthGraph"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Private Type SIZE
    cx As Long
    cy As Long
End Type

Private Type LOGBRUSH
        lbStyle As Long
        lbColor As Long
        lbHatch As Long
End Type

Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function SetMapMode Lib "gdi32" (ByVal hdc As Long, ByVal nMapMode As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function CloseEnhMetaFile Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function CreateEnhMetaFile Lib "gdi32" Alias "CreateEnhMetaFileA" _
      (ByVal hdcRef As Long, ByVal lpFileName As String, lpRect As RECT, ByVal lpDescription As String) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteEnhMetaFile Lib "gdi32" (ByVal hemf As Long) As Long
Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Private Declare Function DrawText Lib "user32" Alias "DrawTextA" _
      (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" _
      (ByVal h As Long, ByVal w As Long, ByVal E As Long, ByVal O As Long, ByVal w As Long, _
      ByVal i As Long, ByVal u As Long, ByVal s As Long, ByVal C As Long, ByVal OP As Long, _
      ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal f As String) As Long
Private Declare Function AngleArc& Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal dwRadius As Long, ByVal eStartAngle As Single, ByVal eSweepAngle As Single)
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Private Declare Function CreatePatternBrush Lib "gdi32" (ByVal hBitmap As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function DrawEdge& Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long)
Private Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function DrawFrameControl Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                    (ByVal hWnd As Long, _
                     ByVal wMsg As Long, _
                     ByVal wParam As Long, _
                     lParam As Any) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function PolyBezier Lib "gdi32.dll" (ByVal hdc As Long, lppt As POINTAPI, ByVal cPoints As Long) As Long
Private Declare Function PolyBezierTo Lib "gdi32.dll" (ByVal hdc As Long, lppt As POINTAPI, ByVal cCount As Long) As Long
Private Declare Function PolyPolygon Lib "gdi32.dll" (ByVal hdc As Long, lpPoint As POINTAPI, lpPolyCounts As Long, ByVal nCount As Long) As Long
Private Declare Function RectangleX Lib "gdi32" Alias "Rectangle" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function CreateHatchBrush Lib "gdi32" (ByVal nIndex As Long, ByVal crColor As Long) As Long
Private Declare Function BeginPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function EndPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function StrokePath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function StrokeAndFillPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function ExtCreatePen Lib "gdi32" (ByVal dwPenStyle As Long, ByVal dwWidth As Long, ByRef lplb As LOGBRUSH, ByVal dwStyleCount As Long, ByVal lpStyle As Long) As Long
Private Declare Function GetLastError Lib "Kernel32" () As Long
Private Declare Function GetTextExtentPoint32 Lib "gdi32.dll" Alias "GetTextExtentPoint32A" (ByVal hdc As Long, ByVal lpsz As String, ByVal cbString As Long, lpSize As SIZE) As Long

Private Const PS_GEOMETRIC = &H10000
Private Const PS_ENDCAP_FLAT = &H200
Private Const HS_BDIAGONAL = 3               '  /////
Private Const HS_CROSS = 4                   '  +++++
Private Const HS_DIAGCROSS = 5               '  xxxxx
Private Const HS_FDIAGONAL = 2               '  \\\\\
Private Const HS_HORIZONTAL = 0              '  -----
Private Const HS_SOLID = 8
Private Const PS_JOIN_BEVEL = &H1000
Private Const BS_SOLID = 0
Private Const LTGRAY_BRUSH = 1
Private Const DT_NOPREFIX = &H800
Private Const DT_NOCLIP = &H100
Private Const DT_WORDBREAK = &H10
Private Const DT_EDITCONTROL = &H2000
Private Const DT_CENTER = &H1
Private Const DT_TOP = &H0
Private Const DT_LEFT = &H0
Private Const DT_RIGHT = &H2
Private Const DT_VCENTER = &H4
Private Const DT_BOTTOM = &H8
Private Const DT_SINGLELINE = &H20
Private Const DT_EXPANDTABS = &H40
Private Const DT_TABSTOP = &H80
Private Const DT_EXTERNALLEADING = &H200
Private Const DT_CALCRECT = &H400
Private Const DT_INTERNAL = &H1000

Private Const PS_SOLID = 0
Private Const PS_DASH = 1
Private Const PS_DOT = 2
Private Const PS_DASHDOT = 3
Private Const PS_DASHDOTDOT = 4
Private Const PS_NULL = 5

Const pi = 3.141578
Private Const EDGE_BUMP = &H9&
Private Const EDGE_ETCHED = &H6&
Private Const EDGE_RAISED = &H5&
Private Const EDGE_SUNKEN = &HA&
Private Const BF_ADJUST = &H2000
Private Const BF_BOTTOM = &H8
Private Const BF_BOTTOMLEFT = &H9
Private Const BF_BOTTOMRIGHT = &HC
Private Const BF_DIAGONAL = &H10
Private Const BF_FLAT = &H4000
Private Const BF_LEFT = &H1
Private Const BF_MIDDLE = &H800
Private Const BF_MONO = &H8000
Private Const BF_RECT = &HF
Private Const BF_RIGHT = &H4
Private Const BF_SOFT = &H1000
Private Const BF_TOP = &H2
Private Const BF_TOPLEFT = &H3
Private Const BF_TOPRIGHT = &H6
Private Const DFC_BUTTON = 4
Private Const DFC_CAPTION = 1
Private Const DFC_MENU = 2
Private Const DFC_SCROLL = 3
Private Const DFCS_BUTTON3STATE = &H8
Private Const DFCS_BUTTONCHECK = &H0
Private Const DFCS_BUTTONRADIO = &H4
Private Const DFCS_BUTTONRADIOIMAGE = &H1
Private Const DFCS_BUTTONRADIOMASK = &H2
Private Const DFCS_CAPTIONCLOSE = &H0
Private Const DFCS_CAPTIONHELP = &H4
Private Const DFCS_CAPTIONMAX = &H2
Private Const DFCS_CAPTIONMIN = &H1
Private Const DFCS_CAPTIONRESTORE = &H3
Private Const DFCS_CHECKED = &H400
Private Const DFCS_FLAT = &H4000
Private Const DFCS_INACTIVE = &H100
Private Const DFCS_MENUARROW = &H0
Private Const DFCS_MENUARROWRIGHT = &H4
Private Const DFCS_MENUBULLET = &H2
Private Const DFCS_MENUCHECK = &H1
Private Const DFCS_MONO = &H8000
Private Const DFCS_PUSHED = &H200
Private Const DFCS_SCROLLCOMBOBOX = &H5
Private Const DFCS_SCROLLDOWN = &H1
Private Const DFCS_SCROLLLEFT = &H2
Private Const DFCS_SCROLLRIGHT = &H3
Private Const DFCS_SCROLLSIZEGRIP = &H8
Private Const DFCS_SCROLLSIZEGRIPRIGHT = &H10
Private Const DFCS_SCROLLUP = &H0
Private Const TBM_SETTOOLTIPS = &H41D
Private Const LOGPIXELSY = 90        '  Logical pixels/inch in Y


Private Const GraphTop = 2
Private Const GraphLeft = 35
Private Const GraphBottom = 180
Private Const GraphRight = 590



' BELOW FROM JENNESS
Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_dblVals() As Double
Private m_dblGraphVals() As Double
Private m_dblMaxY As Double
Private m_dblMaxGraphY As Double
Private m_dblIncrement As Double
Private m_dblXIncrement As Double
Private m_dblGraphMaxY As Double
Private m_dblMaxX As Double
Private m_dblGraphMaxX As Double
Private m_lngPtCount As Long
Private m_dblYRange As Double
Private m_dblXRange As Double
Private m_dblThreshold As Double
Private m_dblMinY As Double
Private m_dblMeanY As Double
Private m_dblSDY As Double
Private m_dblMedY As Double
Private m_dblRangeY As Double
Private m_pAboveThreshold As esriSystem.IDoubleArray
Private m_pBelowThreshold As esriSystem.IDoubleArray
Private m_dblLengthAbove As Double
Private m_dblLengthBelow As Double
Private m_booIsScrolling As Boolean
Private m_booMinimizeToggle As Boolean
Private m_SpRef As ISpatialReference
Private m_UnitName As String
Private m_booCreateShapes As Boolean
Private m_Frame As IModelessFrame
Private m_pYLabels As esriSystem.IStringArray
Private m_pXLabels As esriSystem.IStringArray
Private m_strYName As String
Private m_strXName As String
Private m_dblSliderAdjustment As Double
Private m_pDataArray As esriSystem.IVariantArray
Private m_SegArray As esriSystem.IArray

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\frmGraph.frm"


Public Function Frame() As IModelessFrame
  On Error GoTo ErrorHandler

211:    If m_Frame Is Nothing Then
212:      Set m_Frame = New ModelessFrame
213:      m_Frame.Create Me
214:      m_Frame.Caption = Me.Caption
215:    End If
216:    Set Frame = m_Frame

  Exit Function
ErrorHandler:
  HandleError True, "Frame " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Property Set ArcApplication(pApp As IApplication)
  On Error GoTo ErrorHandler

225:   Set m_pApp = pApp
226:   Set m_pMxDoc = m_pApp.Document

  Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set SpatReference(pSpRef As ISpatialReference)
  On Error GoTo ErrorHandler

236:   Set m_SpRef = pSpRef
237:   If TypeOf pSpRef Is IProjectedCoordinateSystem Then
    Dim pPrCoSy As IProjectedCoordinateSystem
239:     Set pPrCoSy = pSpRef
240:     m_UnitName = LCase(pPrCoSy.CoordinateUnit.Name & "s")
'    MsgBox "TypeOf pSpRef Is IProjectedCoordinateSystem = TRUE" & vbCrLf & "m_UnitName has been set to " & CStr(m_UnitName)
242:   Else
243:     m_UnitName = "map units"
'    MsgBox "TypeOf pSpRef Is IProjectedCoordinateSystem = FALSE" & vbCrLf & "m_UnitName has been set to " & CStr(m_UnitName)
245:   End If
246:   lblUnits.Caption = m_UnitName
  
  Exit Property
ErrorHandler:
  HandleError True, "SpatReference " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set GraphNumbers(pDataArray As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
  
256:   Set m_pDataArray = pDataArray
  
  ReDim m_dblVals(pDataArray.Count - 1, 1)
  Dim lngIndex As Long
  Dim pDblArray As esriSystem.IDoubleArray
261:   For lngIndex = 0 To pDataArray.Count - 1
262:     Set pDblArray = pDataArray.Element(lngIndex)
263:     m_dblVals(lngIndex, 0) = pDblArray.Element(3)           ' DISTANCE
264:     m_dblVals(lngIndex, 1) = pDblArray.Element(2)           ' WIDTH
265:   Next lngIndex
  
'  Dim dblVals() As Double
'  dblVals = m_dblVals
    
270:   Set m_pAboveThreshold = New esriSystem.DoubleArray
271:   Set m_pBelowThreshold = New esriSystem.DoubleArray
  
273:   m_dblMaxY = 0
274:   m_dblMaxX = 0
  
  Dim dblTempX As Double
  Dim dblTempY As Double
278:   m_lngPtCount = UBound(m_dblVals, 1) + 1
  
'  m_dblMinY = m_dblVals(lngIndex, 1)
  
  Dim dblStatsArray() As Double
  ReDim dblStatsArray(UBound(m_dblVals, 1))
  
285:   For lngIndex = 0 To UBound(m_dblVals, 1)
286:     dblTempX = m_dblVals(lngIndex, 0)
287:     If dblTempX > m_dblMaxX Then m_dblMaxX = dblTempX
288:     dblStatsArray(lngIndex) = m_dblVals(lngIndex, 1)
289:   Next lngIndex
  
  ' CALC STATISTICS ON DISTANCE VALUES
292:   QuickSort.DoubleAscending dblStatsArray, 0, UBound(dblStatsArray)
  Dim pVarArray As esriSystem.IVariantArray
294:   Set pVarArray = Linkages.MyGeneralOperations.BasicStatsFromArray(dblStatsArray, "", "", m_pApp)
295:   m_dblMeanY = pVarArray.Element(1)
296:   m_dblMinY = pVarArray.Element(2)
297:   m_dblMaxY = pVarArray.Element(3)
298:   m_dblRangeY = pVarArray.Element(4)
299:   m_dblSDY = pVarArray.Element(6)
300:   m_dblMedY = pVarArray.Element(8)
  
  ' FIGURE OUT WHAT MAXIMUM Y SHOULD BE FOR THE GRAPH, SO THAT INCREMENTS CAN BE INTUITIVE.
303:   m_dblIncrement = m_dblMaxY / 300
  Dim dblPower As Double
305:   dblPower = 1
306:   Do Until (m_dblIncrement * dblPower) > 1
307:     dblPower = dblPower * 10
308:   Loop
309:   Do Until (m_dblIncrement * dblPower) < 10
310:     dblPower = dblPower / 10
311:   Loop
312:   m_dblIncrement = m_dblIncrement * dblPower
  
  ' NOW SHOULD HAVE AN INCREMENT BASED ON 1/400 OF RANGE, BUT BETWEEN 0 AND 10 AND WITH AN ADJUSTMENT VALUE TO RETURN IT TO ORIGINAL
315:   m_dblIncrement = (Int(m_dblIncrement) * 100) / dblPower
'  Debug.Print m_dblIncrement & ", " & m_dblMaxY
  
  Dim strFormat As String
319:   If m_dblIncrement < 1 Then
320:     strFormat = "0." & String(Len(CStr(Int(1 / m_dblIncrement))), "0")
321:   Else
322:     strFormat = "0"
323:   End If
    
325:   Set m_pYLabels = New esriSystem.strArray
326:   m_dblMaxGraphY = 0
327:   m_pYLabels.Add CStr(Format(0, strFormat))
328:   Do Until m_dblMaxGraphY >= m_dblMaxY
329:     m_dblMaxGraphY = m_dblMaxGraphY + m_dblIncrement
330:     m_pYLabels.Add CStr(Format(m_dblMaxGraphY, strFormat))
331:   Loop
  
  ' FIGURE OUT X-INCREMENT, SUCH THAT MAX X-VALUE WILL BE GREATER THAN LAST TIC MARK
334:   m_dblXIncrement = m_dblMaxX / 500
335:   dblPower = 1
336:   Do Until (m_dblXIncrement * dblPower) > 1
337:     dblPower = dblPower * 10
338:   Loop
339:   m_dblXIncrement = m_dblXIncrement * dblPower
340:   Do Until (m_dblXIncrement * dblPower) < 10
341:     dblPower = dblPower / 10
342:   Loop
343:   m_dblXIncrement = m_dblXIncrement * dblPower
  
345:   If m_dblXIncrement < 1 Then
346:     strFormat = "0." & String(Len(CStr(Int(1 / m_dblXIncrement))), "0")
347:   Else
348:     strFormat = "0"
349:   End If
  
  ' NOW SHOULD HAVE AN INCREMENT BASED ON 1/400 OF RANGE, BUT BETWEEN 0 AND 10 AND WITH AN ADJUSTMENT VALUE TO RETURN IT TO ORIGINAL
352:   m_dblXIncrement = (Int(m_dblXIncrement) * 100) / dblPower
  
354:   Set m_pXLabels = New esriSystem.strArray
  Dim dblInc As Double
356:   dblInc = m_dblXIncrement
357:   m_pXLabels.Add CStr(Format(0, strFormat))
358:   Do Until dblInc > m_dblMaxX
    
360:     If (m_UnitName = "meters") And (m_dblMaxX >= 10000) Then
361:       m_pXLabels.Add CStr(Format(dblInc / 1000, strFormat))
362:     Else
363:       m_pXLabels.Add CStr(Format(dblInc, strFormat))
364:     End If
365:     dblInc = dblInc + m_dblXIncrement
366:   Loop
367:   If (m_UnitName = "meters") And (m_dblMaxX >= 10000) Then
368:       m_strXName = "Distance (km)"
369:   ElseIf (m_UnitName = "meters") And (m_dblMaxX < 10000) Then
370:       m_strXName = "Distance (meters)"
371:   Else
372:       m_strXName = "Distance (" & m_UnitName & ")"
373:   End If
374:   m_strYName = "Width (" & m_UnitName & ")"
  
376:   rtbStats.TextRTF = _
      "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\b\f0\fs16 Bottleneck Width Statistics:\b0\par" & vbCrLf & _
      "   1] Minimum =  " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblMinY, "0.00"))) & " " & m_UnitName & "\par" & vbCrLf & _
      "   2] Maximum =  " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblMaxY, "0.00"))) & " " & m_UnitName & "\par" & vbCrLf & _
      "   3] Range =  " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblRangeY, "0.00"))) & " " & m_UnitName & "\par" & vbCrLf & _
      "   4] Mean =  " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblMeanY, "0.00"))) & " " & m_UnitName & "\par" & vbCrLf & _
      "   5] Median =  " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblMedY, "0.00"))) & " " & m_UnitName & "\par" & vbCrLf & _
      "   6] St. Dev. =  " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblSDY, "0.0000"))) & " " & m_UnitName & "\par" & vbCrLf & _
      "\par" & vbCrLf & _
      "\b Length \b0 = " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblMaxX, "0.00"))) & " " & m_UnitName & "\par" & _
      "}"
  
389:   m_dblXRange = GraphRight - 15 - (GraphLeft + 58)
390:   m_dblYRange = GraphBottom - 38 - (GraphTop + 17)
  
  ReDim m_dblGraphVals(UBound(m_dblVals, 1), 1)
393:   For lngIndex = 0 To UBound(m_dblVals, 1)
394:     m_dblGraphVals(lngIndex, 0) = ConvertValToGraphX(m_dblVals(lngIndex, 0))
395:     m_dblGraphVals(lngIndex, 1) = ConvertValToGraphY(m_dblVals(lngIndex, 1))
'    Debug.Print CStr(lngIndex) & "]  Original:  X = " & CStr(m_dblVals(lngIndex, 0)) & ",   Y = " & CStr(m_dblVals(lngIndex, 1))
'    Debug.Print "        Converted:  X = " & CStr(m_dblGraphVals(lngIndex, 0)) & ",   Y = " & CStr(m_dblGraphVals(lngIndex, 1))
398:   Next lngIndex
  
400:   If m_dblMaxGraphY < 100 Then
401:     m_dblThreshold = Round((((m_dblMaxY - m_dblMinY) / 2) + m_dblMinY), 5)
402:   Else
403:     m_dblThreshold = Int(((m_dblMaxY - m_dblMinY) / 2) + m_dblMinY)
404:   End If
405:   txtDistance.Text = CStr(m_dblThreshold)
406:   slidThreshold.Left = 15 * (GraphLeft - 29)
407:   slidThreshold.Top = 15 * (GraphTop + 10)
408:   slidThreshold.Height = 15 * (GraphBottom - 40)
  
  ' HAVE TO SET MAX AT 1 INSTEAD OF 0.  DON'T KNOW WHY!
  ' HAVE TO TAKE NEGATIVE BECAUSE CAN'T SET VERTICAL SLIDER TO BEHAVE THE WAY YOU WOULD EXPECT, WITH MAX AT TOP AND MIN AT BOTTOM.
  ' THRESHOLD VALUE IS THEREFORE 1 UNIT HIGHER THAN THE SLIDER VALUE WOULD SUGGEST.  SLIDER CONTROL LOCATION MOVED TO ADJUST.

414:   slidThreshold.max = 1
  ' SET SLIDER POSITION DIFFERENTLY BASED ON WHETHER MAXIMUM VALUE IS < OR > 100
416:   If m_dblMaxGraphY < 100 Then
417:     slidThreshold.min = -998
418:     slidThreshold.Value = -Int((m_dblThreshold / m_dblMaxGraphY) * 1000) + 1
419:   Else
420:     slidThreshold.min = -(m_dblMaxGraphY) + 1    ' USE m_dblMaxGraphY
421:     slidThreshold.Value = -Int(m_dblThreshold) + 1
422:   End If
423:   slidThreshold.TickFrequency = 1
  
425:   SendMessage slidThreshold.hWnd, TBM_SETTOOLTIPS, 0, ByVal 0
426:   m_booIsScrolling = False
427:   m_booCreateShapes = True
428:   m_booMinimizeToggle = False
'  Debug.Print slidThreshold.TickFrequency
  
  ' MAKE GRAY BOX
  Dim nullPen As Long
  Dim greyBrush As Long
  
435:   nullPen = CreatePen(PS_NULL, 0, vbRed)
436:   DeleteObject SelectObject(hdc, nullPen)
  
438:   greyBrush = CreateSolidBrush(RGB(230, 230, 230))
439:   DeleteObject SelectObject(hdc, greyBrush)
  
'  RectangleX hdc, GraphLeft, GraphTop, GraphRight, GraphBottom
442:   RectangleX hdc, 4, 184, 592, 354
  
  ' DRAW INSET EDGE
  Dim di As Long
  Dim rc As RECT
'    di = GetClientRect(hwnd, rc)

449:   rc.Left = 4
450:   rc.Top = 184
451:   rc.Right = 592
452:   rc.Bottom = 354
453:   di = DrawEdge(hdc, rc, EDGE_SUNKEN, BF_TOPLEFT)
454:   di = DrawEdge(hdc, rc, EDGE_SUNKEN, BF_BOTTOMRIGHT)
  
456:   FillGraph

  Exit Property
ErrorHandler:
  HandleError True, "GraphNumbers " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Function ConvertValToGraphX(dblDistance As Double) As Double
  On Error GoTo ErrorHandler

466:   ConvertValToGraphX = GraphLeft + 58 + ((dblDistance / m_dblMaxX) * m_dblXRange)

  Exit Function
ErrorHandler:
  HandleError False, "ConvertValToGraphX " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Private Function ConvertValToGraphY(dblDistance As Double) As Double
  On Error GoTo ErrorHandler

'  ConvertValToGraphY = (GraphBottom - 38) - ((dblDistance / m_dblMaxY) * m_dblYRange)     ' USE m_dblMaxGraphY
476:   ConvertValToGraphY = (GraphBottom - 38) - ((dblDistance / m_dblMaxGraphY) * m_dblYRange)     ' USE m_dblMaxGraphY

  Exit Function
ErrorHandler:
  HandleError False, "ConvertValToGraphY " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Private Sub FillGraph()
  On Error GoTo ErrorHandler

486:   pctBackColor.Visible = False
  
  ' DIMENSION PENS AND BRUSHES
  Dim bluePen As Long
  Dim redPen As Long
  Dim nullPen As Long
  Dim blackPen As Long
  Dim magentaPen As Long
  Dim blackDashPen As Long
  Dim whiteBrush As Long
  
  Dim lngFontWeight As Long
  Dim lngFontHeight As Long
  Dim nFont As Long, oFont As Long
  
  ' PREPARE THRESHOLD STATS VARIABLES
502:   m_pAboveThreshold.RemoveAll
503:   m_pBelowThreshold.RemoveAll
504:   m_dblLengthAbove = 0
505:   m_dblLengthBelow = 0
  Dim dblLength As Double
  Dim dblTruePrevX As Double
  Dim dblTrueCurrentX As Double
  Dim dblTrueShortX As Double
  Dim dblRunningLengthAbove As Double
  Dim dblRunningLengthBelow As Double
512:   dblRunningLengthAbove = 0
513:   dblRunningLengthBelow = 0
  
  ' DRAW WHITE BOX
516:   nullPen = CreatePen(PS_NULL, 0, vbRed)
517:   DeleteObject SelectObject(hdc, nullPen)
  
519:   whiteBrush = CreateSolidBrush(vbWhite)
520:   DeleteObject SelectObject(hdc, whiteBrush)
  
522:   RectangleX hdc, GraphLeft, GraphTop, GraphRight, GraphBottom
  
  ' GET THRESHOLD VALUE IN GRAPH UNITS
  Dim dblGraphThreshold As Double
526:   dblGraphThreshold = ConvertValToGraphY(m_dblThreshold)
  
  ' DRAW INSET EDGE
  Dim di As Long
  Dim rc As RECT
'    di = GetClientRect(hwnd, rc)

533:   rc.Left = GraphLeft - 2
534:   rc.Top = GraphTop - 2
535:   rc.Right = GraphRight + 2
536:   rc.Bottom = GraphBottom + 2
537:   di = DrawEdge(hdc, rc, EDGE_SUNKEN, BF_TOPLEFT)
538:   di = DrawEdge(hdc, rc, EDGE_SUNKEN, BF_BOTTOMRIGHT)

  ' DRAW X- AND Y-AXIS
541:   blackPen = CreatePen(PS_SOLID, 1, vbBlack)
542:   DeleteObject SelectObject(hdc, blackPen)
  Dim lpPoint As POINTAPI
  Dim strText As String
  Dim textSize As SIZE
  
  ' FONT FOR NUMBERS
548:   lngFontHeight = -((8 * GetDeviceCaps(hdc, LOGPIXELSY)) / 72)
549:   nFont = CreateFont(lngFontHeight, 0, 0, 0, 450, -1, 0, 0, 1, 7, 0, 0, 0, ByVal "Arial")
550:   oFont = SelectObject(hdc, nFont)

  ' X-AXIS
553:   MoveToEx hdc, GraphLeft + 55, GraphBottom - 38, lpPoint
554:   LineTo hdc, GraphRight - 15, GraphBottom - 38
555:   strText = m_pYLabels.Element(0)
556:   GetTextExtentPoint32 hdc, strText, Len(strText), textSize
557:   rc.Left = GraphLeft + 55 - textSize.cx - 2
558:   rc.Top = GraphBottom - 38 - (textSize.cy / 2)
559:   rc.Right = GraphLeft + 53
560:   rc.Bottom = GraphBottom - 38 + (textSize.cy / 2)
561:   DrawText hdc, strText, Len(strText), rc, DT_NOCLIP + DT_RIGHT
    
  ' Y-AXIS
564:   MoveToEx hdc, GraphLeft + 58, GraphTop + 17, lpPoint
565:   LineTo hdc, GraphLeft + 58, GraphBottom - 34
566:   strText = m_pXLabels.Element(0)
567:   GetTextExtentPoint32 hdc, strText, Len(strText), textSize
568:   rc.Left = GraphLeft + 58 - (textSize.cx / 2)
569:   rc.Top = GraphBottom - 32
570:   rc.Right = GraphLeft + 58 + (textSize.cx / 2)
571:   rc.Bottom = GraphBottom - 32 + textSize.cy
572:   DrawText hdc, strText, Len(strText), rc, DT_NOCLIP + DT_CENTER
  ' Measure the text, and return it into the textSize SIZE structure
  
  ' MAKE DASHED HORIZONTAL LINES
  Dim lngCounter As Long
577:   lngCounter = 1
  
  Dim dblInc As Double
580:   dblInc = m_dblIncrement
  Dim dblVertVal As Double
582:   dblVertVal = ConvertValToGraphY(dblInc)
583:   Do Until dblInc > m_dblMaxGraphY
  
    ' BLACK TICS
586:     blackPen = CreatePen(PS_SOLID, 1, vbBlack)
587:     DeleteObject SelectObject(hdc, blackPen)
588:     MoveToEx hdc, GraphLeft + 55, dblVertVal, lpPoint
589:     LineTo hdc, GraphLeft + 59, dblVertVal
    
    ' GRAY DASHES
592:     blackDashPen = CreatePen(PS_DOT, 1, RGB(195, 195, 195))
593:     DeleteObject SelectObject(hdc, blackDashPen)
594:     LineTo hdc, GraphRight - 15, dblVertVal
    
    ' TEXT
597:     strText = m_pYLabels.Element(lngCounter)
598:     GetTextExtentPoint32 hdc, strText, Len(strText), textSize
599:     rc.Left = GraphLeft + 55 - textSize.cx - 2
600:     rc.Top = dblVertVal - (textSize.cy / 2)
601:     rc.Right = GraphLeft + 53
602:     rc.Bottom = dblVertVal + (textSize.cy / 2)
603:     DrawText hdc, strText, Len(strText), rc, DT_NOCLIP + DT_RIGHT
    
605:     dblInc = dblInc + m_dblIncrement
606:     dblVertVal = ConvertValToGraphY(dblInc)
607:     lngCounter = lngCounter + 1
608:   Loop
  
  ' MAKE DASHED VERTICAL LINES
611:   dblInc = m_dblXIncrement
  Dim dblHorizVal As Double
613:   dblHorizVal = ConvertValToGraphX(dblInc)
614:   lngCounter = 1
  
616:   Do Until dblInc > m_dblMaxX
  
    ' BLACK TICS
619:     blackPen = CreatePen(PS_SOLID, 1, vbBlack)
620:     DeleteObject SelectObject(hdc, blackPen)
621:     MoveToEx hdc, dblHorizVal, GraphBottom - 34, lpPoint
622:     LineTo hdc, dblHorizVal, GraphBottom - 38
    
    ' GRAY DASHES
625:     blackDashPen = CreatePen(PS_DOT, 1, RGB(195, 195, 195))
626:     DeleteObject SelectObject(hdc, blackDashPen)
627:     LineTo hdc, dblHorizVal, GraphTop + 17
    
    ' TEXT
630:     strText = m_pXLabels.Element(lngCounter)
631:     GetTextExtentPoint32 hdc, strText, Len(strText), textSize
632:     rc.Left = dblHorizVal - (textSize.cx / 2)
633:     rc.Top = GraphBottom - 32
634:     rc.Right = dblHorizVal + (textSize.cx / 2)
635:     rc.Bottom = GraphBottom - 32 + textSize.cy
636:     DrawText hdc, strText, Len(strText), rc, DT_NOCLIP + DT_CENTER
    
638:     dblInc = dblInc + m_dblXIncrement
639:     dblHorizVal = ConvertValToGraphX(dblInc)
640:     lngCounter = lngCounter + 1
641:   Loop
  
  ' FONT FOR Y-AXIS LABEL
644:   DeleteObject nFont
645:   lngFontHeight = -((11 * GetDeviceCaps(hdc, LOGPIXELSY)) / 72)
646:   nFont = CreateFont(lngFontHeight, 0, 900, 900, 700, 0, 0, 0, 1, 7, 0, 0, 0, ByVal "Arial")
647:   oFont = SelectObject(hdc, nFont)
648:   strText = m_strYName
649:   GetTextExtentPoint32 hdc, strText, Len(strText), textSize
650:   rc.Left = GraphLeft + (textSize.cx / 2)
651:   rc.Top = ((GraphBottom - GraphTop) / 2) + GraphTop + (textSize.cx / 2)
652:   rc.Right = rc.Left + textSize.cy
653:   rc.Bottom = rc.Top + textSize.cx ' (GraphBottom - GraphTop) / 2 + (textSize.cx / 2)
654:   DrawText hdc, strText, Len(strText), rc, DT_NOCLIP + DT_CENTER
  
'  Debug.Print "rc.Left = " & CStr(rc.Left)
'  Debug.Print "rc.Top = " & CStr(rc.Top)
'  Debug.Print "rc.Right = " & CStr(rc.Right)
'  Debug.Print "rc.Bottom = " & CStr(rc.Bottom)
  
  ' FONT FOR X-AXIS LABEL
662:   DeleteObject nFont
663:   lngFontHeight = -((11 * GetDeviceCaps(hdc, LOGPIXELSY)) / 72)
664:   nFont = CreateFont(lngFontHeight, 0, 0, 0, 700, 0, 0, 0, 1, 7, 0, 0, 0, ByVal "Arial")
665:   oFont = SelectObject(hdc, nFont)
666:   strText = m_strXName
667:   GetTextExtentPoint32 hdc, strText, Len(strText), textSize
668:   rc.Left = ((GraphRight - GraphLeft) / 2) + GraphLeft - (textSize.cx / 2)
669:   rc.Top = (GraphBottom - textSize.cy) - 1
670:   rc.Right = ((GraphRight - GraphLeft) / 2) + GraphLeft + (textSize.cx / 2)
671:   rc.Bottom = GraphBottom - 1
672:   DrawText hdc, strText, Len(strText), rc, DT_NOCLIP + DT_CENTER
  
674:   DeleteObject nFont
  
  ' DRAW THRESHOLD LINE
677:   magentaPen = CreatePen(PS_SOLID, 1, RGB(255, 0, 255))
678:   DeleteObject SelectObject(hdc, magentaPen)
679:   MoveToEx hdc, GraphLeft + 59, dblGraphThreshold, lpPoint
680:   LineTo hdc, GraphRight - 15, dblGraphThreshold
  
  ' DRAW GRAPH LINE
  Dim dblTempX As Double
  Dim dblTempY As Double
  Dim dblPrevX As Double
  Dim dblPrevY As Double
  Dim lngIndex As Long
  Dim booCurrentThresh As Boolean
  Dim booPreviousThresh As Boolean ' false for below threshold, true for above threshold
  
691:   dblTempY = m_dblGraphVals(0, 1)
  ' Y-AXIS REVERSED IN GRAPH SPACE!!!
693:   booCurrentThresh = (dblTempY <= dblGraphThreshold)
694:   dblPrevX = m_dblGraphVals(0, 0)
695:   dblPrevY = dblTempY
696:   dblTruePrevX = m_dblVals(0, 0)
  Dim dblProportion As Double
  Dim dblShortX As Double
  
700:   BeginPath hdc
701:   MoveToEx hdc, m_dblGraphVals(0, 0), m_dblGraphVals(0, 1), lpPoint
  
  ' FOR MAP SEGMENTS
704:   If m_booCreateShapes Then
    Dim pValueArray As esriSystem.IDoubleArray
    Dim dblMapX As Double
    Dim dblMapY As Double
    Dim dblMapShortX As Double
    Dim dblMapShortY As Double
    Dim dblMapPrevX As Double
    Dim dblMapPrevY As Double
    Dim pAboveSegment As IPointCollection
    Dim pBelowSegment As IPointCollection
    Dim pPoint As IPoint
    Dim pPrevPoint As IPoint
    Dim pShortPoint As IPoint
    Dim pClone As IClone
    Dim pSegAbovePair As esriSystem.IVariantArray
    Dim pTopoOp As ITopologicalOperator
    
721:     Set m_SegArray = New esriSystem.Array
    
723:     Set pValueArray = m_pDataArray.Element(0)
724:     dblMapX = pValueArray.Element(0)
725:     dblMapY = pValueArray.Element(1)
726:     Set pPoint = New Point
727:     pPoint.PutCoords dblMapX, dblMapY
728:     Set m_SegArray = New esriSystem.Array
729:     dblMapPrevX = dblMapX
730:     dblMapPrevY = dblMapY
731:     If booCurrentThresh Then
732:       Set pAboveSegment = New Polyline
'      pAboveSegment.AddPoint pPoint
734:     Else
735:       Set pBelowSegment = New Polyline
'      pBelowSegment.AddPoint pPoint
737:     End If
738:   End If
  
740:   If booCurrentThresh Then
741:     bluePen = CreatePen(PS_SOLID, 1, vbBlue)
742:     DeleteObject SelectObject(hdc, bluePen)
743:     booPreviousThresh = True
744:   Else
745:     redPen = CreatePen(PS_SOLID, 1, vbRed)
746:     DeleteObject SelectObject(hdc, redPen)
747:     booPreviousThresh = False
748:   End If
  
  ' FOR DEBUGGING
'  Static lngStaticCounter As Long
'  Static lngStaticCounter2 As Long
'  If m_booCreateShapes Then
'    lngStaticCounter = lngStaticCounter + 1
'    Debug.Print CStr(lngStaticCounter) & "] Creating shapes..."
'  End If
'  If Not m_booIsScrolling Then
'    lngStaticCounter2 = lngStaticCounter2 + 1
'    Debug.Print CStr(lngStaticCounter2) & "] Calculating Stats..."
'  End If
  
762:   For lngIndex = 0 To UBound(m_dblGraphVals, 1)
763:     dblTempX = m_dblGraphVals(lngIndex, 0)
764:     dblTempY = m_dblGraphVals(lngIndex, 1)
    
766:     booCurrentThresh = (dblTempY <= dblGraphThreshold)
767:     If booCurrentThresh = booPreviousThresh Then    ' THEN HAS NOT CROSSED THRESHOLD
768:       LineTo hdc, dblTempX, dblTempY
      
      ' IF CREATING SHAPES
771:       If m_booCreateShapes Then
772:         Set pValueArray = m_pDataArray.Element(lngIndex)
773:         dblMapX = pValueArray.Element(0)
774:         dblMapY = pValueArray.Element(1)
775:         dblTrueCurrentX = m_dblVals(lngIndex, 0)
776:         dblLength = (dblTrueCurrentX - dblTruePrevX)
777:         Set pPoint = New Point
778:         pPoint.PutCoords dblMapX, dblMapY

780:         If booCurrentThresh Then
781:           pAboveSegment.AddPoint pPoint
          ' ONLY ADD THIS SEGMENT TO LIST IF WE ARE ON LAST POINT
783:           If lngIndex = UBound(m_dblGraphVals, 1) Then
784:             Set pSegAbovePair = New esriSystem.VarArray
785:             Set pTopoOp = pAboveSegment
786:             pTopoOp.Simplify
787:             pSegAbovePair.Add pAboveSegment
788:             pSegAbovePair.Add True
789:             m_SegArray.Add pSegAbovePair
790:           End If
791:         Else
792:           pBelowSegment.AddPoint pPoint
          ' ONLY ADD THIS SEGMENT TO LIST IF WE ARE ON LAST POINT
794:           If lngIndex = UBound(m_dblGraphVals, 1) Then
795:             Set pSegAbovePair = New esriSystem.VarArray
796:             Set pTopoOp = pBelowSegment
797:             pTopoOp.Simplify
798:             pSegAbovePair.Add pBelowSegment
799:             pSegAbovePair.Add False
800:             m_SegArray.Add pSegAbovePair
801:           End If
802:         End If
        
804:         Set pClone = pPoint
805:         Set pPrevPoint = pClone.Clone
806:         dblMapPrevX = dblMapX
807:         dblMapPrevY = dblMapY
        
809:       End If
      
      ' IF FILLING OUT STATS BOXES, TOO...
812:       If Not m_booIsScrolling Then
813:         dblTrueCurrentX = m_dblVals(lngIndex, 0)
814:         dblLength = (dblTrueCurrentX - dblTruePrevX)
815:         If booCurrentThresh Then
816:           m_dblLengthAbove = m_dblLengthAbove + dblLength
817:           dblRunningLengthAbove = dblRunningLengthAbove + dblLength
          ' ONLY ADD THIS SEGMENT TO LIST IF WE ARE ON LAST POINT
819:           If lngIndex = UBound(m_dblGraphVals, 1) Then
820:             m_pAboveThreshold.Add dblRunningLengthAbove
821:           End If
822:         Else
823:           m_dblLengthBelow = m_dblLengthBelow + dblLength
824:           dblRunningLengthBelow = dblRunningLengthBelow + dblLength
          ' ONLY ADD THIS SEGMENT TO LIST IF WE ARE ON LAST POINT
826:           If lngIndex = UBound(m_dblGraphVals, 1) Then
827:             m_pBelowThreshold.Add dblRunningLengthBelow
828:           End If
829:         End If
830:         dblTruePrevX = dblTrueCurrentX
831:       End If
      
833:     Else    ' HAS CROSSED THRESHOLD; NEED TO MAKE TWO LINES
834:       dblProportion = (dblGraphThreshold - dblPrevY) / (dblTempY - dblPrevY)
835:       dblShortX = dblPrevX + ((dblTempX - dblPrevX) * dblProportion)
836:       LineTo hdc, dblShortX, dblGraphThreshold
      
      ' IF CREATING SHAPES
839:       If m_booCreateShapes Then
840:         Set pValueArray = m_pDataArray.Element(lngIndex)
841:         dblMapX = pValueArray.Element(0)
842:         dblMapY = pValueArray.Element(1)
843:         dblMapShortX = dblMapPrevX + ((dblMapX - dblMapPrevX) * dblProportion)
844:         dblMapShortY = dblMapPrevY + ((dblMapY - dblMapPrevY) * dblProportion)
        
846:         dblTrueCurrentX = m_dblVals(lngIndex, 0)
847:         dblLength = (dblTrueCurrentX - dblTruePrevX)
848:         Set pShortPoint = New Point
849:         pShortPoint.PutCoords dblMapShortX, dblMapShortY
850:         Set pPoint = New Point
851:         pPoint.PutCoords dblMapX, dblMapY
        
853:         Set pClone = pPoint
854:         Set pPrevPoint = pClone.Clone
855:         dblMapPrevX = dblMapX
856:         dblMapPrevY = dblMapY
      
858:       End If
      
      ' ADD TO CUMULATIVE DISTANCE TOTALS BASED ON WHAT PREVIOUS "OVER THRESHOLD" CONDITION WAS
861:       If Not m_booIsScrolling Then
862:         dblTrueCurrentX = m_dblVals(lngIndex, 0)
863:         dblTrueShortX = dblTruePrevX + ((dblTrueCurrentX - dblTruePrevX) * dblProportion)
864:         dblLength = (dblTrueShortX - dblTruePrevX)
865:         If booPreviousThresh Then
866:           m_dblLengthAbove = m_dblLengthAbove + dblLength
867:           dblRunningLengthAbove = dblRunningLengthAbove + dblLength
868:           m_pAboveThreshold.Add dblRunningLengthAbove
869:           dblRunningLengthAbove = 0
870:           dblRunningLengthBelow = 0
871:         Else
872:           m_dblLengthBelow = m_dblLengthBelow + dblLength
873:           dblRunningLengthBelow = dblRunningLengthBelow + dblLength
874:           m_pBelowThreshold.Add dblRunningLengthBelow
875:           dblRunningLengthAbove = 0
876:           dblRunningLengthBelow = 0
877:         End If
878:       End If
      
      ' END CURRENT PATH AND START ANOTHER
881:       EndPath hdc
882:       StrokePath hdc
883:       BeginPath hdc
      
885:       If Not m_booIsScrolling Then dblLength = (dblTrueCurrentX - dblTrueShortX)
      
887:       If booCurrentThresh Then ' THEN PREVIOUSLY WAS BELOW THRESHOLD, AND USING RED PEN.  NOW IS ABOVE THRESHOLD.
888:         bluePen = CreatePen(PS_SOLID, 1, vbBlue)
889:         DeleteObject SelectObject(hdc, bluePen)
        
        ' IF CREATING SHAPES
892:         If m_booCreateShapes Then
          
          ' ADD SEGMENT BEFORE CROSSING ABOVE THRESHOLD
895:           pBelowSegment.AddPoint pShortPoint
          'ADD THIS SEGMENT TO LIST
897:           Set pSegAbovePair = New esriSystem.VarArray
898:           Set pTopoOp = pBelowSegment
899:           pTopoOp.Simplify
900:           pSegAbovePair.Add pBelowSegment
901:           pSegAbovePair.Add False
902:           m_SegArray.Add pSegAbovePair
          
          ' ADD SEGMENT AFTER CROSSING ABOVE THRESHOLD
905:           Set pAboveSegment = New Polyline
906:           pAboveSegment.AddPoint pShortPoint
907:           pAboveSegment.AddPoint pPoint
          ' ONLY ADD THIS SEGMENT TO LIST IF WE ARE ON LAST POINT
909:           If lngIndex = UBound(m_dblGraphVals, 1) Then
910:             Set pSegAbovePair = New esriSystem.VarArray
911:             Set pTopoOp = pAboveSegment
912:             pTopoOp.Simplify
913:             pSegAbovePair.Add pAboveSegment
914:             pSegAbovePair.Add True
915:             m_SegArray.Add pSegAbovePair
916:           End If
917:         End If
        
        ' IF CALCULATING STATS
920:         If Not m_booIsScrolling Then
921:           m_dblLengthAbove = m_dblLengthAbove + dblLength
922:           dblRunningLengthAbove = dblRunningLengthAbove + dblLength
          ' ONLY ADD THIS SEGMENT TO LIST IF WE ARE ON LAST POINT
924:           If lngIndex = UBound(m_dblGraphVals, 1) Then
925:             m_pAboveThreshold.Add dblRunningLengthAbove
926:           End If
927:         End If
928:       Else                     ' THEN PREVIOUSLY WAS ABOVE THRESHOLD, AND USING BLUE PEN.  NOW IS BELOW THRESHOLD.
929:         redPen = CreatePen(PS_SOLID, 1, vbRed)
930:         DeleteObject SelectObject(hdc, redPen)
        
        ' IF CREATING SHAPES
933:         If m_booCreateShapes Then
          
          ' ADD SEGMENT BEFORE CROSSING BELOW THRESHOLD
936:           pAboveSegment.AddPoint pShortPoint
          'ADD THIS SEGMENT TO LIST
938:           Set pSegAbovePair = New esriSystem.VarArray
939:           Set pTopoOp = pAboveSegment
940:           pTopoOp.Simplify
941:           pSegAbovePair.Add pAboveSegment
942:           pSegAbovePair.Add True
943:           m_SegArray.Add pSegAbovePair
          
          ' ADD SEGMENT AFTER CROSSING ABOVE THRESHOLD
946:           Set pBelowSegment = New Polyline
947:           pBelowSegment.AddPoint pShortPoint
948:           pBelowSegment.AddPoint pPoint
          ' ONLY ADD THIS SEGMENT TO LIST IF WE ARE ON LAST POINT
950:           If lngIndex = UBound(m_dblGraphVals, 1) Then
951:             Set pSegAbovePair = New esriSystem.VarArray
952:             Set pTopoOp = pBelowSegment
953:             pTopoOp.Simplify
954:             pSegAbovePair.Add pBelowSegment
955:             pSegAbovePair.Add False
956:             m_SegArray.Add pSegAbovePair
957:           End If
958:         End If
        
        ' IF CALCULATING STATS
961:         If Not m_booIsScrolling Then
962:           m_dblLengthBelow = m_dblLengthBelow + dblLength
963:           dblRunningLengthBelow = dblRunningLengthBelow + dblLength
          ' ONLY ADD THIS SEGMENT TO LIST IF WE ARE ON LAST POINT
965:           If lngIndex = UBound(m_dblGraphVals, 1) Then
966:             m_pBelowThreshold.Add dblRunningLengthBelow
967:           End If
968:         End If
969:       End If
      
      ' IF CREATING SHAPES
972:       If m_booCreateShapes Then
      
974:       End If
975:       If Not m_booIsScrolling Then dblTruePrevX = dblTrueCurrentX
      
977:       LineTo hdc, dblTempX, dblTempY
978:     End If
    
980:     dblPrevY = dblTempY
981:     dblPrevX = dblTempX
982:     booPreviousThresh = booCurrentThresh
    
'    Debug.Print CStr(lngIndex) & "]  Original:  X = " & CStr(m_dblVals(lngIndex, 0)) & ",   Y = " & CStr(m_dblVals(lngIndex, 1))
'    Debug.Print "        Converted:  X = " & CStr(m_dblGraphVals(lngIndex, 0)) & ",   Y = " & CStr(m_dblGraphVals(lngIndex, 1))
986:   Next lngIndex
  
988:   EndPath hdc
989:   StrokePath hdc
  
'  Debug.Print "Filling Textboxes = " & CStr(Not m_booIsScrolling) & ",    Threshold = " & CStr(m_dblThreshold)
  
  ' IF CREATING SHAPES
994:   If m_booCreateShapes Then
  
996:   End If
  
998:   If Not m_booIsScrolling Then
    Dim lngIndex2 As Long
    Dim strAboveReport As String
    Dim strBelowReport As String

1003:     If m_pAboveThreshold.Count > 0 Then
      Dim dblAboveForSort() As Double
      ReDim dblAboveForSort(m_pAboveThreshold.Count - 1)
1006:       For lngIndex = 0 To m_pAboveThreshold.Count - 1
1007:         dblAboveForSort(lngIndex) = m_pAboveThreshold.Element(lngIndex)
1008:       Next lngIndex
1009:       Call QuickSort.DoubleDescending(dblAboveForSort, 0, UBound(dblAboveForSort))
1010:       strAboveReport = _
          "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
          "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\b\f0\fs16 Above Threshold Statistics:\b0\par" & vbCrLf & _
          "- Total Length = " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblMaxX, "0.00"))) & " " & m_UnitName & "\par" & vbCrLf & _
          "- Total > Threshold = " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblLengthAbove, "0.00"))) & "\par" & vbCrLf & _
          "- Proportion = " & Linkages.aml_func_mod.InsertCommas(CStr(Format((m_dblLengthAbove / m_dblMaxX) * 100, "0.00"))) & "%\par" & vbCrLf & _
          "- Number of Segments = " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_pAboveThreshold.Count))) & "\par" & vbCrLf & _
          "\par" & vbCrLf & "\b Segment Lengths:\b0\par" & vbCrLf
1018:       For lngIndex2 = 0 To UBound(dblAboveForSort)
1019:         strAboveReport = strAboveReport & "    " & _
          CStr(lngIndex2 + 1) & "]  " & Linkages.aml_func_mod.InsertCommas(CStr(Format(dblAboveForSort(lngIndex2), "0.00"))) & "\par" & vbCrLf
1021:       Next lngIndex2
1022:       strAboveReport = strAboveReport + "}"
1023:     Else
1024:       strAboveReport = _
          "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
          "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\b\f0\fs16 Above Threshold Statistics:\b0\par" & vbCrLf & _
          "- No portion of the route is above the threshold...\par" & vbCrLf & "}"
1028:     End If
1029:     rtbAboveStats.TextRTF = strAboveReport
    
1031:     If m_pBelowThreshold.Count > 0 Then
      Dim dblBelowForSort() As Double
      ReDim dblBelowForSort(m_pBelowThreshold.Count - 1)
1034:       For lngIndex = 0 To m_pBelowThreshold.Count - 1
1035:         dblBelowForSort(lngIndex) = m_pBelowThreshold.Element(lngIndex)
1036:       Next lngIndex
1037:       Call QuickSort.DoubleDescending(dblBelowForSort, 0, UBound(dblBelowForSort))
1038:       strBelowReport = _
          "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
          "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\b\f0\fs16 Below Threshold Statistics:\b0\par" & vbCrLf & _
          "- Total Length = " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblMaxX, "0.00"))) & " " & m_UnitName & "\par" & vbCrLf & _
          "- Total <= Threshold = " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_dblLengthBelow, "0.00"))) & "\par" & vbCrLf & _
          "- Proportion = " & Linkages.aml_func_mod.InsertCommas(CStr(Format((m_dblLengthBelow / m_dblMaxX) * 100, "0.00"))) & "%\par" & vbCrLf & _
          "- Number of Segments = " & Linkages.aml_func_mod.InsertCommas(CStr(Format(m_pBelowThreshold.Count))) & "\par" & vbCrLf & _
          "\par" & vbCrLf & "\b Segment Lengths:\b0\par" & vbCrLf
1046:       For lngIndex2 = 0 To UBound(dblBelowForSort)
1047:         strBelowReport = strBelowReport & "    " & _
          CStr(lngIndex2 + 1) & "]  " & Linkages.aml_func_mod.InsertCommas(CStr(Format(dblBelowForSort(lngIndex2), "0.00"))) & "\par" & vbCrLf
1049:       Next lngIndex2
1050:       strBelowReport = strBelowReport + "}"
1051:     Else
1052:       strBelowReport = _
          "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
          "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\b\f0\fs16 Above Threshold Statistics:\b0\par" & vbCrLf & _
          "- No portion of the route is below the threshold...\par" & vbCrLf & "}"
1056:     End If
1057:     rtbBelowStats.TextRTF = strBelowReport
1058:   End If
  
1060:   Refresh

  ' DRAW GRAPHICS ON SCREEN
1063:   If m_booCreateShapes Then
  
    Dim pActiveView As esriCarto.IActiveView
1066:     Set pActiveView = m_pMxDoc.ActiveView
    Dim pGContainer As IGraphicsContainer
1068:     Set pGContainer = m_pMxDoc.FocusMap
    Dim pElement As IElement
    Dim pPolyline As IPolyline
    Dim booIsAbove As Boolean
    Dim strName As String
    Dim pLineElement As ILineElement
    Dim pSym As ISimpleLineSymbol
    Dim pElementProperties As IElementProperties
    Dim pEnvelope As IEnvelope
1077:     Set pEnvelope = New Envelope
'    MsgBox m_SegArray.Count & " segments..."
    Dim pRed As IColor
1080:     Set pRed = Linkages.MyGeneralOperations.MakeColorRGB(255, 0, 0)
    Dim pBlue As IColor
1082:     Set pBlue = Linkages.MyGeneralOperations.MakeColorRGB(0, 0, 255)
    
    ' DELETE EXISTING THRESHOLD ELEMENTS
1085:     pGContainer.Reset
1086:     Set pElement = pGContainer.Next
1087:     While Not pElement Is Nothing
1088:       Set pElementProperties = pElement
1089:       strName = Left(pElementProperties.Name, 17)
1090:       If (strName = "Above Threshold (") Or (strName = "Below Threshold (") Then
1091:         pGContainer.DeleteElement pElement
1092:         If (pEnvelope Is Nothing) Then
1093:           Set pEnvelope = pElement.Geometry.Envelope
1094:         Else
1095:           pEnvelope.Union pElement.Geometry.Envelope
1096:         End If
1097:       End If
1098:       Set pElement = pGContainer.Next
1099:     Wend

1101:     For lngIndex = 0 To m_SegArray.Count - 1
1102:       Set pSegAbovePair = m_SegArray.Element(lngIndex)
1103:       Set pPolyline = pSegAbovePair.Element(0)
1104:       If pPolyline.SpatialReference Is Nothing Then Set pPolyline.SpatialReference = m_SpRef
1105:       If (pEnvelope Is Nothing) Then
1106:         Set pEnvelope = pPolyline.Envelope
1107:       Else
1108:         pEnvelope.Union pPolyline.Envelope
1109:       End If
1110:       booIsAbove = pSegAbovePair.Element(1)
1111:       If booIsAbove Then
1112:         strName = "Above Threshold (>" & CStr(m_dblThreshold) & ")"
1113:       Else
1114:         strName = "Below Threshold (<=" & CStr(m_dblThreshold) & ")"
1115:       End If
        
1117:       Set pElement = Linkages.MyGeneralOperations.Graphic_ReturnElementFromGeometry(m_pMxDoc, pPolyline, strName, False)

1119:       Set pLineElement = pElement
1120:       Set pSym = New SimpleLineSymbol
1121:       If booIsAbove Then
1122:         pSym.Color = pBlue
1123:       Else
1124:         pSym.Color = pRed
1125:       End If
1126:       pSym.Width = 2
1127:       pSym.Style = esriSLSSolid
1128:       pLineElement.Symbol = pSym
      
1130:       pGContainer.AddElement pLineElement, 0
1131:     Next lngIndex
  
1133:     If (Not pEnvelope Is Nothing) Then
1134:       pActiveView.PartialRefresh esriViewGraphics + esriViewGraphicSelection + esriViewGeography, Nothing, pEnvelope
1135:     End If
1136:   End If

  Exit Sub
ErrorHandler:
  HandleError True, "FillGraph " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdClose_Click()
  On Error GoTo ErrorHandler

1146:   Me.Frame.Visible = False
1147:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdClose_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdLayout_Click()
  On Error GoTo ErrorHandler

1157:   Call MakeEMF

  Exit Sub
ErrorHandler:
  HandleError True, "cmdLayout_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdMinimize_Click()
  On Error GoTo ErrorHandler

  
  ' MAKE DIALOG DISAPPEAR
  Dim pControl As Control
  Dim pWindowPos As IWindowPosition
1171:   Set pWindowPos = m_Frame
  
1173:   If m_booMinimizeToggle = False Then  ' THEN IT WAS MAXIMIZED, WILL CHANGE TO MINIMIZED
1174:     m_booMinimizeToggle = True
1175:     cmdMinimize.Caption = "Maximize >>"
1176:     pWindowPos.Width = (cmdMinimize.Width + 210) / 15
1177:     pWindowPos.Height = (cmdMinimize.Height + 510) / 15
1178:     cmdMinimize.Left = (240)
1179:     cmdMinimize.Top = (60)
1180:     For Each pControl In Me.Controls
1181:      pControl.Visible = False
1182:     Next pControl
1183:     pctBackColor.Visible = True
1184:     cmdMinimize.Visible = True
    
1186:   Else                                 ' THEN IT WAS MINIMIZED, WILL CHANGE TO MAXIMIZED
1187:     m_booMinimizeToggle = False
1188:     cmdMinimize.Caption = "<< Minimize"
1189:     pWindowPos.Width = (9000) / 15
1190:     pWindowPos.Height = (6105) / 15
1191:     cmdMinimize.Left = (7785)
1192:     cmdMinimize.Top = (5355)
1193:     For Each pControl In Me.Controls
1194:      pControl.Visible = True
1195:     Next pControl
1196:     pctBackColor.Visible = False
1197:     FillGraph
1198:   End If
  
1200:   Refresh

  Exit Sub
ErrorHandler:
  HandleError True, "cmdMinimize_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdPoints_Click()
  On Error GoTo ErrorHandler


  Dim strReport As String
  
  Dim strFName As String

  ' WORKSPACE
  ' FIRST SEE IF IT HAS BEEN SAVED TO EXTENSION PROPERTIES.  THIS PROPERTY WILL BE EMPTY THE FIRST TIME THE DIALOG
  '      IS OPENED, BUT EACH TIME THEREAFTER IT WILL HAVE A VALUE.
  ' IF NOT IN EXTENSION PROPERTY, THEN CHECK ArcGIS LAST SAVE TO LOCATION
  ' IF THIS DOESN'T WORK, USE MxDoc PATH NAME.
  Dim strDirPath As String
  
  Dim newUid As New uID
1223:   newUid.Value = "Linkages.clsExtension"
  Dim ext As Linkages.clsExtension
1225:   Set ext = m_pApp.FindExtensionByCLSID(newUid)
  
  ' FOR USE WHEN WRAPPED INTO FULL EXTENSION
1228:   strDirPath = ext.ClipDirectoryPath
1229:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
1230:     strDirPath = Linkages.aml_func_mod.ReturnArcGISGeneralDir(enumLastSaveToLocation)
1231:   End If
1232:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
1233:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
1234:     strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
1235:   End If
  
  ' USE BELOW UNTIL WRAPPED INTO FULL EXTENSION
'  strDirPath = aml_func_mod.GetFullFileString(aml_func_mod.GetMxDocPath(m_pApp))
'  strDirPath = aml_func_mod.ReturnDir(strDirPath)
  '----------------------------------------------------
  
1242:   If Right(strDirPath, 1) <> "/" And Right(strDirPath, 1) <> "\" Then strDirPath = strDirPath & "\"
  
  Dim lngIndex As Long
  
  Dim pMap As IMap
1247:   Set pMap = m_pMxDoc.FocusMap
  Dim pActiveView As IActiveView
1249:   Set pActiveView = m_pMxDoc.ActiveView
  
1251:   strFName = strDirPath & "bottleneck_points.shp"
1252:   strFName = Linkages.aml_func_mod.MakeUniqueFilename(strFName)
  Dim strJustFilename As String
1254:   strJustFilename = Linkages.aml_func_mod.ReturnFilename(strFName)
  
  ' MAKE SHAPEFILE
  Dim pPointsFClass As IFeatureClass
1258:   Set pPointsFClass = Linkages.aml_func_mod.CreateShapefile(strDirPath, strJustFilename, m_SpRef, "Point")
  
    ' MAKE FIELDS
    ' MAKE X_Coord FIELD
  Dim pPointsXField As IField
  Dim pPointsXFieldEdit As IFieldEdit
1264:   Set pPointsXField = New Field
1265:   Set pPointsXFieldEdit = pPointsXField
1266:   With pPointsXFieldEdit
1267:     .Name = "X_Coord"
1268:     .Type = esriFieldTypeDouble
1269:     .Precision = 16
1270:     .Scale = 8
1271:   End With
1272:   pPointsFClass.AddField pPointsXField
  
    ' MAKE Y_Coord FIELD
  Dim pPointsYField As IField
  Dim pPointsYFieldEdit As IFieldEdit
1277:   Set pPointsYField = New Field
1278:   Set pPointsYFieldEdit = pPointsYField
1279:   With pPointsYFieldEdit
1280:     .Name = "Y_Coord"
1281:     .Type = esriFieldTypeDouble
1282:     .Precision = 16
1283:     .Scale = 8
1284:   End With
1285:   pPointsFClass.AddField pPointsYField
  
    ' MAKE WIDTH FIELD
  Dim pPointsWidthField As IField
  Dim pPointsWidthFieldEdit As IFieldEdit
1290:   Set pPointsWidthField = New Field
1291:   Set pPointsWidthFieldEdit = pPointsWidthField
1292:   With pPointsWidthFieldEdit
1293:     .Name = "Width"
1294:     .Type = esriFieldTypeDouble
1295:     .Precision = 16
1296:     .Scale = 8
1297:   End With
1298:   pPointsFClass.AddField pPointsWidthField
    
  ' FIND VARIABLE INDEX VALUES
  Dim lngPointsID As Long
  Dim lngPointsX As Long
  Dim lngPointsY As Long
  Dim lngPointsWidth As Long
1305:   lngPointsID = pPointsFClass.FindField("Unique_ID")
1306:   lngPointsX = pPointsFClass.FindField("X_Coord")
1307:   lngPointsY = pPointsFClass.FindField("Y_Coord")
1308:   lngPointsWidth = pPointsFClass.FindField("Width")
  
  ' MAKE INSERT CURSOR
  Dim pPointsCur As IFeatureCursor
1312:   Set pPointsCur = pPointsFClass.Insert(True)
  Dim pPointsBuf As IFeatureBuffer
1314:   Set pPointsBuf = pPointsFClass.CreateFeatureBuffer
  
  Dim pPoint As IPoint
  Dim pValArray  As esriSystem.IDoubleArray
  Dim dblX As Double
  Dim dblY As Double
  Dim dblWidth As Double
  
  ' ADD DATA TO SHAPEFILE
1323:   For lngIndex = 0 To m_pDataArray.Count - 1
1324:     Set pValArray = m_pDataArray.Element(lngIndex)
1325:     dblX = pValArray.Element(0)
1326:     dblY = pValArray.Element(1)
1327:     dblWidth = pValArray.Element(2)
    
1329:     Set pPoint = New Point
1330:     pPoint.PutCoords dblX, dblY
1331:     Set pPoint.SpatialReference = m_SpRef
1332:     With pPointsBuf
1333:       Set .Shape = pPoint
1334:       .Value(lngPointsID) = lngIndex + 1
1335:       .Value(lngPointsX) = dblX
1336:       .Value(lngPointsY) = dblY
1337:       .Value(lngPointsWidth) = dblWidth
1338:     End With
1339:     pPointsCur.InsertFeature pPointsBuf
1340:   Next lngIndex
  
1342:   pPointsCur.Flush
  Dim pFeatureLayer As IFeatureLayer
1344:   Set pFeatureLayer = New FeatureLayer
1345:   Set pFeatureLayer.FeatureClass = pPointsFClass
1346:   pFeatureLayer.Name = Linkages.aml_func_mod.ClipExtension(strJustFilename)
1347:   pMap.AddLayer pFeatureLayer
  
1349:   pActiveView.PartialRefresh esriViewGraphics + esriViewGraphicSelection + esriViewGeography, Nothing, Nothing

  ' FOR REPORT
'  strReport = _
'      "The shapefile " & strJustFilename & "' has been generated and added to your view.  Individual points " & _
'      "include X-coordinates, Y-coordinates and Corridor Width values at each location." & vbCrLf & vbCrLf & _
'      "  \i Shapefile Saved to " & Replace(strFName, "\", "\\") & "\i0\par" & vbCrLf
  
  Dim pDocDirty As IDocumentDirty
1358:   Set pDocDirty = m_pMxDoc
1359:   pDocDirty.SetDirty
  
  ' FOR REPORT
1362:   strReport = _
      "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\tx90\tx360\tx450\tx720\f0\fs16 " & _
      "The shapefile \b " & strJustFilename & "\b0  has been generated and added to your view.  Individual points " & _
      "include X-coordinates, Y-coordinates and Corridor Width values at each location.\par" & vbCrLf & "\par" & vbCrLf & _
      "\b Shapefile saved to:\b0 \i  " & Replace(strFName, "\", "\\") & "\i0\par" & vbCrLf & vbCrLf & "}"
  
    ' SHOW REPORT
  Dim frmReportForm As New Linkages.frmReport_modal
1371:   frmReportForm.txtReport.TextRTF = strReport
1372:   frmReportForm.Caption = "Operation Successful:"
1373:   frmReportForm.Show vbModal

  Exit Sub
ErrorHandler:
  HandleError True, "cmdPoints_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdTables_Click()
  On Error GoTo ErrorHandler

  Dim strReport As String
  
'  strReport = "The following tables have been created and added as Standalone Tables to your Map document.  " & _
      "All standalone tables are available by clicking the 'Source' tab at the bottom of the Map Table of Contents." & _
      vbCrLf & "------------------------------------------------------" & vbCrLf
  
1389:   strReport = _
      "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\tx90\tx360\tx450\tx720\f0\fs16 " & _
      "The following tables have been created and added as Standalone Tables to your Map document.  " & _
      "All standalone tables are available by clicking the 'Source' tab at the bottom of the Map Table of Contents.\par" & _
      vbCrLf & "\par" & vbCrLf & "------------------------------------------------------\par" & vbCrLf
      
  Dim strFName As String
  
  Dim newUid As New uID
1399:   newUid.Value = "Linkages.clsExtension"
  Dim ext As Linkages.clsExtension
1401:   Set ext = m_pApp.FindExtensionByCLSID(newUid)

  ' WORKSPACE
  ' FIRST SEE IF IT HAS BEEN SAVED TO EXTENSION PROPERTIES.  THIS PROPERTY WILL BE EMPTY THE FIRST TIME THE DIALOG
  '      IS OPENED, BUT EACH TIME THEREAFTER IT WILL HAVE A VALUE.
  ' IF NOT IN EXTENSION PROPERTY, THEN CHECK ArcGIS LAST SAVE TO LOCATION
  ' IF THIS DOESN'T WORK, USE MxDoc PATH NAME.
  Dim strDirPath As String
  
  ' FOR USE WHEN WRAPPED INTO FULL EXTENSION
1411:   strDirPath = ext.ClipDirectoryPath
1412:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
1413:     strDirPath = Linkages.aml_func_mod.ReturnArcGISGeneralDir(enumLastSaveToLocation)
1414:   End If
1415:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
1416:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
1417:     strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
1418:   End If
  
  ' USE BELOW UNTIL WRAPPED INTO FULL EXTENSION
'  strDirPath = aml_func_mod.GetFullFileString(aml_func_mod.GetMxDocPath(m_pApp))
'  strDirPath = aml_func_mod.ReturnDir(strDirPath)
  '----------------------------------------------------
  
1425:   If Right(strDirPath, 1) <> "/" And Right(strDirPath, 1) <> "\" Then strDirPath = strDirPath & "\"
  
  Dim lngCounter As Long
1428:   lngCounter = 0
  Dim lngIndex As Long
  
  Dim pStandaloneTableCollection As IStandaloneTableCollection
1432:   Set pStandaloneTableCollection = m_pMxDoc.FocusMap
  
  ' SEGMENT LENGTHS TABLE -------------------------------------------------------------------------------
1435:   strFName = strDirPath & "threshold_lengths.dbf"
1436:   strFName = aml_func_mod.MakeUniqueFilename(strFName)
    ' MAKE FIELDS
  Dim pSegsFields As IFields
  Dim pSegsFieldsEdit As IFieldsEdit
1440:   Set pSegsFields = New Fields
1441:   Set pSegsFieldsEdit = pSegsFields
1442:   pSegsFieldsEdit.FieldCount = 3
  
    ' MAKE UNIQUE ID FIELD
  Dim pSegsUniqueIDField As IField
  Dim pSegsUniqueIDFieldEdit As IFieldEdit
1447:   Set pSegsUniqueIDField = New Field
1448:   Set pSegsUniqueIDFieldEdit = pSegsUniqueIDField
1449:   With pSegsUniqueIDFieldEdit
1450:     .Name = "Unique_ID"
1451:     .Type = esriFieldTypeInteger
1452:     .Precision = 8
1453:   End With
  
    ' MAKE NAME FIELD
  Dim pSegsNameField As IField
  Dim pSegsNameFieldEdit As IFieldEdit
1458:   Set pSegsNameField = New Field
1459:   Set pSegsNameFieldEdit = pSegsNameField
1460:   With pSegsNameFieldEdit
1461:     .Name = "Name"
1462:     .Type = esriFieldTypeString
1463:     .Precision = 25
1464:   End With
  
    ' MAKE LENGTH FIELD
  Dim pSegsLengthField As IField
  Dim pSegsLengthFieldEdit As IFieldEdit
1469:   Set pSegsLengthField = New Field
1470:   Set pSegsLengthFieldEdit = pSegsLengthField
1471:   With pSegsLengthFieldEdit
1472:     .Name = "Length"
1473:     .Type = esriFieldTypeDouble
1474:     .Precision = 16
1475:     .Scale = 8
1476:   End With
  
1478:   Set pSegsFieldsEdit.Field(0) = pSegsUniqueIDField
1479:   Set pSegsFieldsEdit.Field(1) = pSegsNameField
1480:   Set pSegsFieldsEdit.Field(2) = pSegsLengthField
  
  ' MAKE dBASE TABLE
  Dim pSegsTable As ITable
1484:   Set pSegsTable = aml_func_mod.CreatedBASETable(strFName, pSegsFields)
  
  ' MAKE INSERT CURSOR
  Dim pSegsCur As ICursor
1488:   Set pSegsCur = pSegsTable.Insert(True)
  Dim pSegsBuf As IRowBuffer
1490:   Set pSegsBuf = pSegsTable.CreateRowBuffer
  
  ' FIND VARIABLE INDEX VALUES
  Dim lngSegsID As Long
  Dim lngSegsName As Long
  Dim lngSegsLength As Long
1496:   lngSegsID = pSegsTable.FindField("Unique_ID")
1497:   lngSegsName = pSegsTable.FindField("Name")
1498:   lngSegsLength = pSegsTable.FindField("Length")
  
  ' ADD DATA TO TABLE
1501:   lngCounter = lngCounter + 1
1502:   pSegsBuf.Value(lngSegsID) = lngCounter
1503:   pSegsBuf.Value(lngSegsName) = "Total Length"
1504:   pSegsBuf.Value(lngSegsLength) = m_dblMaxX
1505:   pSegsCur.InsertRow pSegsBuf
  
1507:   lngCounter = lngCounter + 1
1508:   pSegsBuf.Value(lngSegsID) = lngCounter
1509:   pSegsBuf.Value(lngSegsName) = "Threshold Value"
1510:   pSegsBuf.Value(lngSegsLength) = m_dblThreshold
1511:   pSegsCur.InsertRow pSegsBuf
  
1513:   If m_pAboveThreshold.Count > 0 Then
    Dim dblAboveForSort() As Double
    ReDim dblAboveForSort(m_pAboveThreshold.Count - 1)
1516:     For lngIndex = 0 To m_pAboveThreshold.Count - 1
1517:       dblAboveForSort(lngIndex) = m_pAboveThreshold.Element(lngIndex)
1518:     Next lngIndex
1519:     Call QuickSort.DoubleDescending(dblAboveForSort, 0, UBound(dblAboveForSort))
  
1521:     For lngIndex = 0 To UBound(dblAboveForSort)
1522:       lngCounter = lngCounter + 1
1523:       pSegsBuf.Value(lngSegsID) = lngCounter
1524:       pSegsBuf.Value(lngSegsName) = "Above Threshold #" & CStr(lngIndex + 1)
1525:       pSegsBuf.Value(lngSegsLength) = dblAboveForSort(lngIndex)
1526:       pSegsCur.InsertRow pSegsBuf
1527:     Next lngIndex
1528:   End If
  
1530:   If m_pBelowThreshold.Count > 0 Then
    Dim dblBelowForSort() As Double
    ReDim dblBelowForSort(m_pBelowThreshold.Count - 1)
1533:     For lngIndex = 0 To m_pBelowThreshold.Count - 1
1534:       dblBelowForSort(lngIndex) = m_pBelowThreshold.Element(lngIndex)
1535:     Next lngIndex
1536:     Call QuickSort.DoubleDescending(dblBelowForSort, 0, UBound(dblBelowForSort))
  
1538:     For lngIndex = 0 To UBound(dblBelowForSort)
1539:       lngCounter = lngCounter + 1
1540:       pSegsBuf.Value(lngSegsID) = lngCounter
1541:       pSegsBuf.Value(lngSegsName) = "Below Threshold #" & CStr(lngIndex + 1)
1542:       pSegsBuf.Value(lngSegsLength) = dblBelowForSort(lngIndex)
1543:       pSegsCur.InsertRow pSegsBuf
1544:     Next lngIndex
1545:   End If
  
1547:   pSegsCur.Flush
  
  ' MAKE STANDALONE TABLE
  Dim pSegsStandaloneTable As IStandaloneTable
  Dim pSegsTableWindow As ITableWindow2
  
1553:   Set pSegsStandaloneTable = New StandaloneTable
1554:   Set pSegsStandaloneTable.Table = pSegsTable
1555:   Set pSegsTableWindow = New TableWindow
1556:   With pSegsTableWindow
1557:     Set .StandaloneTable = pSegsStandaloneTable
1558:     Set .Application = m_pApp
1559:     .TableSelectionAction = esriSelectFeatures
1560:     .ShowAliasNamesInColumnHeadings = True
1561:     .ShowSelected = False
1562:     .Show True
1563:   End With
1564:   pStandaloneTableCollection.AddStandaloneTable pSegsStandaloneTable
  
  ' FOR REPORT
1567:   strReport = strReport & _
  "\b  1] Table of Segment Lengths:\b0\par" & vbCrLf & _
  "     \i Saved to " & Replace(strFName, "\", "\\") & "\i0\par" & vbCrLf
  

  
  ' GENERAL STATISTICS TABLE -------------------------------------------------------------------------------
1574:   strFName = strDirPath & "bottleneck_stats.dbf"
1575:   strFName = aml_func_mod.MakeUniqueFilename(strFName)
    ' MAKE FIELDS
  Dim pStatsFields As IFields
  Dim pStatsFieldsEdit As IFieldsEdit
1579:   Set pStatsFields = New Fields
1580:   Set pStatsFieldsEdit = pStatsFields
1581:   pStatsFieldsEdit.FieldCount = 3
  
    ' MAKE UNIQUE ID FIELD
  Dim pStatsUniqueIDField As IField
  Dim pStatsUniqueIDFieldEdit As IFieldEdit
1586:   Set pStatsUniqueIDField = New Field
1587:   Set pStatsUniqueIDFieldEdit = pStatsUniqueIDField
1588:   With pStatsUniqueIDFieldEdit
1589:     .Name = "Unique_ID"
1590:     .Type = esriFieldTypeInteger
1591:     .Precision = 8
1592:   End With
  
    ' MAKE Statistics FIELD
  Dim pStatsStatisticsField As IField
  Dim pStatsStatisticsFieldEdit As IFieldEdit
1597:   Set pStatsStatisticsField = New Field
1598:   Set pStatsStatisticsFieldEdit = pStatsStatisticsField
1599:   With pStatsStatisticsFieldEdit
1600:     .Name = "Statistic"
1601:     .Type = esriFieldTypeString
1602:     .length = 30
1603:   End With
  
    ' MAKE Value FIELD
  Dim pStatsValueField As IField
  Dim pStatsValueFieldEdit As IFieldEdit
1608:   Set pStatsValueField = New Field
1609:   Set pStatsValueFieldEdit = pStatsValueField
1610:   With pStatsValueFieldEdit
1611:     .Name = "Value"
1612:     .Type = esriFieldTypeDouble
1613:     .Precision = 16
1614:     .Scale = 8
1615:   End With
  
1617:   Set pStatsFieldsEdit.Field(0) = pStatsUniqueIDField
1618:   Set pStatsFieldsEdit.Field(1) = pStatsStatisticsField
1619:   Set pStatsFieldsEdit.Field(2) = pStatsValueField
  
  ' MAKE dBASE TABLE
  Dim pStatsTable As ITable
1623:   Set pStatsTable = aml_func_mod.CreatedBASETable(strFName, pStatsFields)
  
  ' MAKE INSERT CURSOR
  Dim pStatsCur As ICursor
1627:   Set pStatsCur = pStatsTable.Insert(True)
  Dim pStatsBuf As IRowBuffer
1629:   Set pStatsBuf = pStatsTable.CreateRowBuffer
  
  ' FIND VARIABLE INDEX VALUES
  Dim lngStatsID As Long
  Dim lngStatsStatistics As Long
  Dim lngStatsValue As Long
  
1636:   lngCounter = 0
  
1638:   lngStatsID = pStatsTable.FindField("Unique_ID")
1639:   lngStatsStatistics = pStatsTable.FindField("Statistic")
1640:   lngStatsValue = pStatsTable.FindField("Value")
  
  ' ADD DATA TO TABLE
  ' MINIMUM
1644:   lngCounter = lngCounter + 1
1645:   pStatsBuf.Value(lngStatsID) = lngCounter
1646:   pStatsBuf.Value(lngStatsStatistics) = "Minimum Width"
1647:   pStatsBuf.Value(lngStatsValue) = m_dblMinY
1648:   pStatsCur.InsertRow pStatsBuf
  
  ' MAXIMUM
1651:   lngCounter = lngCounter + 1
1652:   pStatsBuf.Value(lngStatsID) = lngCounter
1653:   pStatsBuf.Value(lngStatsStatistics) = "Maximum Width"
1654:   pStatsBuf.Value(lngStatsValue) = m_dblMaxY
1655:   pStatsCur.InsertRow pStatsBuf
  
  ' RANGE
1658:   lngCounter = lngCounter + 1
1659:   pStatsBuf.Value(lngStatsID) = lngCounter
1660:   pStatsBuf.Value(lngStatsStatistics) = "Range of Width Values"
1661:   pStatsBuf.Value(lngStatsValue) = m_dblRangeY
1662:   pStatsCur.InsertRow pStatsBuf
  
  ' MEAN
1665:   lngCounter = lngCounter + 1
1666:   pStatsBuf.Value(lngStatsID) = lngCounter
1667:   pStatsBuf.Value(lngStatsStatistics) = "Mean Width"
1668:   pStatsBuf.Value(lngStatsValue) = m_dblMeanY
1669:   pStatsCur.InsertRow pStatsBuf
  
  ' MEDIAN
1672:   lngCounter = lngCounter + 1
1673:   pStatsBuf.Value(lngStatsID) = lngCounter
1674:   pStatsBuf.Value(lngStatsStatistics) = "Median Width"
1675:   pStatsBuf.Value(lngStatsValue) = m_dblMedY
1676:   pStatsCur.InsertRow pStatsBuf
  
  ' STANDARD DEVIATION
1679:   lngCounter = lngCounter + 1
1680:   pStatsBuf.Value(lngStatsID) = lngCounter
1681:   pStatsBuf.Value(lngStatsStatistics) = "Standard Deviation of Width"
1682:   pStatsBuf.Value(lngStatsValue) = m_dblSDY
1683:   pStatsCur.InsertRow pStatsBuf
  
  ' CENTERLINE LENGTH
1686:   lngCounter = lngCounter + 1
1687:   pStatsBuf.Value(lngStatsID) = lngCounter
1688:   pStatsBuf.Value(lngStatsStatistics) = "Centerline Length"
1689:   pStatsBuf.Value(lngStatsValue) = m_dblMaxX
1690:   pStatsCur.InsertRow pStatsBuf
  
  ' THRESHOLD VALUE
1693:   lngCounter = lngCounter + 1
1694:   pStatsBuf.Value(lngStatsID) = lngCounter
1695:   pStatsBuf.Value(lngStatsStatistics) = "Width Threshold Value"
1696:   pStatsBuf.Value(lngStatsValue) = m_dblThreshold
1697:   pStatsCur.InsertRow pStatsBuf
  
  ' LENGTH BELOW THRESHOLD
1700:   lngCounter = lngCounter + 1
1701:   pStatsBuf.Value(lngStatsID) = lngCounter
1702:   pStatsBuf.Value(lngStatsStatistics) = "Length Below Threshold"
1703:   pStatsBuf.Value(lngStatsValue) = m_dblLengthBelow
1704:   pStatsCur.InsertRow pStatsBuf
  
  ' PROPORTION BELOW THRESHOLD
1707:   lngCounter = lngCounter + 1
1708:   pStatsBuf.Value(lngStatsID) = lngCounter
1709:   pStatsBuf.Value(lngStatsStatistics) = "Proportion Below Threshold"
1710:   pStatsBuf.Value(lngStatsValue) = (m_dblLengthBelow / m_dblMaxX)
1711:   pStatsCur.InsertRow pStatsBuf

  ' LENGTH ABOVE THRESHOLD
1714:   lngCounter = lngCounter + 1
1715:   pStatsBuf.Value(lngStatsID) = lngCounter
1716:   pStatsBuf.Value(lngStatsStatistics) = "Length Above Threshold"
1717:   pStatsBuf.Value(lngStatsValue) = m_dblLengthAbove
1718:   pStatsCur.InsertRow pStatsBuf
  
  ' PROPORTION ABOVE THRESHOLD
1721:   lngCounter = lngCounter + 1
1722:   pStatsBuf.Value(lngStatsID) = lngCounter
1723:   pStatsBuf.Value(lngStatsStatistics) = "Proportion Above Threshold"
1724:   pStatsBuf.Value(lngStatsValue) = (m_dblLengthAbove / m_dblMaxX)
1725:   pStatsCur.InsertRow pStatsBuf
  
1727:   pStatsCur.Flush
  
  ' MAKE STANDALONE TABLE
  Dim pStatsStandaloneTable As IStandaloneTable
  Dim pStatsTableWindow As ITableWindow2
  
1733:   Set pStatsStandaloneTable = New StandaloneTable
1734:   Set pStatsStandaloneTable.Table = pStatsTable
1735:   Set pStatsTableWindow = New TableWindow
1736:   With pStatsTableWindow
1737:     Set .StandaloneTable = pStatsStandaloneTable
1738:     Set .Application = m_pApp
1739:     .TableSelectionAction = esriSelectFeatures
1740:     .ShowAliasNamesInColumnHeadings = True
1741:     .ShowSelected = False
1742:     .Show True
1743:   End With
1744:   pStandaloneTableCollection.AddStandaloneTable pStatsStandaloneTable
  
  Dim pDocDirty As IDocumentDirty
1747:   Set pDocDirty = m_pMxDoc
1748:   pDocDirty.SetDirty
  
  ' FOR REPORT
1751:   strReport = strReport & _
  "\b  2] Table of Bottleneck Statistics:\b0\par" & vbCrLf & _
  "     \i Saved to " & Replace(strFName, "\", "\\") & "\i0\par" & vbCrLf & "}"
  
    ' SHOW REPORT
  Dim frmReportForm As New Linkages.frmReport_modal
1757:   frmReportForm.txtReport.TextRTF = strReport
1758:   frmReportForm.Caption = "Operation Successful:"
1759:   frmReportForm.Show vbModal
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdTables_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub Command1_Click()
  On Error GoTo ErrorHandler

  Dim strReport As String
  
  Dim strFName As String

  
  Dim newUid As New uID
1776:   newUid.Value = "Linkages.clsExtension"
  Dim ext As Linkages.clsExtension
1778:   Set ext = m_pApp.FindExtensionByCLSID(newUid)
  
  ' WORKSPACE
  ' FIRST SEE IF IT HAS BEEN SAVED TO EXTENSION PROPERTIES.  THIS PROPERTY WILL BE EMPTY THE FIRST TIME THE DIALOG
  '      IS OPENED, BUT EACH TIME THEREAFTER IT WILL HAVE A VALUE.
  ' IF NOT IN EXTENSION PROPERTY, THEN CHECK ArcGIS LAST SAVE TO LOCATION
  ' IF THIS DOESN'T WORK, USE MxDoc PATH NAME.
  Dim strDirPath As String
  
  ' FOR USE WHEN WRAPPED INTO FULL EXTENSION
1788:   strDirPath = ext.ClipDirectoryPath
1789:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
1790:     strDirPath = Linkages.aml_func_mod.ReturnArcGISGeneralDir(enumLastSaveToLocation)
1791:   End If
1792:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
1793:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
1794:     strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
1795:   End If
  
  ' USE BELOW UNTIL WRAPPED INTO FULL EXTENSION
'  strDirPath = aml_func_mod.GetFullFileString(aml_func_mod.GetMxDocPath(m_pApp))
'  strDirPath = aml_func_mod.ReturnDir(strDirPath)
  '----------------------------------------------------
  
1802:   If Right(strDirPath, 1) <> "/" And Right(strDirPath, 1) <> "\" Then strDirPath = strDirPath & "\"
  
  Dim lngIndex As Long
  
  Dim pMap As IMap
1807:   Set pMap = m_pMxDoc.FocusMap
  Dim pActiveView As IActiveView
1809:   Set pActiveView = m_pMxDoc.ActiveView
  
1811:   strFName = strDirPath & "bottleneck_segments.shp"
1812:   strFName = aml_func_mod.MakeUniqueFilename(strFName)
  Dim strJustFilename As String
1814:   strJustFilename = aml_func_mod.ReturnFilename(strFName)
  
  ' MAKE SHAPEFILE
  Dim pSegsFClass As IFeatureClass
1818:   Set pSegsFClass = aml_func_mod.CreateShapefile(strDirPath, strJustFilename, m_SpRef, "Polyline")
  
    ' MAKE FIELDS
    ' MAKE NAME FIELD
  Dim pSegsNameField As IField
  Dim pSegsNameFieldEdit As IFieldEdit
1824:   Set pSegsNameField = New Field
1825:   Set pSegsNameFieldEdit = pSegsNameField
1826:   With pSegsNameFieldEdit
1827:     .Name = "Name"
1828:     .Type = esriFieldTypeString
1829:     .length = 25
1830:   End With
1831:   pSegsFClass.AddField pSegsNameField
  
    ' MAKE LENGTH FIELD
  Dim pSegsLengthField As IField
  Dim pSegsLengthFieldEdit As IFieldEdit
1836:   Set pSegsLengthField = New Field
1837:   Set pSegsLengthFieldEdit = pSegsLengthField
1838:   With pSegsLengthFieldEdit
1839:     .Name = "Length"
1840:     .Type = esriFieldTypeDouble
1841:     .Precision = 16
1842:     .Scale = 8
1843:   End With
1844:   pSegsFClass.AddField pSegsLengthField
  
  Dim pEnvelope As IEnvelope
1847:   Set pEnvelope = New Envelope
    
  ' FIND VARIABLE INDEX VALUES
  Dim lngSegsID As Long
  Dim lngSegsName As Long
  Dim lngSegsLength As Long
1853:   lngSegsID = pSegsFClass.FindField("Unique_ID")
1854:   lngSegsName = pSegsFClass.FindField("Name")
1855:   lngSegsLength = pSegsFClass.FindField("Length")
  
  ' MAKE INSERT CURSOR
  Dim pSegsCur As IFeatureCursor
1859:   Set pSegsCur = pSegsFClass.Insert(True)
  Dim pSegsBuf As IFeatureBuffer
1861:   Set pSegsBuf = pSegsFClass.CreateFeatureBuffer
  
  Dim pPolyline As IPolyline
  Dim pSegAbovePair As esriSystem.IVariantArray
  Dim booIsAbove As Boolean
  Dim strName As String
  
  ' ADD DATA TO SHAPEFILE
1869:   For lngIndex = 0 To m_SegArray.Count - 1
1870:     Set pSegAbovePair = m_SegArray.Element(lngIndex)
1871:     Set pPolyline = pSegAbovePair.Element(0)
1872:     If pPolyline.SpatialReference Is Nothing Then Set pPolyline.SpatialReference = m_SpRef
1873:     If (pEnvelope Is Nothing) Then
1874:       Set pEnvelope = pPolyline.Envelope
1875:     Else
1876:       pEnvelope.Union pPolyline.Envelope
1877:     End If
1878:     booIsAbove = pSegAbovePair.Element(1)
1879:     If booIsAbove Then
1880:       strName = "Above Threshold (>" & CStr(m_dblThreshold) & ")"
1881:     Else
1882:       strName = "Below Threshold (<=" & CStr(m_dblThreshold) & ")"
1883:     End If
      
1885:     With pSegsBuf
1886:       Set .Shape = pPolyline
1887:       .Value(lngSegsID) = lngIndex + 1
1888:       .Value(lngSegsName) = strName
1889:       .Value(lngSegsLength) = pPolyline.length
1890:     End With
1891:     pSegsCur.InsertFeature pSegsBuf
1892:   Next lngIndex
  
1894:   pSegsCur.Flush
  Dim pFeatureLayer As IFeatureLayer
1896:   Set pFeatureLayer = New FeatureLayer
1897:   Set pFeatureLayer.FeatureClass = pSegsFClass
1898:   pFeatureLayer.Name = aml_func_mod.ClipExtension(strJustFilename)
1899:   pMap.AddLayer pFeatureLayer
  
1901:   If (Not pEnvelope Is Nothing) Then
1902:     pActiveView.PartialRefresh esriViewGraphics + esriViewGraphicSelection + esriViewGeography, Nothing, pEnvelope
1903:   End If

  Dim pDocDirty As IDocumentDirty
1906:   Set pDocDirty = m_pMxDoc
1907:   pDocDirty.SetDirty
  
  ' FOR REPORT
1910:   strReport = _
      "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\tx90\tx360\tx450\tx720\f0\fs16 " & _
      "The shapefile \b " & strJustFilename & "\b0  has been generated and added to your view.  Individual segments " & _
      "are attributed according to whether they are above or below the threshold value of " & CStr(m_dblThreshold) & _
      " " & m_UnitName & ".\par" & vbCrLf & "\par" & vbCrLf & _
      "\b Shapefile saved to:\b0 \i  " & Replace(strFName, "\", "\\") & "\i0\par" & vbCrLf & vbCrLf & "}"
  
    ' SHOW REPORT
  Dim frmReportForm As New Linkages.frmReport_modal
1920:   frmReportForm.txtReport.TextRTF = strReport
1921:   frmReportForm.Caption = "Operation Successful:"
1922:   frmReportForm.Show vbModal
  ' MsgBox strReport
  
  Exit Sub
ErrorHandler:
  HandleError True, "Command1_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  On Error GoTo ErrorHandler

1933:   X = X / 15
1934:   Y = Y / 15
'  Debug.Print X & ", " & Y
  
1937:   If (X >= (GraphLeft + 58)) And (X <= (GraphRight - 15)) And _
    (Y >= (GraphTop + 17)) And (Y <= (GraphBottom - 38)) Then
    
    Dim dblTrueY As Double
1941:     dblTrueY = (GraphBottom - 38) - Y   ' = # PIXELS ABOVE BOTTOM OF GRAPH
1942:     dblTrueY = dblTrueY / (GraphBottom - 38 - (GraphTop + 17))   ' = PROPORTION UP
1943:     dblTrueY = dblTrueY * m_dblMaxGraphY
1944:     m_booIsScrolling = False
1945:     m_booCreateShapes = True
1946:     If m_dblMaxGraphY < 100 Then
1947:       txtDistance.Text = Round(dblTrueY, 5)
1948:     Else
1949:       txtDistance.Text = Int(dblTrueY)
1950:     End If
'    Debug.Print Int(dblTrueY)
   ' ConvertValToGraphY = (GraphBottom - 38) - ((dblDistance / m_dblMaxGraphY) * m_dblYRange)     ' USE m_dblMaxGraphY
  
1954:   End If
  

  Exit Sub
ErrorHandler:
  HandleError True, "Form_MouseDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler

1965:   Set m_pApp = Nothing
1966:   Set m_pAboveThreshold = Nothing
1967:   Set m_pBelowThreshold = Nothing
1968:   Set m_SpRef = Nothing
1969:   Set m_Frame = Nothing
1970:   Set m_pXLabels = Nothing
1971:   Set m_pYLabels = Nothing
1972:   Set m_pDataArray = Nothing
1973:   Set m_pMxDoc = Nothing
1974:   Set m_SegArray = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub slidThreshold_Click()
  On Error GoTo ErrorHandler

'  Debug.Print "Clicking..."
1985:   If m_dblMaxGraphY < 100 Then
1986:     m_dblThreshold = ((-slidThreshold.Value + 1) / 1000) * m_dblMaxGraphY
1987:   Else
1988:     m_dblThreshold = -slidThreshold.Value + 1
1989:   End If
'  m_dblThreshold = -(slidThreshold.Value - 1) * m_dblSliderAdjustment
1991:   txtDistance.Text = CStr(m_dblThreshold)
1992:   m_booIsScrolling = False
1993:   m_booCreateShapes = True
1994:   FillGraph
'  Debug.Print "Click:  " & -slidThreshold.Value + 1

  Exit Sub
ErrorHandler:
  HandleError True, "slidThreshold_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub slidThreshold_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  On Error GoTo ErrorHandler


'  m_dblThreshold = -(slidThreshold.Value - 1) * m_dblSliderAdjustment

2008:   If m_dblMaxGraphY < 100 Then
2009:     m_dblThreshold = ((-slidThreshold.Value + 1) / 1000) * m_dblMaxGraphY
2010:   Else
2011:     m_dblThreshold = -slidThreshold.Value + 1
2012:   End If
2013:   txtDistance.Text = CStr(m_dblThreshold)
2014:   m_booIsScrolling = False
2015:   m_booCreateShapes = True
2016:   FillGraph
'  Debug.Print "MouseUp:  " & -slidThreshold.Value + 1
  

  Exit Sub
ErrorHandler:
  HandleError True, "slidThreshold_MouseUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub slidThreshold_Scroll()
  On Error GoTo ErrorHandler

'  Debug.Print "Scrolling..."
2029:   m_booIsScrolling = False
2030:   m_booCreateShapes = False
'  m_dblThreshold = -(slidThreshold.Value - 1) * m_dblSliderAdjustment

2033:   If m_dblMaxGraphY < 100 Then
2034:     m_dblThreshold = ((-slidThreshold.Value + 1) / 1000) * m_dblMaxGraphY
2035:   Else
2036:     m_dblThreshold = -slidThreshold.Value + 1
2037:   End If
2038:   txtDistance.Text = CStr(m_dblThreshold)


  Exit Sub
ErrorHandler:
  HandleError True, "slidThreshold_Scroll " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtDistance_Change()
  On Error GoTo ErrorHandler

'  Debug.Print "Changing Textbox...    m_booIsScrolling = " & CStr(m_booIsScrolling) & ", " & _
      "m_booCreateShapes = " & CStr(m_booCreateShapes)
      
'  Dim dblThreshDist As Double
  Dim dblDist As Double
2054:   If Not IsNumeric(txtDistance.Text) Then
2055:     dblDist = 0
2056:   Else
2057:     dblDist = CDbl(txtDistance.Text)
2058:   End If
'  If dblDist > m_dblMaxY Then      ' USE m_dblMaxGraphY
2060:   If dblDist > m_dblMaxGraphY Then      ' USE m_dblMaxGraphY
2061:     dblDist = m_dblMaxGraphY
2062:   ElseIf dblDist < 0 Then
2063:     dblDist = 0
2064:   End If
  
'  dblThreshDist = -(dblDist + 1) / m_dblSliderAdjustment
'  dblThreshDist = -(dblDist + 1)
2068:   m_dblThreshold = dblDist
  
2070:   If m_dblMaxGraphY < 100 Then
2071:     slidThreshold.Value = -Int((m_dblThreshold / m_dblMaxGraphY) * 1000) + 1
2072:   Else
2073:     slidThreshold.Value = -Int(m_dblThreshold) + 1
2074:   End If
  
'  slidThreshold.Value = dblThreshDist
2077:   FillGraph
'  Debug.Print slidThreshold.Value & ", " & dblThreshDist
  Exit Sub
ErrorHandler:
  HandleError True, "txtDistance_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtDistance_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

2087:   Call Linkages.MyGeneralOperations.CheckNumericRealPositive(KeyAscii, txtDistance)
2088:   m_booIsScrolling = False
2089:   m_booCreateShapes = True
'  Debug.Print "calling KeyPress..."

  Exit Sub
ErrorHandler:
  HandleError True, "txtDistance_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub MakeEMF()
  On Error GoTo ErrorHandler

  Dim strFile As String
  Dim hdcEMF As Long
  Dim hemf As Long
  Dim rBounds As RECT
  Dim pWidth As Long
  Dim pHeight As Long
  
  Dim dblMultiplier As Double
2108:   dblMultiplier = 2
  
  Dim strDirPath As String
2111:   strDirPath = aml_func_mod.GetFullFileString(aml_func_mod.GetMxDocPath(m_pApp))
2112:   strDirPath = aml_func_mod.ReturnDir(strDirPath)
    
  Dim boolWorkspaceExists As Boolean
  ' MODIFIED FEB 2008 TO ADD vbDirectory
2116:   boolWorkspaceExists = Not Dir$(strDirPath, vbDirectory) = ""
  
2118:   If Not boolWorkspaceExists Then
2119:     strDirPath = aml_func_mod.GetFullFileString(aml_func_mod.TempPathLocation)
2120:   End If
  
2122:   If Right(strDirPath, 1) = "\" Then
2123:     strFile = strDirPath & "bottleneck_graph.emf"
2124:   Else
2125:     strFile = strDirPath & "\bottleneck_graph.emf"
2126:   End If
2127:   strFile = aml_func_mod.MakeUniqueFilename(strFile)

  Dim lngFontWeight As Long
  Dim lngFontHeight As Long
  Dim nFont As Long, oFont As Long
  Dim strText As String
  Dim textSize As SIZE
  Dim lngCounter As Long

2136:   rBounds.Left = 0
2137:   rBounds.Top = 0
2138:   rBounds.Right = (GraphRight - GraphLeft) * 27 * dblMultiplier
2139:   rBounds.Bottom = (GraphBottom - GraphTop) * 27 * dblMultiplier
  
  Dim emfGraphRight As Double
  Dim emfGraphLeft As Double
  Dim emfGraphTop As Double
  Dim emvGraphBottom As Double
  
'  strFile = App.Path & "\temp.emf"
  
2148:   hdcEMF = CreateEnhMetaFile(Me.hdc, strFile, rBounds, "")
2149:   SetMapMode hdcEMF, 1 ' MM_TEXT
2150:   SetBkMode hdcEMF, 1 ' transparent

  ' DRAW
  ' DIMENSION PENS AND BRUSHES
  Dim bluePen As Long
  Dim redPen As Long
  Dim nullPen As Long
  Dim blackPen As Long
  Dim blackDashPen As Long
  Dim magentaPen As Long
  Dim whiteBrush As Long
  
  ' PREPARE THRESHOLD STATS VARIABLES
2163:   m_pAboveThreshold.RemoveAll
2164:   m_pBelowThreshold.RemoveAll
2165:   m_dblLengthAbove = 0
2166:   m_dblLengthBelow = 0
  Dim dblLength As Double
  Dim dblTruePrevX As Double
  Dim dblTrueCurrentX As Double
  Dim dblTrueShortX As Double
  Dim dblRunningLengthAbove As Double
  Dim dblRunningLengthBelow As Double
2173:   dblRunningLengthAbove = 0
2174:   dblRunningLengthBelow = 0
  
  ' DRAW WHITE BOX
2177:   nullPen = CreatePen(PS_NULL, 0, vbRed)
2178:   DeleteObject SelectObject(hdc, nullPen)
  
2180:   whiteBrush = CreateSolidBrush(vbWhite)
2181:   DeleteObject SelectObject(hdc, whiteBrush)
  
'  RectangleX hdcEMF, GraphLeft, GraphTop, GraphRight, GraphBottom
  
  ' GET THRESHOLD VALUE IN GRAPH UNITS
  Dim dblGraphThreshold As Double
2187:   dblGraphThreshold = ConvertValToGraphY(m_dblThreshold)
  
  ' DRAW INSET EDGE
  Dim di As Long
  Dim rc As RECT
'    di = GetClientRect(hwnd, rc)

  ' DRAW X- AND Y-AXIS
2195:   blackPen = CreatePen(PS_SOLID, 1, vbBlack)
2196:   DeleteObject SelectObject(hdcEMF, blackPen)
  Dim lpPoint As POINTAPI
'  ' X-AXIS
'  MoveToEx hdcEMF, GraphLeft + 45, GraphBottom - 38, lpPoint
'  LineTo hdcEMF, GraphRight - 15, GraphBottom - 38
'  ' Y-AXIS
'  MoveToEx hdcEMF, GraphLeft + 58, GraphTop + 17, lpPoint
'  LineTo hdcEMF, GraphLeft + 58, GraphBottom - 30
'  Dim strReport As String
  
  ' FONT FOR NUMBERS
2207:   lngFontHeight = -((8 * dblMultiplier * GetDeviceCaps(hdcEMF, LOGPIXELSY)) / 72)
2208:   nFont = CreateFont(lngFontHeight, 0, 0, 0, 450, -1, 0, 0, 1, 7, 0, 0, 0, ByVal "Arial")
2209:   oFont = SelectObject(hdcEMF, nFont)
  
  ' X-AXIS
2212:   MoveToEx hdcEMF, (GraphLeft + 55) * dblMultiplier, (GraphBottom - 38) * dblMultiplier, lpPoint
2213:   LineTo hdcEMF, (GraphRight - 15) * dblMultiplier, (GraphBottom - 38) * dblMultiplier
2214:   strText = m_pYLabels.Element(0)
2215:   GetTextExtentPoint32 hdcEMF, strText, Len(strText), textSize
2216:   rc.Left = ((GraphLeft + 55 - 2) * dblMultiplier) - textSize.cx
2217:   rc.Top = (GraphBottom - 38) * dblMultiplier - (textSize.cy / 2)
2218:   rc.Right = rc.Left + textSize.cx
2219:   rc.Bottom = rc.Top + textSize.cy
2220:   DrawText hdcEMF, strText, Len(strText), rc, DT_NOCLIP + DT_RIGHT
  
  ' Y-AXIS
2223:   MoveToEx hdcEMF, (GraphLeft + 58) * dblMultiplier, (GraphTop + 17) * dblMultiplier, lpPoint
2224:   LineTo hdcEMF, (GraphLeft + 58) * dblMultiplier, (GraphBottom - 34) * dblMultiplier
2225:   strText = m_pXLabels.Element(0)
2226:   GetTextExtentPoint32 hdcEMF, strText, Len(strText), textSize
2227:   rc.Left = ((GraphLeft + 58) * dblMultiplier) - (textSize.cx / 2)
2228:   rc.Top = (GraphBottom - 32) * dblMultiplier
2229:   rc.Right = rc.Left + textSize.cx
2230:   rc.Bottom = rc.Top + textSize.cy
2231:   DrawText hdcEMF, strText, Len(strText), rc, DT_NOCLIP + DT_CENTER
  
'  strReport = strReport & _
    "X-Axis:  Y = " & CStr((GraphBottom - 38) * dblMultiplier) & ", X goes from " & _
        CStr((GraphLeft + 55) * dblMultiplier) & " to " & CStr((GraphRight - 15) * dblMultiplier) & "..." & vbCrLf & _
    "Y-Axis:  X = " & CStr((GraphLeft + 58) * dblMultiplier) & ", Y goes from " & _
        CStr((GraphTop + 17) * dblMultiplier) & " to " & CStr((GraphBottom - 30) * dblMultiplier) & "..." & vbCrLf

  ' MAKE DASHED HORIZONTAL LINES
2240:   lngCounter = 1
  Dim dblInc As Double
2242:   dblInc = m_dblIncrement
  Dim dblVertVal As Double
2244:   dblVertVal = ConvertValToGraphY(dblInc)
2245:   Do Until dblInc > m_dblMaxGraphY
  
    ' BLACK TICS
2248:     blackPen = CreatePen(PS_SOLID, 1, vbBlack)
2249:     DeleteObject SelectObject(hdcEMF, blackPen)
2250:     MoveToEx hdcEMF, (GraphLeft + 55) * dblMultiplier, Int(dblVertVal * dblMultiplier), lpPoint
2251:     LineTo hdcEMF, (GraphLeft + 59) * dblMultiplier, Int(dblVertVal * dblMultiplier)
    
    ' GRAY DASHES
2254:     blackDashPen = CreatePen(PS_DOT, 1, RGB(195, 195, 195))
2255:     DeleteObject SelectObject(hdcEMF, blackDashPen)
'    MoveToEx hdcEMF, (GraphLeft + 59) * dblMultiplier, dblVertVal * dblMultiplier, lpPoint
2257:     LineTo hdcEMF, (GraphRight - 15) * dblMultiplier, Int(dblVertVal * dblMultiplier)
    
    ' TEXT
2260:     strText = m_pYLabels.Element(lngCounter)
2261:     GetTextExtentPoint32 hdcEMF, strText, Len(strText), textSize
2262:     rc.Left = ((GraphLeft + 55 - 2) * dblMultiplier) - textSize.cx
2263:     rc.Top = (dblVertVal * dblMultiplier) - (textSize.cy / 2)
2264:     rc.Right = rc.Left + textSize.cx
2265:     rc.Bottom = rc.Top + textSize.cy
2266:     DrawText hdcEMF, strText, Len(strText), rc, DT_NOCLIP + DT_RIGHT
    
2268:     dblInc = dblInc + m_dblIncrement
2269:     dblVertVal = ConvertValToGraphY(dblInc)
2270:     lngCounter = lngCounter + 1
    
'    strReport = strReport & _
      "Horizontal Lines:  Y = " & CStr(Int(dblVertVal * dblMultiplier)) & ", X goes from " & _
          CStr((GraphLeft + 55) * dblMultiplier) & " to " & CStr((GraphRight - 15) * dblMultiplier) & "..." & vbCrLf
2275:   Loop
  
  ' MAKE DASHED VERTICAL LINES
2278:   lngCounter = 1
2279:   dblInc = m_dblXIncrement
  Dim dblHorizVal As Double
2281:   dblHorizVal = ConvertValToGraphX(dblInc)
2282:   Do Until dblInc > m_dblMaxX
  
    ' BLACK TICS
2285:     blackPen = CreatePen(PS_SOLID, 1, vbBlack)
2286:     DeleteObject SelectObject(hdcEMF, blackPen)
2287:     MoveToEx hdcEMF, Int((dblHorizVal) * dblMultiplier), (GraphBottom - 34) * dblMultiplier, lpPoint
2288:     LineTo hdcEMF, Int((dblHorizVal) * dblMultiplier), (GraphBottom - 38) * dblMultiplier
    
    ' GRAY DASHES
2291:     blackDashPen = CreatePen(PS_DOT, 1, RGB(195, 195, 195))
2292:     DeleteObject SelectObject(hdcEMF, blackDashPen)
'    MoveToEx hdcEMF, (dblHorizVal) * dblMultiplier, (GraphBottom - 38) * dblMultiplier, lpPoint
2294:     LineTo hdcEMF, Int((dblHorizVal) * dblMultiplier), (GraphTop + 17) * dblMultiplier
    
    ' TEXT
2297:     strText = m_pXLabels.Element(lngCounter)
2298:     GetTextExtentPoint32 hdcEMF, strText, Len(strText), textSize
2299:     rc.Left = (dblHorizVal * dblMultiplier) - (textSize.cx / 2)
2300:     rc.Top = (GraphBottom - 32) * dblMultiplier
2301:     rc.Right = rc.Left + textSize.cx
2302:     rc.Bottom = rc.Top + textSize.cy
2303:     DrawText hdcEMF, strText, Len(strText), rc, DT_NOCLIP + DT_CENTER
    
2305:     dblInc = dblInc + m_dblXIncrement
2306:     dblHorizVal = ConvertValToGraphX(dblInc)
2307:     lngCounter = lngCounter + 1
    
'    strReport = strReport & _
      "Vertical Lines:  X = " & CStr(Int((dblHorizVal) * dblMultiplier)) & ", Y goes from " & _
          CStr((GraphBottom - 34) * dblMultiplier) & " to " & CStr((GraphTop + 17) * dblMultiplier) & "..." & vbCrLf
2312:   Loop
  
  ' FONT FOR Y-AXIS LABEL
2315:   DeleteObject nFont
2316:   lngFontHeight = -((11 * dblMultiplier * GetDeviceCaps(hdcEMF, LOGPIXELSY)) / 72)
2317:   nFont = CreateFont(lngFontHeight, 0, 900, 900, 700, 0, 0, 0, 1, 7, 0, 0, 0, ByVal "Arial")
2318:   oFont = SelectObject(hdcEMF, nFont)
2319:   strText = m_strYName
2320:   GetTextExtentPoint32 hdcEMF, strText, Len(strText), textSize
'  rc.Left = ((GraphLeft + 3) * dblMultiplier) + textSize.cy
2322:   rc.Left = GraphLeft * dblMultiplier + (textSize.cx / 2)
2323:   rc.Top = (((GraphBottom - GraphTop) / 2) + GraphTop) * dblMultiplier + (textSize.cx / 2)
2324:   rc.Right = rc.Left + textSize.cy
2325:   rc.Bottom = rc.Top + textSize.cx ' (GraphBottom - GraphTop) / 2 + (textSize.cx / 2)
2326:   DrawText hdcEMF, strText, Len(strText), rc, DT_NOCLIP + DT_CENTER
  
  ' FONT FOR X-AXIS LABEL
2329:   DeleteObject nFont
2330:   lngFontHeight = -((11 * dblMultiplier * GetDeviceCaps(hdcEMF, LOGPIXELSY)) / 72)
2331:   nFont = CreateFont(lngFontHeight, 0, 0, 0, 700, 0, 0, 0, 1, 7, 0, 0, 0, ByVal "Arial")
2332:   oFont = SelectObject(hdcEMF, nFont)
2333:   strText = m_strXName
2334:   GetTextExtentPoint32 hdcEMF, strText, Len(strText), textSize
2335:   rc.Left = ((((GraphRight - GraphLeft) / 2) + GraphLeft) * dblMultiplier) - (textSize.cx / 2)
2336:   rc.Top = ((GraphBottom - 1) * dblMultiplier) - textSize.cy
2337:   rc.Right = rc.Left + textSize.cx ' ((GraphRight - GraphLeft) / 2) + GraphLeft + (textSize.cx / 2)
2338:   rc.Bottom = rc.Top + textSize.cy '  GraphBottom - 1
2339:   DrawText hdcEMF, strText, Len(strText), rc, DT_NOCLIP + DT_CENTER
  
2341:   DeleteObject nFont
  
  ' DRAW THRESHOLD LINE
2344:   magentaPen = CreatePen(PS_SOLID, 1, RGB(255, 0, 255))
2345:   DeleteObject SelectObject(hdcEMF, magentaPen)
'  MoveToEx hdcEMF, GraphLeft + 59, dblGraphThreshold, lpPoint
'  LineTo hdcEMF, GraphRight - 15, dblGraphThreshold
2348:   MoveToEx hdcEMF, (GraphLeft + 59) * dblMultiplier, (dblGraphThreshold) * dblMultiplier, lpPoint
2349:   LineTo hdcEMF, (GraphRight - 15) * dblMultiplier, (dblGraphThreshold) * dblMultiplier
  
  ' DRAW GRAPH LINE
  Dim dblTempX As Double
  Dim dblTempY As Double
  Dim dblPrevX As Double
  Dim dblPrevY As Double
  Dim lngIndex As Long
  Dim booCurrentThresh As Boolean
  Dim booPreviousThresh As Boolean ' false for below threshold, true for above threshold
  
2360:   dblTempY = m_dblGraphVals(0, 1)
  ' Y-AXIS REVERSED IN GRAPH SPACE!!!
2362:   booCurrentThresh = (dblTempY <= dblGraphThreshold)
2363:   dblPrevX = m_dblGraphVals(0, 0)
2364:   dblPrevY = dblTempY
2365:   dblTruePrevX = m_dblVals(0, 0)
  Dim dblProportion As Double
  Dim dblShortX As Double
  
2369:   BeginPath hdcEMF
'  MoveToEx hdcEMF, m_dblGraphVals(0, 0), m_dblGraphVals(0, 1), lpPoint
2371:   MoveToEx hdcEMF, (m_dblGraphVals(0, 0)) * dblMultiplier, (m_dblGraphVals(0, 1)) * dblMultiplier, lpPoint
  
2373:   If booCurrentThresh Then
2374:     bluePen = CreatePen(PS_SOLID, 1, vbBlue)
2375:     DeleteObject SelectObject(hdcEMF, bluePen)
2376:     booPreviousThresh = True
2377:   Else
2378:     redPen = CreatePen(PS_SOLID, 1, vbRed)
2379:     DeleteObject SelectObject(hdcEMF, redPen)
2380:     booPreviousThresh = False
2381:   End If
  
2383:   For lngIndex = 0 To UBound(m_dblGraphVals, 1)
2384:     dblTempX = m_dblGraphVals(lngIndex, 0)
2385:     dblTempY = m_dblGraphVals(lngIndex, 1)
    
2387:     booCurrentThresh = (dblTempY <= dblGraphThreshold)
2388:     If booCurrentThresh = booPreviousThresh Then    ' THEN HAS NOT CROSSED THRESHOLD
'      LineTo hdcEMF, dblTempX, dblTempY
2390:       LineTo hdcEMF, dblTempX * dblMultiplier, dblTempY * dblMultiplier
      
2392:     Else    ' HAS CROSSED THRESHOLD; NEED TO MAKE TWO LINES
2393:       dblProportion = (dblGraphThreshold - dblPrevY) / (dblTempY - dblPrevY)
2394:       dblShortX = dblPrevX + ((dblTempX - dblPrevX) * dblProportion)
'      LineTo hdcEMF, dblShortX, dblGraphThreshold
2396:       LineTo hdcEMF, dblShortX * dblMultiplier, dblGraphThreshold * dblMultiplier
      
      ' END CURRENT PATH AND START ANOTHER
2399:       EndPath hdcEMF
2400:       StrokePath hdcEMF
2401:       BeginPath hdcEMF
      
2403:       If booCurrentThresh Then ' THEN PREVIOUSLY WAS BELOW THRESHOLD, AND USING RED PEN.  NOW IS ABOVE THRESHOLD.
2404:         bluePen = CreatePen(PS_SOLID, 1, vbBlue)
2405:         DeleteObject SelectObject(hdcEMF, bluePen)
2406:       Else                     ' THEN PREVIOUSLY WAS ABOVE THRESHOLD, AND USING BLUE PEN.  NOW IS BELOW THRESHOLD.
2407:         redPen = CreatePen(PS_SOLID, 1, vbRed)
2408:         DeleteObject SelectObject(hdcEMF, redPen)
2409:       End If
      
'      LineTo hdcEMF, dblTempX, dblTempY
2412:       LineTo hdcEMF, dblTempX * dblMultiplier, dblTempY * dblMultiplier
2413:     End If
    
2415:     dblPrevY = dblTempY
2416:     dblPrevX = dblTempX
2417:     booPreviousThresh = booCurrentThresh
    
'    Debug.Print CStr(lngIndex) & "]  Original:  X = " & CStr(m_dblVals(lngIndex, 0)) & ",   Y = " & CStr(m_dblVals(lngIndex, 1))
'    Debug.Print "        Converted:  X = " & CStr(m_dblGraphVals(lngIndex, 0)) & ",   Y = " & CStr(m_dblGraphVals(lngIndex, 1))
2421:   Next lngIndex
  
2423:   EndPath hdcEMF
2424:   StrokePath hdcEMF

  'close metafile
2427:   hemf = CloseEnhMetaFile(hdcEMF)
2428:   DeleteDC hdcEMF
2429:   DeleteEnhMetaFile hemf
2430:   DeleteObject nFont
  'load it to printer
'  Printer.PaintPicture LoadPicture(strFile), 0, 0
'  Printer.EndDoc

  
'  Exit Sub

  Dim pMxDoc As IMxDocument
2439:   Set pMxDoc = m_pApp.Document
  Dim pGraphicContainer As IGraphicsContainer
2441:   Set pGraphicContainer = pMxDoc.PageLayout
  Dim pSelGraphContainer As IGraphicsContainerSelect
2443:   Set pSelGraphContainer = pGraphicContainer
2444:   pSelGraphContainer.UnselectAllElements
  
  Dim pPictureElement As IPictureElement
2447:   Set pPictureElement = New EmfPictureElement
  'open the emf file
2449:   pPictureElement.ImportPictureFromFile strFile
  Dim pElement As IElement
2451:   Set pElement = pPictureElement
  Dim pEnvelope As IEnvelope
2453:   Set pEnvelope = New Envelope
  'Set the position of the element (page coordinates)
2455:   pEnvelope.PutCoords 0, 0, 5.781, 1.854
2456:   pElement.Geometry = pEnvelope
2457:   pGraphicContainer.AddElement pElement, 0
'  pPictureElement.SavePictureInDocument = True
2459:   pSelGraphContainer.SelectElement pElement
  
  Dim strReport As String
2462:   strReport = _
      "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\tx90\tx360\tx450\tx720\f0\fs16 " & _
      "The Bottleneck Chart has been converted to an Enhanced Windows Metafile (*.emf) and added to your " & _
      "layout view.  This graphic file is a standard Windows format and can be inserted into many " & _
      "other document types, such as Microsoft Word documents.\par" & vbCrLf & "\par" & vbCrLf & _
      "File located at " & Replace(strFile, "\", "\\") & "\par" & vbCrLf & "\par" & vbCrLf & _
      "\b Note:\b0   This graphic is not automatically saved into the Map document.  " & _
      "ArcMap only stores a reference to the graphic file on the hard drive, not the " & _
      "graphic itself.  If you delete the graphic file from the hard drive, then " & _
      "the graphic will be missing from your layout the next time you open your Map document.  " & _
      "If you wish to save the actual graphic in the map document file itself, then right-click on the graphic, " & _
      "select 'Properties', select the 'Picture' tab, and check the box for 'Save Picture as Part of Document'.\par" & _
      "}"
  
  Dim pDocDirty As IDocumentDirty
2478:   Set pDocDirty = m_pMxDoc
2479:   pDocDirty.SetDirty
  
  Dim pAV As IActiveView
2482:   Set pAV = pMxDoc.PageLayout
2483:   Set pMxDoc.ActiveView = pAV
2484:   pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing
  
  ' FOR REPORT
'  strReport = _
      "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\tx90\tx360\tx450\tx720\f0\fs16 " & _
      "The shapefile \b " & strJustFilename & "\b0  has been generated and added to your view.  Individual points " & _
      "include X-coordinates, Y-coordinates and Corridor Width values at each location.\par" & vbCrLf & "\par" & vbCrLf & _
      "\b Shapefile saved to:\b0 \i  " & Replace(strFName, "\", "\\") & "\i0\par" & vbCrLf & vbCrLf & "}"
  
    ' SHOW REPORT
  Dim frmReportForm As New Linkages.frmReport_modal
2496:   frmReportForm.txtReport.TextRTF = strReport
2497:   frmReportForm.Caption = "Operation Successful:"
2498:   frmReportForm.Show vbModal
  
'  MsgBox strReport, , "Graph Export Successful:"
  
  Exit Sub
ErrorHandler:
  HandleError False, "MakeEMF " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub



