VERSION 5.00
Begin VB.Form frmGraphicsShapefile 
   BorderStyle     =   1  'Fixed Single
   Caption         =   " Create Shapefile:"
   ClientHeight    =   3705
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8085
   Icon            =   "frmGraphicsShapefile.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3705
   ScaleWidth      =   8085
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox frmNew 
      BorderStyle     =   0  'None
      Height          =   1305
      Left            =   420
      ScaleHeight     =   1305
      ScaleWidth      =   2445
      TabIndex        =   12
      Top             =   690
      Width           =   2445
      Begin VB.OptionButton optPoint 
         Caption         =   "Point Shapefile"
         Height          =   240
         Left            =   180
         TabIndex        =   15
         Top             =   60
         Width           =   2040
      End
      Begin VB.OptionButton optPolyline 
         Caption         =   "Polyline Shapefile"
         Height          =   240
         Left            =   180
         TabIndex        =   14
         Top             =   510
         Width           =   1620
      End
      Begin VB.OptionButton optPolygon 
         Caption         =   "Polygon Shapefile"
         Height          =   240
         Left            =   180
         TabIndex        =   13
         Top             =   945
         Width           =   1935
      End
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   375
      Left            =   7140
      TabIndex        =   8
      Top             =   2085
      Width           =   885
   End
   Begin VB.ListBox lbxGraphics 
      Height          =   1230
      Left            =   3240
      TabIndex        =   2
      Top             =   540
      Width           =   3660
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   7140
      TabIndex        =   7
      Top             =   1665
      Width           =   885
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   375
      Left            =   7140
      TabIndex        =   9
      Top             =   2505
      Width           =   885
   End
   Begin VB.CommandButton cmdSpRef 
      Caption         =   "Set Spatial Reference"
      Height          =   525
      Left            =   180
      TabIndex        =   4
      Top             =   2325
      Width           =   1350
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   165
      TabIndex        =   5
      Text            =   "Text1"
      Top             =   3270
      Width           =   6135
   End
   Begin VB.CommandButton cmdGetWorkspace 
      Height          =   360
      Left            =   6390
      Picture         =   "frmGraphicsShapefile.frx":038A
      Style           =   1  'Graphical
      TabIndex        =   6
      ToolTipText     =   "Browse for Output Folder..."
      Top             =   3255
      Width           =   555
   End
   Begin VB.CheckBox chkSelected 
      Caption         =   "Only convert selected graphics"
      Height          =   255
      Left            =   3705
      TabIndex        =   3
      Top             =   1830
      Width           =   2760
   End
   Begin VB.OptionButton optConvert 
      Caption         =   "Convert graphics to shapefile"
      Height          =   255
      Left            =   3030
      TabIndex        =   1
      Top             =   135
      Width           =   3015
   End
   Begin VB.OptionButton optNew 
      Caption         =   "Create new shapefile"
      Height          =   255
      Left            =   225
      TabIndex        =   0
      Top             =   135
      Width           =   1935
   End
   Begin VB.Image Image3 
      Height          =   390
      Left            =   60
      Picture         =   "frmGraphicsShapefile.frx":0400
      Top             =   60
      Width           =   6975
   End
   Begin VB.Image Image2 
      BorderStyle     =   1  'Fixed Single
      Height          =   720
      Left            =   30
      Top             =   2970
      Width           =   7020
   End
   Begin VB.Image Image1 
      BorderStyle     =   1  'Fixed Single
      Height          =   765
      Left            =   30
      Top             =   2190
      Width           =   7020
   End
   Begin VB.Image imgBack1 
      BorderStyle     =   1  'Fixed Single
      Height          =   2145
      Left            =   30
      Top             =   30
      Width           =   7020
   End
   Begin VB.Label lblOutputName 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Output Shapefile:"
      Height          =   195
      Left            =   150
      TabIndex        =   11
      Top             =   3060
      Width           =   1230
   End
   Begin VB.Image imgCorrIcon 
      Height          =   855
      Left            =   7110
      Picture         =   "frmGraphicsShapefile.frx":920C
      Top             =   30
      Width           =   945
   End
   Begin VB.Label lblSpRef 
      AutoSize        =   -1  'True
      Caption         =   "Shapefile Spatial Reference ="
      Height          =   195
      Left            =   1650
      TabIndex        =   10
      Top             =   2490
      Width           =   2115
   End
End
Attribute VB_Name = "frmGraphicsShapefile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_SpRef As ISpatialReference
Private m_ExtensionConfig As IExtensionConfig

Private m_AllPointGraphics As esriSystem.IVariantArray
Private m_SelPointGraphics As esriSystem.IVariantArray
Private m_AllPolylineGraphics As esriSystem.IVariantArray
Private m_SelPolylineGraphics As esriSystem.IVariantArray
Private m_AllPolygonGraphics As esriSystem.IVariantArray
Private m_SelPolygonGraphics As esriSystem.IVariantArray
Private m_AllGraphicsList As esriSystem.IStringArray
Private m_SelGraphicslist As esriSystem.IStringArray

Private m_AllPointGraphicsNames As esriSystem.IStringArray
Private m_SelPointGraphicsNames As esriSystem.IStringArray
Private m_AllPolylineGraphicsNames As esriSystem.IStringArray
Private m_SelPolylineGraphicsNames As esriSystem.IStringArray
Private m_AllPolygonGraphicsNames As esriSystem.IStringArray
Private m_SelPolygonGraphicsNames As esriSystem.IStringArray
  
Private m_booAllPointHasNames As Boolean
Private m_booSelPointHasNames As Boolean
Private m_booAllPolylineHasNames As Boolean
Private m_booSelPolylineHasNames As Boolean
Private m_booAllPolygonHasNames As Boolean
Private m_booSelPolygonHasNames As Boolean

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\frmGraphicsShapefile.frm"


Public Property Set ArcApplication(ByVal theApplication As IApplication)
  On Error GoTo ErrorHandler

37:   Set m_pApp = theApplication
38:   Set m_pMxDoc = m_pApp.Document
39:   Call FillGraphicsArrays

  Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Private Sub chkSelected_Click()
  On Error GoTo ErrorHandler

50:   Call FillGraphicsListBox

  Exit Sub
ErrorHandler:
  HandleError True, "chkSelected_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetWorkspace_Click()
  On Error GoTo ErrorHandler

  Dim pGxDialog As IGxDialog
61:   Set pGxDialog = New GxDialog
  
  Dim pGxDialogFilter As IGxObjectFilter
64:   Set pGxDialogFilter = New GxFilterShapefiles
  
  Dim pGxObject As IGxObject
  Dim pGxSelection As IEnumGxObject
  
  ' SET DEFAULT NAME
  Dim strDefault As String
  'strDefault = Linkages.aml_func_mod.MakeUniqueFilename(strDefault & "NewShape.shp")
72:   strDefault = Linkages.aml_func_mod.MakeUniqueFilename(txtOutput.Text)
'  MsgBox "strDefault = " & vbCrLf & strDefault
74:   With pGxDialog
75:     .AllowMultiSelect = False
76:     .StartingLocation = strDefault
77:     .Title = "Please enter the name of your new shapefile:"
78:     Set .ObjectFilter = pGxDialogFilter
79:     .Name = Linkages.aml_func_mod.ReturnFilename(strDefault)
80:   End With
  
82:   If (pGxDialog.DoModalSave(Me.hWnd) = True) Then
83:     txtOutput.Text = pGxDialog.FinalLocation.FullName & "\" & pGxDialog.Name
84:   End If
  
86:   Call CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetWorkspace_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

End Sub

Private Sub cmdHelp_Click()

  Dim strPath As String
97:   strPath = App.Path & "\help"
  
99:   Call Linkages.MyGeneralOperations.OpenDoc("Shapefile_Subdocument.pdf", strPath)
  
End Sub

Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler

  Dim strFullName As String
107:   strFullName = txtOutput.Text
  Dim strDir As String
109:   strDir = Linkages.aml_func_mod.ReturnDir(strFullName)
  Dim strFileName As String
111:   strFileName = Linkages.aml_func_mod.ReturnFilename(strFullName)
  
  Dim pSpRef As ISpatialReference
114:   Set pSpRef = m_SpRef
  
  Dim pOrigSpRef As ISpatialReference
  Dim pGeoSpRef As IGeographicCoordinateSystem
  Dim pPrjSpRef As IProjectedCoordinateSystem
  
  Dim pFeatureClass As IFeatureClass
  Dim pFeatureBuf As IFeatureBuffer
  Dim pFeatureCursor As IFeatureCursor
  
  ' POLYGON SHAPEFILES WILL GET AREA FIELD
  ' POLYLINE SHAPEFILES WILL GET LENGTH FIELD
  ' POINT SHAPEFILES WILL GET X AND Y FIELD
  
  Dim pAreaField As IField
  Dim pAreaFieldEdit As IFieldEdit
130:   Set pAreaField = New Field
131:   Set pAreaFieldEdit = pAreaField
132:   With pAreaFieldEdit
133:     .Name = "Area"
134:     .Type = esriFieldTypeDouble
135:     .Precision = 16
136:     .Scale = 8
137:   End With
  
  Dim pLengthField As IField
  Dim pLengthFieldEdit As IFieldEdit
141:   Set pLengthField = New Field
142:   Set pLengthFieldEdit = pLengthField
143:   With pLengthFieldEdit
144:     .Name = "Length"
145:     .Type = esriFieldTypeDouble
146:     .Precision = 16
147:     .Scale = 8
148:   End With
  
  Dim pXField As IField
  Dim pXFieldEdit As IFieldEdit
152:   Set pXField = New Field
153:   Set pXFieldEdit = pXField
154:   With pXFieldEdit
155:     .Name = "X_Coord"
156:     .Type = esriFieldTypeDouble
157:     .Precision = 16
158:     .Scale = 8
159:   End With
  
  Dim pYField As IField
  Dim pYFieldEdit As IFieldEdit
163:   Set pYField = New Field
164:   Set pYFieldEdit = pYField
165:   With pYFieldEdit
166:     .Name = "Y_Coord"
167:     .Type = esriFieldTypeDouble
168:     .Precision = 16
169:     .Scale = 8
170:   End With
  
  
  Dim pNameField As IField
  Dim pNameFieldEdit As IFieldEdit
175:   Set pNameField = New Field
176:   Set pNameFieldEdit = pNameField
177:   With pNameFieldEdit
178:     .Name = "Name"
179:     .Type = esriFieldTypeString
180:     .Precision = 50
181:   End With
    
  Dim pGeometry As IGeometry
  Dim pPoint As IPoint
  Dim pPolyline As IPolyline
  Dim pPolygon As IPolygon
  Dim pSegCol As ISegmentCollection
  Dim pArea As IArea
  
  Dim lngIndex As Long
  Dim lngCounter As Long
192:   lngCounter = 0
  
  Dim strName As String
  
196:   If optNew.Value = True Then
197:     If optPoint.Value = True Then
198:       Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Point")
199:       If pFeatureClass Is Nothing Then
200:         MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
        Exit Sub
202:       End If
203:       pFeatureClass.AddField pXField
204:       pFeatureClass.AddField pYField
205:     ElseIf optPolyline.Value = True Then
206:       Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polyline")
207:       If pFeatureClass Is Nothing Then
208:         MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
        Exit Sub
210:       End If
211:       pFeatureClass.AddField pLengthField
212:     ElseIf optPolygon.Value = True Then
213:       Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polygon")
214:       If pFeatureClass Is Nothing Then
215:         MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
        Exit Sub
217:       End If
218:       pFeatureClass.AddField pAreaField
219:     End If
220:   ElseIf optConvert.Value = True Then
    Dim lngResponse As Long
222:     If chkSelected.Value = 0 Then                 ' ALL GRAPHICS
      Select Case lbxGraphics.ListIndex
        Case 0                                    ' CONVERT POINTS TO POINT SHAPEFILE
225:           If m_AllPointGraphics.Count = 0 Then
226:             lngResponse = MsgBox("No graphic points in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Point Shapefile:")
229:             If lngResponse <> 1 Then
230:               Unload Me
231:             End If
            Exit Sub
233:           End If
234:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Point")
235:           If pFeatureClass Is Nothing Then
236:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
238:           End If
239:           pFeatureClass.AddField pXField
240:           pFeatureClass.AddField pYField
241:           If m_booAllPointHasNames Then pFeatureClass.AddField pNameField
          
243:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
244:           Set pFeatureCursor = pFeatureClass.Insert(True)
245:           For lngIndex = 0 To m_AllPointGraphics.Count - 1
246:             lngCounter = lngCounter + 1
247:             Set pPoint = m_AllPointGraphics.Element(lngIndex)
248:             strName = m_AllPointGraphicsNames.Element(lngIndex)
            
            ' SET SPATIAL REFERENCE
251:             Set pOrigSpRef = pPoint.SpatialReference
252:             If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
254:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
255:                 Set pPoint.SpatialReference = pSpRef
256:               Else
257:                 Set pPrjSpRef = pSpRef
258:                 Set pPoint.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
259:               End If
260:             ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
262:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
263:                 Set pPoint.SpatialReference = pSpRef
264:               Else
265:                 Set pPrjSpRef = pSpRef
266:                 Set pPoint.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
267:               End If
268:             End If
269:             If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPoint.SpatialReference) Then
270:               pPoint.Project pSpRef
271:             End If
            ' ADD DATA TO FEATURE BUFFER
273:             Set pFeatureBuf.Shape = pPoint
274:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
275:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("X_Coord")) = pPoint.X
276:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Y_Coord")) = pPoint.Y
277:             If m_booAllPointHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
278:             pFeatureCursor.InsertFeature pFeatureBuf
279:           Next lngIndex
280:           pFeatureCursor.Flush
        Case 1                                    ' CONVERT POLYLINE GRAPHICS TO POLYLINE SHAPEFILE
282:           If m_AllPolylineGraphics.Count = 0 Then
283:             lngResponse = MsgBox("No graphic polylines in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Polyline Shapefile:")
286:             If lngResponse <> 1 Then
287:               Unload Me
288:             End If
            Exit Sub
290:           End If
291:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polyline")
292:           If pFeatureClass Is Nothing Then
293:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
295:           End If
296:           pFeatureClass.AddField pLengthField
297:           If m_booAllPolylineHasNames Then pFeatureClass.AddField pNameField
          
299:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
300:           Set pFeatureCursor = pFeatureClass.Insert(True)
301:           For lngIndex = 0 To m_AllPolylineGraphics.Count - 1
302:             lngCounter = lngCounter + 1
303:             Set pGeometry = m_AllPolylineGraphics.Element(lngIndex)
304:             strName = m_AllPolylineGraphicsNames.Element(lngIndex)
            
'            MsgBox "pGeometry.SpatialReference is Nothing? = " & CStr(pGeometry.SpatialReference Is Nothing)
307:             Set pSegCol = pGeometry
'            MsgBox "pSegCol.SpatialReference is Nothing? = " & CStr(pSegCol.SpatialReference Is Nothing)
309:             Set pPolyline = Linkages.MyGeometricOperations.CurveToPolyline(pGeometry, 200)
'            MsgBox "Length = " & pPolyline.length
'            MsgBox "pPolyline.SpatialReference is Nothing? = " & CStr(pPolyline.SpatialReference Is Nothing)
            ' SET SPATIAL REFERENCE
313:             Set pOrigSpRef = pPolyline.SpatialReference
'            MsgBox "Orig Sp Ref is nothing? " & CStr(pOrigSpRef Is Nothing)
315:             If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
'              MsgBox "pSpRef () = " & pSpRef.Name
318:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
319:                 Set pPolyline.SpatialReference = pSpRef
320:               Else
321:                 Set pPrjSpRef = pSpRef
322:                 Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
323:               End If
324:             ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
326:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
327:                 Set pPolyline.SpatialReference = pSpRef
328:               Else
329:                 Set pPrjSpRef = pSpRef
330:                 Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
331:               End If
332:             End If
333:             If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolyline.SpatialReference) Then
334:               pPolyline.Project pSpRef
335:             End If
            ' ADD DATA TO FEATURE BUFFER
'            MsgBox "Length Before = " & pPolyline.length
338:             Set pFeatureBuf.Shape = pPolyline
'            MsgBox "Length After = " & pPolyline.length
340:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
341:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Length")) = pPolyline.length
342:             If m_booAllPolylineHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
'            MsgBox "Adding Length = " & pPolyline.length & " to Field #" & pFeatureBuf.Fields.FindField("Length")
344:             pFeatureCursor.InsertFeature pFeatureBuf
345:           Next lngIndex
346:           pFeatureCursor.Flush
        Case 2                                    ' CONVERT POLYLINE + POLYGON GRAPHICS TO POLYLINE SHAPEFILE
348:           If m_AllPolylineGraphics.Count = 0 And m_AllPolygonGraphics.Count = 0 Then
349:             lngResponse = MsgBox("No graphic polylines or polygons in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Polyline Shapefile:")
352:             If lngResponse <> 1 Then
353:               Unload Me
354:             End If
            Exit Sub
356:           End If
357:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polyline")
358:           If pFeatureClass Is Nothing Then
359:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
361:           End If
362:           pFeatureClass.AddField pLengthField
363:           If m_booAllPolylineHasNames Or m_booAllPolygonHasNames Then pFeatureClass.AddField pNameField
          
365:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
366:           Set pFeatureCursor = pFeatureClass.Insert(True)
367:           If m_AllPolylineGraphics.Count > 0 Then
368:             For lngIndex = 0 To m_AllPolylineGraphics.Count - 1
369:               lngCounter = lngCounter + 1
370:               Set pGeometry = m_AllPolylineGraphics.Element(lngIndex)
371:               strName = m_AllPolylineGraphicsNames.Element(lngIndex)
            
373:               Set pSegCol = pGeometry
374:               Set pPolyline = Linkages.MyGeometricOperations.CurveToPolyline(pGeometry, 200)
              ' SET SPATIAL REFERENCE
376:               Set pOrigSpRef = pPolyline.SpatialReference
377:               If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
379:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
380:                   Set pPolyline.SpatialReference = pSpRef
381:                 Else
382:                   Set pPrjSpRef = pSpRef
383:                   Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
384:                 End If
385:               ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
387:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
388:                   Set pPolyline.SpatialReference = pSpRef
389:                 Else
390:                   Set pPrjSpRef = pSpRef
391:                   Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
392:                 End If
393:               End If
394:               If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolyline.SpatialReference) Then
395:                 pPolyline.Project pSpRef
396:               End If
              ' ADD DATA TO FEATURE BUFFER
398:               Set pFeatureBuf.Shape = pPolyline
399:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
400:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Length")) = pPolyline.length
401:               If m_booAllPolylineHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
402:               pFeatureCursor.InsertFeature pFeatureBuf
403:             Next lngIndex
404:           End If
405:           If m_AllPolygonGraphics.Count > 0 Then
406:             For lngIndex = 0 To m_AllPolygonGraphics.Count - 1
407:               lngCounter = lngCounter + 1
408:               Set pGeometry = m_AllPolygonGraphics.Element(lngIndex)
409:               strName = m_AllPolygonGraphicsNames.Element(lngIndex)
            
411:               Set pSegCol = pGeometry
412:               Set pPolyline = Linkages.MyGeometricOperations.CurveToPolyline(pGeometry, 200)
              ' SET SPATIAL REFERENCE
414:               Set pOrigSpRef = pPolyline.SpatialReference
415:               If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
417:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
418:                   Set pPolyline.SpatialReference = pSpRef
419:                 Else
420:                   Set pPrjSpRef = pSpRef
421:                   Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
422:                 End If
423:               ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
425:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
426:                   Set pPolyline.SpatialReference = pSpRef
427:                 Else
428:                   Set pPrjSpRef = pSpRef
429:                   Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
430:                 End If
431:               End If
432:               If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolyline.SpatialReference) Then
433:                 pPolyline.Project pSpRef
434:               End If
              ' ADD DATA TO FEATURE BUFFER
436:               Set pFeatureBuf.Shape = pPolyline
437:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
438:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Length")) = pPolyline.length
439:               If m_booAllPolygonHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
440:               pFeatureCursor.InsertFeature pFeatureBuf
441:             Next lngIndex
442:           End If
443:           pFeatureCursor.Flush
        Case 3                                    ' CONVERT POLYGON GRAPHICS TO POLYGON SHAPEFILE
445:           If m_AllPolygonGraphics.Count = 0 Then
446:             lngResponse = MsgBox("No graphic polygons in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Polygon Shapefile:")
449:             If lngResponse <> 1 Then
450:               Unload Me
451:             End If
            Exit Sub
453:           End If
454:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polygon")
455:           If pFeatureClass Is Nothing Then
456:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
458:           End If
459:           pFeatureClass.AddField pAreaField
460:           If m_booAllPolygonHasNames Then pFeatureClass.AddField pNameField
          
462:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
463:           Set pFeatureCursor = pFeatureClass.Insert(True)
464:           For lngIndex = 0 To m_AllPolygonGraphics.Count - 1
465:             lngCounter = lngCounter + 1
466:             Set pGeometry = m_AllPolygonGraphics.Element(lngIndex)
467:             strName = m_AllPolygonGraphicsNames.Element(lngIndex)
            
469:             Set pSegCol = pGeometry
470:             Set pPolygon = Linkages.MyGeometricOperations.CurveToPolygon(pGeometry, 200)
            ' SET SPATIAL REFERENCE
472:             Set pOrigSpRef = pPolygon.SpatialReference
473:             If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
475:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
476:                 Set pPolygon.SpatialReference = pSpRef
477:               Else
478:                 Set pPrjSpRef = pSpRef
479:                 Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
480:               End If
481:             ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
483:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
484:                 Set pPolygon.SpatialReference = pSpRef
485:               Else
486:                 Set pPrjSpRef = pSpRef
487:                 Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
488:               End If
489:             End If
490:             If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolygon.SpatialReference) Then
491:               pPolygon.Project pSpRef
492:             End If
            ' ADD DATA TO FEATURE BUFFER
494:             Set pFeatureBuf.Shape = pPolygon
495:             Set pArea = pPolygon
496:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
497:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Area")) = pArea.Area
498:             If m_booAllPolygonHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
499:             pFeatureCursor.InsertFeature pFeatureBuf
500:           Next lngIndex
501:           pFeatureCursor.Flush
        Case 4                                    ' CONVERT POLYLINE + POLYGON GRAPHICS TO POLYGON SHAPEFILE
503:           If m_AllPolylineGraphics.Count = 0 And m_AllPolygonGraphics.Count = 0 Then
504:             lngResponse = MsgBox("No graphic polylines or polygons in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Polygon Shapefile:")
507:             If lngResponse <> 1 Then
508:               Unload Me
509:             End If
            Exit Sub
511:           End If
512:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polygon")
513:           If pFeatureClass Is Nothing Then
514:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
516:           End If
517:           pFeatureClass.AddField pAreaField
518:           If m_booAllPolylineHasNames Or m_booAllPolygonHasNames Then pFeatureClass.AddField pNameField
          
520:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
521:           Set pFeatureCursor = pFeatureClass.Insert(True)
522:           If m_AllPolylineGraphics.Count > 0 Then
523:             For lngIndex = 0 To m_AllPolylineGraphics.Count - 1
524:               lngCounter = lngCounter + 1
525:               Set pGeometry = m_AllPolylineGraphics.Element(lngIndex)
526:               strName = m_AllPolylineGraphicsNames.Element(lngIndex)
            
528:               Set pSegCol = pGeometry
529:               Set pPolygon = Linkages.MyGeometricOperations.CurveToPolygon(pGeometry, 200)
              ' SET SPATIAL REFERENCE
531:               Set pOrigSpRef = pPolygon.SpatialReference
532:               If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
534:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
535:                   Set pPolygon.SpatialReference = pSpRef
536:                 Else
537:                   Set pPrjSpRef = pSpRef
538:                   Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
539:                 End If
540:               ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
542:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
543:                   Set pPolygon.SpatialReference = pSpRef
544:                 Else
545:                   Set pPrjSpRef = pSpRef
546:                   Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
547:                 End If
548:               End If
549:               If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolygon.SpatialReference) Then
550:                 pPolygon.Project pSpRef
551:               End If
              ' ADD DATA TO FEATURE BUFFER
553:               Set pFeatureBuf.Shape = pPolygon
554:               Set pArea = pPolygon
555:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
556:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Area")) = pArea.Area
557:               If m_booAllPolylineHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
558:               pFeatureCursor.InsertFeature pFeatureBuf
559:             Next lngIndex
560:           End If
561:           If m_AllPolygonGraphics.Count > 0 Then
562:             For lngIndex = 0 To m_AllPolygonGraphics.Count - 1
563:               lngCounter = lngCounter + 1
564:               Set pGeometry = m_AllPolygonGraphics.Element(lngIndex)
565:               strName = m_AllPolygonGraphicsNames.Element(lngIndex)
            
567:               Set pSegCol = pGeometry
568:               Set pPolygon = Linkages.MyGeometricOperations.CurveToPolygon(pGeometry, 200)
              ' SET SPATIAL REFERENCE
570:               Set pOrigSpRef = pPolygon.SpatialReference
571:               If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
573:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
574:                   Set pPolygon.SpatialReference = pSpRef
575:                 Else
576:                   Set pPrjSpRef = pSpRef
577:                   Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
578:                 End If
579:               ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
581:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
582:                   Set pPolygon.SpatialReference = pSpRef
583:                 Else
584:                   Set pPrjSpRef = pSpRef
585:                   Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
586:                 End If
587:               End If
588:               If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolygon.SpatialReference) Then
589:                 pPolygon.Project pSpRef
590:               End If
              ' ADD DATA TO FEATURE BUFFER
592:               Set pFeatureBuf.Shape = pPolygon
593:               Set pArea = pPolygon
594:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
595:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Area")) = pArea.Area
596:               If m_booAllPolygonHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
597:               pFeatureCursor.InsertFeature pFeatureBuf
598:             Next lngIndex
599:           End If
600:           pFeatureCursor.Flush
601:       End Select
602:     Else                                          ' ONLY SELECTED GRAPHICS
      Select Case lbxGraphics.ListIndex
        Case 0                                    ' CONVERT POINTS TO POINT SHAPEFILE
605:           If m_SelPointGraphics.Count = 0 Then
606:             lngResponse = MsgBox("No selected graphic points in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Point Shapefile:")
609:             If lngResponse <> 1 Then
610:               Unload Me
611:             End If
            Exit Sub
613:           End If
614:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Point")
615:           If pFeatureClass Is Nothing Then
616:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
618:           End If
619:           pFeatureClass.AddField pXField
620:           pFeatureClass.AddField pYField
621:           If m_booSelPointHasNames Then pFeatureClass.AddField pNameField
          
623:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
624:           Set pFeatureCursor = pFeatureClass.Insert(True)
625:           For lngIndex = 0 To m_SelPointGraphics.Count - 1
626:             lngCounter = lngCounter + 1
627:             Set pPoint = m_SelPointGraphics.Element(lngIndex)
628:             strName = m_SelPointGraphicsNames.Element(lngIndex)
            
            ' SET SPATIAL REFERENCE
631:             Set pOrigSpRef = pPoint.SpatialReference
632:             If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
634:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
635:                 Set pPoint.SpatialReference = pSpRef
636:               Else
637:                 Set pPrjSpRef = pSpRef
638:                 Set pPoint.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
639:               End If
640:             ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
642:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
643:                 Set pPoint.SpatialReference = pSpRef
644:               Else
645:                 Set pPrjSpRef = pSpRef
646:                 Set pPoint.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
647:               End If
648:             End If
649:             If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPoint.SpatialReference) Then
650:               pPoint.Project pSpRef
651:             End If
            ' ADD DATA TO FEATURE BUFFER
653:             Set pFeatureBuf.Shape = pPoint
654:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
655:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("X_Coord")) = pPoint.X
656:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Y_Coord")) = pPoint.Y
657:             If m_booSelPointHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
658:             pFeatureCursor.InsertFeature pFeatureBuf
659:           Next lngIndex
660:           pFeatureCursor.Flush
        Case 1                                    ' CONVERT POLYLINE GRAPHICS TO POLYLINE SHAPEFILE
662:           If m_SelPolylineGraphics.Count = 0 Then
663:             lngResponse = MsgBox("No selected graphic polylines in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Polyline Shapefile:")
666:             If lngResponse <> 1 Then
667:               Unload Me
668:             End If
            Exit Sub
670:           End If
671:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polyline")
672:           If pFeatureClass Is Nothing Then
673:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
675:           End If
676:           pFeatureClass.AddField pLengthField
677:           If m_booSelPolylineHasNames Then pFeatureClass.AddField pNameField
          
679:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
680:           Set pFeatureCursor = pFeatureClass.Insert(True)
681:           For lngIndex = 0 To m_SelPolylineGraphics.Count - 1
682:             lngCounter = lngCounter + 1
683:             Set pGeometry = m_SelPolylineGraphics.Element(lngIndex)
684:             strName = m_SelPolylineGraphicsNames.Element(lngIndex)
            
686:             Set pSegCol = pGeometry
687:             Set pPolyline = Linkages.MyGeometricOperations.CurveToPolyline(pGeometry, 200)
            ' SET SPATIAL REFERENCE
689:             Set pOrigSpRef = pPolyline.SpatialReference
690:             If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
692:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
693:                 Set pPolyline.SpatialReference = pSpRef
694:               Else
695:                 Set pPrjSpRef = pSpRef
696:                 Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
697:               End If
698:             ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
700:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
701:                 Set pPolyline.SpatialReference = pSpRef
702:               Else
703:                 Set pPrjSpRef = pSpRef
704:                 Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
705:               End If
706:             End If
707:             If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolyline.SpatialReference) Then
708:               pPolyline.Project pSpRef
709:             End If
            ' ADD DATA TO FEATURE BUFFER
711:             Set pFeatureBuf.Shape = pPolyline
712:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
713:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Length")) = pPolyline.length
714:             If m_booSelPolylineHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
715:             pFeatureCursor.InsertFeature pFeatureBuf
716:           Next lngIndex
717:           pFeatureCursor.Flush
        Case 2                                    ' CONVERT POLYLINE + POLYGON GRAPHICS TO POLYLINE SHAPEFILE
719:           If m_SelPolylineGraphics.Count = 0 And m_SelPolygonGraphics.Count = 0 Then
720:             lngResponse = MsgBox("No selected graphic polylines or polygons in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Polyline Shapefile:")
723:             If lngResponse <> 1 Then
724:               Unload Me
725:             End If
            Exit Sub
727:           End If
728:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polyline")
729:           If pFeatureClass Is Nothing Then
730:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
732:           End If
733:           pFeatureClass.AddField pLengthField
734:           If m_booSelPolylineHasNames Or m_booSelPolygonHasNames Then pFeatureClass.AddField pNameField
          
736:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
737:           Set pFeatureCursor = pFeatureClass.Insert(True)
738:           If m_SelPolylineGraphics.Count > 0 Then
739:             For lngIndex = 0 To m_SelPolylineGraphics.Count - 1
740:               lngCounter = lngCounter + 1
741:               Set pGeometry = m_SelPolylineGraphics.Element(lngIndex)
742:               strName = m_SelPolylineGraphicsNames.Element(lngIndex)
            
744:               Set pSegCol = pGeometry
745:               Set pPolyline = Linkages.MyGeometricOperations.CurveToPolyline(pGeometry, 200)
              ' SET SPATIAL REFERENCE
747:               Set pOrigSpRef = pPolyline.SpatialReference
748:               If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
750:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
751:                   Set pPolyline.SpatialReference = pSpRef
752:                 Else
753:                   Set pPrjSpRef = pSpRef
754:                   Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
755:                 End If
756:               ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
758:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
759:                   Set pPolyline.SpatialReference = pSpRef
760:                 Else
761:                   Set pPrjSpRef = pSpRef
762:                   Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
763:                 End If
764:               End If
765:               If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolyline.SpatialReference) Then
766:                 pPolyline.Project pSpRef
767:               End If
              ' ADD DATA TO FEATURE BUFFER
769:               Set pFeatureBuf.Shape = pPolyline
770:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
771:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Length")) = pPolyline.length
772:               If m_booSelPolylineHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
773:               pFeatureCursor.InsertFeature pFeatureBuf
774:             Next lngIndex
775:           End If
776:           If m_SelPolygonGraphics.Count > 0 Then
777:             For lngIndex = 0 To m_SelPolygonGraphics.Count - 1
778:               lngCounter = lngCounter + 1
779:               Set pGeometry = m_SelPolygonGraphics.Element(lngIndex)
780:               strName = m_SelPolygonGraphicsNames.Element(lngIndex)
            
782:               Set pSegCol = pGeometry
783:               Set pPolyline = Linkages.MyGeometricOperations.CurveToPolyline(pGeometry, 200)
              ' SET SPATIAL REFERENCE
785:               Set pOrigSpRef = pPolyline.SpatialReference
786:               If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
788:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
789:                   Set pPolyline.SpatialReference = pSpRef
790:                 Else
791:                   Set pPrjSpRef = pSpRef
792:                   Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
793:                 End If
794:               ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
796:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
797:                   Set pPolyline.SpatialReference = pSpRef
798:                 Else
799:                   Set pPrjSpRef = pSpRef
800:                   Set pPolyline.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
801:                 End If
802:               End If
803:               If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolyline.SpatialReference) Then
804:                 pPolyline.Project pSpRef
805:               End If
              ' ADD DATA TO FEATURE BUFFER
807:               Set pFeatureBuf.Shape = pPolyline
808:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
809:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Length")) = pPolyline.length
810:               If m_booSelPolygonHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
811:               pFeatureCursor.InsertFeature pFeatureBuf
812:             Next lngIndex
813:           End If
814:           pFeatureCursor.Flush
        Case 3                                    ' CONVERT POLYGON GRAPHICS TO POLYGON SHAPEFILE
816:           If m_SelPolygonGraphics.Count = 0 Then
817:             lngResponse = MsgBox("No selected graphic polygons in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Polygon Shapefile:")
820:             If lngResponse <> 1 Then
821:               Unload Me
822:             End If
            Exit Sub
824:           End If
825:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polygon")
826:           If pFeatureClass Is Nothing Then
827:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
829:           End If
830:           pFeatureClass.AddField pAreaField
831:           If m_booSelPolygonHasNames Then pFeatureClass.AddField pNameField
          
833:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
834:           Set pFeatureCursor = pFeatureClass.Insert(True)
835:           For lngIndex = 0 To m_SelPolygonGraphics.Count - 1
836:             lngCounter = lngCounter + 1
837:             Set pGeometry = m_SelPolygonGraphics.Element(lngIndex)
838:             strName = m_SelPolygonGraphicsNames.Element(lngIndex)
            
840:             Set pSegCol = pGeometry
841:             Set pPolygon = Linkages.MyGeometricOperations.CurveToPolygon(pGeometry, 200)
            ' SET SPATIAL REFERENCE
843:             Set pOrigSpRef = pPolygon.SpatialReference
844:             If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
846:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
847:                 Set pPolygon.SpatialReference = pSpRef
848:               Else
849:                 Set pPrjSpRef = pSpRef
850:                 Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
851:               End If
852:             ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                               ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
854:               If TypeOf pSpRef Is IGeographicCoordinateSystem Then
855:                 Set pPolygon.SpatialReference = pSpRef
856:               Else
857:                 Set pPrjSpRef = pSpRef
858:                 Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
859:               End If
860:             End If
861:             If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolygon.SpatialReference) Then
862:               pPolygon.Project pSpRef
863:             End If
            ' ADD DATA TO FEATURE BUFFER
865:             Set pFeatureBuf.Shape = pPolygon
866:             Set pArea = pPolygon
867:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
868:             pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Area")) = pArea.Area
869:             If m_booSelPolygonHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
870:             pFeatureCursor.InsertFeature pFeatureBuf
871:           Next lngIndex
872:           pFeatureCursor.Flush
        Case 4                                    ' CONVERT POLYLINE + POLYGON GRAPHICS TO POLYGON SHAPEFILE
874:           If m_SelPolylineGraphics.Count = 0 And m_SelPolygonGraphics.Count = 0 Then
875:             lngResponse = MsgBox("No selected graphic polylines or polygons in map!  No new shapefile will be made." & vbCrLf & _
                   "Do you wish to go back and " & _
                   "make a different selection?", vbOKCancel, "Unable to Make Polygon Shapefile:")
878:             If lngResponse <> 1 Then
879:               Unload Me
880:             End If
            Exit Sub
882:           End If
883:           Set pFeatureClass = Linkages.aml_func_mod.CreateShapefile(strDir, strFileName, pSpRef, "Polygon")
884:           If pFeatureClass Is Nothing Then
885:             MsgBox "Failed to Create Shapefile:" & vbCrLf & "Bailing out of 'cmdOK_Click' function...", , "Function Failed:"
            Exit Sub
887:           End If
888:           pFeatureClass.AddField pAreaField
889:           If m_booSelPolylineHasNames Or m_booSelPolygonHasNames Then pFeatureClass.AddField pNameField
          
891:           Set pFeatureBuf = pFeatureClass.CreateFeatureBuffer
892:           Set pFeatureCursor = pFeatureClass.Insert(True)
893:           If m_SelPolylineGraphics.Count > 0 Then
894:             For lngIndex = 0 To m_SelPolylineGraphics.Count - 1
895:               lngCounter = lngCounter + 1
896:               Set pGeometry = m_SelPolylineGraphics.Element(lngIndex)
897:               strName = m_SelPolylineGraphicsNames.Element(lngIndex)
            
899:               Set pSegCol = pGeometry
900:               Set pPolygon = Linkages.MyGeometricOperations.CurveToPolygon(pGeometry, 200)
              ' SET SPATIAL REFERENCE
902:               Set pOrigSpRef = pPolygon.SpatialReference
903:               If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
905:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
906:                   Set pPolygon.SpatialReference = pSpRef
907:                 Else
908:                   Set pPrjSpRef = pSpRef
909:                   Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
910:                 End If
911:               ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
913:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
914:                   Set pPolygon.SpatialReference = pSpRef
915:                 Else
916:                   Set pPrjSpRef = pSpRef
917:                   Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
918:                 End If
919:               End If
920:               If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolygon.SpatialReference) Then
921:                 pPolygon.Project pSpRef
922:               End If
              ' ADD DATA TO FEATURE BUFFER
924:               Set pFeatureBuf.Shape = pPolygon
925:               Set pArea = pPolygon
926:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
927:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Area")) = pArea.Area
928:               If m_booSelPolylineHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
929:               pFeatureCursor.InsertFeature pFeatureBuf
930:             Next lngIndex
931:           End If
932:           If m_SelPolygonGraphics.Count > 0 Then
933:             For lngIndex = 0 To m_SelPolygonGraphics.Count - 1
934:               lngCounter = lngCounter + 1
935:               Set pGeometry = m_SelPolygonGraphics.Element(lngIndex)
936:               strName = m_SelPolygonGraphicsNames.Element(lngIndex)
            
938:               Set pSegCol = pGeometry
939:               Set pPolygon = Linkages.MyGeometricOperations.CurveToPolygon(pGeometry, 200)
              ' SET SPATIAL REFERENCE
941:               Set pOrigSpRef = pPolygon.SpatialReference
942:               If pOrigSpRef Is Nothing Then      ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
944:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
945:                   Set pPolygon.SpatialReference = pSpRef
946:                 Else
947:                   Set pPrjSpRef = pSpRef
948:                   Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
949:                 End If
950:               ElseIf TypeOf pOrigSpRef Is IUnknownCoordinateSystem Then ' PRESUMABLY CAN ONLY HAPPEN IF DATA FRAME HAS NO SPATIAL REFERENCE YET
                                                 ' THEREFORE TREAT LIKE GEOGRAPHIC COORDINATES
952:                 If TypeOf pSpRef Is IGeographicCoordinateSystem Then
953:                   Set pPolygon.SpatialReference = pSpRef
954:                 Else
955:                   Set pPrjSpRef = pSpRef
956:                   Set pPolygon.SpatialReference = pPrjSpRef.GeographicCoordinateSystem
957:                 End If
958:               End If
959:               If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pSpRef, pPolygon.SpatialReference) Then
960:                 pPolygon.Project pSpRef
961:               End If
              ' ADD DATA TO FEATURE BUFFER
963:               Set pFeatureBuf.Shape = pPolygon
964:               Set pArea = pPolygon
965:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Unique_ID")) = lngCounter
966:               pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Area")) = pArea.Area
967:               If m_booSelPolygonHasNames Then pFeatureBuf.Value(pFeatureBuf.Fields.FindField("Name")) = strName
968:               pFeatureCursor.InsertFeature pFeatureBuf
969:             Next lngIndex
970:           End If
971:           pFeatureCursor.Flush
972:       End Select
973:     End If
974:   End If
      
  Dim pFeatureLayer As IFeatureLayer
977:   Set pFeatureLayer = New FeatureLayer
978:   Set pFeatureLayer.FeatureClass = pFeatureClass
979:   pFeatureLayer.Name = Linkages.aml_func_mod.ClipExtension(strFileName)
980:   m_pMxDoc.FocusMap.AddLayer pFeatureLayer
  
982:   Call Linkages.MyGeneralOperations.EnableSelectTool(m_pApp)
  
984:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdSpRef_Click()
  On Error GoTo ErrorHandler

  Dim pSpRef As ISpatialReference
  Dim pSpRefDlg As ISpatialReferenceDialog2
    
997:   Set pSpRefDlg = New SpatialReferenceDialog
998:   Set pSpRef = pSpRefDlg.DoModalCreate(False, False, False, Me.hWnd)
  
1000:   If Not pSpRef Is Nothing Then
1001:     lblSpRef.Caption = "Spatial Reference = " & pSpRef.Name
1002:     Set m_SpRef = pSpRef
1003:   End If
  
1005:   Call CheckEnable
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdSpRef_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub CheckEnable()
  On Error GoTo ErrorHandler

  Dim OptionsOK As Boolean
1016:   OptionsOK = ((optNew.Value = True) And ((optPoint.Value = True) Or (optPolyline.Value = True) Or (optPolygon.Value = True))) Or _
      ((optConvert.Value = True) And (lbxGraphics.ListIndex > -1))
  
  Dim booSpRefOK As Boolean
1020:   booSpRefOK = (Not m_SpRef Is Nothing)
  
1022:   If booSpRefOK Then
1023:     booSpRefOK = (Not TypeOf m_SpRef Is IUnknownCoordinateSystem)
'    MsgBox "In CheckEnable: " & vbCrLf & _
          "Spatial Reference is Unknown? " & CStr(TypeOf m_SpRef Is IUnknownCoordinateSystem) & vbCrLf & _
          "Spatial Reference Name = " & m_SpRef.Name
1027:   End If
  
1029:   If optNew.Value = True Then
1030:     optPolyline.Enabled = True
1031:     optPoint.Enabled = True
1032:     optPolygon.Enabled = True
1033:     frmNew.Enabled = True
1034:     lbxGraphics.Enabled = False
1035:     chkSelected.Enabled = False
1036:   ElseIf optConvert.Value = True Then
1037:     optPolyline.Enabled = False
1038:     optPoint.Enabled = False
1039:     optPolygon.Enabled = False
1040:     frmNew.Enabled = False
1041:     lbxGraphics.Enabled = True
1042:     chkSelected.Enabled = True
1043:   End If
  
1045:   cmdOK.Enabled = booSpRefOK And OptionsOK
  
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

1055:   Unload Me
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler

1066:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
1067:   Me.Left = (2 * Screen.Width / 3) - (2 * Me.Width / 3)
1068:   Me.Top = (2 * Screen.Height / 3) - (Me.Height / 3)
    
  Dim newUid As New uID
1071:   newUid.Value = "Linkages.clsExtension"
1072:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  Dim ext As Linkages.clsExtension
1074:   Set ext = m_ExtensionConfig
  
  ' PRESET OPTIONS
1077:   optNew.Value = True
1078:   optConvert.Value = False
1079:   optPolygon.Value = True
1080:   optPolyline.Value = False
1081:   optPoint.Value = False
1082:   lbxGraphics.Clear
  
1084:   If (m_SelPointGraphics.Count > 0) Or (m_SelPolylineGraphics.Count > 0) Or (m_SelPolygonGraphics.Count > 0) Then
1085:     chkSelected.Value = 1
1086:     optConvert.Value = True
1087:     optNew.Value = False
1088:   Else
1089:     optConvert.Value = False
1090:     optNew.Value = True
1091:     chkSelected.Value = 0
1092:   End If
  
1094:   Call FillGraphicsListBox
  
  ' PRESET SPATIAL REFERENCE
  Dim pSpRef As ISpatialReference
1098:   Set pSpRef = m_pMxDoc.FocusMap.SpatialReference
1099:   If Not pSpRef Is Nothing Then
1100:     If TypeOf pSpRef Is IUnknownCoordinateSystem Then
1101:       Set pSpRef = Nothing
1102:       Set m_SpRef = Nothing
1103:     Else
1104:       Set m_SpRef = pSpRef
1105:     End If
1106:   Else
1107:     Set m_SpRef = Nothing
1108:   End If
  
1110:   If pSpRef Is Nothing Then
1111:     lblSpRef.Caption = "Spatial Reference = <-- No Spatial Reference Set -->"
1112:   Else
1113:     lblSpRef.Caption = "Spatial Reference = " & pSpRef.Name
1114:   End If
  
  ' WORKSPACE
  ' FIRST SEE IF IT HAS BEEN SAVED TO EXTENSION PROPERTIES.  THIS PROPERTY WILL BE EMPTY THE FIRST TIME THE DIALOG
  '      IS OPENED, BUT EACH TIME THEREAFTER IT WILL HAVE A VALUE.
  ' IF NOT IN EXTENSION PROPERTY, THEN CHECK ArcGIS LAST SAVE TO LOCATION
  ' IF THIS DOESN'T WORK, USE MxDoc PATH NAME.
  Dim strDirPath As String
  Dim strUserName As String
  
1124:   strDirPath = ext.ClipDirectoryPath
1125:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
1126:     strDirPath = Linkages.aml_func_mod.ReturnArcGISGeneralDir(enumLastSaveToLocation)
1127:   End If
1128:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
1129:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
1130:     strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
1131:   End If

1133:   If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then
1134:     strDirPath = strDirPath & "\"
1135:   End If
  
1137:   strDirPath = Linkages.aml_func_mod.MakeUniqueFilename(strDirPath & "NewShape.shp")
1138:   txtOutput.Text = strDirPath
1139:   optNew.BackColor = RGB(194, 194, 194)
1140:   optConvert.BackColor = RGB(194, 194, 194)
  
1142:   Call CheckEnable
  
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub FillGraphicsListBox()
  On Error GoTo ErrorHandler

  
  Dim lngIndex As Long
1154:   lbxGraphics.Clear
  
1156:   If chkSelected.Value = 1 Then
1157:     For lngIndex = 0 To m_SelGraphicslist.Count - 1
1158:       lbxGraphics.AddItem (m_SelGraphicslist.Element(lngIndex))
1159:     Next lngIndex
1160:   Else
1161:     For lngIndex = 0 To m_AllGraphicsList.Count - 1
1162:       lbxGraphics.AddItem (m_AllGraphicsList.Element(lngIndex))
1163:     Next lngIndex
1164:   End If


  Exit Sub
ErrorHandler:
  HandleError False, "FillGraphicsListBox " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub FillGraphicsArrays()
  On Error GoTo ErrorHandler


  Dim strPointWord As String
  Dim strPolylineWord As String
  Dim strPolygonWord As String
  Dim strSelPointWord As String
  Dim strSelPolylineWord As String
  Dim strSelPolygonWord As String
  
  Dim pGraphicsContainer As IGraphicsContainer
  Dim pGraphicsContainerSel As IGraphicsContainerSelect
1185:   Set pGraphicsContainer = m_pMxDoc.FocusMap
1186:   Set pGraphicsContainerSel = m_pMxDoc.FocusMap
  
1188:   pGraphicsContainer.Reset
  
1190:   Set m_AllPointGraphics = New esriSystem.VarArray
1191:   Set m_SelPointGraphics = New esriSystem.VarArray
1192:   Set m_AllPolylineGraphics = New esriSystem.VarArray
1193:   Set m_SelPolylineGraphics = New esriSystem.VarArray
1194:   Set m_AllPolygonGraphics = New esriSystem.VarArray
1195:   Set m_SelPolygonGraphics = New esriSystem.VarArray
  
1197:   Set m_AllPointGraphicsNames = New esriSystem.strArray
1198:   Set m_SelPointGraphicsNames = New esriSystem.strArray
1199:   Set m_AllPolylineGraphicsNames = New esriSystem.strArray
1200:   Set m_SelPolylineGraphicsNames = New esriSystem.strArray
1201:   Set m_AllPolygonGraphicsNames = New esriSystem.strArray
1202:   Set m_SelPolygonGraphicsNames = New esriSystem.strArray
  
1204:   m_booAllPointHasNames = False
1205:   m_booSelPointHasNames = False
1206:   m_booAllPolylineHasNames = False
1207:   m_booSelPolylineHasNames = False
1208:   m_booAllPolygonHasNames = False
1209:   m_booSelPolygonHasNames = False
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
1213:   Set pElement = pGraphicsContainer.Next
  Dim pGeometryType As esriGeometryType
'  Dim pElProps3 As IElementProperties3
  
  Dim pClone As IClone
  Dim pGeometry As IGeometry
  
  Dim strName As String
  Dim pElementProps As IElementProperties
  
1223:   Do Until pElement Is Nothing
    
1225:     Set pElementProps = pElement
1226:     Set pClone = pElement.Geometry
1227:     Set pGeometry = pClone.Clone
    
'    MsgBox "Fill Graphics Array: Spatial Reference = " & CStr(pElement.Geometry.SpatialReference.Name)
'    MsgBox "Fill Graphics Array: pGeometry Spatial Reference = " & CStr(pGeometry.SpatialReference.Name)
'    Set pElProps3 = pElement
'    MsgBox "pElProps3.SpRef = " & pElProps3.SpatialReference.Name
    
1234:     pGeometryType = pGeometry.GeometryType
1235:     strName = pElementProps.Name
    
1237:     If pGeometryType = esriGeometryPoint Then
1238:       m_AllPointGraphics.Add pGeometry
1239:       m_AllPointGraphicsNames.Add strName
1240:       If strName <> "" Then m_booAllPointHasNames = True
1241:     ElseIf pGeometryType = esriGeometryPolyline Then
1242:       m_AllPolylineGraphics.Add pGeometry
1243:       m_AllPolylineGraphicsNames.Add strName
1244:       If strName <> "" Then m_booAllPolylineHasNames = True
1245:     ElseIf pGeometryType = esriGeometryPolygon Then
1246:       m_AllPolygonGraphics.Add pGeometry
1247:       m_AllPolygonGraphicsNames.Add strName
1248:       If strName <> "" Then m_booAllPolygonHasNames = True
1249:     End If
1250:     Set pElement = pGraphicsContainer.Next
1251:   Loop
  
'  MsgBox pGraphicsContainerSel.ElementSelectionCount & " elements selected..."
  
1255:   If pGraphicsContainerSel.ElementSelectionCount > 0 Then
    Dim pEnum As IEnumElement
1257:     Set pEnum = pGraphicsContainerSel.SelectedElements
1258:     pEnum.Reset
1259:     Set pElement = pEnum.Next
1260:     Do Until pElement Is Nothing
'      MsgBox "Looping..."
1262:       Set pElementProps = pElement
1263:       strName = pElementProps.Name
1264:       Set pClone = pElement.Geometry
1265:       Set pGeometry = pClone.Clone
1266:       pGeometryType = pGeometry.GeometryType
1267:       If pGeometryType = esriGeometryPoint Then
1268:         m_SelPointGraphics.Add pGeometry
1269:         m_SelPointGraphicsNames.Add strName
1270:         If strName <> "" Then m_booSelPointHasNames = True
1271:       ElseIf pGeometryType = esriGeometryPolyline Then
1272:         m_SelPolylineGraphics.Add pGeometry
1273:         m_SelPolylineGraphicsNames.Add strName
1274:         If strName <> "" Then m_booSelPolylineHasNames = True
1275:       ElseIf pGeometryType = esriGeometryPolygon Then
1276:         m_SelPolygonGraphics.Add pGeometry
1277:         m_SelPolygonGraphicsNames.Add strName
1278:         If strName <> "" Then m_booSelPolygonHasNames = True
1279:       End If
1280:       Set pElement = pEnum.Next
1281:     Loop
1282:   End If
  
1284:   If (m_AllPointGraphics.Count = 1) Then
1285:     strPointWord = " Point"
1286:   Else
1287:     strPointWord = " Points"
1288:   End If
1289:   If (m_AllPolylineGraphics.Count = 1) Then
1290:     strPolylineWord = " Polyline"
1291:   Else
1292:     strPolylineWord = " Polylines"
1293:   End If
1294:   If (m_AllPolygonGraphics.Count = 1) Then
1295:     strPolygonWord = " Polygon"
1296:   Else
1297:     strPolygonWord = " Polygons"
1298:   End If
1299:   If (m_SelPointGraphics.Count = 1) Then
1300:     strSelPointWord = " Point"
1301:   Else
1302:     strSelPointWord = " Points"
1303:   End If
1304:   If (m_SelPolylineGraphics.Count = 1) Then
1305:     strSelPolylineWord = " Polyline"
1306:   Else
1307:     strSelPolylineWord = " Polylines"
1308:   End If
1309:   If (m_SelPolygonGraphics.Count = 1) Then
1310:     strSelPolygonWord = " Polygon"
1311:   Else
1312:     strSelPolygonWord = " Polygons"
1313:   End If
  
1315:   Set m_AllGraphicsList = New esriSystem.strArray
1316:   Set m_SelGraphicslist = New esriSystem.strArray
  
1318:   m_AllGraphicsList.Add "1) Point Shapefile: " & CStr(m_AllPointGraphics.Count) & strPointWord
1319:   m_AllGraphicsList.Add "2) Polyline Shapefile: " & CStr(m_AllPolylineGraphics.Count) & strPolylineWord
1320:   m_AllGraphicsList.Add "3) Polyline Shapefile: " & CStr(m_AllPolylineGraphics.Count) & strPolylineWord & " + " & _
                                                    CStr(m_AllPolygonGraphics.Count) & strPolygonWord
1322:   m_AllGraphicsList.Add "4) Polygon Shapefile: " & CStr(m_AllPolygonGraphics.Count) & strPolygonWord
1323:   m_AllGraphicsList.Add "5) Polygon Shapefile: " & CStr(m_AllPolylineGraphics.Count) & strPolylineWord & " + " & _
                                                    CStr(m_AllPolygonGraphics.Count) & strPolygonWord
  
1326:   m_SelGraphicslist.Add "1) Point Shapefile: " & CStr(m_SelPointGraphics.Count) & strSelPointWord
1327:   m_SelGraphicslist.Add "2) Polyline Shapefile: " & CStr(m_SelPolylineGraphics.Count) & strSelPolylineWord
1328:   m_SelGraphicslist.Add "3) Polyline Shapefile: " & CStr(m_SelPolylineGraphics.Count) & strSelPolylineWord & " + " & _
                                                    CStr(m_SelPolygonGraphics.Count) & strSelPolygonWord
1330:   m_SelGraphicslist.Add "4) Polygon Shapefile: " & CStr(m_SelPolygonGraphics.Count) & strSelPolygonWord
1331:   m_SelGraphicslist.Add "5) Polygon Shapefile: " & CStr(m_SelPolylineGraphics.Count) & strSelPolylineWord & " + " & _
                                                    CStr(m_SelPolygonGraphics.Count) & strSelPolygonWord

  

  Exit Sub
ErrorHandler:
  HandleError False, "FillGraphicsArrays " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler

1344:   Set m_pApp = Nothing
1345:   Set m_pMxDoc = Nothing
1346:   Set m_SpRef = Nothing
1347:   Set m_ExtensionConfig = Nothing
1348:   Set m_AllPointGraphics = Nothing
1349:   Set m_SelPointGraphics = Nothing
1350:   Set m_AllPolylineGraphics = Nothing
1351:   Set m_SelPolylineGraphics = Nothing
1352:   Set m_AllPolygonGraphics = Nothing
1353:   Set m_SelPolygonGraphics = Nothing
1354:   Set m_AllGraphicsList = Nothing
1355:   Set m_SelGraphicslist = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxGraphics_Click()
1363:   Call CheckEnable
End Sub

Private Sub optConvert_Click()
  On Error GoTo ErrorHandler

1369:   Call FillGraphicsListBox
1370:   Call CheckEnable

  Exit Sub
ErrorHandler:
  HandleError True, "optConvert_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub optNew_Click()
  On Error GoTo ErrorHandler

1380:   Call FillGraphicsListBox
1381:   Call CheckEnable


  Exit Sub
ErrorHandler:
  HandleError True, "optNew_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub optPoint_Click()
  On Error GoTo ErrorHandler

1392:   Call CheckEnable
  

  Exit Sub
ErrorHandler:
  HandleError True, "optPoint_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub optPolygon_Click()
  On Error GoTo ErrorHandler

1403:   Call CheckEnable


  Exit Sub
ErrorHandler:
  HandleError True, "optPolygon_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub optPolyline_Click()
  On Error GoTo ErrorHandler

1414:   Call CheckEnable


  Exit Sub
ErrorHandler:
  HandleError True, "optPolyline_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
