VERSION 5.00
Begin VB.Form frmHabSuitStats 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Habitat Suitability Model Statistics:"
   ClientHeight    =   3465
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5040
   Icon            =   "frmHabSuitStats.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3465
   ScaleWidth      =   5040
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdGetFile 
      Height          =   360
      Left            =   4358
      Picture         =   "frmHabSuitStats.frx":038A
      Style           =   1  'Graphical
      TabIndex        =   2
      ToolTipText     =   "Browse for Output Filename..."
      Top             =   2505
      Width           =   555
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   165
      Locked          =   -1  'True
      TabIndex        =   1
      Top             =   2535
      Width           =   4110
   End
   Begin VB.TextBox txtNumBins 
      Height          =   345
      Left            =   2970
      TabIndex        =   3
      Top             =   2955
      Width           =   1035
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   345
      Left            =   3937
      TabIndex        =   6
      Top             =   1755
      Width           =   1080
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      Height          =   345
      Left            =   3937
      TabIndex        =   5
      Top             =   1350
      Width           =   1080
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   345
      Left            =   3937
      TabIndex        =   4
      Top             =   945
      Width           =   1080
   End
   Begin VB.ListBox lbxLayers 
      Height          =   1815
      Left            =   15
      TabIndex        =   0
      Top             =   300
      Width           =   3840
   End
   Begin VB.Image Image1 
      BorderStyle     =   1  'Fixed Single
      Height          =   1215
      Left            =   45
      Top             =   2220
      Width           =   4965
   End
   Begin VB.Label lbl3 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Specify folder for output tables:"
      Height          =   195
      Left            =   165
      TabIndex        =   9
      Top             =   2295
      Width           =   2190
   End
   Begin VB.Label lblHistogramBins 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Number of Histogram Bins:"
      Height          =   195
      Left            =   1028
      TabIndex        =   8
      Top             =   3015
      Width           =   1875
   End
   Begin VB.Image imgCorrIcon 
      Height          =   855
      Left            =   4005
      Picture         =   "frmHabSuitStats.frx":0400
      Top             =   30
      Width           =   945
   End
   Begin VB.Label lblSelLayer 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Select Habitat Suitability Grid"
      Height          =   195
      Left            =   915
      TabIndex        =   7
      Top             =   45
      Width           =   2040
   End
End
Attribute VB_Name = "frmHabSuitStats"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_pApp As IApplication
Private m_ExtensionConfig As IExtensionConfig
Private m_CurrentSelected As IRasterLayer
Private m_RasterLayers As esriSystem.IVariantArray
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\frmHabSuitStats.frm"



Public Property Set ArcApp(ByVal vNewValue As IApplication)
  On Error GoTo ErrorHandler


15:   Set m_pApp = vNewValue


  Exit Property
ErrorHandler:
  HandleError True, "ArcApp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set theRasterLayers(ByVal theLayers As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler


27:   Set m_RasterLayers = theLayers


  Exit Property
ErrorHandler:
  HandleError True, "theRasterLayers " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set theCurrentSelected(ByVal aPossibleLayer As IRasterLayer)
  On Error GoTo ErrorHandler


39:   Set m_CurrentSelected = aPossibleLayer


  Exit Property
ErrorHandler:
  HandleError True, "theCurrentSelected " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

50:   Unload Me

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetFile_Click()
  On Error GoTo ErrorHandler


61:   SetWindowPos Me.hWnd, -2, 0, 0, 0, 0, &H1 Or &H2
  
  Dim strDirPath As String
  Dim strUserName As String
  
66:   strDirPath = txtOutput.Text
67:   If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then strDirPath = strDirPath & "\"
68:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
69:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
70:     strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
71:   End If
  
  Dim boolWorkspaceExists As Boolean
  ' MODIFIED FEB 2008 TO ADD vbDirectory
75:   boolWorkspaceExists = Not Dir$(strDirPath, vbDirectory) = ""
  
77:   If Not boolWorkspaceExists Then
78:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.TempPathLocation)
79:   End If

  Dim pGxDialog As IGxDialog
82:   Set pGxDialog = New GxDialog
  
  Dim pGxDialogFilter As IGxObjectFilter
'  Set pGxDialogFilter = New GxFilterWorkspaces
86:   Set pGxDialogFilter = New GxFilterBasicTypes
'  pGxDialogFilter.Name = "Folders"
'  Set pGxDialogFilter = New GxFilterContainers      ' INCLUDED GRIDS AND COVERAGES
  
  Dim pGxObject As IGxObject
  Dim pGxSelection As IEnumGxObject
  
93:   With pGxDialog
94:     .AllowMultiSelect = False
95:     .StartingLocation = strDirPath
96:     .Title = "Please select (don't open!) folder to contain your dBASE Tables:"
97:     Set .ObjectFilter = pGxDialogFilter
98:   End With
  
  Dim theFinalString As String
'  If Not pGxDialog.DoModalOpen(0, pEnumGx) Then
'Exit Sub 'Exit if user press Cancel
'End If
'MsgBox pEnumGx.Next.FullName
105:   If (pGxDialog.DoModalOpen(Me.hWnd, pGxSelection) = True) Then
    'Set pGxObject = pGxDialog.FinalLocation
107:     Set pGxObject = pGxSelection.Next
    
    Dim pGxFile As IGxFile
110:     Set pGxFile = pGxObject
    
112:     theFinalString = pGxObject.FullName
113:     If (Right(theFinalString, 1) <> "\") And (Right(theFinalString, 1) <> "/") Then theFinalString = theFinalString & "\"
    
'    If aml_func_mod.ExistFileDir(theFinalString) Then
'      theFinalString = aml_func_mod.MakeUniqueFilename(theFinalString)
'
'      MsgBox "Unable to overwrite the file '" & pGxDialog.Name & "'.  The new file will be saved to " & _
'        theFinalString & "..."
'    End If

122:     txtOutput.Text = theFinalString
    
124:   End If


127:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2





  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetFile_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdHelp_Click()
  On Error GoTo ErrorHandler


  Dim strPath As String
143:   strPath = App.Path & "\help"
  
145:   Call Linkages.MyGeneralOperations.OpenDoc("Hab_Statistics_Subdocument.pdf", strPath)
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdHelp_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdOK_Click()
  On Error GoTo ErrorHandler
  
  ' UPDATE SAVED NUMBER OF BINS VALUE
  Dim newUid As New uID
158:   newUid.Value = "Linkages.clsExtension"
159:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  Dim ext As Linkages.clsExtension
161:   Set ext = m_ExtensionConfig
162:   ext.HistogramBinCount = CLng(txtNumBins.Text)
  
  Dim theTimeBegan As Date
165:   theTimeBegan = Now
  
  ' UPDATE CURRENT SAVE FOLDER
  Dim strWorkFolder As String
169:   strWorkFolder = txtOutput.Text
170:   If Right(strWorkFolder, 1) <> "\" And Right(strWorkFolder, 1) <> "/" Then
171:     strWorkFolder = strWorkFolder & "\"
172:   End If
173:   ext.ClipDirectoryPath = strWorkFolder
  
  ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
177:   Set psbar = m_pApp.StatusBar
  Dim pPro As IStepProgressor
179:   Set pPro = psbar.ProgressBar
180:   Screen.MousePointer = vbHourglass
  
  ' CALCULATE STATS
  Dim pRasterLayer As IRasterLayer
  Dim pRaster As IRaster
  Dim pRasterBandCollection As IRasterBandCollection
  Dim pRasterBand As IRasterBand
  Dim pRasterStatistics As IRasterStatistics
  Dim pRasterDataset As IRasterDataset
  Dim dblCellSize As Double
  Dim pLogicalOp As ILogicalOp
  Dim pNewFields As IFields
  Dim pNewFieldsEdit As IFieldsEdit
  Dim pNewField As IField
  Dim pNewFieldEdit As IFieldEdit
  Dim pCountRasterBand As IRasterBand
  Dim pCountRasterBandCollection As IRasterBandCollection
  Dim pCountGeoDataset As IGeoDataset
  Dim pCountCursor As ICursor
  Dim pCountRow As IRow
  Dim lngCountValField As Long
  Dim lngCountCountField As Long
  Dim lngCountValValue As Long
  Dim lngCountCountValue As Long
  Dim lngNumBins As Long
  Dim strReport As String
  Dim strHistReport As String
  Dim pTable As ITable
  Dim strFileName As String
  
210:   Set pRasterLayer = m_RasterLayers.Element(lbxLayers.ListIndex)
211:   Set pRaster = pRasterLayer.Raster
212:   Set pRasterBandCollection = pRaster
213:   Set pRasterBand = pRasterBandCollection.Item(0)
214:   Set pRasterStatistics = pRasterBand.Statistics
215:   Set pRasterDataset = pRasterBand.RasterDataset
  
217:   lngNumBins = CLng(txtNumBins.Text)
  
  ' MAKE EMPTY FIELD INFO ARRAY; HISTOGRAM FUNCTION EXPECTS IT
  Dim pFieldInfoArray As esriSystem.IStringArray
221:   Set pFieldInfoArray = New esriSystem.strArray

  ' GET INFORMATION ON FIELD AND ADD TO FIELD INFO ARRAY
224:   pFieldInfoArray.Add pRasterLayer.Name
  
  ' GET CELL SIZE
227:   dblCellSize = (Linkages.GridFunctions.ReturnCellSize(pRaster)) ^ 2
  
  ' GET GENERAL COUNT OF NON-NULL CELL VALUES
230:   Set pLogicalOp = New RasterMathOps
231:   Set pCountGeoDataset = pLogicalOp.IsNull(pRaster)
232:   Set pCountRasterBandCollection = pCountGeoDataset
233:   Set pCountRasterBand = pCountRasterBandCollection.Item(0)
234:   Set pTable = pCountRasterBand.AttributeTable
235:   lngCountValField = pTable.FindField("Value")
236:   lngCountCountField = pTable.FindField("Count")
237:   lngCountCountValue = -9999
238:   Set pCountCursor = pTable.Search(Nothing, True)
239:   Set pCountRow = pCountCursor.NextRow
240:   Do Until pCountRow Is Nothing
241:     lngCountValValue = pCountRow.Value(lngCountValField)
242:     If lngCountValValue = 0 Then
243:       lngCountCountValue = pCountRow.Value(lngCountCountField)
244:     End If
245:     Set pCountRow = pCountCursor.NextRow
246:   Loop
  
  Dim lngHistArray() As Long
249:   lngHistArray = Linkages.CorridorAnalysisFunctions.GridHistogram(pRasterLayer, 0, _
      100, lngNumBins, m_pApp)
      
'  strReport = "Statistics Report on Grid '" & pRasterLayer.Name & "':" & vbCrLf & _
      "------------------------------------------------" & vbCrLf & _
      "Non-Null Grid Cell Count = " & Linkages.aml_func_mod.InsertCommas(lngCountCountValue) & _
      " grid cells" & vbCrLf & _
      "------------------------------------------------" & vbCrLf & _
      "  --> Continuous Grid Value Statistics" & vbCrLf & _
      "  --> Data saved to zzzFilename" & vbCrLf & _
      "  --> Statistics: " & vbCrLf & _
      "       a] Minimum = " & CStr(pRasterStatistics.Minimum) & vbCrLf & _
      "       b] Maximum = " & CStr(pRasterStatistics.Maximum) & vbCrLf & _
      "       c] Mean = " & CStr(pRasterStatistics.Mean) & vbCrLf & _
      "       d] Standard Deviation = " & CStr(pRasterStatistics.StandardDeviation) & vbCrLf & _
      "       e] Histogram:" & vbCrLf
      
266:   strReport = _
      "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fprq2\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\qc\tx90\tx360\tx450\tx720\b\f0\fs16 Statistics Report on Grid '" & _
      pRasterLayer.Name & "'\b0\par" & vbCrLf & _
      "\pard ------------------------------------------------------------------------------\par" & vbCrLf & _
      "\b Non-Null Grid Cell Count: \b0 " & Linkages.aml_func_mod.InsertCommas(lngCountCountValue) & _
        " grid cells\par" & vbCrLf & _
      "------------------------------------------------------------------------------\par" & vbCrLf & _
      "\b Continuous Grid Value Statistics\b0\par" & vbCrLf & _
      "\b Data saved to \b0 zzzFilename\par" & vbCrLf & _
      "\b Statistics: \b0\par" & vbCrLf & _
      "\b     a] Minimum: \b0 " & CStr(pRasterStatistics.Minimum) & "\par" & vbCrLf & _
      "\b     b] Maximum: \b0 " & CStr(pRasterStatistics.Maximum) & "\par" & vbCrLf & _
      "\b     c] Mean: \b0 " & CStr(pRasterStatistics.Mean) & "\par" & vbCrLf & _
      "\b     d] Standard Deviation: \b0 " & CStr(pRasterStatistics.StandardDeviation) & "\par" & vbCrLf & _
      "\b     e] Histogram: \b0\par" & vbCrLf
      
283:   If UBound(lngHistArray) = 0 Then
284:     strReport = strReport & "        !!! Single Value:  No Histogram created...\par" & vbCrLf
285:   Else
    ' REMEMBER THAT HABITAT SUITABILITY ANALYSIS ALWAYS GOES FROM 0 TO 100
287:     strHistReport = Linkages.CorridorAnalysisFunctions.MakeHistogramData(pFieldInfoArray, lngNumBins, 0, _
        100, lngHistArray, m_pApp, txtOutput.Text, 1)
289:     strReport = strReport & strHistReport
290:   End If

  ' MAKE NEW TABLE
293:   Set pNewFields = New Fields
294:   Set pNewFieldsEdit = pNewFields
295:   pNewFieldsEdit.FieldCount = 5
  
  ' MAKE UNIQUE ID FIELD
298:   Set pNewField = New Field
299:   Set pNewFieldEdit = pNewField
300:   pNewFieldEdit.Name = "Unique_ID"
301:   pNewFieldEdit.Type = esriFieldTypeInteger
302:   pNewFieldEdit.Precision = 8
303:   Set pNewFieldsEdit.Field(0) = pNewField
    
  ' MAKE STAT FIELDS
306:   Set pNewField = New Field
307:   Set pNewFieldEdit = pNewField
308:   With pNewFieldEdit
309:     .Type = esriFieldTypeDouble
310:     .Name = "Minimum"
311:     .Precision = 14
312:     .Scale = 8
313:   End With
314:   Set pNewFieldsEdit.Field(1) = pNewField

316:   Set pNewField = New Field
317:   Set pNewFieldEdit = pNewField
318:   With pNewFieldEdit
319:     .Type = esriFieldTypeDouble
320:     .Name = "Maximum"
321:     .Precision = 14
322:     .Scale = 8
323:   End With
324:   Set pNewFieldsEdit.Field(2) = pNewField

326:   Set pNewField = New Field
327:   Set pNewFieldEdit = pNewField
328:   With pNewFieldEdit
329:     .Type = esriFieldTypeDouble
330:     .Name = "Mean"
331:     .Precision = 14
332:     .Scale = 8
333:   End With
334:   Set pNewFieldsEdit.Field(3) = pNewField

336:   Set pNewField = New Field
337:   Set pNewFieldEdit = pNewField
338:   With pNewFieldEdit
339:     .Type = esriFieldTypeDouble
340:     .Name = "St_Dev"
341:     .Precision = 14
342:     .Scale = 8
343:   End With
344:   Set pNewFieldsEdit.Field(4) = pNewField
  
346:   strFileName = txtOutput.Text
347:   If Right(strFileName, 1) <> "/" And Right(strFileName, 1) <> "\" Then strFileName = strFileName & "\"
348:   strFileName = strFileName & pRasterLayer.Name & "_stats.dbf"
349:   strFileName = Linkages.aml_func_mod.MakeUniqueFilename(strFileName)
350:   Set pTable = Linkages.aml_func_mod.CreatedBASETable(strFileName, pNewFields)
  
  ' ADD DATA
  Dim pRow As IRow
354:   Set pRow = pTable.CreateRow
355:   pRow.Value(pTable.FindField("Unique_ID")) = 1
356:   pRow.Value(pTable.FindField("Minimum")) = pRasterStatistics.Minimum
357:   pRow.Value(pTable.FindField("Maximum")) = pRasterStatistics.Maximum
358:   pRow.Value(pTable.FindField("Mean")) = pRasterStatistics.Mean
359:   pRow.Value(pTable.FindField("St_Dev")) = pRasterStatistics.StandardDeviation
360:   pRow.Store
  
  ' MAKE TABLE AND ADD TO MAP DOCUMENT
  Dim pNewStandaloneTable As IStandaloneTable
  Dim pTableWindow2 As ITableWindow2
  Dim pStandaloneTableCollection As IStandaloneTableCollection
  Dim pMxDoc As IMxDocument
  
368:   Set pNewStandaloneTable = New StandaloneTable
369:   Set pNewStandaloneTable.Table = pTable

371:   Set pTableWindow2 = New TableWindow

373:   With pTableWindow2
374:     Set .StandaloneTable = pNewStandaloneTable
375:     Set .Application = m_pApp
376:     .TableSelectionAction = esriSelectFeatures
377:     .ShowAliasNamesInColumnHeadings = True
378:     .ShowSelected = False
379:     .Show True
380:   End With
381:   Set pMxDoc = m_pApp.Document
382:   Set pStandaloneTableCollection = pMxDoc.FocusMap
383:   pStandaloneTableCollection.AddStandaloneTable pNewStandaloneTable
  
385:   pMxDoc.UpdateContents
  
387:   strReport = Linkages.aml_func_mod.SubstituteString(strReport, "zzzFilename", strFileName)

389:   psbar.HideProgressBar
390:   Screen.MousePointer = vbDefault
  
392:   strReport = strReport & _
          "=========================================================\par" & vbCrLf & _
          Linkages.MyGeneralOperations.ReturnTimeElapsedRTF(theTimeBegan, Now, 7) & "}"
          
  ' SHOW REPORT
  Dim frmReportForm As New Linkages.frmReport_modal
398:   frmReportForm.txtReport.TextRTF = strReport
399:   frmReportForm.Show vbModal
  
  ' UNLOAD DIALOG
402:   Unload Me
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdOK_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub CheckOK()
  On Error GoTo ErrorHandler


  Dim booCheckOK As Boolean
414:   booCheckOK = (txtNumBins.Text <> "") And IsNumeric(txtNumBins.Text) And (lbxLayers.ListIndex > -1)
415:   cmdOK.Enabled = booCheckOK


  Exit Sub
ErrorHandler:
  HandleError False, "CheckOK " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler

426:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
  
  Dim newUid As New uID
429:   newUid.Value = "Linkages.clsExtension"
430:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  Dim ext As Linkages.clsExtension
432:   Set ext = m_ExtensionConfig
  
434:   If ext.HistogramBinCount > 0 Then
435:     txtNumBins.Text = CStr(ext.HistogramBinCount)
436:   Else
437:     txtNumBins.Text = "9"
438:     ext.HistogramBinCount = 9
439:   End If
  
441:   lbxLayers.Clear
  Dim pRasterLayer As IRasterLayer
  Dim lngIndex As Long
  Dim lngSelIndex As Long
445:   lngSelIndex = -9999
446:   For lngIndex = 0 To m_RasterLayers.Count - 1
447:     Set pRasterLayer = m_RasterLayers.Element(lngIndex)
448:     If pRasterLayer Is m_CurrentSelected Then lngSelIndex = lngIndex
449:     lbxLayers.AddItem pRasterLayer.Name
450:   Next lngIndex
     
  ' WORKSPACE
  ' FIRST SEE IF IT HAS BEEN SAVED TO EXTENSION PROPERTIES.  THIS PROPERTY WILL BE EMPTY THE FIRST TIME THE DIALOG
  '      IS OPENED, BUT EACH TIME THEREAFTER IT WILL HAVE A VALUE.
  ' IF NOT IN EXTENSION PROPERTY, THEN CHECK ArcGIS LAST SAVE TO LOCATION
  ' IF THIS DOESN'T WORK, USE MxDoc PATH NAME.
  Dim strDirPath As String
  Dim strUserName As String
  
460:   strDirPath = ext.ClipDirectoryPath
461:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
462:     strDirPath = Linkages.aml_func_mod.ReturnArcGISGeneralDir(enumLastSaveToLocation)
463:   End If
464:   If Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
465:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
466:     strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
467:   End If

469:   If Right(strDirPath, 1) <> "\" And Right(strDirPath, 1) <> "/" Then
470:     strDirPath = strDirPath & "\"
471:   End If
  
473:   txtOutput.Text = strDirPath
  
475:   Call CheckOK
  
477:   If lngSelIndex > -1 Then
478:     lbxLayers.ListIndex = lngSelIndex
479:     Call lbxLayers_Click
480:   End If

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Terminate()
  On Error GoTo ErrorHandler

490:   Set m_CurrentSelected = Nothing
491:   Set m_RasterLayers = Nothing
492:   Set m_pApp = Nothing
493:   Set m_ExtensionConfig = Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler



  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxLayers_Click()
  On Error GoTo ErrorHandler

514:   Call CheckOK

  Exit Sub
ErrorHandler:
  HandleError True, "lbxLayers_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtNumBins_Change()
  On Error GoTo ErrorHandler

524:   Call CheckOK

  Exit Sub
ErrorHandler:
  HandleError True, "txtNumBins_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub txtNumBins_KeyPress(KeyAscii As Integer)
  On Error GoTo ErrorHandler

534:   Call Linkages.MyGeneralOperations.CheckNumericRealPositive(KeyAscii, txtNumBins)

  Exit Sub
ErrorHandler:
  HandleError True, "txtNumBins_KeyPress " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
