VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmMultiListBox 
   Caption         =   " Message"
   ClientHeight    =   3165
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4275
   Icon            =   "frmMultiListBox.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3165
   ScaleWidth      =   4275
   StartUpPosition =   3  'Windows Default
   Begin RichTextLib.RichTextBox txtMessage 
      Height          =   960
      Left            =   -15
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   -15
      Width           =   4275
      _ExtentX        =   7541
      _ExtentY        =   1693
      _Version        =   393217
      Enabled         =   -1  'True
      ScrollBars      =   2
      TextRTF         =   $"frmMultiListBox.frx":038A
   End
   Begin VB.ListBox lbxList 
      Height          =   1860
      Left            =   -15
      Style           =   1  'Checkbox
      TabIndex        =   1
      Top             =   945
      Width           =   4275
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   330
      Left            =   2535
      TabIndex        =   0
      Top             =   2835
      Width           =   915
   End
   Begin VB.CommandButton cmdNo 
      Caption         =   "No"
      Height          =   330
      Left            =   2152
      TabIndex        =   3
      Top             =   2835
      Width           =   825
   End
   Begin VB.CommandButton cmdYes 
      Caption         =   "OK"
      Height          =   330
      Left            =   1297
      TabIndex        =   2
      Top             =   2835
      Width           =   825
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   4035
      Picture         =   "frmMultiListBox.frx":0415
      Top             =   2925
      Width           =   225
   End
End
Attribute VB_Name = "frmMultiListBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_pSelection As esriSystem.ILongArray
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_pExt As IExtension
Private m_pThisExt As Linkages.clsExtension
Private m_lngSelection As Long
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_lngOption As Long
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\test_graph_form\frmMultiListBox.frm"

Public Property Get SelectionArray() As esriSystem.ILongArray
  On Error GoTo ErrorHandler

16:   Set SelectionArray = m_pSelection

  Exit Property
ErrorHandler:
  HandleError True, "SelectionArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get theSelection() As Long
  On Error GoTo ErrorHandler


27:   theSelection = m_lngSelection


  Exit Property
ErrorHandler:
  HandleError True, "theSelection " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set theParameters(pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

  Dim lngOption As Long
39:   Set m_pApp = pParams.Element(0)
40:   Set m_pMxDoc = m_pApp.Document
41:   lngOption = pParams.Element(1)

  ' PRESET RESPONSE TO "CANCEL"
44:   m_lngSelection = -1
    
  Select Case lngOption
    Case 1 ' YES / NO
48:       cmdYes.Left = 1297
49:       cmdYes.Caption = "Yes"
50:       cmdNo.Left = 2152
51:       cmdNo.Visible = False
52:       cmdCancel.Left = 0
53:       cmdCancel.Visible = False
    Case 2 ' OK / CANCEL
55:       cmdYes.Left = 1252
56:       cmdYes.Caption = "OK"
57:       cmdNo.Left = 0
58:       cmdNo.Visible = False
59:       cmdCancel.Left = 2107
60:       cmdCancel.Visible = True
    Case 3 ' YES / NO / CANCEL
62:       cmdYes.Left = 825
63:       cmdYes.Caption = "Yes"
64:       cmdNo.Left = 1680
65:       cmdNo.Visible = True
66:       cmdCancel.Left = 2535
67:       cmdCancel.Visible = True
    Case 4 ' OK ONLY
69:       cmdYes.Left = 1725
70:       cmdYes.Caption = "OK"
71:       cmdNo.Left = 0
72:       cmdNo.Visible = False
73:       cmdCancel.Left = 0
74:       cmdCancel.Visible = False
75:   End Select

77:   Me.Caption = pParams.Element(2)
78:   txtMessage.TextRTF = pParams.Element(3)

  Dim pList As esriSystem.IVariantArray
81:   Set pList = pParams.Element(4)

  Dim lngIndex As Long
84:   For lngIndex = 0 To pList.Count - 1
85:     lbxList.AddItem pList.Element(lngIndex)
86:   Next lngIndex
87:   lbxList.ListIndex = -1
'  MsgBox "Option = " & CStr(lngOption) & vbCrLf & _
         "cmdYes.Visible = " & CStr(cmdYes.Visible) & vbCrLf & _
         "cmdNo.Visible = " & CStr(cmdNo.Visible) & vbCrLf & _
         "cmdCancel.Visible = " & CStr(cmdCancel.Visible)

'   cmdCancel.SetFocus
  
95:   CheckEnable

  Exit Property
ErrorHandler:
  HandleError True, "theParameters " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
 

106:   cmdYes.Enabled = lbxList.SelCount > 0
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
 
116:   m_lngSelection = -1
117:   Me.Visible = False
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdNo_Click()
  On Error GoTo ErrorHandler
 
127:   m_lngSelection = -1
128:   Me.Visible = False
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdNo_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdYes_Click()
  On Error GoTo ErrorHandler
  
138:   Set m_pSelection = New esriSystem.LongArray
  Dim lngIndex As Long
140:   For lngIndex = 0 To lbxList.ListCount - 1
141:     m_pSelection.Add lbxList.Selected(lngIndex)   ' FALSE FOR NON-SELECTED, TRUE FOR SELECTED
142:   Next lngIndex
    
144:   Me.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "cmdYes_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler

154:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
155:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
156:   Me.Top = (2 * Screen.Height / 3) - (Me.Height / 2)
 
158:   Set Anchors = New AnchorObjectList  ' Create new instance
159:   With Anchors
160:      With .Item(cmdNo)
161:         .SetAnchors enumStartsize, enumSizeEnd
162:      End With
163:      With .Item(cmdYes)
164:         .SetAnchors enumStartsize, enumSizeEnd
165:      End With
166:      With .Item(cmdCancel)
167:         .SetAnchors enumStartsize, enumSizeEnd
168:      End With
169:      With .Item(imgCornerBars)
170:         .SetAnchors enumSizeEnd, enumSizeEnd
171:      End With
172:      With .Item(txtMessage)
173:         .SetAnchors enumStartEnd, enumStartsize
174:      End With
175:      With .Item(lbxList)
176:         .SetAnchors enumStartEnd, enumStartEnd
177:      End With
178:      .Form = Me  ' Set form reference (suggested to be last step)
179:   End With

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
189:   Set m_pMxDoc = Nothing
190:   Set m_pApp = Nothing
 
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub SampleCode()
  On Error GoTo ErrorHandler
 
' FOLLOWING NEEDS TO GO IN EXTENSION
'
'Private m_pfrmSaveListBoxResponse As esrisystem.IVariantArray
'Public Property set frmSaveListBoxResponse(pSelection As esrisystem.IVariantArray)
'  Set m_pfrmSaveListBoxResponse = pSelection
'End Property
'Public Property Get frmSaveListBoxResponse() As Long
'  set frmSaveListBoxResponse = m_pfrmSaveListBoxResponse
'End Property
'
' FOLLOWING NEEDS TO GO IN EXTENSION SHUTDOWN
' Set m_pfrmSaveListBoxResponse = Nothing
'
' FOLLOWING WILL RUN THE DIALOG AND CHECK THE RESPONSE
 
'  ' NEEDS TO HAVE A REFERENCE TO THE APPLICATION
'  Dim pParams As esriSystem.IVariantArray
'  Set pParams = New esriSystem.VarArray
'
'  Dim lngOption As Long
'  ' 1 = Yes / No
'  ' 2 = OK / Cancel
'  ' 3 = Yes / No / Cancel
'  ' 4 = OK Only
'  lngOption = 2
'
'  Dim pList As esriSystem.IVariantArray
'  Set pList = New esriSystem.VarArray
'  pList.Add "Blue"
'  pList.Add "Flagstaff"
'  pList.Add "Spotted Owl"
'  pList.Add "12"
'  pList.Add "December 7, 1941"
'
'  pParams.Add m_pApp
'  pParams.Add lngOption
'  pParams.Add " Sample Caption:"                                                 ' DIALOG CAPTION
'  pParams.Add "This is a sample message that might appear in the message box."   ' MESSAGE
'  pParams.Add pList
'
'  Dim pForm As Linkages.frmSaveListBox
'  Set pForm = New Linkages.frmSaveListBox
'  Set pForm.theParameters = pParams
'  pForm.Show vbModal
'
'  Dim pExt As IExtension
'  Dim pThisExt As Linkages.cmdTestForm
'  Dim newUid As New UID
'  newUid.Value = "Linkages.cmdTestForm"
'  Set pExt = m_pApp.FindExtensionByCLSID(newUid)
'  Set pThisExt = pExt
'
'  Dim pResponse As esriSystem.IVariantArray
'  Set pResponse = pThisExt.frmSaveListBoxResponse
'
'  Dim lngResponse As Long
'  lngResponse = pResponse.Element(0)
'  ' 0 = Cancel
'  ' 1 = Yes / OK
'  ' 2 = No
'
'  Dim strResponseReport As String
'
'  strResponseReport = "List Box Response = " & CStr(lngResponse) & vbCrLf
'  If lngResponse = 1 Then
'    Dim pSubArray As esriSystem.IVariantArray
'    Set pSubArray = pResponse.Element(1)
'    strResponseReport = strResponseReport & pSubArray.Count & " list elements selected..." & vbCrLf
'    Dim lngIndex As Long
'    For lngIndex = 0 To pSubArray.Count - 1
'      strResponseReport = strResponseReport & "  " & CStr(lngIndex + 1) & "]  " & CStr(pSubArray.Element(lngIndex)) & vbCrLf
'    Next lngIndex
'  End If
'
'  MsgBox strResponseReport
 
  Exit Sub
ErrorHandler:
  HandleError False, "SampleCode " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxList_Click()
  On Error GoTo ErrorHandler
 
284:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError True, "lbxList_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 

Private Sub lbxList_DblClick()
  On Error GoTo ErrorHandler

  
296:   m_lngSelection = lbxList.ListIndex
297:   Me.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "lbxList_DblClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
