VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form frmSaveListBox 
   Caption         =   " Message"
   ClientHeight    =   3150
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4275
   Icon            =   "frmSaveListBox.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3150
   ScaleWidth      =   4275
   StartUpPosition =   3  'Windows Default
   Begin RichTextLib.RichTextBox txtMessage 
      Height          =   960
      Left            =   -15
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   -15
      Width           =   4275
      _ExtentX        =   7541
      _ExtentY        =   1693
      _Version        =   393217
      ScrollBars      =   2
      TextRTF         =   $"frmSaveListBox.frx":038A
   End
   Begin VB.ListBox lbxList 
      Height          =   1815
      Left            =   -15
      TabIndex        =   1
      Top             =   945
      Width           =   4275
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   330
      Left            =   2535
      TabIndex        =   0
      Top             =   2820
      Width           =   915
   End
   Begin VB.CommandButton cmdNo 
      Caption         =   "No"
      Height          =   330
      Left            =   2152
      TabIndex        =   3
      Top             =   2820
      Width           =   825
   End
   Begin VB.CommandButton cmdYes 
      Caption         =   "OK"
      Height          =   330
      Left            =   1297
      TabIndex        =   2
      Top             =   2820
      Width           =   825
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   4035
      Picture         =   "frmSaveListBox.frx":0415
      Top             =   2910
      Width           =   225
   End
End
Attribute VB_Name = "frmSaveListBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
 
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_pApp As IApplication
Private m_pExt As IExtension
Private m_pThisExt As Linkages.clsExtension
Private m_lngSelection As Long
Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_lngOption As Long
Const c_sModuleFileName As String = "...FORM = frmSaveListBox.frm"

Public Property Get theSelection() As Long

14:   theSelection = m_lngSelection

End Property

Public Property Set theParameters(pParams As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

  Dim lngOption As Long
22:   Set m_pApp = pParams.Element(0)
23:   Set m_pMxDoc = m_pApp.Document
24:   lngOption = pParams.Element(1)

  ' PRESET RESPONSE TO "CANCEL"
27:   m_lngSelection = -1
    
  Select Case lngOption
    Case 1 ' YES / NO
31:       cmdYes.Left = 1297
32:       cmdYes.Caption = "Yes"
33:       cmdNo.Left = 2152
34:       cmdNo.Visible = False
35:       cmdCancel.Left = 0
36:       cmdCancel.Visible = False
    Case 2 ' OK / CANCEL
38:       cmdYes.Left = 1252
39:       cmdYes.Caption = "OK"
40:       cmdNo.Left = 0
41:       cmdNo.Visible = False
42:       cmdCancel.Left = 2107
43:       cmdCancel.Visible = True
    Case 3 ' YES / NO / CANCEL
45:       cmdYes.Left = 825
46:       cmdYes.Caption = "Yes"
47:       cmdNo.Left = 1680
48:       cmdNo.Visible = True
49:       cmdCancel.Left = 2535
50:       cmdCancel.Visible = True
    Case 4 ' OK ONLY
52:       cmdYes.Left = 1725
53:       cmdYes.Caption = "OK"
54:       cmdNo.Left = 0
55:       cmdNo.Visible = False
56:       cmdCancel.Left = 0
57:       cmdCancel.Visible = False
58:   End Select

60:   Me.Caption = pParams.Element(2)
61:   txtMessage.TextRTF = pParams.Element(3)

  Dim pList As esriSystem.IVariantArray
64:   Set pList = pParams.Element(4)

  Dim lngIndex As Long
67:   For lngIndex = 0 To pList.Count - 1
68:     lbxList.AddItem pList.Element(lngIndex)
69:   Next lngIndex
70:   lbxList.ListIndex = -1
'  MsgBox "Option = " & CStr(lngOption) & vbCrLf & _
         "cmdYes.Visible = " & CStr(cmdYes.Visible) & vbCrLf & _
         "cmdNo.Visible = " & CStr(cmdNo.Visible) & vbCrLf & _
         "cmdCancel.Visible = " & CStr(cmdCancel.Visible)

'   cmdCancel.SetFocus
  
78:   CheckEnable

  Exit Property
ErrorHandler:
  HandleError True, "theParameters " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub CheckEnable()
  On Error GoTo ErrorHandler
 

89:   cmdYes.Enabled = lbxList.SelCount > 0
 
  Exit Sub
ErrorHandler:
  HandleError False, "CheckEnable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler
 
99:   m_lngSelection = -1
100:   Me.Visible = False
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdNo_Click()
  On Error GoTo ErrorHandler
 
110:   m_lngSelection = -1
111:   Me.Visible = False
 
  Exit Sub
ErrorHandler:
  HandleError True, "cmdNo_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub cmdYes_Click()
  On Error GoTo ErrorHandler

121:   m_lngSelection = lbxList.ListIndex
122:   Me.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "cmdYes_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Load()
  On Error GoTo ErrorHandler

132:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
133:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
134:   Me.Top = (2 * Screen.Height / 3) - (Me.Height / 2)
 
136:   Set Anchors = New AnchorObjectList  ' Create new instance
137:   With Anchors
138:      With .Item(cmdNo)
139:         .SetAnchors enumStartsize, enumSizeEnd
140:      End With
141:      With .Item(cmdYes)
142:         .SetAnchors enumStartsize, enumSizeEnd
143:      End With
144:      With .Item(cmdCancel)
145:         .SetAnchors enumStartsize, enumSizeEnd
146:      End With
147:      With .Item(imgCornerBars)
148:         .SetAnchors enumSizeEnd, enumSizeEnd
149:      End With
150:      With .Item(txtMessage)
151:         .SetAnchors enumStartEnd, enumStartsize
152:      End With
153:      With .Item(lbxList)
154:         .SetAnchors enumStartEnd, enumStartEnd
155:      End With
156:      .Form = Me  ' Set form reference (suggested to be last step)
157:   End With

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler
 
167:   Set m_pMxDoc = Nothing
168:   Set m_pApp = Nothing
 
  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub SampleCode()
  On Error GoTo ErrorHandler
 
' FOLLOWING NEEDS TO GO IN EXTENSION
'
'Private m_pfrmSaveListBoxResponse As esrisystem.IVariantArray
'Public Property set frmSaveListBoxResponse(pSelection As esrisystem.IVariantArray)
'  Set m_pfrmSaveListBoxResponse = pSelection
'End Property
'Public Property Get frmSaveListBoxResponse() As Long
'  set frmSaveListBoxResponse = m_pfrmSaveListBoxResponse
'End Property
'
' FOLLOWING NEEDS TO GO IN EXTENSION SHUTDOWN
' Set m_pfrmSaveListBoxResponse = Nothing
'
' FOLLOWING WILL RUN THE DIALOG AND CHECK THE RESPONSE
 
'  ' NEEDS TO HAVE A REFERENCE TO THE APPLICATION
'  Dim pParams As esriSystem.IVariantArray
'  Set pParams = New esriSystem.VarArray
'
'  Dim lngOption As Long
'  ' 1 = Yes / No
'  ' 2 = OK / Cancel
'  ' 3 = Yes / No / Cancel
'  ' 4 = OK Only
'  lngOption = 2
'
'  Dim pList As esriSystem.IVariantArray
'  Set pList = New esriSystem.VarArray
'  pList.Add "Blue"
'  pList.Add "Flagstaff"
'  pList.Add "Spotted Owl"
'  pList.Add "12"
'  pList.Add "December 7, 1941"
'
'  pParams.Add m_pApp
'  pParams.Add lngOption
'  pParams.Add " Sample Caption:"                                                 ' DIALOG CAPTION
'  pParams.Add "This is a sample message that might appear in the message box."   ' MESSAGE
'  pParams.Add pList
'
'  Dim pForm As Linkages.frmSaveListBox
'  Set pForm = New Linkages.frmSaveListBox
'  Set pForm.theParameters = pParams
'  pForm.Show vbModal
'
'  Dim pExt As IExtension
'  Dim pThisExt As Linkages.cmdTestForm
'  Dim newUid As New UID
'  newUid.Value = "Linkages.cmdTestForm"
'  Set pExt = m_pApp.FindExtensionByCLSID(newUid)
'  Set pThisExt = pExt
'
'  Dim pResponse As esriSystem.IVariantArray
'  Set pResponse = pThisExt.frmSaveListBoxResponse
'
'  Dim lngResponse As Long
'  lngResponse = pResponse.Element(0)
'  ' 0 = Cancel
'  ' 1 = Yes / OK
'  ' 2 = No
'
'  Dim strResponseReport As String
'
'  strResponseReport = "List Box Response = " & CStr(lngResponse) & vbCrLf
'  If lngResponse = 1 Then
'    Dim pSubArray As esriSystem.IVariantArray
'    Set pSubArray = pResponse.Element(1)
'    strResponseReport = strResponseReport & pSubArray.Count & " list elements selected..." & vbCrLf
'    Dim lngIndex As Long
'    For lngIndex = 0 To pSubArray.Count - 1
'      strResponseReport = strResponseReport & "  " & CStr(lngIndex + 1) & "]  " & CStr(pSubArray.Element(lngIndex)) & vbCrLf
'    Next lngIndex
'  End If
'
'  MsgBox strResponseReport
 
  Exit Sub
ErrorHandler:
  HandleError False, "SampleCode " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub lbxList_Click()
  On Error GoTo ErrorHandler
 
262:   CheckEnable
 
  Exit Sub
ErrorHandler:
  HandleError True, "lbxList_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 

Private Sub lbxList_DblClick()
  
272:   m_lngSelection = lbxList.ListIndex
273:   Me.Visible = False
End Sub
