VERSION 5.00
Begin VB.Form frmSelScreen 
   Caption         =   "Form1"
   ClientHeight    =   4410
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5715
   BeginProperty Font 
      Name            =   "Times New Roman"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmSelScreen.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   4410
   ScaleWidth      =   5715
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   4695
      TabIndex        =   5
      Top             =   955
      Width           =   945
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "Help"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   4695
      TabIndex        =   4
      Top             =   1340
      Width           =   945
   End
   Begin VB.CommandButton cmdAccept 
      Caption         =   "Accept"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   345
      Left            =   4695
      TabIndex        =   2
      Top             =   1725
      Width           =   945
   End
   Begin VB.ListBox lbxThemes 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2010
      Left            =   75
      TabIndex        =   1
      Top             =   60
      Width           =   4485
   End
   Begin VB.TextBox txtCoords 
      BackColor       =   &H8000000F&
      BeginProperty Font 
         Name            =   "Microsoft Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1755
      Left            =   195
      MultiLine       =   -1  'True
      TabIndex        =   0
      Text            =   "frmSelScreen.frx":038A
      Top             =   2250
      Width           =   4800
   End
   Begin VB.Image imgDrawDisable 
      Height          =   360
      Left            =   5145
      Picture         =   "frmSelScreen.frx":039A
      ToolTipText     =   "Draw Corridor Polygon..."
      Top             =   3255
      Width           =   360
   End
   Begin VB.Image imgDrawEnable 
      Height          =   360
      Left            =   5145
      Picture         =   "frmSelScreen.frx":0A9E
      ToolTipText     =   "Draw Corridor Polygon..."
      Top             =   3255
      Width           =   360
   End
   Begin VB.Image imgDrawClick 
      Height          =   360
      Left            =   5145
      Picture         =   "frmSelScreen.frx":11A2
      ToolTipText     =   "Draw Corridor Polygon..."
      Top             =   3255
      Width           =   360
   End
   Begin VB.Label lblLink 
      AutoSize        =   -1  'True
      Caption         =   "http://www.corridordesign.org"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   195
      Left            =   1785
      MousePointer    =   99  'Custom
      TabIndex        =   3
      Top             =   4185
      Width           =   2130
   End
   Begin VB.Image imgIcon 
      Height          =   855
      Left            =   4695
      Picture         =   "frmSelScreen.frx":18A6
      Top             =   60
      Width           =   945
   End
   Begin VB.Image imgToolDisable 
      Height          =   360
      Left            =   5145
      Picture         =   "frmSelScreen.frx":43AA
      ToolTipText     =   "Click to Select Polygon..."
      Top             =   2820
      Width           =   360
   End
   Begin VB.Image imgToolOut 
      Height          =   360
      Left            =   5145
      Picture         =   "frmSelScreen.frx":4AAE
      ToolTipText     =   "Click to Select Polygon..."
      Top             =   2820
      Width           =   360
   End
   Begin VB.Image imgToolIn 
      Height          =   360
      Left            =   5145
      Picture         =   "frmSelScreen.frx":51B2
      Top             =   2820
      Width           =   360
   End
   Begin VB.Image imgBoundaryBox 
      BorderStyle     =   1  'Fixed Single
      Height          =   2010
      Left            =   60
      Top             =   2145
      Width           =   5610
   End
End
Attribute VB_Name = "frmSelScreen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_pMxDoc As esriArcMapUI.IMxDocument
'Private m_Command As esriSystemUI.ICommand
Private m_pApp As IApplication
Private m_Frame As IModelessFrame
'Private m_WindowPos As IWindowPosition
Private m_ExtensionConfig As IExtensionConfig
Private m_SearchMessage As String
Private m_ToolEnable As Boolean
Private m_DrawToolEnable As Boolean
Private m_strNameArray() As String
Private m_intNameCount As Integer
Private m_colPolygons As Collection
Private m_PolygonPurpose As String
Private m_pPolygon As IPolygon

Const conHwndTopmost = -1
Const conHwndNoTopmost = -2
Const conSwpNoActivate = &H10
Const conSwpShowWindow = &H40
  
Private Declare Function ShellExecute Lib "shell32.dll" Alias _
           "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, _
           ByVal lpFile As String, ByVal lpParameters As String, _
           ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Private Anchors As AnchorObjectList  ' Main anchor control object

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\frmSelScreen.frm"

Public Property Set thePolygon(pPolygon As IPolygon)
  On Error GoTo ErrorHandler

35:   Set m_pPolygon = pPolygon

  Exit Property
ErrorHandler:
  HandleError True, "thePolygon " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let PolygonPurpose(strPurpose As String)
  On Error GoTo ErrorHandler

45:   m_PolygonPurpose = strPurpose

  Exit Property
ErrorHandler:
  HandleError True, "PolygonPurpose " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let NameList(strNameArray() As String)
  On Error GoTo ErrorHandler

54:   m_strNameArray = strNameArray

  Exit Property
ErrorHandler:
  HandleError True, "NameList " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Set NameCollection(colNames As Collection)
  On Error GoTo ErrorHandler

63:   Set m_colPolygons = colNames

  Exit Property
ErrorHandler:
  HandleError True, "NameCollection " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get GetNameCollection() As Collection
  On Error GoTo ErrorHandler

72:   Set GetNameCollection = m_colPolygons

  Exit Property
ErrorHandler:
  HandleError True, "GetNameCollection " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let NameCount(intNameCount As Long)
  On Error GoTo ErrorHandler

81:   m_intNameCount = intNameCount

  Exit Property
ErrorHandler:
  HandleError True, "NameCount " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let EnableTool(booEnable As Boolean)
  On Error GoTo ErrorHandler

91:   m_ToolEnable = booEnable

  Exit Property
ErrorHandler:
  HandleError True, "EnableTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Let SearchMessage(strMessage As String)
  On Error GoTo ErrorHandler


103:   m_SearchMessage = strMessage


  Exit Property
ErrorHandler:
  HandleError True, "SearchMessage " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set ArcApplication(ByVal theApplication As IApplication)
  On Error GoTo ErrorHandler

114:   Set m_pApp = theApplication

  Exit Property
ErrorHandler:
  HandleError True, "ArcApplication " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Function Frame() As IModelessFrame
  On Error GoTo ErrorHandler

123:   If m_Frame Is Nothing Then
124:     Set m_Frame = New ModelessFrame
125:     m_Frame.Create Me
'    Set m_WindowPos = m_Frame
'    MsgBox m_WindowPos.Width & "    x    " & m_WindowPos.Height
128:   End If

130:   Set Frame = m_Frame

  Exit Function
ErrorHandler:
  HandleError True, "Frame " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Property Set Doc(pDoc As esriArcMapUI.IMxDocument)
  On Error GoTo ErrorHandler

139:   Set m_pMxDoc = pDoc

  Exit Property
ErrorHandler:
  HandleError True, "Doc " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Sub cmdAccept_Click()
  On Error GoTo ErrorHandler

  
150:   If m_pPolygon Is Nothing Then
151:     MsgBox "Error identifying selected polygon!  Please click on desired polygon again and try this button one more time...", _
       vbOKOnly, "Unexpected Problem:"
    Exit Sub
154:   End If
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New uID
158:   pUID.Value = "Linkages.toolReturnCoords"
    
  Dim ext As Linkages.clsExtension
161:   Set ext = m_ExtensionConfig
162:   ext.EnableSelTool = False
163:   ext.EnableDrawTool = False
164:   ext.CorrPolygonIsDrawn = lbxThemes.ListIndex = 0
  
  Select Case m_PolygonPurpose
    Case "Wildland1", "Wildland2", "Corridor"
      Dim pStep1Form As Linkages.Jennessent_CompareParameters
169:       Set pStep1Form = ext.frmStep1
    Case "Bottleneck_Wildland1", "Bottleneck_Wildland2", "Bottleneck_Corridor"
      Dim pBottleneckForm As Linkages.frmBottleneck
172:       Set pBottleneckForm = ext.BottleneckForm
    Case "Clip"
      Dim pClipForm As Linkages.frmClip
175:       Set pClipForm = ext.frmClipForm
    Case "CrossTab"
      Dim pCrossTabForm As Linkages.frmCrosstabInput
178:       Set pCrossTabForm = ext.formCrossTabInput
179:   End Select
  
  Dim pTopoOp2 As ITopologicalOperator2
182:   Set pTopoOp2 = m_pPolygon
183:   If Not pTopoOp2.IsSimple Then pTopoOp2.Simplify
' MsgBox "Spatial Reference Name = " & (m_pPolygon.SpatialReference.Name)
  Select Case m_PolygonPurpose
    Case "Wildland1"
187:       Set ext.PolyWildland1 = m_pPolygon
188:       pStep1Form.m_lngWB1Count = 1
    Case "Wildland2"
190:       Set ext.PolyWildland2 = m_pPolygon
191:       pStep1Form.m_lngWB2Count = 1
    Case "Corridor"
193:       Set ext.PolyCorridor = m_pPolygon
194:       pStep1Form.m_lngCorrCount = 1
    Case "Bottleneck_Wildland1"
196:       Set ext.PolyWildland1 = m_pPolygon
197:       pBottleneckForm.m_lngWB1Count = 1
    Case "Bottleneck_Wildland2"
199:       Set ext.PolyWildland2 = m_pPolygon
200:       pBottleneckForm.m_lngWB2Count = 1
    Case "Bottleneck_Corridor"
202:       Set ext.PolyCorridor = m_pPolygon
203:       pBottleneckForm.m_lngCorrCount = 1
    Case "Clip"
205:       Set ext.PolyCorridor = m_pPolygon
206:       pClipForm.m_lngCorrCount = 1
    Case "CrossTab"
208:       Set ext.PolyCorridor = m_pPolygon
209:       pCrossTabForm.m_lngCorrCount = 1
210:   End Select
  
212:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
213:   Set m_pApp.CurrentTool = Nothing
  
  Dim pCommandItem As ICommandItem
216:   Set pCommandItem = pCommand
  
218:   pCommandItem.Refresh
  
220:   Set ext.aSelForm = Nothing
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
223:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
  
  ' UPDATE CALLING FORM
'  If m_PolygonPurpose = "Clip" Then
'    Call pClipForm.UpdateCheckmarks
'    Call pClipForm.EnableOKButton
'    pClipForm.Frame.Visible = True
'  ElseIf Not pStep1Form Is Nothing Then
'    Call pStep1Form.UpdateCheckmarks
'    Call pStep1Form.EnableOKButton
'  End If
 
  Select Case m_PolygonPurpose
    Case "Wildland1", "Wildland2", "Corridor"
237:       Call pStep1Form.UpdateCheckmarks
238:       Call pStep1Form.EnableOKButton
239:       pStep1Form.Frame.Visible = True
    Case "Bottleneck_Wildland1", "Bottleneck_Wildland2", "Bottleneck_Corridor"
241:       Call pBottleneckForm.UpdateCheckmarks
242:       Call pBottleneckForm.EnableOKButton
243:       pBottleneckForm.Frame.Visible = True
    Case "Clip"
245:       Call pClipForm.UpdateCheckmarks
246:       Call pClipForm.EnableOKButton
247:       pClipForm.Frame.Visible = True
    Case "CrossTab"
249:       Call pCrossTabForm.CheckCrossTabEnable
250:       pCrossTabForm.Frame.Visible = True
251:   End Select
  
253:   Unload Me

  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdAccept_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

  Dim newUid As New uID
267:   newUid.Value = "Linkages.clsExtension"
268:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  
  Dim ext As Linkages.clsExtension
271:   Set ext = m_ExtensionConfig
  
  Select Case m_PolygonPurpose
    Case "Wildland1", "Wildland2", "Corridor"
      Dim pStep1Form As Linkages.Jennessent_CompareParameters
276:       Set pStep1Form = ext.frmStep1
277:       Call pStep1Form.UpdateCheckmarks
278:       Call pStep1Form.EnableOKButton
279:       pStep1Form.Frame.Visible = True
    Case "Bottleneck_Wildland1", "Bottleneck_Wildland2", "Bottleneck_Corridor"
      Dim pBottleneckForm As Linkages.frmBottleneck
282:       Set pBottleneckForm = ext.BottleneckForm
283:       Call pBottleneckForm.UpdateCheckmarks
284:       Call pBottleneckForm.EnableOKButton
285:       pBottleneckForm.Frame.Visible = True
    Case "Clip"
      Dim pClipForm As Linkages.frmClip
288:       Set pClipForm = ext.frmClipForm
289:       Call pClipForm.UpdateCheckmarks
290:       Call pClipForm.EnableOKButton
291:       pClipForm.Frame.Visible = True
    Case "CrossTab"
      Dim pCrossTabForm As Linkages.frmCrosstabInput
294:       Set pCrossTabForm = ext.formCrossTabInput
295:       pCrossTabForm.CheckCrossTabEnable
296:       pCrossTabForm.Frame.Visible = True
297:   End Select
  
299:   Unload Me
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdHelp_Click()
  On Error GoTo ErrorHandler

  Dim strPath As String
310:   strPath = App.Path & "\help"
  
312:   Call Linkages.MyGeneralOperations.OpenDoc("Select_Tool_Subdocument.pdf", strPath)
  
  
  '  MsgBox App.Path & vbCrLf & App.EXEName & vbCrLf & App.FileDescription
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdHelp_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Initialize()
  On Error GoTo ErrorHandler

'  Set m_Command = New Linkages.toolReturnCoords


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Text1_Change()
  On Error GoTo ErrorHandler



  Exit Sub
ErrorHandler:
  HandleError False, "Text1_Change " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler

347:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
  
349:   Me.Left = (Screen.Width / 3) - (Me.Width / 2)
350:   Me.Top = (Screen.Height / 2) - (Me.Height / 2)
  
352:   If m_Frame Is Nothing Then
353:     Set m_Frame = New ModelessFrame
354:     m_Frame.Create Me
'    Set m_WindowPos = m_Frame
'    MsgBox m_WindowPos.Width & "    x    " & m_WindowPos.Height
357:   End If
  
'235:    MsgBox m_WindowPos.Width & "    x    " & m_WindowPos.Height& Vbcrlf & _
'        cmdhelp.Container & "   x   " & cmdhelp.Container.height
  ' ANCHORS FOR RESIZE FUNCTIONS
362:   Set Anchors = New AnchorObjectList  ' Create new instance
363:    With Anchors
364:       With .Item(cmdAccept)
365:          .SetAnchors enumSizeEnd, enumStartsize
'         Set .WindowPos = m_WindowPos
367:       End With
368:       With .Item(imgBoundaryBox)
369:          .SetAnchors enumStartEnd, enumSizeEnd
'         Set .WindowPos = m_WindowPos
371:       End With
372:       With .Item(cmdHelp)
373:          .SetAnchors enumSizeEnd, enumStartsize
'         Set .WindowPos = m_WindowPos
375:       End With
376:       With .Item(cmdCancel)
377:          .SetAnchors enumSizeEnd, enumStartsize
'         Set .WindowPos = m_WindowPos
379:       End With
380:       With .Item(imgIcon)
381:          .SetAnchors enumSizeEnd, enumStartsize
'         Set .WindowPos = m_WindowPos
383:       End With
384:       With .Item(imgToolDisable)
385:          .SetAnchors enumSizeEnd, enumSizeEnd
'         Set .WindowPos = m_WindowPos
387:       End With
388:       With .Item(imgToolIn)
389:          .SetAnchors enumSizeEnd, enumSizeEnd
'         Set .WindowPos = m_WindowPos
391:       End With
392:       With .Item(imgToolOut)
393:          .SetAnchors enumSizeEnd, enumSizeEnd
'         Set .WindowPos = m_WindowPos
395:       End With
396:       With .Item(imgDrawClick)
397:          .SetAnchors enumSizeEnd, enumSizeEnd
'         Set .WindowPos = m_WindowPos
399:       End With
400:       With .Item(imgDrawDisable)
401:          .SetAnchors enumSizeEnd, enumSizeEnd
'         Set .WindowPos = m_WindowPos
403:       End With
404:       With .Item(imgDrawEnable)
405:          .SetAnchors enumSizeEnd, enumSizeEnd
'         Set .WindowPos = m_WindowPos
407:       End With
408:       With .Item(lbxThemes)
409:          .SetAnchors enumStartEnd, enumStartEnd
'         Set .WindowPos = m_WindowPos
411:       End With
412:       With .Item(lblLink)
413:          .SetAnchors enumSize, enumSizeEnd
'         Set .WindowPos = m_WindowPos
415:       End With
416:       With .Item(txtCoords)
417:          .SetAnchors enumStartEnd, enumSizeEnd
'         Set .WindowPos = m_WindowPos
419:       End With
420:       .Form = Me  ' Set form reference (suggested to be last step)
421:    End With

  Dim newUid As New uID
424:   newUid.Value = "Linkages.clsExtension"
425:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  
  Dim ext As Linkages.clsExtension
428:   Set ext = m_ExtensionConfig
429:   Set ext.aSelForm = Me
  
431:   m_ToolEnable = False
  
  Dim anIndex As Integer
434:   For anIndex = 0 To m_intNameCount
435:     lbxThemes.AddItem m_strNameArray(anIndex)
436:   Next anIndex
  
  Dim strInstructions As String
439:   strInstructions = _
    "INSTRUCTIONS:" & vbCrLf & _
    "1) Select the appropriate layer from the list above." & vbCrLf & _
    "2) Enable the Polygon Selection tool by clicking the crosshair button ---->" & vbCrLf & _
    "3) Click on the map to select your " & m_SearchMessage & " polygon." & vbCrLf & _
    "4) Click 'Accept'."
  
446:   txtCoords.Text = strInstructions
447:   txtCoords.Locked = True
    
449:   lblLink.MouseIcon = LoadResPicture(102, vbResCursor)
  
451:   cmdAccept.Enabled = False
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
454:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler

'  Set m_Command = Nothing
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
469:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New uID
473:   pUID.Value = "Linkages.toolReturnCoords"
  
  Dim ext As Linkages.clsExtension
476:   Set ext = m_ExtensionConfig
477:   ext.EnableSelTool = False
478:   ext.EnableDrawTool = False
  
'  ' SET ORIGINAL FORM BACK TO VISIBLE
'  If Not ext.frmStep1 Is Nothing Then
'    Dim pForm As Linkages.Jennessent_CompareParameters
'    Set pForm = ext.frmStep1
'    pForm.Frame.Visible = True
'  End If
  
487:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
488:   Set m_pApp.CurrentTool = Nothing
  
  Dim pCommandItem As ICommandItem
491:   Set pCommandItem = pCommand
  
493:   pCommandItem.Refresh
  
495:   Set ext.aSelForm = Nothing
  
497:   Set pCommand = Nothing
498:   Set pCommandItem = Nothing
499:   Set ext = Nothing
500:   Set m_pApp = Nothing
501:   Set m_pMxDoc = Nothing
502:   Set m_Frame = Nothing
503:   Set m_ExtensionConfig = Nothing
504:   Set m_colPolygons = Nothing
505:   Set m_pPolygon = Nothing
'  Set m_WindowPos = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Sub imgDrawClick_Click()
  On Error GoTo ErrorHandler

515:   m_DrawToolEnable = False
516:   m_ToolEnable = False
517:   Call SetSelToolEnabled
    
  Dim ext As Linkages.clsExtension
520:   Set ext = m_ExtensionConfig
521:   ext.EnableSelTool = False
522:   ext.EnableDrawTool = False
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New uID
526:   pUID.Value = "Linkages.toolDrawPoly"
  
528:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
529:   Set m_pApp.CurrentTool = Nothing
  
  Dim pCommandItem As ICommandItem
532:   Set pCommandItem = pCommand
  
534:   pCommandItem.Refresh
  

  Exit Sub
ErrorHandler:
  HandleError True, "imgDrawClick_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub imgDrawEnable_Click()
  On Error GoTo ErrorHandler

545:   m_DrawToolEnable = True
546:   m_ToolEnable = False
547:   Call SetToolEnabledDraw
548:   Call ClickOnScreenDraw

  Exit Sub
ErrorHandler:
  HandleError True, "imgDrawEnable_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Sub ClickOnScreenDraw()
On Error GoTo ErrorHandler

557:   If (m_ExtensionConfig Is Nothing) Then
558:     MsgBox "Unexpected error!  'm_ExtensionConfig' set to nothing..."
    Exit Sub
560:   End If
  
  Dim ext As Linkages.clsExtension
563:   Set ext = m_ExtensionConfig
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New uID
567:   pUID.Value = "Linkages.toolDrawPoly"
  
569:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
570:   ext.EnableSelTool = False
571:   ext.EnableDrawTool = True
    
  Dim pCommandItem As ICommandItem
574:   Set pCommandItem = pCommand

576:   pCommandItem.Refresh
  
578:   Set m_pApp.CurrentTool = pCommandItem

  Exit Sub
ErrorHandler:
  HandleError False, "ClickOnScreenDraw " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub SetToolEnabledDraw()
  On Error GoTo ErrorHandler

  
'  MsgBox m_ToolEnable & vbCrLf & "Starting SetToolEnabled Function" & vbCrLf & lbxThemes.ListIndex
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
591:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
592:   cmdAccept.Enabled = False
  
594:   If (lbxThemes.ListIndex = -1) Then  ' SET DISABLED IMAGE FOR BOTH TOOLS IF NOTHING SELECTED IN LIST
595:     imgToolOut.Visible = False
596:     imgToolIn.Visible = False
597:     imgToolDisable.Visible = True
598:     imgDrawEnable.Visible = False
599:     imgDrawClick.Visible = False
600:     imgDrawDisable.Visible = True
601:   Else
602:     imgToolOut.Visible = True              ' SELECT TOOL SHOULD BE ENABLED BUT NOT CLICKED
603:     imgToolIn.Visible = False
604:     imgToolDisable.Visible = False
605:     If (lbxThemes.ListIndex = 0) Then
606:       If (m_DrawToolEnable) Then             ' IF DRAWING TOOL CAN BE ENABLED AND CLICKED, SET IT TO ENABLED
607:         imgDrawClick.Visible = True
608:         imgDrawEnable.Visible = False
609:         imgDrawDisable.Visible = False
610:       Else
611:         imgDrawClick.Visible = False
612:         imgDrawEnable.Visible = True
613:         imgDrawDisable.Visible = False
614:       End If
615:     Else
616:       imgDrawEnable.Visible = False
617:       imgDrawClick.Visible = False
618:       imgDrawDisable.Visible = True
619:     End If
620:   End If
  
622:   Me.Refresh


  Exit Sub
ErrorHandler:
  HandleError True, "SetToolEnabledDraw " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub SetSelToolEnabled()
  On Error GoTo ErrorHandler

  
'  MsgBox m_ToolEnable & vbCrLf & "Starting SetSelToolEnabled Function" & vbCrLf & lbxThemes.ListIndex
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
636:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
637:   cmdAccept.Enabled = False
  
639:   If (lbxThemes.ListIndex = -1) Then
640:     imgToolOut.Visible = False
641:     imgToolIn.Visible = False
642:     imgToolDisable.Visible = True
643:     imgDrawEnable.Visible = False
644:     imgDrawClick.Visible = False
645:     imgDrawDisable.Visible = True
646:   Else
647:     If (lbxThemes.ListIndex = 0) Then
648:       imgDrawClick.Visible = False             ' DRAW TOOL SHOULD BE ENABLED BUT NOT CLICKED, BUT ONLY IF
                                               ' FIRST ITEM IS SELECTED IN LISTBOX
650:       imgDrawEnable.Visible = True
651:       imgDrawDisable.Visible = False
652:     Else
653:       imgDrawClick.Visible = False             ' DRAW TOOL SHOULD BE ENABLED BUT NOT CLICKED, BUT ONLY IF
                                               ' FIRST ITEM IS SELECTED IN LISTBOX
655:       imgDrawEnable.Visible = False
656:       imgDrawDisable.Visible = True
      
658:     End If
659:     If (m_ToolEnable) Then
660:       imgToolOut.Visible = False
661:       imgToolIn.Visible = True
662:       imgToolDisable.Visible = False
663:     Else
664:       imgToolOut.Visible = True
665:       imgToolIn.Visible = False
666:       imgToolDisable.Visible = False
667:     End If
668:   End If
  
670:   Me.Refresh


  Exit Sub
ErrorHandler:
  HandleError True, "SetSelToolEnabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub ClickOnScreen()
On Error GoTo ErrorHandler

681:   If (m_ExtensionConfig Is Nothing) Then
682:     MsgBox "Unexpected error!  'm_ExtensionConfig' set to nothing..."
    Exit Sub
684:   End If
  
  
  Dim ext As Linkages.clsExtension
688:   Set ext = m_ExtensionConfig
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New uID
692:   pUID.Value = "Linkages.toolReturnCoords"
  
694:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
695:   ext.EnableSelTool = True
696:   ext.EnableDrawTool = False
    
  Dim pCommandItem As ICommandItem
699:   Set pCommandItem = pCommand

701:   pCommandItem.Refresh
  
703:   Set m_pApp.CurrentTool = pCommandItem

  Exit Sub
ErrorHandler:
  HandleError False, "ClickOnScreen " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub imgToolIn_Click()
  On Error GoTo ErrorHandler

713:   m_ToolEnable = False
714:   m_DrawToolEnable = False
715:   Call SetSelToolEnabled
    
  Dim ext As Linkages.clsExtension
718:   Set ext = m_ExtensionConfig
719:   ext.EnableSelTool = False
720:   ext.EnableDrawTool = False
  
  Dim pCommand As esriSystemUI.ICommand
  Dim pUID As New uID
724:   pUID.Value = "Linkages.toolReturnCoords"
  
726:   Set pCommand = m_pApp.Document.CommandBars.Find(pUID)
727:   Set m_pApp.CurrentTool = Nothing
  
  Dim pCommandItem As ICommandItem
730:   Set pCommandItem = pCommand
  
732:   pCommandItem.Refresh
  

  Exit Sub
ErrorHandler:
  HandleError True, "imgToolIn_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub imgToolOut_Click()
  On Error GoTo ErrorHandler

743:   m_ToolEnable = True
744:   m_DrawToolEnable = False
745:   Call SetSelToolEnabled
746:   Call ClickOnScreen

  Exit Sub
ErrorHandler:
  HandleError True, "imgToolOut_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub lblLink_Click()
  On Error GoTo ErrorHandler

757:   Call ShellExecute(0, vbNullString, "http://www.corridordesign.org/", vbNullString, "", 1)

  Exit Sub
ErrorHandler:
  HandleError True, "lblLink_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  On Error GoTo ErrorHandler


768:   lblLink.ForeColor = vbBlue


  Exit Sub
ErrorHandler:
  HandleError True, "Form_MouseMove " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lblLink_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  On Error GoTo ErrorHandler

779:   lblLink.ForeColor = vbRed

  Exit Sub
ErrorHandler:
  HandleError True, "lblLink_MouseMove " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub lbxThemes_Click()
  On Error GoTo ErrorHandler

789:   m_ToolEnable = False
790:   m_DrawToolEnable = False
  
  Dim strInstructions As String
  
794:   If lbxThemes.ListIndex > 0 Then
795:     strInstructions = _
      "INSTRUCTIONS:" & vbCrLf & _
      "1) Select the appropriate layer from the list above." & vbCrLf & _
      "2) Enable the Polygon Selection tool by clicking the crosshair button ---->" & vbCrLf & _
      "3) Click on the map to select your " & m_SearchMessage & " polygon." & vbCrLf & _
      "4) Click 'Accept'."
801:     Call SetSelToolEnabled
802:     Call imgToolOut_Click
803:   Else
804:       strInstructions = _
      "INSTRUCTIONS:" & vbCrLf & _
      "1) Select the appropriate layer from the list above." & vbCrLf & _
      "2) To SELECT an existing graphic, enable the Polygon Selection tool by clicking the crosshair button " & _
      "on the upper right.  Then click on the map to select your " & m_SearchMessage & " polygon." & vbCrLf & _
      "3) To DRAW a new graphic, click the Polygon Draw tool on the lower right and use it to draw your " & _
       m_SearchMessage & " polygon. " & vbCrLf & _
      "4) Click 'Accept'."
812:     Call SetSelToolEnabled
813:   End If
  
815:   txtCoords.Text = strInstructions
816:   txtCoords.Locked = True
  
'  Call SetSelToolEnabled
'  Call imgToolOut_Click

  Exit Sub
ErrorHandler:
  HandleError True, "lbxThemes_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


