VERSION 5.00
Begin VB.Form frmWidthGraph 
   AutoRedraw      =   -1  'True
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Graph"
   ClientHeight    =   6135
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   8910
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6135
   ScaleWidth      =   8910
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmWidthGraph"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

 '
 ' Visual Basic Sample Code provided by BITWISE MAGAZINE
 '
 '      http://www.bitwisemag.com
 '
 ' This code and information is provided "as is" without warranty of
 ' any kind, either expressed or implied, including but not limited
 ' to the implied warranties of merchantability and/or fitness for a
 ' particular purpose.
 '
 ' You may use and modify this code for your personal use only.
 ' You may also redistribute this code providing that
 ' a) No fee is charged
 ' b) This copyright notice is retained in the source code.
 '
 ' You may not use this code for commercial purposes
 ' without the express permission of the copyright holder
 '
 ' Copyright (c) 2006 Dermot Hogan
 '
 '
Private Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, lpPoint As Any) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function PolyBezier Lib "gdi32.dll" (ByVal hDC As Long, lppt As POINTAPI, ByVal cPoints As Long) As Long
Private Declare Function PolyBezierTo Lib "gdi32.dll" (ByVal hDC As Long, lppt As POINTAPI, ByVal cCount As Long) As Long
Private Declare Function PolyPolygon Lib "gdi32.dll" (ByVal hDC As Long, lpPoint As POINTAPI, lpPolyCounts As Long, ByVal nCount As Long) As Long
Private Declare Function RectangleX Lib "gdi32" Alias "Rectangle" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function CreateHatchBrush Lib "gdi32" (ByVal nIndex As Long, ByVal crColor As Long) As Long
Private Declare Function BeginPath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function EndPath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function StrokePath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function StrokeAndFillPath Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function ExtCreatePen Lib "gdi32" (ByVal dwPenStyle As Long, ByVal dwWidth As Long, ByRef lplb As LOGBRUSH, ByVal dwStyleCount As Long, ByVal lpStyle As Long) As Long
Private Declare Function GetLastError Lib "kernel32" () As Long
Private Const PS_GEOMETRIC = &H10000
Private Const PS_ENDCAP_FLAT = &H200
Private Const HS_BDIAGONAL = 3               '  /////
Private Const HS_CROSS = 4                   '  +++++
Private Const HS_DIAGCROSS = 5               '  xxxxx
Private Const HS_FDIAGONAL = 2               '  \\\\\
Private Const HS_HORIZONTAL = 0              '  -----
Private Const HS_SOLID = 8
Private Const PS_JOIN_BEVEL = &H1000
Private Const BS_SOLID = 0
Private Type POINTAPI
        x As Long
        y As Long
End Type
Private Type LOGBRUSH
        lbStyle As Long
        lbColor As Long
        lbHatch As Long
End Type
Private Const PS_SOLID = 0
Dim redPen As Long
Dim blueBrush As Long
Dim htchBrush As Long
Dim activeFlag As Boolean

' FROM JENNESS
Private Declare Function DrawEdge& Lib "user32" (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long)
Const pi = 3.141578
Private Const EDGE_BUMP = &H9&
Private Const EDGE_ETCHED = &H6&
Private Const EDGE_RAISED = &H5&
Private Const EDGE_SUNKEN = &HA&
Private Const PS_NULL = 5
Private m_dblVals() As Double
Dim blackPen As Long
Dim whiteBrush As Long
Dim nullPen As Long


Public Property Let graphNumbers(dblVals() As Double)
  m_dblVals = dblVals
  FillGraph
End Property

Public Sub FillGraph()

nullPen = CreatePen(PS_NULL, 0, vbBlack)
DeleteObject SelectObject(hDC, nullPen)
whiteBrush = CreateSolidBrush(vbWhite)
DeleteObject SelectObject(hDC, whiteBrush)
RectangleX hDC, 50, 50, 550, 250

Dim rc As RECT
Dim di As Long
rc.Left = 45
rc.Top = 45
rc.Right = 605
rc.Bottom = 305
di = DrawEdge(hDC, rc, EDGE_SUNKEN, BF_TOPLEFT)
di = DrawEdge(hDC, rc, EDGE_SUNKEN, BF_BOTTOMRIGHT)

Refresh

End Sub

