VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsExtension"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\Extension.cls"
Const c_requiredLicenseProductCode = esriLicenseProductCodeArcView
Private m_pApp As IApplication
Private m_AoInitialize As IAoInitialize
Private m_CorrectLicense As Boolean
Private m_SpatialAnalyst As Boolean
Private m_LicenseDescription As String
Private m_ExtensionState As esriExtensionState
Private m_ExtensionLicenseStatus As esriLicenseStatus
Private m_SelForm As Object
Private m_FormStep1 As Object
Private m_FormStep2 As Object
Private m_frmBottleneck As Object
Private m_CrossTabInputForm As Object
Private m_ClipForm As Object
Private m_EnableSelTool As Boolean
Private m_EnableDrawTool As Boolean
Private m_WildlandPolygon1 As IPolygon
Private m_WildlandPolygon2 As IPolygon
Private m_Corridor As IPolygon
Private m_booHelpToggle1 As Boolean
Private m_booUsePatchesStep1 As Boolean
Private m_pPatchLayerStep1 As IFeatureLayer
Private m_booDoAllPatchesStep1 As Boolean
Private m_pPatchAttFieldStep1 As IField
Private m_intPatchOperatorStep1 As Integer
Private m_strPatchValueStep1 As String
Private m_intPatchFieldIndexStep1 As Integer
Private m_ProgressDialogExpanded As Boolean
Private m_ProgressDialogCloseOnComplete As Boolean
Private m_PatchArray As esriSystem.IArray
Private m_ClipDirectoryPath As String
Private m_CorrPolygonIsDrawn As Boolean
Private m_lngHistogramBinCount As Long
Private m_pfrmCombineLayerIDReturn As esriSystem.IVariantArray
Private m_arcToolboxExtension As IArcToolboxExtension
Private m_booShouldContinue As Boolean
Private m_strDirPath As String
Private m_strDirType As String
Private m_booIsFeatDataset As Boolean
Private m_strFeatDatasetName As String
Private m_lngNumSaved As Long
Private m_strCumulativeCorWS As String
Private m_booCumulativeUseSelected As Boolean
Private m_lngCumulativeTransparency As Long
Private m_strCumulativeLabel As String
Private m_booZeroToNoData As Boolean
Private m_pfrmAddHistogramLayerReturn As esriSystem.IVariantArray
Private m_strEMFFolder As String
Private m_strHistTableFolder As String
Private m_strHistBinsFolder As String
Private m_strHistDefinitionFolder As String
Private m_pfrmCrosstabInputReturn As esriSystem.IVariantArray
Private m_pfrmClassDefinitionReturn As esriSystem.IVariantArray

Private m_lngPixelResolution As Long

Private m_pfrmRasterExportLayerIDReturn As esriSystem.IVariantArray
Private m_pfrmCircuitscapeLayerIDReturn As esriSystem.IVariantArray
Private m_booClipLayers As Boolean
Private m_strFolderPath As String

' BATCH BOTTLENECK
Private m_strBlock1Fields As Variant
Private m_strBlock2Fields As Variant
Private m_strCorridorFields As Variant
Private m_strPointWSFields As Variant
Private m_strPointNameFields As Variant
Private m_strSegWSFields As Variant
Private m_strSegNameFields As Variant
Private m_strThresholdDistanceFields As Variant
Private m_strBottleneckStatsFields As Variant
Private m_strSegmentStatsFields As Variant
Private m_strStatsWSFields As Variant
Private m_pfrmBatchBottleneckIDReturn As esriSystem.IVariantArray

Const c_toolboxName As String = "CorridorDesigner Arizona.tbx"
Private WithEvents DocumentEvents As MxDocument
Attribute DocumentEvents.VB_VarHelpID = -1

Implements IExtension
Implements IExtensionConfig
Implements IPersistVariant

Public Property Set frmBatchBottleneckLayerIDReturn(pfrmBatchBottleneckIDReturn As esriSystem.IVariantArray)
87:   Set m_pfrmBatchBottleneckIDReturn = pfrmBatchBottleneckIDReturn
End Property
Public Property Get frmBatchBottleneckLayerIDReturn() As esriSystem.IVariantArray
90:   Set frmBatchBottleneckLayerIDReturn = m_pfrmBatchBottleneckIDReturn
End Property

Public Property Let BatchBNStatsWSFields(strStatsWSFields As Variant)
  On Error GoTo ErrorHandler
95:   m_strStatsWSFields = strStatsWSFields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNStatsWSFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNStatsWSFields() As Variant
  On Error GoTo ErrorHandler
102:   BatchBNStatsWSFields = m_strStatsWSFields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNStatsWSFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNSegmentStatsFields(strSegmentStatsFields As Variant)
  On Error GoTo ErrorHandler
110:   m_strSegmentStatsFields = strSegmentStatsFields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNSegmentStatsFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNSegmentStatsFields() As Variant
  On Error GoTo ErrorHandler
117:   BatchBNSegmentStatsFields = m_strSegmentStatsFields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNSegmentStatsFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNBottleneckStatsFields(strBottleneckStatsFields As Variant)
  On Error GoTo ErrorHandler
125:   m_strBottleneckStatsFields = strBottleneckStatsFields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNBottleneckStatsFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNBottleneckStatsFields() As Variant
  On Error GoTo ErrorHandler
132:   BatchBNBottleneckStatsFields = m_strBottleneckStatsFields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNBottleneckStatsFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNThresholdDistanceFields(strThresholdDistanceFields As Variant)
  On Error GoTo ErrorHandler
140:   m_strThresholdDistanceFields = strThresholdDistanceFields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNThresholdDistanceFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNThresholdDistanceFields() As Variant
  On Error GoTo ErrorHandler
147:   BatchBNThresholdDistanceFields = m_strThresholdDistanceFields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNThresholdDistanceFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNSegNameFields(strSegNameFields As Variant)
  On Error GoTo ErrorHandler
155:   m_strSegNameFields = strSegNameFields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNSegWSFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNSegNameFields() As Variant
  On Error GoTo ErrorHandler
162:   BatchBNSegNameFields = m_strSegNameFields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNSegNameFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNSegWSFields(strSegWSFields As Variant)
  On Error GoTo ErrorHandler
170:   m_strSegWSFields = strSegWSFields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNSegWSFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNSegWSFields() As Variant
  On Error GoTo ErrorHandler
177:   BatchBNSegWSFields = m_strSegWSFields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNSegWSFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNPointNameFields(strPointNameFields As Variant)
  On Error GoTo ErrorHandler
185:   m_strPointNameFields = strPointNameFields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNPointWSFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNPointNameFields() As Variant
  On Error GoTo ErrorHandler
192:   BatchBNPointNameFields = m_strPointNameFields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNPointNameFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNPointWSFields(strPointWSFields As Variant)
  On Error GoTo ErrorHandler
200:   m_strPointWSFields = strPointWSFields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNPointWSFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNPointWSFields() As Variant
  On Error GoTo ErrorHandler
207:   BatchBNPointWSFields = m_strPointWSFields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNPointWSFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNCorridorFields(strCorridorFields As Variant)
  On Error GoTo ErrorHandler
215:   m_strCorridorFields = strCorridorFields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNCorridorFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNCorridorFields() As Variant
  On Error GoTo ErrorHandler
222:   BatchBNCorridorFields = m_strCorridorFields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNCorridorFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNBlock2Fields(strBlock2Fields As Variant)
  On Error GoTo ErrorHandler
230:   m_strBlock2Fields = strBlock2Fields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNBlock2Fields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNBlock2Fields() As Variant
  On Error GoTo ErrorHandler
237:   BatchBNBlock2Fields = m_strBlock2Fields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNBlock2Fields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let BatchBNBlock1Fields(strBlock1Fields As Variant)
  On Error GoTo ErrorHandler
245:   m_strBlock1Fields = strBlock1Fields
  Exit Property
ErrorHandler:
  HandleError True, "Let BatchBNBlock1Fields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get BatchBNBlock1Fields() As Variant
  On Error GoTo ErrorHandler
252:   BatchBNBlock1Fields = m_strBlock1Fields
  Exit Property
ErrorHandler:
  HandleError True, "Set BatchBNBlock1Fields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let KruskallPixelResolution(lngPixelResolution As Long)
  On Error GoTo ErrorHandler
260:   m_lngPixelResolution = lngPixelResolution
  Exit Property
ErrorHandler:
  HandleError True, "KruskallPixelResolution " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get KruskallPixelResolution() As Long
  On Error GoTo ErrorHandler
268:   KruskallPixelResolution = m_lngPixelResolution
  Exit Property
ErrorHandler:
  HandleError True, "KruskallPixelResolution " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let Folder_Export_Location(strFolderPath As String)
  On Error GoTo ErrorHandler
276:   m_strFolderPath = strFolderPath
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Export_Location " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get Folder_Export_Location() As String
  On Error GoTo ErrorHandler
284:   Folder_Export_Location = m_strFolderPath
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Export_Location " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let RasterExportClip(booShouldClipToPolygon As Boolean)
291:   m_booClipLayers = booShouldClipToPolygon
End Property
Public Property Get RasterExportClip() As Boolean
294:   RasterExportClip = m_booClipLayers
End Property

Public Property Set frmRasterExportLayerIDReturn(pfrmRasterExportLayerIDReturn As esriSystem.IVariantArray)
298:   Set m_pfrmRasterExportLayerIDReturn = pfrmRasterExportLayerIDReturn
End Property

Public Property Get frmRasterExportLayerIDReturn() As esriSystem.IVariantArray
302:   Set frmRasterExportLayerIDReturn = m_pfrmRasterExportLayerIDReturn
End Property
Public Property Set frmCircuitscapeLayerIDReturn(pfrmCircuitscapeLayerIDReturn As esriSystem.IVariantArray)
305:   Set m_pfrmCircuitscapeLayerIDReturn = pfrmCircuitscapeLayerIDReturn
End Property

Public Property Get frmCircuitscapeLayerIDReturn() As esriSystem.IVariantArray
309:   Set frmCircuitscapeLayerIDReturn = m_pfrmCircuitscapeLayerIDReturn
End Property
Public Property Get formCrossTabInput() As Object                      ' FOR frmCrossTabInput
  On Error GoTo ErrorHandler

314:   Set formCrossTabInput = m_CrossTabInputForm

  Exit Property
ErrorHandler:
  HandleError True, "formCrossTabInput " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set formCrossTabInput(ByRef frm1 As Object)            ' FOR frmCrossTabInput
  On Error GoTo ErrorHandler

324:   Set m_CrossTabInputForm = frm1

  Exit Property
ErrorHandler:
  HandleError True, "formCrossTabInput " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set frmClassDefinitionReturn(pFrmClassDefinitionReturn As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

334:   Set m_pfrmClassDefinitionReturn = pFrmClassDefinitionReturn

  Exit Property
ErrorHandler:
  HandleError True, "frmClassDefinitionReturn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get frmClassDefinitionReturn() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

344:   Set frmClassDefinitionReturn = m_pfrmClassDefinitionReturn

  Exit Property
ErrorHandler:
  HandleError True, "frmClassDefinitionReturn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set frmCrosstabInputReturn(pfrmCrosstabInputReturn As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

354:   Set m_pfrmCrosstabInputReturn = pfrmCrosstabInputReturn

  Exit Property
ErrorHandler:
  HandleError True, "frmCrosstabInputReturn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get frmCrosstabInputReturn() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

364:   Set frmCrosstabInputReturn = m_pfrmCrosstabInputReturn

  Exit Property
ErrorHandler:
  HandleError True, "frmCrosstabInputReturn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let Folder_Hist_Bins_Files(strHistBinsFiles As String)
  On Error GoTo ErrorHandler
373:   m_strHistBinsFolder = strHistBinsFiles
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Hist_Bins_Files " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get Folder_Hist_Bins_Files() As String
  On Error GoTo ErrorHandler
381:   Folder_Hist_Bins_Files = m_strHistBinsFolder
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Hist_Bins_Files " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let Folder_EMF_Files(strEMFFiles As String)
  On Error GoTo ErrorHandler
388:   m_strEMFFolder = strEMFFiles
  Exit Property
ErrorHandler:
  HandleError True, "Folder_EMF_Files " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get Folder_EMF_Files() As String
  On Error GoTo ErrorHandler
396:   Folder_EMF_Files = m_strEMFFolder
  Exit Property
ErrorHandler:
  HandleError True, "Folder_EMF_Files " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let Folder_Histogram_Def_Files(strHist_Def_Files As String)
  On Error GoTo ErrorHandler
403:   m_strHistDefinitionFolder = strHist_Def_Files
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Histogram_Def_Files " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get Folder_Histogram_Def_Files() As String
  On Error GoTo ErrorHandler
411:   Folder_Histogram_Def_Files = m_strHistDefinitionFolder
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Histogram_Def_Files " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let Folder_Histogram_Files(strHistFiles As String)
  On Error GoTo ErrorHandler
418:   m_strHistTableFolder = strHistFiles
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Histogram_Files " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get Folder_Histogram_Files() As String
  On Error GoTo ErrorHandler
426:   Folder_Histogram_Files = m_strHistTableFolder
  Exit Property
ErrorHandler:
  HandleError True, "Folder_Histogram_Files " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set frmAddHistogramLayerReturn(pfrmAddHistogramLayerReturn As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

435:   Set m_pfrmAddHistogramLayerReturn = pfrmAddHistogramLayerReturn

  Exit Property
ErrorHandler:
  HandleError True, "frmAddHistogramLayerReturn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get frmAddHistogramLayerReturn() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

445:   Set frmAddHistogramLayerReturn = m_pfrmAddHistogramLayerReturn

  Exit Property
ErrorHandler:
  HandleError True, "frmAddHistogramLayerReturn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let WS_ZeroToNoData(booZeroToNoData As Boolean)
  On Error GoTo ErrorHandler

455:   m_booZeroToNoData = booZeroToNoData

  Exit Property
ErrorHandler:
  HandleError True, "WS_ZeroToNoData " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get WS_ZeroToNoData() As Boolean
  On Error GoTo ErrorHandler

464:   WS_ZeroToNoData = m_booZeroToNoData

  Exit Property
ErrorHandler:
  HandleError True, "WS_ZeroToNoData " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let WS_CumulativeUseSelected(booUseSelected As Boolean)
  On Error GoTo ErrorHandler

474:   m_booCumulativeUseSelected = booUseSelected

  Exit Property
ErrorHandler:
  HandleError True, "WS_CumulativeUseSelected " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get WS_CumulativeUseSelected() As Boolean
  On Error GoTo ErrorHandler

483:   WS_CumulativeUseSelected = m_booCumulativeUseSelected

  Exit Property
ErrorHandler:
  HandleError True, "WS_CumulativeUseSelected " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let WS_CumulativeTransparency(lngTransparency As Long)
  On Error GoTo ErrorHandler

493:   m_lngCumulativeTransparency = lngTransparency

  Exit Property
ErrorHandler:
  HandleError True, "WS_CumulativeTransparency " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get WS_CumulativeTransparency() As Long
  On Error GoTo ErrorHandler

502:   WS_CumulativeTransparency = m_lngCumulativeTransparency

  Exit Property
ErrorHandler:
  HandleError True, "WS_CumulativeTransparency " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let WS_CumulativeLabel(strCumulativeLabel As String)
  On Error GoTo ErrorHandler

512:   m_strCumulativeLabel = strCumulativeLabel

  Exit Property
ErrorHandler:
  HandleError True, "WS_CumulativeLabel " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get WS_CumulativeLabel() As String
  On Error GoTo ErrorHandler

521:   WS_CumulativeLabel = m_strCumulativeLabel

  Exit Property
ErrorHandler:
  HandleError True, "WS_CumulativeLabel " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let WS_CumulativeCorridor(strCumulativeCorridorWS As String)
  On Error GoTo ErrorHandler

531:   m_strCumulativeCorWS = strCumulativeCorridorWS

  Exit Property
ErrorHandler:
  HandleError True, "WS_CumulativeCorridor " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get WS_CumulativeCorridor() As String
  On Error GoTo ErrorHandler

540:   WS_CumulativeCorridor = m_strCumulativeCorWS

  Exit Property
ErrorHandler:
  HandleError True, "WS_CumulativeCorridor " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get GetNumTimesSaved() As Long
  On Error GoTo ErrorHandler

550:   GetNumTimesSaved = m_lngNumSaved

  Exit Property
ErrorHandler:
  HandleError True, "GetNumTimesSaved " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let DirectoryPath(strPath As String)
  On Error GoTo ErrorHandler
558:   m_strDirPath = strPath
  Exit Property
ErrorHandler:
  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get DirectoryPath() As String
  On Error GoTo ErrorHandler
566:   DirectoryPath = m_strDirPath
  Exit Property
ErrorHandler:
  HandleError True, "DirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let FeatDatasetName(strFeatDatasetName As String)
  On Error GoTo ErrorHandler

574:   m_strFeatDatasetName = strFeatDatasetName

  Exit Property
ErrorHandler:
  HandleError True, "FeatDatasetName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get FeatDatasetName() As String
  On Error GoTo ErrorHandler

583:   FeatDatasetName = m_strFeatDatasetName

  Exit Property
ErrorHandler:
  HandleError True, "FeatDatasetName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let IsFeatureDataset(booIsFeatDataset As Boolean)
  On Error GoTo ErrorHandler

592:   m_booIsFeatDataset = booIsFeatDataset

  Exit Property
ErrorHandler:
  HandleError True, "IsFeatureDataset " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get IsFeatureDataset() As Boolean
  On Error GoTo ErrorHandler

601:   IsFeatureDataset = m_booIsFeatDataset

  Exit Property
ErrorHandler:
  HandleError True, "IsFeatureDataset " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let DirectoryType(strDirType As String)
  On Error GoTo ErrorHandler

610:   m_strDirType = strDirType

  Exit Property
ErrorHandler:
  HandleError True, "DirectoryType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get DirectoryType() As String
  On Error GoTo ErrorHandler

619:   DirectoryType = m_strDirType

  Exit Property
ErrorHandler:
  HandleError True, "DirectoryType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let ShouldContinue(booShouldContinue As Boolean)
  On Error GoTo ErrorHandler
627:   m_booShouldContinue = booShouldContinue
  Exit Property
ErrorHandler:
  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get ShouldContinue() As Boolean
  On Error GoTo ErrorHandler
635:   ShouldContinue = m_booShouldContinue
  Exit Property
ErrorHandler:
  HandleError True, "ShouldContinue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Set frmCombineLayerIDReturn(pfrmCombineLayerIDReturn As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

643:   Set m_pfrmCombineLayerIDReturn = pfrmCombineLayerIDReturn

  Exit Property
ErrorHandler:
  HandleError True, "frmCombineLayerIDReturn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get frmCombineLayerIDReturn() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

653:   Set frmCombineLayerIDReturn = m_pfrmCombineLayerIDReturn

  Exit Property
ErrorHandler:
  HandleError True, "frmCombineLayerIDReturn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let HistogramBinCount(lngBinCount As Long)
  On Error GoTo ErrorHandler

662:   Let m_lngHistogramBinCount = lngBinCount

  Exit Property
ErrorHandler:
  HandleError True, "HistogramBinCount " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get HistogramBinCount() As Long
  On Error GoTo ErrorHandler

671:   HistogramBinCount = m_lngHistogramBinCount

  Exit Property
ErrorHandler:
  HandleError True, "HistogramBinCount " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let CorrPolygonIsDrawn(booIsDrawn As Boolean)            ' FOR frmClip; FLAG TO INDICATE IF POLYGON WAS HAND-DRAWN
  On Error GoTo ErrorHandler

680:   Let m_CorrPolygonIsDrawn = booIsDrawn

  Exit Property
ErrorHandler:
  HandleError True, "CorrPolygonIsDrawn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get CorrPolygonIsDrawn() As Boolean                       ' FOR frmClip; FLAG TO INDICATE IF POLYGON WAS HAND-DRAWN
  On Error GoTo ErrorHandler

689:   CorrPolygonIsDrawn = m_CorrPolygonIsDrawn

  Exit Property
ErrorHandler:
  HandleError True, "CorrPolygonIsDrawn " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let ClipDirectoryPath(strPathName As String)            ' FOR frmClip Default Folder Path
  On Error GoTo ErrorHandler

698:   Let m_ClipDirectoryPath = strPathName

  Exit Property
ErrorHandler:
  HandleError True, "ClipDirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get ClipDirectoryPath() As String                       ' FOR frmClip Default Folder Path
  On Error GoTo ErrorHandler

707:   ClipDirectoryPath = m_ClipDirectoryPath

  Exit Property
ErrorHandler:
  HandleError True, "ClipDirectoryPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let ProgressDialogAutoClose(SetAutoClose As Boolean)    ' FOR frmJenProgressPercent
  On Error GoTo ErrorHandler

716:   Let m_ProgressDialogCloseOnComplete = SetAutoClose

  Exit Property
ErrorHandler:
  HandleError True, "ProgressDialogAutoClose " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get ProgressDialogAutoClose() As Boolean           ' FOR frmJenProgressPercent
  On Error GoTo ErrorHandler

725:   ProgressDialogAutoClose = m_ProgressDialogCloseOnComplete

  Exit Property
ErrorHandler:
  HandleError True, "ProgressDialogAutoClose " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let ProgressDialogSetExpanded(SetExpanded As Boolean)    ' FOR frmJenProgressPercent
  On Error GoTo ErrorHandler

735:   Let m_ProgressDialogExpanded = SetExpanded

  Exit Property
ErrorHandler:
  HandleError True, "ProgressDialogSetExpanded " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get ProgressDialogSetExpanded() As Boolean           ' FOR frmJenProgressPercent
  On Error GoTo ErrorHandler

744:   ProgressDialogSetExpanded = m_ProgressDialogExpanded

  Exit Property
ErrorHandler:
  HandleError True, "ProgressDialogSetExpanded " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Let PatchAttFieldIndex(intIndex As Integer)   ' FOR Jennessent_CompareParameters.cbxPatchField
  On Error GoTo ErrorHandler

753:   Let m_intPatchFieldIndexStep1 = intIndex

  Exit Property
ErrorHandler:
  HandleError True, "PatchAttFieldIndex " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get PatchAttFieldIndex() As Integer           ' FOR Jennessent_CompareParameters.cbxPatchField
  On Error GoTo ErrorHandler

762:   PatchAttFieldIndex = m_intPatchFieldIndexStep1

  Exit Property
ErrorHandler:
  HandleError True, "PatchAttFieldIndex " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let PatchAttValue(strValue As String)         ' FOR Jennessent_CompareParameters.txtValue
  On Error GoTo ErrorHandler

772:   Let m_strPatchValueStep1 = strValue

  Exit Property
ErrorHandler:
  HandleError True, "PatchAttValue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get PatchAttValue() As String                 ' FOR Jennessent_CompareParameters.txtValue
  On Error GoTo ErrorHandler

781:   PatchAttValue = m_strPatchValueStep1

  Exit Property
ErrorHandler:
  HandleError True, "PatchAttValue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let PatchOperatorIndex(intIndex As Integer)   ' FOR Jennessent_CompareParameters.cbxValue
  On Error GoTo ErrorHandler

791:   Let m_intPatchOperatorStep1 = intIndex

  Exit Property
ErrorHandler:
  HandleError True, "PatchOperatorIndex " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get PatchOperatorIndex() As Integer           ' FOR Jennessent_CompareParameters.cbxValue
  On Error GoTo ErrorHandler

800:   PatchOperatorIndex = m_intPatchOperatorStep1

  Exit Property
ErrorHandler:
  HandleError True, "PatchOperatorIndex " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set PatchField(pField As IField)              ' FOR Jennessent_CompareParameters.cbxPatchField
  On Error GoTo ErrorHandler

810:   Set m_pPatchAttFieldStep1 = pField

  Exit Property
ErrorHandler:
  HandleError True, "PatchField " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get PatchField() As IField                    ' FOR Jennessent_CompareParameters.cbxPatchField
  On Error GoTo ErrorHandler

819:   Set PatchField = m_pPatchAttFieldStep1

  Exit Property
ErrorHandler:
  HandleError True, "PatchField " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let PatchUseAll(booPatchUseAll As Boolean)    ' FOR Jennessent_CompareParameters.optUseAll, optSubSet
  On Error GoTo ErrorHandler

829:   Let m_booDoAllPatchesStep1 = booPatchUseAll
  Exit Property
ErrorHandler:
  HandleError True, "PatchUseAll " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4


End Property
Public Property Get PatchUseAll() As Boolean                  ' FOR Jennessent_CompareParameters.optUseAll, optSubSet
  On Error GoTo ErrorHandler

839:   PatchUseAll = m_booDoAllPatchesStep1
  Exit Property
ErrorHandler:
  HandleError True, "PatchUseAll " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Set PatchLayer(pFeatureLayer As IFeatureLayer) ' FOR Jennessent_CompareParameters.cbxPatchLayer
  On Error GoTo ErrorHandler

847:   Set m_pPatchLayerStep1 = pFeatureLayer

  Exit Property
ErrorHandler:
  HandleError True, "PatchLayer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get PatchLayer() As IFeatureLayer             ' FOR Jennessent_CompareParameters.cbxPatchLayer
  On Error GoTo ErrorHandler

856:   Set PatchLayer = m_pPatchLayerStep1

  Exit Property
ErrorHandler:
  HandleError True, "PatchLayer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Set PatchArray(pPatchArray As esriSystem.IArray) ' FOR Jennessent_CompareParameters.cbxPatchLayer
  On Error GoTo ErrorHandler

867:   Set m_PatchArray = pPatchArray

  Exit Property
ErrorHandler:
  HandleError True, "PatchArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get PatchArray() As esriSystem.IArray             ' FOR Jennessent_CompareParameters.cbxPatchLayer
  On Error GoTo ErrorHandler

876:   Set PatchArray = m_PatchArray

  Exit Property
ErrorHandler:
  HandleError True, "PatchArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Let PatchUse(booPatchUse As Boolean)          ' FOR Jennessent_CompareParameters.chkUsePatches
  On Error GoTo ErrorHandler

887:   Let m_booUsePatchesStep1 = booPatchUse

  Exit Property
ErrorHandler:
  HandleError True, "PatchUse " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get PatchUse() As Boolean                     ' FOR Jennessent_CompareParameters.chkUsePatches
  On Error GoTo ErrorHandler

896:   PatchUse = m_booUsePatchesStep1

  Exit Property
ErrorHandler:
  HandleError True, "PatchUse " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let HelpToggle1(booHelp As Boolean)           ' FOR Jennessent_CompareParameters.cmdHelp
  On Error GoTo ErrorHandler

906:   Let m_booHelpToggle1 = booHelp

  Exit Property
ErrorHandler:
  HandleError True, "HelpToggle1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get HelpToggle1() As Boolean                  ' FOR Jennessent_CompareParameters.cmdHelp
  On Error GoTo ErrorHandler

915:   HelpToggle1 = m_booHelpToggle1

  Exit Property
ErrorHandler:
  HandleError True, "HelpToggle1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get PolyWildland1() As IPolygon               ' FOR Jennessent_CompareParameters.imgCheckWB1, cbxHab1
  On Error GoTo ErrorHandler

925:   Set PolyWildland1 = m_WildlandPolygon1

  Exit Property
ErrorHandler:
  HandleError True, "PolyWildland1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set PolyWildland1(ByRef pPolygon As IPolygon) ' FOR Jennessent_CompareParameters.imgCheckWB1, cbxHab1
  On Error GoTo ErrorHandler

935:   Set m_WildlandPolygon1 = pPolygon

  Exit Property
ErrorHandler:
  HandleError True, "PolyWildland1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get PolyWildland2() As IPolygon               ' FOR Jennessent_CompareParameters.imgCheckWB2, cbxHab2
  On Error GoTo ErrorHandler

945:   Set PolyWildland2 = m_WildlandPolygon2

  Exit Property
ErrorHandler:
  HandleError True, "PolyWildland2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set PolyWildland2(ByRef pPolygon As IPolygon) ' FOR Jennessent_CompareParameters.imgCheckWB2, cbxHab2
  On Error GoTo ErrorHandler

955:   Set m_WildlandPolygon2 = pPolygon

  Exit Property
ErrorHandler:
  HandleError True, "PolyWildland2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get PolyCorridor() As IPolygon                ' FOR Jennessent_CompareParameters.imgCheckSpCorr, cbxCorridor
  On Error GoTo ErrorHandler

965:   Set PolyCorridor = m_Corridor

  Exit Property
ErrorHandler:
  HandleError True, "PolyCorridor " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set PolyCorridor(ByRef pPolygon As IPolygon)  ' FOR Jennessent_CompareParameters.imgCheckSpCorr, cbxCorridor
  On Error GoTo ErrorHandler
  
975:   Set m_Corridor = pPolygon

  Exit Property
ErrorHandler:
  HandleError True, "PolyCorridor " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Get aSelForm() As Object                      ' FOR frmSelScreen
  On Error GoTo ErrorHandler

986:   Set aSelForm = m_SelForm

  Exit Property
ErrorHandler:
  HandleError True, "aSelForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set aSelForm(ByRef vNewValue As Object)       ' FOR frmSelScreen
  On Error GoTo ErrorHandler

996:   Set m_SelForm = vNewValue

  Exit Property
ErrorHandler:
  HandleError True, "aSelForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get frmStep1() As Object                      ' FOR Jennessent_CompareParameters
  On Error GoTo ErrorHandler

1006:   Set frmStep1 = m_FormStep1

  Exit Property
ErrorHandler:
  HandleError True, "frmStep1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set frmStep1(ByRef frm1 As Object)            ' FOR Jennessent_CompareParameters
  On Error GoTo ErrorHandler

1016:   Set m_FormStep1 = frm1

  Exit Property
ErrorHandler:
  HandleError True, "frmStep1 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get BottleneckForm() As Object                      ' FOR frmBottleneck
  On Error GoTo ErrorHandler

1026:   Set BottleneckForm = m_frmBottleneck

  Exit Property
ErrorHandler:
  HandleError True, "BottleneckForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set BottleneckForm(ByRef frm1 As Object)            ' FOR frmBottleneck
  On Error GoTo ErrorHandler

1036:   Set m_frmBottleneck = frm1

  Exit Property
ErrorHandler:
  HandleError True, "BottleneckForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Get frmClipForm() As Object                      ' FOR frmClip
  On Error GoTo ErrorHandler

1045:   Set frmClipForm = m_ClipForm

  Exit Property
ErrorHandler:
  HandleError True, "frmClipForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set frmClipForm(ByRef frm1 As Object)            ' FOR frmClip
  On Error GoTo ErrorHandler

1055:   Set m_ClipForm = frm1

  Exit Property
ErrorHandler:
  HandleError True, "frmClipForm " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Get frmStep2() As Object                      ' FOR frmStep1
  On Error GoTo ErrorHandler

1066:   Set frmStep2 = m_FormStep2

  Exit Property
ErrorHandler:
  HandleError True, "frmStep2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Set frmStep2(ByRef frm2 As Object)            ' FOR frmStep1
  On Error GoTo ErrorHandler

1076:   Set m_FormStep2 = frm2

  Exit Property
ErrorHandler:
  HandleError True, "frmStep2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Let EnableSelTool(ShouldEnable As Boolean)    ' FOR frmSelScreen.lbxThemes and imgToolDisable, In, Out
  On Error GoTo ErrorHandler

1086:   m_EnableSelTool = ShouldEnable
  

  Exit Property
ErrorHandler:
  HandleError True, "EnableSelTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get EnableSelTool() As Boolean                ' FOR frmSelScreen.lbxThemes and imgToolDisable, In, Out
  On Error GoTo ErrorHandler

1097:   EnableSelTool = m_EnableSelTool
  

  Exit Property
ErrorHandler:
  HandleError True, "EnableSelTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property


Public Property Let EnableDrawTool(ShouldEnable As Boolean)    ' FOR frmSelScreen.lbxThemes and imgToolDisable, In, Out
  On Error GoTo ErrorHandler

1109:   m_EnableDrawTool = ShouldEnable
  
  Exit Property
ErrorHandler:
  HandleError True, "EnableDrawTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get EnableDrawTool() As Boolean                ' FOR frmSelScreen.lbxThemes and imgToolDisable, In, Out
  On Error GoTo ErrorHandler

1119:   EnableDrawTool = m_EnableDrawTool
  

  Exit Property
ErrorHandler:
  HandleError True, "EnableDrawTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get ArcApp() As IMxApplication
  On Error GoTo ErrorHandler


1131:   Set ArcApp = m_pApp
  

  Exit Property
ErrorHandler:
  HandleError True, "ArcApp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Property Get IExtension_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
1143:   IExtension_Name = "Linkages_Extension"
  
  Exit Property
ErrorHandler:
  HandleError True, "IExtension_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub IExtension_Startup(ByRef initializationData As Variant)
  On Error GoTo ErrorHandler
  
1153:   If (TypeOf initializationData Is IMxApplication) Then
1154:     Set m_pApp = initializationData
1155:     Set DocumentEvents = m_pApp.Document
    
    ' Get the current user so the commands don't have to do this...
    Dim documentInfo As IDocumentInfo
1159:     Set documentInfo = m_pApp.Document
    
1161:     Set m_AoInitialize = New AoInitialize
    
    Dim licenseStatus As esriLicenseStatus
    'First try copy protection EngineGeoDB
1165:     licenseStatus = CheckOutLicenses(esriLicenseProductCodeArcInfo)
1166:     If (licenseStatus = esriLicenseNotLicensed) Then
      'Next try Desktop ArcEditor
1168:       licenseStatus = CheckOutLicenses(esriLicenseProductCodeArcEditor)
      'For Desktop licenses we also need to consider them being unavailable
1170:       If ((licenseStatus = esriLicenseNotLicensed) Or (licenseStatus = esriLicenseUnavailable)) Then
        'Last try Desktop ArcView
1172:         licenseStatus = CheckOutLicenses(esriLicenseProductCodeArcView)
1173:       End If
1174:     End If
    
    'Take a look at the licenseStatus to see if it failed
    'Not licensed
1178:     If (licenseStatus = esriLicenseNotLicensed) Then
1179:       m_SpatialAnalyst = False
1180:       m_LicenseDescription = "You are not licensed to run this product.  You are probably missing a license for Spatial Analyst."
    'The licenses needed are currently in use
1182:     ElseIf (licenseStatus = esriLicenseUnavailable) Then
1183:       m_SpatialAnalyst = False
1184:       m_LicenseDescription = "There are insufficient licenses to run..."
    'The licenses unexpected license failure
1186:     ElseIf (licenseStatus = esriLicenseFailure) Then
1187:       m_SpatialAnalyst = False
1188:       m_LicenseDescription = "Unexpected license failure!  Please contact your administrator..."
    'Already initialized (Initialization can only occur once)
1190:     ElseIf (licenseStatus = esriLicenseAlreadyInitialized) Then
1191:       m_SpatialAnalyst = True
1192:       m_LicenseDescription = "Licenses checked out successfully..."
    'Everything was checkedout successfully
1194:     ElseIf (licenseStatus = esriLicenseCheckedOut) Then
1195:       m_SpatialAnalyst = True
1196:       m_LicenseDescription = "Licenses checked out successfully..."
1197:     End If
    
1199:     m_EnableSelTool = False
1200:     m_EnableDrawTool = False
    
1202:     If m_strDirPath = "" Or m_strDirType = "" Then
1203:       m_strDirType = "Shapefile"
1204:       m_strDirPath = ""
1205:       m_booIsFeatDataset = False
1206:       m_strFeatDatasetName = ""
1207:     End If
    
1209:   End If
  
  ' Find the toolboxextension
  Dim uID As New uID
1213:   uID.Value = "{BD6262BC-D9D4-4B93-87E0-E442702D93E6}"
1214:   Set m_arcToolboxExtension = m_pApp.FindExtensionByCLSID(uID)
  
  Exit Sub
ErrorHandler:
  HandleError True, "IExtension_Startup " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 Private Function CheckOutLicenses(productCode As esriLicenseProductCode) As esriLicenseStatus
  On Error GoTo ErrorHandler

  
  Dim licenseStatus As esriLicenseStatus
1225:   Set m_AoInitialize = New AoInitialize
1226:   CheckOutLicenses = esriLicenseUnavailable
    
  'Check the productCode
1229:   licenseStatus = m_AoInitialize.IsProductCodeAvailable(productCode)
1230:   If (licenseStatus = esriLicenseAvailable) Then
    'Check the extensionCode
1232:     licenseStatus = m_AoInitialize.IsExtensionCodeAvailable(productCode, esriLicenseExtensionCodeSpatialAnalyst)
1233:     If (licenseStatus = esriLicenseAvailable) Then
      'Initialize the license
1235:       licenseStatus = m_AoInitialize.Initialize(productCode)
1236:       If (licenseStatus = esriLicenseCheckedOut) Then
          'Checkout the extension
1238:         licenseStatus = m_AoInitialize.CheckOutExtension(esriLicenseExtensionCodeSpatialAnalyst)
1239:       End If
1240:     End If
1241:   End If
  
1243:   CheckOutLicenses = licenseStatus
  

  Exit Function
ErrorHandler:
  HandleError False, "CheckOutLicenses " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Private Sub IExtension_Shutdown()
  On Error GoTo ErrorHandler
  
1253:   Set m_pApp = Nothing
1254:   Set DocumentEvents = Nothing
1255:   m_AoInitialize.CheckInExtension (esriLicenseExtensionCodeSpatialAnalyst)
1256:   Set m_WildlandPolygon1 = Nothing
1257:   Set m_WildlandPolygon2 = Nothing
1258:   Set m_Corridor = Nothing
1259:   Set m_SelForm = Nothing
1260:   Set m_FormStep1 = Nothing
1261:   Set m_FormStep2 = Nothing
1262:   Set m_pPatchLayerStep1 = Nothing
1263:   Set m_pPatchAttFieldStep1 = Nothing
1264:   Set m_arcToolboxExtension = Nothing
1265:   Set m_AoInitialize = Nothing
1266:   Set m_PatchArray = Nothing
1267:   Set m_pfrmCombineLayerIDReturn = Nothing
1268:   Set m_CrossTabInputForm = Nothing
1269:   Set m_pfrmCrosstabInputReturn = Nothing
1270:   Set m_pfrmClassDefinitionReturn = Nothing
  
1272:   Set m_pfrmRasterExportLayerIDReturn = Nothing
1273:   Set m_pfrmCircuitscapeLayerIDReturn = Nothing

'MsgBox "Shutting down..."
  Exit Sub
ErrorHandler:
  HandleError True, "IExtension_Shutdown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Property Get IExtensionConfig_ProductName() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
1285:   IExtensionConfig_ProductName = "Corridor Designer Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "IExtensionConfig_ProductName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get IExtensionConfig_Description() As String
  On Error GoTo ErrorHandler
  
  If (m_pApp Is Nothing) Then Exit Property
  
1297:   IExtensionConfig_Description = "Corridor Designer Tools   " & _
    "2006-2014" & vbCrLf & _
    "ArcGIS Tools and Information for Designing Wildlife Corridors" & vbCrLf & _
    "Visit us at http://www.corridordesign.org/" & vbCrLf & vbCrLf & _
    "Requires Spatial Analyst  [License is " & IIf(m_SpatialAnalyst, "available]", _
    "not available]") & vbCrLf & m_LicenseDescription & vbCrLf
    
  
  Exit Property
ErrorHandler:
  HandleError True, "IExtensionConfig_Description " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get IExtensionConfig_State() As esriSystem.esriExtensionState
  On Error GoTo ErrorHandler
  
1313:   IExtensionConfig_State = m_ExtensionState
1314:   If (Not m_SpatialAnalyst) Then
1315:     IExtensionConfig_State = esriESUnavailable
1316:   End If
  
  ' for Lara Nunes, nunes.lara@gmail.com; November 11, 2013
'  IExtensionConfig_State = esriESEnabled
  
  Exit Property
ErrorHandler:
  HandleError True, "IExtensionConfig_State " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Function CheckIfToolboxLoaded(ToolboxName As String) As Boolean
  On Error GoTo ErrorHandler
  Dim arcToolbox As IArcToolbox
1329:   Set arcToolbox = m_arcToolboxExtension.arcToolbox
  
  Dim booToolboxLoaded As Boolean
  Dim pGPTool As IGPTool
1333:   Set pGPTool = arcToolbox.GetToolbyNameString(ToolboxName)
1334:   booToolboxLoaded = (Not pGPTool Is Nothing)
    
1336:   CheckIfToolboxLoaded = booToolboxLoaded
  Exit Function
ErrorHandler:
1339:   CheckIfToolboxLoaded = False

End Function

Private Property Let IExtensionConfig_State(ByVal ExtensionState As esriSystem.esriExtensionState)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
1347:   m_ExtensionState = ExtensionState
  
'  Dim arcToolbox As IArcToolbox
'  Set arcToolbox = m_arcToolboxExtension.arcToolbox
''  MsgBox App.Path & vbCrLf & "ArcToolbox is nothing? " & CStr(arcToolbox Is Nothing)
'
' Dim ToolboxIsLoaded As Boolean
' ToolboxIsLoaded = CheckIfToolboxLoaded("CorridorModelAZ")
'
'' MsgBox "Toolbox loaded? " & CStr(ToolboxIsLoaded)
'
'
'  Dim DLLPath As String
'  DLLPath = App.Path
'
'  Dim gpToolbox As IGPToolbox
'
''    MsgBox "About to test code..."
''    Dim strName As String
''    strName = c_toolboxName
''    Dim pTestTool As IGPToolbox
''    MsgBox "About to query toolbox"
''    Set pTestTool = arcToolbox.GetToolbyNameString(strName)
''    MsgBox pTestTool.Alias
''    MsgBox "Done testing code..."
''    MsgBox "About to test code..." & vbCrLf & "Extension Enabled = " & CStr(m_ExtensionState = esriESEnabled)
'
'  If (m_ExtensionState = esriESEnabled) Then   ' LOAD TOOLBOX IF ENABLED
'       Set gpToolbox = FindToolBox(DLLPath, c_toolboxName)
'
''       MsgBox "Hello" & vbCrLf & c_toolboxName
''       MsgBox "Is Corridor Designer toolbox nothing?  " & CStr(gpToolbox Is Nothing)
'
'       If (gpToolbox Is Nothing) Then
''           Set gpToolbox = CreateToolBox(DLLPath, c_toolboxName, c_toolboxName)
'         MsgBox "Was not able to find the Corridor Designer toolbox (CorridorDesigner Arizona.tbx) in the " & _
'            "following folder:" & vbCrLf & vbCrLf & "  -->  " & DLLPath & vbCrLf & vbCrLf & "The toolbox " & _
'            "must be located in this folder in order to be automatically loaded..." & vbCrLf & vbCrLf & _
'            "If your version is lost or corrupted, please visit http://www.corridordesign.org to " & _
'            "download the latest version.", vbInformation, _
'            "Caution - CorridorDesigner Toolbox is not available:"
'
'       Else
'         arcToolbox.AddToolbox gpToolbox
'         arcToolbox.Refresh
'       End If
'
'   Else  ' UNLOAD TOOLBOX IF EXTENSION UNLOADED
'       Set gpToolbox = FindToolBox(DLLPath, c_toolboxName)
'  '       MsgBox "Hello; in Unload Toolbox routine..." & vbCrLf & c_toolboxName
'
'       If (Not gpToolbox Is Nothing) Then
'       ' THIS SEEMS TO CRASH IF GPTOOLBOX IS NOT LOADED
'       ' THERE DOES NOT SEEM TO BE A WAY TO EASILY CHECK IF A TOOLBOX IS LOADED
'       ' HOWEVER, THERE IT DOES NOT SEEM TO LOAD IT TWICE, SO WE CAN FIRST LOAD IT THEN UNLOAD IT...
'       '
'       ' BACK OFF; SEEMS THAT THIS FUNCTION CRASHES ArcGIS IF THE TOOLBOX IS NOT MANUALLY OPENED BEFORE TURNING OFF EXTENSION
''         MsgBox "About to add duplicate version of toolbox..."
''         arcToolbox.AddToolbox gpToolbox
''         arcToolbox.Refresh
'         If ToolboxIsLoaded Then
''           MsgBox "Refreshing the toolbox..."
''           arcToolbox.Refresh
''           MsgBox "Try to open dockable window"
''           Dim pDocWin As IDockableWindow
''           Set pDocWin = arcToolbox.hWnd
''           MsgBox "About to remove toolbox..."
''           arcToolbox.RemoveToolbox gpToolbox
' '          arcToolbox.Refresh
'         End If
'       End If
'   End If

  '  Dim strToolName As String
  '  strToolName = "CorridorModelAZ"
    
    
    

  'MsgBox "FINISHED: --> GPToolboxExtension_IExtensionConfig_State"
  Exit Property
ErrorHandler:
  HandleError True, "IExtensionConfig_State " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 Public Function FindToolBox(sTBLocation As String, sTBName As String) As IGPToolbox
  On Error GoTo ErrorHandler

  
    'MsgBox "GPToolboxExtension_FindToolBox"
'  MsgBox sTBLocation & vbCrLf & sTBName
  
  ' CHECK IF ANY TOOLBOX FILES EXIST IN FOLDER
  Dim intCount As Integer
  Dim fileCollection As Collection
1441:   Set fileCollection = Linkages.aml_func_mod.ReturnFiles(sTBLocation, "*.tbx", True)
1442:   intCount = fileCollection.Item(1)
  
'  MsgBox "Looking for " & sTBName & " in " & sTBLocation & ":" & vbCrLf & _
    "  --> Found " & CStr(intCount) & " toolbox files..."
  
  ' FOR DEBUGGING
'  Dim theReport As String
'  theReport = CStr(intCount) & " toolbox files (*.tbx)" & vbCrLf
'  Dim strArray() As String
'  strArray = fileCollection.Item(2)
'    Dim anIndex As Integer
'  For anIndex = LBound(strArray) To UBound(strArray)
'    theReport = theReport & "  --> " & strArray(anIndex)
'  Next anIndex
'  MsgBox theReport
  
1458:   If intCount = 0 Then
1459:     Set FindToolBox = Nothing
    Exit Function
1461:   End If
  
  'Create a toolbox workspace factory
  Dim ToolboxWorkspaceFactory As IWorkspaceFactory
1465:   Set ToolboxWorkspaceFactory = New esriGeoprocessing.ToolboxWorkspaceFactory
  
  'Open a toolbox workspace
  Dim ToolboxWorkspace As IToolboxWorkspace
1469:   Set ToolboxWorkspace = ToolboxWorkspaceFactory.OpenFromFile(sTBLocation, 0)
  
  Dim enumTB As IEnumGPToolbox
1472:   Set enumTB = ToolboxWorkspace.Toolboxes
1473:   enumTB.Reset
  
  Dim gpOutToolbox As IGPToolbox
1476:   Set gpOutToolbox = Nothing
  
  Dim gpToolbox As IGPToolbox
1479:   Set gpToolbox = enumTB.Next
  
1481:   Do Until gpToolbox Is Nothing
'    MsgBox gpToolbox.Alias & vbCrLf & gpToolbox.PathName & vbCrLf & InStr(1, gpToolbox.PathName, sTBName, vbTextCompare)
1483:     If InStr(1, gpToolbox.PathName, sTBName, vbTextCompare) > 0 Then
'    If (gpToolbox.Alias = sTBName) Then
1485:             Set gpOutToolbox = gpToolbox
1486:     End If
1487:     Set gpToolbox = enumTB.Next
1488:   Loop
  
1490:   Set FindToolBox = gpOutToolbox
  
'  MsgBox "FINISHED: --> GPToolboxExtension_FindToolBox" & vbCrLf & "Found Toolbox = " & CStr(Not gpOutToolbox Is Nothing) & _
      vbCrLf & "Is IGPToolbox?  " & CStr(TypeOf gpOutToolbox Is IGPToolbox)


  Exit Function
ErrorHandler:
  HandleError True, "FindToolBox " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Private Function FindTool(gpToolbox As IGPToolbox, sFunctionName As String) As IGPTool
  On Error GoTo ErrorHandler

    'MsgBox "GPToolboxExtension_FindTool"
  Dim gpTool As IGPTool
  Dim gpOutTool As IGPTool
  
  Dim enumGPTool As IEnumGPTool
1509:   Set enumGPTool = gpToolbox.Tools
  
1511:   enumGPTool.Reset
1512:   Set gpTool = enumGPTool.Next

1514:   Do While Not gpTool Is Nothing
1515:     If (gpTool.Name = sFunctionName) Then
1516:      Set gpOutTool = gpTool
1517:    End If
1518:         Set gpTool = enumGPTool.Next
1519:    Loop
  
1521:   Set FindTool = gpOutTool
    'MsgBox "FINISHED: --> GPToolboxExtension_FindTool"

  Exit Function
ErrorHandler:
  HandleError False, "FindTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

End Function

Private Property Get IPersistVariant_ID() As esriSystem.IUID
  On Error GoTo ErrorHandler
  
  Dim newUid As New uID
1534:   newUid.Value = "Linkages.clsExtension"
  
1536:   Set IPersistVariant_ID = newUid
  
  Exit Property
ErrorHandler:
  HandleError True, "IPersistVariant_ID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub IPersistVariant_Load(ByVal Stream As esriSystem.IVariantStream)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
1547:   m_ProgressDialogCloseOnComplete = Stream.Read
1548:   m_ProgressDialogExpanded = Stream.Read
1549:   m_strDirPath = Stream.Read
1550:   m_strDirType = Stream.Read
1551:   m_lngNumSaved = Stream.Read
1552:   m_strCumulativeCorWS = Stream.Read
1553:   m_booCumulativeUseSelected = Stream.Read
1554:   m_lngCumulativeTransparency = Stream.Read
1555:   m_strCumulativeLabel = Stream.Read
1556:   m_booZeroToNoData = Stream.Read
1557:   m_strEMFFolder = Stream.Read
1558:   m_strHistTableFolder = Stream.Read
1559:   m_strHistDefinitionFolder = Stream.Read
1560:   m_strHistBinsFolder = Stream.Read
1561:   m_booClipLayers = Stream.Read
1562:   m_strFolderPath = Stream.Read
  
1564:   m_lngPixelResolution = Stream.Read
  
1566:   m_strBlock1Fields = ConvertVariantToVariantStringArray(Stream.Read)
1567:   m_strBlock2Fields = ConvertVariantToVariantStringArray(Stream.Read)
1568:   m_strCorridorFields = ConvertVariantToVariantStringArray(Stream.Read)
1569:   m_strPointWSFields = ConvertVariantToVariantStringArray(Stream.Read)
1570:   m_strPointNameFields = ConvertVariantToVariantStringArray(Stream.Read)
1571:   m_strSegWSFields = ConvertVariantToVariantStringArray(Stream.Read)
1572:   m_strSegNameFields = ConvertVariantToVariantStringArray(Stream.Read)
1573:   m_strThresholdDistanceFields = ConvertVariantToVariantStringArray(Stream.Read)
    
1575:   m_strBottleneckStatsFields = ConvertVariantToVariantStringArray(Stream.Read)
1576:   m_strSegmentStatsFields = ConvertVariantToVariantStringArray(Stream.Read)
1577:   m_strStatsWSFields = ConvertVariantToVariantStringArray(Stream.Read)
  
  ' SET BATCH BOTTLENECK VARIABLES IF NULL
  Dim strNames() As String
1581:   If IsNull(m_strBlock1Fields) Then
    ReDim strNames(1)
1583:     strNames(0) = "Wildland_Block_1"
1584:     strNames(1) = "WB1"
1585:     m_strBlock1Fields = strNames
1586:   End If
  
1588:   If IsNull(m_strBlock2Fields) Then
    ReDim strNames(1)
1590:     strNames(0) = "Wildland_Block_2"
1591:     strNames(1) = "WB2"
1592:     m_strBlock2Fields = strNames
1593:   End If
  
1595:   If IsNull(m_strCorridorFields) Then
    ReDim strNames(1)
1597:     strNames(0) = "Corridor"
1598:     strNames(1) = "Corr"
1599:     m_strCorridorFields = strNames
1600:   End If
  
1602:   If IsNull(m_strPointWSFields) Then
    ReDim strNames(1)
1604:     strNames(0) = "Output_Point_Workspace"
1605:     strNames(1) = "Out_PWS"
1606:     m_strPointWSFields = strNames
1607:   End If
  
1609:   If IsNull(m_strPointNameFields) Then
    ReDim strNames(1)
1611:     strNames(0) = "Output_Point_FClass_Name"
1612:     strNames(1) = "Out_PFCls"
1613:     m_strPointNameFields = strNames
1614:   End If
  
1616:   If IsNull(m_strSegWSFields) Then
    ReDim strNames(1)
1618:     strNames(0) = "Output_Segment_Workspace"
1619:     strNames(1) = "Out_SWS"
1620:     m_strSegWSFields = strNames
1621:   End If
  
1623:   If IsNull(m_strSegNameFields) Then
    ReDim strNames(1)
1625:     strNames(0) = "Output_Segment_FClass_Name"
1626:     strNames(1) = "Out_SFCls"
1627:     m_strSegNameFields = strNames
1628:   End If
  
1630:   If IsNull(m_strThresholdDistanceFields) Then
    ReDim strNames(1)
1632:     strNames(0) = "Threshold_Distance"
1633:     strNames(1) = "Threshold"
1634:     m_strThresholdDistanceFields = strNames
1635:   End If
  
1637:   If IsNull(m_strBottleneckStatsFields) Then
    ReDim strNames(1)
1639:     strNames(0) = "Bottleneck_Stats_Name"
1640:     strNames(1) = "Stat_Btl"
1641:     m_strBottleneckStatsFields = strNames
1642:   End If
  
1644:   If IsNull(m_strSegmentStatsFields) Then
    ReDim strNames(1)
1646:     strNames(0) = "Segment_Stats_Name"
1647:     strNames(1) = "Stat_Seg"
1648:     m_strSegmentStatsFields = strNames
1649:   End If
  
1651:   If IsNull(m_strStatsWSFields) Then
    ReDim strNames(1)
1653:     strNames(0) = "Stats_Workspace"
1654:     strNames(1) = "Stat_WS"
1655:     m_strStatsWSFields = strNames
1656:   End If
  
  
  Exit Sub
ErrorHandler:
  HandleError True, "IPersistVariant_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub IPersistVariant_Save(ByVal Stream As esriSystem.IVariantStream)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
1668:   Stream.Write m_ProgressDialogCloseOnComplete
1669:   Stream.Write m_ProgressDialogExpanded
1670:   Stream.Write m_strDirPath
1671:   Stream.Write m_strDirType
1672:   Stream.Write m_lngNumSaved + 1
1673:   Stream.Write m_strCumulativeCorWS
1674:   Stream.Write m_booCumulativeUseSelected
1675:   Stream.Write m_lngCumulativeTransparency
1676:   Stream.Write m_strCumulativeLabel
1677:   Stream.Write m_booZeroToNoData
1678:   Stream.Write m_strEMFFolder
1679:   Stream.Write m_strHistTableFolder
1680:   Stream.Write m_strHistDefinitionFolder
1681:   Stream.Write m_strHistBinsFolder
  
1683:   Stream.Write m_booClipLayers
1684:   Stream.Write m_strFolderPath
  
1686:   Stream.Write m_lngPixelResolution
  
  
1689:   Stream.Write ConvertVariantStringArrayToString(m_strBlock1Fields)
1690:   Stream.Write ConvertVariantStringArrayToString(m_strBlock2Fields)
1691:   Stream.Write ConvertVariantStringArrayToString(m_strCorridorFields)
1692:   Stream.Write ConvertVariantStringArrayToString(m_strPointWSFields)
1693:   Stream.Write ConvertVariantStringArrayToString(m_strPointNameFields)
1694:   Stream.Write ConvertVariantStringArrayToString(m_strSegWSFields)
1695:   Stream.Write ConvertVariantStringArrayToString(m_strSegNameFields)
1696:   Stream.Write ConvertVariantStringArrayToString(m_strThresholdDistanceFields)
  
1698:   Stream.Write ConvertVariantStringArrayToString(m_strBottleneckStatsFields)
1699:   Stream.Write ConvertVariantStringArrayToString(m_strSegmentStatsFields)
1700:   Stream.Write ConvertVariantStringArrayToString(m_strStatsWSFields)
  
  Exit Sub
ErrorHandler:
  HandleError True, "IPersistVariant_Save " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function ConvertVariantStringArrayToString(varValue As Variant) As String
  Dim lngIndex As Long
  Dim strVals() As String
1710:   If IsEmpty(varValue) Or IsNull(varValue) Then
1711:     ConvertVariantStringArrayToString = ""
1712:   Else
1713:     strVals = varValue
1714:     ConvertVariantStringArrayToString = ""
1715:     For lngIndex = 0 To UBound(strVals)
1716:       ConvertVariantStringArrayToString = ConvertVariantStringArrayToString & strVals(lngIndex) & "@#$%"
1717:     Next lngIndex
1718:     ConvertVariantStringArrayToString = Left(ConvertVariantStringArrayToString, Len(ConvertVariantStringArrayToString) - 4)
1719:   End If
   
End Function
Public Function ConvertVariantToVariantStringArray(varValue As Variant) As Variant

  Dim lngIndex As Long
  Dim strSplit() As String
  Dim strValue As String
  
1728:   If IsNull(varValue) Or IsEmpty(varValue) Then
1729:     ConvertVariantToVariantStringArray = Null
1730:   Else
1731:     strValue = CStr(varValue)
1732:     If strValue = "" Then
1733:       ConvertVariantToVariantStringArray = Null
1734:     Else
1735:       strSplit = Split(strValue, "@#$%")
1736:       ConvertVariantToVariantStringArray = strSplit
1737:     End If
1738:   End If
  
End Function
