VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCrossTab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_bitmap As IPictureDisp
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_ExtensionConfig As IExtensionConfig
Private m_pThisExt As Linkages.clsExtension

Implements ICommand
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\clsCrossTab.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

16:   Set m_bitmap = LoadResPicture(119, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

26:   Set m_bitmap = Nothing
27:   Set m_pApp = Nothing
28:   Set m_pThisExt = Nothing
29:   Set m_ExtensionConfig = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler

  ' TODO: Add your implementation here
40:   If (Not m_ExtensionConfig Is Nothing) Then
41:     If (m_ExtensionConfig.State = esriESEnabled) Then
42:       ICommand_Enabled = True
43:     End If
44:   Else
45:     ICommand_Enabled = False
46:   End If

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
58:    ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
71:   ICommand_Name = "CorridorDesigner_CrossTabs"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
84:   ICommand_Caption = "CrossTab Statistics"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
97:   ICommand_Tooltip = "CrossTab Statistics"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
110:   ICommand_Message = "Generate cross-tabulation table..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
123:   ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
136:   ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
149:   ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
162:   ICommand_Category = "Corridor Designer Tools"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler


174:   Set m_pApp = hook
175:   Set m_pMxDoc = m_pApp.Document
  Dim newUid As New uID
  Dim pExt As IExtension
178:   newUid.Value = "Linkages.clsExtension"
179:   Set pExt = m_pApp.FindExtensionByCLSID(newUid)
180:   Set m_pThisExt = pExt
181:   Set m_ExtensionConfig = pExt

  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler

  
'  MsgBox "First Line of Code; Click Event about to start (Step 1)..."  ' ************************************************************
'
'  Dim anIndex As Long
'
'  Dim pSpatialReferenceFactory2 As ISpatialReferenceFactory2
'  Set pSpatialReferenceFactory2 = New SpatialReferenceEnvironment ' The file test.prj contains a spatial reference in its WKT aka string representation.
'  Dim pSpRef As ISpatialReference
'  Set pSpRef = pSpatialReferenceFactory2.CreateSpatialReference(esriSRProjCS_NAD1983UTM_12N)
'
'  Dim dblLength As Double
'  dblLength = 17000
'
'  Dim pDataArray As esriSystem.IVariantArray
'  Set pDataArray = MakeData
'
'  Dim dblVal() As Double
'  ReDim dblVal(700, 1)
'  Randomize
'
'  For anIndex = 0 To 700
'    dblVal(anIndex, 0) = (anIndex / 700) * dblLength
'    dblVal(anIndex, 1) = (anIndex + (Rnd * 55) - 22) / 1000
'  Next anIndex
'
''  For anIndex = 0 To 700
''    Debug.Print CStr(anIndex) & "]  X = " & CStr(dblval(anIndex, 0)) & ",   Y = " & CStr(dblval(anIndex, 1))
''  Next anIndex
'
'  Dim frmGraph As frmWidthGraph
'  Set frmGraph = New frmWidthGraph
'
'  Set frmGraph.ArcApplication = m_App
'  Set frmGraph.SpatReference = pSpRef
''  frmGraph.GraphNumbers = dblVal
'  Set frmGraph.GraphNumbers = pDataArray
'  frmGraph.Frame.Visible = True
  
' JUST FOR DEBUGGING MODE; REMOVE FOR ACTUAL TOOL
'Dim pAoInitialize As IAoInitialize
'Set pAoInitialize = New AoInitialize
'Dim licenseStatus As esriLicenseStatus
'Dim productCode As esriLicenseProductCode
'productCode = esriLicenseProductCodeArcView
'licenseStatus = pAoInitialize.Initialize(productCode)

'  Randomize
'  Dim pArray As esriSystem.IVariantArray
'  Set pArray = New esriSystem.VarArray
'  Dim dblPair(2) As Double
'
'  Dim lngIndex As Long
'  Dim dblVal As Double
'  Randomize
'  Dim dblVal2 As Double
'  Dim dblCount As Double
'
'  For lngIndex = 1 To 1000
'    'dblVal = Int((1500 * Rnd) + 1)
'   linkages.MyGeneralOperations.MakeRandomNormalPolar 750, 150, dblVal
'   linkages.MyGeneralOperations.MakeRandomNormalPolar 750, 130, dblVal2
'   linkages.MyGeneralOperations.MakeRandomNormalPolar 10, 2, dblCount
'
'
'    dblPair(0) = dblVal
'    dblPair(1) = dblVal2
'    dblPair(2) = dblCount
'    pArray.Add dblPair
'  Next lngIndex
'
'  Dim pIntroData As esriSystem.IVariantArray
'  Set pIntroData = New esriSystem.VarArray
'  pIntroData.Add m_pApp
'  pIntroData.Add m_pMxDoc
'  pIntroData.Add m_pThisExt
'  pIntroData.Add pArray
'  pIntroData.Add " Cross-Tabulation Table:"
'  pIntroData.Add "First Variable"
'  pIntroData.Add "Variable #2"
'
'  Dim frmCrosstab As linkages.frmCrosstab
'  Set frmCrosstab = New linkages.frmCrosstab
'
''  MsgBox "About to set Intro Data"
'  Set frmCrosstab.IntroData = pIntroData
'  frmCrosstab.Show vbModal
'
  
  ' CLOSE EXISTING OPEN DIALOGS
  Dim pFormCrosstabInput As Linkages.frmCrosstabInput
282:   If Not m_pThisExt.formCrossTabInput Is Nothing Then
283:     Set pFormCrosstabInput = m_pThisExt.formCrossTabInput
284:     Unload pFormCrosstabInput
285:     Set m_pThisExt.formCrossTabInput = Nothing
286:   End If
  Dim pFormSelect As Linkages.frmSelScreen
288:   If Not m_pThisExt.aSelForm Is Nothing Then
289:     Set pFormSelect = m_pThisExt.aSelForm
290:     Unload pFormSelect
291:     Set m_pThisExt.aSelForm = Nothing
292:   End If


  Dim pVarArray As esriSystem.IVariantArray
296:   Set pVarArray = New VarArray

  ' ADD APPLICATION
299:   pVarArray.Add m_pApp

  'EXTENSION SHOULD HAVE PROPERTIES FOR "ShouldContinue", "DirectoryPath", "frmCrosstabInputReturn",
  '     "DirectoryType", "IsFeatureDataset", "FeatDatasetName"
303:   pVarArray.Add m_pThisExt
304:   pVarArray.Add m_pMxDoc

'  Dim pForm As linkages.frmCrosstabInput
'  Set pForm = New linkages.frmCrosstabInput
'  Set pForm.ArcApplication = pVarArray
  
'  pForm.Show vbModal
'  Set pForm = Nothing
'
'  If m_pThisExt.ShouldContinue = False Then
'    MsgBox "Function Canceled:" & vbCrLf & "Bailing out..."
'    Exit Sub
'  End If
'
'  Dim pReturnArray As esrisystem.IVariantArray
'  Set pReturnArray = m_pThisExt.frmCrosstabInputReturn
  
  ' MAKE NEW CROSSTAB INPUT FORM
322:   Set pFormCrosstabInput = New Linkages.frmCrosstabInput
323:   Set m_pThisExt.formCrossTabInput = pFormCrosstabInput
324:   Set pFormCrosstabInput.ArcApplication = pVarArray
  
326:   Load pFormCrosstabInput
327:   pFormCrosstabInput.Frame.Caption = " Cross Tabulation Table Input Data:"
328:   pFormCrosstabInput.Frame.Visible = True
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub




