VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdCompare"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_ExtensionConfig As IExtensionConfig

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\cmdCompare.cls"
Implements ICommand
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler


14:   Set m_bitmap = LoadResPicture(114, vbResBitmap)



  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler


27:   Set m_bitmap = Nothing
28:   Set m_pApp = Nothing
29:   Set m_pMxDoc = Nothing
30:   Set m_ExtensionConfig = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
40:   If (Not m_ExtensionConfig Is Nothing) Then
41:     If (m_ExtensionConfig.State = esriESEnabled) Then
42:       ICommand_Enabled = True
43:     End If
44:   Else
45:     ICommand_Enabled = False
46:   End If
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
57:   ICommand_Checked = False
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
68:   ICommand_Name = "CorridorDesigner_PatchStats"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
79:   ICommand_Caption = "Calculate Patch Distance Statistics"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
90:   ICommand_Tooltip = "Patch Distance Statistics"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
101:   ICommand_Message = "Calculate Patch Distance Statistics"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
112:   ICommand_HelpFile = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
123:   ICommand_HelpContextID = 0
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
134:   ICommand_Bitmap = m_bitmap.Handle
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
145:   ICommand_Category = "Corridor Designer Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here

157:   Set m_pApp = hook
158:   Set m_pMxDoc = m_pApp.Document
  
  Dim newUid As New uID
161:   newUid.Value = "Linkages.clsExtension"
162:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  
' 153:   SetWindowLong m_frm1.hwnd, GWL_HWNDPARENT, m_pApp.hwnd
'  m_frm1.Frame
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
'  MsgBox "<-- Code in development -->" & vbCrLf & _
'         "Please check http://www.corridordesign.org for updates...", , "Function Not Implemented Yet:"
'  Exit Sub
  
  Dim frmStep1 As Jennessent_CompareParameters
  Dim frmSelect As Linkages.frmSelScreen
  
  ' CLOSE EXISTING OPEN DIALOGS
  Dim ext As Linkages.clsExtension
186:   Set ext = m_ExtensionConfig
187:   If Not ext.frmStep1 Is Nothing Then
188:     Set frmStep1 = ext.frmStep1
189:     Unload frmStep1
190:     Set ext.frmStep1 = Nothing
191:   End If
192:   If Not ext.aSelForm Is Nothing Then
193:     Set frmSelect = ext.aSelForm
194:     Unload frmSelect
195:     Set ext.aSelForm = Nothing
196:   End If
  
  ' MAKE NEW STEP 1 FORM
199:   Set frmStep1 = New Jennessent_CompareParameters
200:   Set ext.frmStep1 = frmStep1
201:   Set frmStep1.ArcApplication = m_pApp
202:   Set frmStep1.Doc = m_pMxDoc
203:   Load frmStep1
204:   frmStep1.Frame.Caption = "Describe Patch-to-Patch Distances:"
205:   frmStep1.Frame.Visible = True
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
