VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdOpenTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_currentUser As String
Private m_element As IElement
Private m_bitmap As IPictureDisp

Implements ICommand
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\cmdOpenTable.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

16:   Set m_bitmap = LoadResPicture(112, vbResBitmap)
  

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

27:   Set m_bitmap = Nothing
28:   Set m_element = Nothing
29:   Set m_pApp = Nothing
30:   Set m_pMxDoc = Nothing
  

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler

  Dim pDoc As IMxDocument
  Dim bolEnabled As Boolean
43:   Set pDoc = m_pMxDoc
44:   bolEnabled = True       ' DEFAULT TO TRUE

  Dim pCV As IContentsView
47:   Set pCV = pDoc.CurrentContentsView

  Dim pSelItem As IUnknown
50:   Set pSelItem = pDoc.SelectedItem

  ' Disable if the selected item is nothing or if
  ' it is not a layer or table
54:   If pSelItem Is Nothing Then
55:     bolEnabled = False
56:   ElseIf Not ((pCV.Name = "Display") Or (pCV.Name = "Source")) Then
57:     bolEnabled = False
58:   ElseIf Not (TypeOf pSelItem Is IFeatureLayer Or TypeOf pSelItem Is IStandaloneTable Or TypeOf pSelItem Is ISet Or _
      TypeOf pSelItem Is IRasterLayer) Then
60:     bolEnabled = False
61:   Else

63:     If TypeOf pSelItem Is IRasterLayer Then
      Dim pRasterLayer As IRasterLayer
65:       Set pRasterLayer = pSelItem

67:       If Not pRasterLayer.Valid Then
68:         bolEnabled = False
69:       Else
        Dim pRaster As IRaster
        Dim pRasterBand As IRasterBand
        Dim pRasterBandCollection As IRasterBandCollection

74:         Set pRaster = pRasterLayer.Raster
75:         Set pRasterBandCollection = pRaster
76:         Set pRasterBand = pRasterBandCollection.Item(0)
77:         pRasterBand.HasTable bolEnabled
78:       End If
79:     End If
80:   End If

82:   ICommand_Enabled = bolEnabled
'  ICommand_Enabled = True
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
95:   ICommand_Checked = False
  

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
108:   ICommand_Name = "CorridorDesigner_OpenTableTool"
  

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
121:   ICommand_Caption = "Open Table"
  

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
134:   ICommand_Tooltip = "Open Attribute Table"
  

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
147:   ICommand_Message = "Open attribute tables for all currently selected themes..."
  

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
160:   ICommand_HelpFile = ""
  

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
173:   ICommand_HelpContextID = 0
  

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
186:   ICommand_Bitmap = m_bitmap.Handle
  

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
199:   ICommand_Category = "Corridor Designer Tools"
  

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
212:   Set m_pApp = hook
213:   Set m_pMxDoc = m_pApp.Document
  
  

  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler

  ' ADAPTED FROM OpenFeatureLayerTable.bas
    
  Dim pMxDoc As IMxDocument
228:   Set pMxDoc = m_pMxDoc
  Dim pMap As IMap
230:   Set pMap = pMxDoc.FocusMap
  
  Dim pCV As IContentsView
233:   Set pCV = pMxDoc.CurrentContentsView
  
 ' Debug.Print pCV.Name & ": Visible = " & pCV.Visible & vbCrLf & pCatView.Name & ": Visible = " & pCatView.Visible
  
  Dim theSelectedLayers As Variant
  
239:   Set theSelectedLayers = pMxDoc.SelectedItem
  
'  If ((TypeOf pCV Is TOCCatalogView) Or (TypeOf pCV Is TOCDisplayView)) And ((TypeOf pCV.SelectedItem Is ISet) Or
242:   If ((pCV.Name = "Source") Or (pCV.Name = "Display")) And ((TypeOf pCV.SelectedItem Is ISet) Or _
      (TypeOf pCV.SelectedItem Is IFeatureLayer) Or (TypeOf pCV.SelectedItem Is IStandaloneTable) Or _
      (TypeOf pCV.SelectedItem Is IRasterLayer)) Then
245:     Set theSelectedLayers = pCV.SelectedItem
246:   Else
    Exit Sub
248:   End If
  
  Dim pLayer As IFeatureLayer
  Dim pFeatureLayer As IFeatureLayer           ' JUST TO CHECK VALIDITY
  Dim pTable As ITableWindow
  Dim pTable2 As ITableWindow
  Dim pTableWindow As ITableWindow
  Dim pRasterTable As ITable
  
  Dim pRasterLayer As IRasterLayer
  Dim pRaster As IRaster
  Dim pRasterBand As IRasterBand
  Dim pRasterBandCollection As IRasterBandCollection
  Dim pRasterDataset As IRasterDataset
  Dim booHasTable As Boolean
  
  Dim pTableWindow2 As ITableWindow2           ' NEED #2 TO FIND OPEN STANDALONE TABLES
  Dim pStandaloneTable As IStandaloneTable
  Dim pExistingTableWindow As ITableWindow     ' FindViaStandaloneTable RETURNS A ITableWindow

268:   If TypeOf theSelectedLayers Is IFeatureLayer Then
269:     Set pFeatureLayer = theSelectedLayers
270:     If pFeatureLayer.Valid = False Then
271:       MsgBox "There is something wrong with " & pFeatureLayer.Name & "!  It is not a valid " & _
          "layer.  Unable to open table...", vbInformation, "Problem with Data:"
      Exit Sub
274:     End If
    
    'Debug.Print theSelectedLayers.Type
277:     Set pLayer = theSelectedLayers
    
279:     Set pTable = New TableWindow
    
    ' CHECK IF TABLE IS ALREADY OPEN
282:     Set pTable = pTable.FindViaFeatureLayer(pLayer, False)
    
284:     If pTable Is Nothing Then
      'Associate the table and a feature layer
286:       Set pTable2 = New TableWindow
287:       With pTable2
288:         Set .FeatureLayer = pLayer
289:         Set .Application = m_pApp
290:         .TableSelectionAction = esriSelectFeatures
291:         .ShowAliasNamesInColumnHeadings = True
292:         .Show True
293:       End With
294:     Else
295:       pTable.Show True
296:     End If
      
    'Debug.Print pLayer.Name
    
300:   ElseIf TypeOf theSelectedLayers Is IStandaloneTable Then
301:     Set pStandaloneTable = theSelectedLayers
302:     If pStandaloneTable.Valid = False Then
303:       MsgBox "There is something wrong with " & pStandaloneTable.Name & "!  It is not a valid " & _
          "table.  Unable to open table...", vbInformation, "Problem with Data:"
      Exit Sub
306:     End If
    
308:     Set pTableWindow2 = New TableWindow
309:     Set pExistingTableWindow = pTableWindow2.FindViaStandaloneTable(pStandaloneTable)
    
    ' Check if a table already exists; if not, create one
312:     If pExistingTableWindow Is Nothing Then

314:       With pTableWindow2
315:         Set .StandaloneTable = pStandaloneTable
316:         Set .Application = m_pApp
317:         .TableSelectionAction = esriSelectFeatures
318:         .ShowAliasNamesInColumnHeadings = True
319:         .ShowSelected = False
320:         .Show True
        
322:       End With
      
324:     Else
325:       pExistingTableWindow.Show True
326:     End If

328:   ElseIf TypeOf theSelectedLayers Is IRasterLayer Then        ' IF RASTER LAYER
    
330:     Set pRasterLayer = theSelectedLayers
    
'    MsgBox "Is Raster layer..."
    
334:     If Not pRasterLayer.Valid Then
335:       MsgBox "There is something wrong with " & pRasterLayer.Name & "!  It is not a valid " & _
          "dataset.  Unable to open table...", vbInformation, "Problem with Data:"
      Exit Sub
338:     End If
339:     Set pRaster = pRasterLayer.Raster
340:     Set pRasterBandCollection = pRaster
341:     Set pRasterBand = pRasterBandCollection.Item(0)
342:     Set pRasterDataset = pRasterBand.RasterDataset
343:     pRasterBand.HasTable booHasTable
    
345:     If booHasTable Then                    ' USE VAT TABLE FIELDS
      
'      MsgBox "Has Table..."
348:       Set pRasterTable = pRasterBand.AttributeTable
349:       Set pTableWindow = New TableWindow
      
      ' CHECK IF TABLE IS ALREADY OPEN
352:       Set pTableWindow = pTableWindow.FindViaTable(pRasterTable, False)
      
354:       If pTableWindow Is Nothing Then
        'Associate the table and the raster layer
356:         Set pTableWindow = New TableWindow
357:         With pTableWindow
358:           Set .Table = pRasterTable
359:           Set .Application = m_pApp
360:           .TableSelectionAction = esriSelectFeatures
361:           .ShowAliasNamesInColumnHeadings = True
362:           .Show True
363:         End With
364:       Else
365:         pTableWindow.Show True
366:       End If
367:     End If


370:   ElseIf TypeOf theSelectedLayers Is ISet Then
  
    Dim pSelSet As ISet
373:     Set pSelSet = theSelectedLayers
    
375:     If (pSelSet.Count = 0) Then
      Exit Sub
377:     End If
    
    ' ROTATE THROUGH SELECTED TABLES AND FEATURE LAYERS, IN RANDOM ORDER PROVIDED BY ISet INTERFACE
    ' WITH TESTING, IT APPEARS THAT SELECTING MULTIPLE TABLES CAUSES A "NOTHING" OBJECT RATHER THAN A SET, DESPITE
    ' WHAT THE DOCUMENTATION CLAIMS WILL HAPPEN.  THEREFORE THERE WILL NEVER BE MULTIPLE TABLES SELECTED.
    
383:     pSelSet.Reset
    Dim pUnknownLayer As Variant
385:     Set pUnknownLayer = pSelSet.Next
    
387:     Do Until pUnknownLayer Is Nothing
    
389:       If TypeOf pUnknownLayer Is IFeatureLayer Then
390:         Set pFeatureLayer = pUnknownLayer
391:         If pFeatureLayer.Valid = False Then
392:           MsgBox "There is something wrong with " & pFeatureLayer.Name & "!  It is not a valid " & _
              "layer.  Unable to open table...", vbInformation, "Problem with Data:"
          Exit Sub
395:         End If
    
        'Debug.Print theSelectedLayers.Type
        
399:         Set pLayer = pUnknownLayer
        
    '    Dim pTable As ITableWindow
402:         Set pTable = New TableWindow
        
        ' CHECK IF TABLE IS ALREADY OPEN
405:         Set pTable = pTable.FindViaFeatureLayer(pLayer, False)
        
407:         If pTable Is Nothing Then
          'Associate the table and a feature layer
409:           Set pTable2 = New TableWindow
410:           With pTable2
411:             Set .FeatureLayer = pLayer
412:             Set .Application = m_pApp
413:             .TableSelectionAction = esriSelectFeatures
414:             .ShowAliasNamesInColumnHeadings = True
415:             .Show True
416:           End With
417:         Else
418:           pTable.Show True
419:         End If
          
        'Debug.Print pLayer.Name
        
423:       ElseIf TypeOf pUnknownLayer Is IStandaloneTable Then
424:         Set pStandaloneTable = pUnknownLayer
425:         If pStandaloneTable.Valid = False Then
426:           MsgBox "There is something wrong with " & pStandaloneTable.Name & "!  It is not a valid " & _
              "table.  Unable to open table...", vbInformation, "Problem with Data:"
          Exit Sub
429:         End If
    
        ' A standalone table
432:         Set pTableWindow2 = New TableWindow
433:         Set pExistingTableWindow = pTableWindow2.FindViaStandaloneTable(pStandaloneTable)
        
        ' Check if a table already exists; if not, create one
436:         If pExistingTableWindow Is Nothing Then
    
438:           With pTableWindow2
439:             Set .StandaloneTable = pStandaloneTable
440:             Set .Application = m_pApp
441:             .TableSelectionAction = esriSelectFeatures
442:             .ShowAliasNamesInColumnHeadings = True
443:             .ShowSelected = False
444:             .Show True
            
446:           End With
          
448:         Else
449:           pExistingTableWindow.Show True
450:         End If
      
452:       ElseIf TypeOf pUnknownLayer Is IRasterLayer Then        ' IF RASTER LAYER
        
454:         Set pRasterLayer = pUnknownLayer
        
456:         If Not pRasterLayer.Valid Then
457:           MsgBox "There is something wrong with " & pRasterLayer.Name & "!  It is not a valid " & _
              "dataset.  Unable to open table...", vbInformation, "Problem with Data:"
          Exit Sub
460:         End If
461:         Set pRaster = pRasterLayer.Raster
462:         Set pRasterBandCollection = pRaster
463:         Set pRasterBand = pRasterBandCollection.Item(0)
464:         Set pRasterDataset = pRasterBand.RasterDataset
465:         pRasterBand.HasTable booHasTable
        
467:         If booHasTable Then                    ' USE VAT TABLE FIELDS
          
469:           Set pRasterTable = pRasterBand.AttributeTable
470:           Set pTableWindow = New TableWindow
    
          ' CHECK IF TABLE IS ALREADY OPEN
473:           Set pTableWindow = pTableWindow.FindViaTable(pRasterTable, False)
          
475:           If pTableWindow Is Nothing Then
            'Associate the table and the raster layer
477:             Set pTableWindow = New TableWindow
478:             With pTableWindow
479:               Set .Table = pRasterTable
480:               Set .Application = m_pApp
481:               .TableSelectionAction = esriSelectFeatures
482:               .ShowAliasNamesInColumnHeadings = True
483:               .Show True
484:             End With
485:           Else
486:             pTableWindow.Show True
487:           End If
488:         End If
      
490:       End If
      
492:       Set pUnknownLayer = pSelSet.Next
      
494:     Loop

496:   End If
    
  'Debug.Print ""  ' new line
  
  Exit Sub
  
ErrorHandler:
503:   MsgBox "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl) & vbCrLf & _
    err.Number & vbCrLf & err.Source & vbCrLf & err.Description
End Sub



