VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdSumMod"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_ExtensionConfig As IExtensionConfig

Implements ICommand
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\cmdSumMod.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler


16:   Set m_bitmap = LoadResPicture(107, vbResBitmap)


  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

27:   Set m_pApp = Nothing
28:   Set m_bitmap = Nothing
29:   Set m_pMxDoc = Nothing
30:   Set m_ExtensionConfig = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler

  Dim booShouldEnable As Boolean
  
42:   If (Not m_ExtensionConfig Is Nothing) Then
43:     If (m_ExtensionConfig.State = esriESEnabled) Then
44:       booShouldEnable = True
45:     End If
46:   Else
47:     booShouldEnable = False
48:   End If
  
50:   If booShouldEnable Then
  
  ' USE THE CODE BELOW TO ALWAYS ENABLE BUTTON
    Dim pEnumLayer As IEnumLayer
    Dim pFeatureLayer As IFeatureLayer
    Dim pRasterLayer As IRasterLayer
    
57:     booShouldEnable = False
    Dim pUID As New uID
59:     pUID.Value = "{E156D7E5-22AF-11D3-9F99-00C04F6BC78E}"   ' ALL DATA LAYERS
    
    On Error Resume Next
62:     Set pEnumLayer = m_pMxDoc.FocusMap.Layers(Nothing, True)
    On Error GoTo ErrorHandler
    
65:     If Not pEnumLayer Is Nothing Then
66:       pEnumLayer.Reset
      Dim pLayer As ILayer
      
      ' CHECK FOR FEATURE AND RASTER LAYERS
70:       Set pLayer = pEnumLayer.Next
71:       Do While Not pLayer Is Nothing
72:         If pLayer.Valid = True Then
  '        MsgBox "Examining " & pLayer.Name
74:           If TypeOf pLayer Is IFeatureLayer Or TypeOf pLayer Is IRasterLayer Then
75:             booShouldEnable = True
  '          MsgBox pLayer.Name & " --> Should enable = " & booShouldEnable
77:             Exit Do
78:           End If
79:         End If
80:         Set pLayer = pEnumLayer.Next
81:       Loop
82:     End If
  
    ' CHECK FOR STANDALONE TABLES
85:     If Not booShouldEnable Then
      Dim pStTabCol As IStandaloneTableCollection
87:       Set pStTabCol = m_pMxDoc.FocusMap
      
89:       If pStTabCol.StandaloneTableCount > 0 Then
        Dim pStandaloneTable As IStandaloneTable
        
        Dim anIndex As Long
93:         For anIndex = 0 To (pStTabCol.StandaloneTableCount - 1)
94:           Set pStandaloneTable = pStTabCol.StandaloneTable(anIndex)
95:           If pStandaloneTable.Valid Then
96:             booShouldEnable = True
97:             Exit For
98:           End If
99:         Next anIndex
100:       End If
101:     End If
102:   End If
103:   ICommand_Enabled = booShouldEnable

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
115:    ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
128:   ICommand_Name = "CorridorDesigner_CorridorSummarize"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
141:   ICommand_Caption = "Corridor Summarize"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
154:   ICommand_Tooltip = "Summary Statistics"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
167:   ICommand_Message = "Generate general summary statistics on tables, feature layers and grids..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
180:   ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
193:   ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
206:   ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
219:   ICommand_Category = "Corridor Designer Tools"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler


231:   Set m_pApp = hook
232:   Set m_pMxDoc = m_pApp.Document
  Dim newUid As New uID
234:   newUid.Value = "Linkages.clsExtension"
235:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)


  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  
'  MsgBox "First Line of Code; Click Event about to start (Step 1)..."  ' ************************************************************
  
  On Error GoTo ErrorHandler
 
  Dim pSelItem As IUnknown
250:   Set pSelItem = m_pMxDoc.SelectedItem
  Dim pFeatureLayer As IFeatureLayer
  Dim pLayer As ILayer
  Dim pStandaloneTable As IStandaloneTable
'  Dim pTableFields As ITableFields
  Dim pTableFields As IUnknown
  Dim pRasterLayer As IRasterLayer
  
  ' MAKE COLLECTION OF VALID FEATURE/RASTER LAYERS AND STANDALONE TABLES
  Dim colLayerCol As Collection
  Dim pEnumLayer As IEnumLayer
  Dim pStTabColl As IStandaloneTableCollection
262:   Set pStTabColl = m_pMxDoc.FocusMap
  
'  MsgBox "Finished dimensioning Variables (Step 2)..."  ' ************************************************************
  
  If (m_pMxDoc.FocusMap.LayerCount = 0) And (pStTabColl.StandaloneTableCount = 0) Then Exit Sub
  
'  Dim pUID As New uID
'  pUID.Value = "{E156D7E5-22AF-11D3-9F99-00C04F6BC78E}"
'
'  On Error Resume Next
'  Set pEnumLayer = pMxDoc.FocusMap.Layers(pUID, True)
  
274:   Set pEnumLayer = m_pMxDoc.FocusMap.Layers(, True)
275:   pEnumLayer.Reset
276:   Set pLayer = pEnumLayer.Next
  
'  MsgBox "Step 3"  ' ************************************************************
  
  Dim anIndex As Long
  Dim intIndex As Long
282:   intIndex = -1
  
  ' MAKE COLLECTION OF VALID FEATURE AND RASTER LAYERS
285:   Set colLayerCol = New Collection
286:   Do While Not pLayer Is Nothing
287:     If pLayer.Valid = True Then
288:       If TypeOf pLayer Is IFeatureLayer Or TypeOf pLayer Is IRasterLayer Then
289:         intIndex = intIndex + 1
290:         colLayerCol.Add pLayer, CStr(intIndex)
291:       End If
292:     End If
293:     Set pLayer = pEnumLayer.Next
294:   Loop

'  MsgBox "Step 5"  ' ************************************************************

298:   For anIndex = 0 To pStTabColl.StandaloneTableCount - 1
299:     Set pStandaloneTable = pStTabColl.StandaloneTable(anIndex)
300:     If pStandaloneTable.Valid = True Then
301:       intIndex = intIndex + 1
302:       colLayerCol.Add pStandaloneTable, CStr(intIndex)
303:     End If
304:   Next anIndex
  
'  MsgBox "Step 6"  ' ************************************************************
  
  ' PRESELECT ACTIVE LAYER OR TABLE IF ANY SINGLE LAYER/TABLE IS ACTIVE
309:   If pSelItem Is Nothing Then
310:     Set pTableFields = Nothing
311:   ElseIf TypeOf pSelItem Is IFeatureLayer Then
312:     Set pFeatureLayer = pSelItem
313:     If pFeatureLayer.Valid = True Then
314:       Set pTableFields = pFeatureLayer
315:     End If
  
317:   ElseIf TypeOf pSelItem Is IStandaloneTable Then
318:     Set pStandaloneTable = pSelItem
319:     If pStandaloneTable.Valid = True Then
320:       Set pTableFields = pStandaloneTable
321:     End If
322:   ElseIf TypeOf pSelItem Is IRasterLayer Then
323:     Set pRasterLayer = pSelItem
324:     If pRasterLayer.Valid Then
325:       Set pTableFields = pRasterLayer
326:     End If
  
328:   Else
329:     Set pTableFields = Nothing
330:     Set pSelItem = Nothing
331:   End If
  
'  MsgBox "Step 7"  ' ************************************************************
  
'  Dim strReport As String
'  For anIndex = 1 To colLayerCol.Count
'    strReport = "Layer #" & CStr(anIndex) & " is Nothing = " & CStr(colLayerCol.Item(anIndex) Is Nothing)
'  Next anIndex
'  MsgBox strReport

  Dim pSumForm As frm_Summarize
342:   Set pSumForm = New frm_Summarize
  
'  MsgBox "Step 8"  ' ************************************************************
  
346:   Set pSumForm.theTableLayers = colLayerCol
  
'  MsgBox "Step 9"  ' ************************************************************
  
350:   Set pSumForm.Field_Array = pTableFields
'  MsgBox "Step 10"  ' ************************************************************
  
353:   Set pSumForm.theCurrentSelected = pSelItem
 ' MsgBox "Step 11"  ' ************************************************************
  
356:   Set pSumForm.ArcApp = m_pApp
'  MsgBox "Step 12"  ' ************************************************************
'  MsgBox "Before Show"
  
360:   pSumForm.Show vbModal
  
'  MsgBox "After Show"
363:   Set pSumForm = Nothing
  
'  MsgBox "After Nothing"
'  Dim pSumUI As ISummarizeUI
'  Set pSumUI = New SummarizeUI
'  Set pSumUI.Application = m_pApp
'  Set pSumUI.SummarizeTable = pSelItem
'  Set pSumUI.SummarizeField = pField
'  pSumUI.SummarizeOnSelectedOnly = True
'  pSumUI.DoModal m_pApp.hWnd


  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub




