VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmExportEMLLocation 
   Caption         =   " Export to EMF:"
   ClientHeight    =   1140
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6855
   Icon            =   "frmExportEMLLocation.frx":0000
   LinkTopic       =   "Form2"
   LockControls    =   -1  'True
   ScaleHeight     =   1140
   ScaleWidth      =   6855
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   300
      Left            =   4020
      TabIndex        =   3
      Top             =   825
      Width           =   825
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   75
      Top             =   795
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "OK"
      Height          =   300
      Left            =   5775
      TabIndex        =   5
      Top             =   825
      Width           =   825
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   300
      Left            =   4905
      TabIndex        =   4
      Top             =   825
      Width           =   825
   End
   Begin VB.CommandButton cmdGetLocation 
      Height          =   360
      Left            =   6255
      Picture         =   "frmExportEMLLocation.frx":038A
      Style           =   1  'Graphical
      TabIndex        =   1
      ToolTipText     =   "Browse for Output Filename..."
      Top             =   330
      Width           =   555
   End
   Begin VB.CheckBox chkAddToLayout 
      Caption         =   "Add EMF Figure to Layout"
      Height          =   255
      Left            =   705
      TabIndex        =   2
      Top             =   810
      Width           =   2280
   End
   Begin VB.TextBox txtOutput 
      Height          =   330
      Left            =   45
      Locked          =   -1  'True
      TabIndex        =   0
      Top             =   360
      Width           =   6135
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6630
      Picture         =   "frmExportEMLLocation.frx":0400
      Top             =   930
      Width           =   225
   End
   Begin VB.Label lblSaveLocation 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Specify Location to Save Enhanced Metafile (EMF):"
      Height          =   195
      Left            =   30
      TabIndex        =   6
      Top             =   105
      Width           =   3675
   End
End
Attribute VB_Name = "frmExportEMLLocation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Anchors As AnchorObjectList  ' Main anchor control object
Private m_pModalResult As esriSystem.IVariantArray
Private m_pApp As IApplication
Private m_pThisExt As Linkages.clsExtension

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\test_graph_form\frmExportEMLLocation.frm"


Public Property Get GetModalResult() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

14:   Set GetModalResult = m_pModalResult

  Exit Property
ErrorHandler:
  HandleError True, "GetModalResult " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
Public Property Set GetModalResult(pOptions As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler

23:   txtOutput.Text = pOptions.Element(0)
24:   If pOptions.Element(1) = True Then
25:     chkAddToLayout.Value = 1
26:   Else
27:     chkAddToLayout.Value = 0
28:   End If
29:   Set m_pApp = pOptions.Element(2)
30:   Set m_pThisExt = pOptions.Element(3)

  Exit Property
ErrorHandler:
  HandleError True, "GetModalResult " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

40:   Set m_pModalResult = Nothing
41:   Me.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdClose_Click()
  On Error GoTo ErrorHandler

51:   Set m_pModalResult = New esriSystem.VarArray
52:   m_pModalResult.Add txtOutput.Text
53:   m_pModalResult.Add chkAddToLayout.Value = 1
54:   Me.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "cmdClose_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetLocation_Click()
  On Error GoTo ErrorHandler

  ' GET WHERE TO SAVE HISTOGRAM DATASET
  Dim strPath As String
  'strPath = Linkages.aml_func_mod.ReturnDir(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
67:   strPath = Linkages.aml_func_mod.ReturnDir(txtOutput.Text)
  
69:   If Not Linkages.aml_func_mod.ExistFileDir(strPath) Then
70:     strPath = Linkages.aml_func_mod.ReturnDir(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
71:   End If
  
73:   If Right(strPath, 1) <> "\" Then strPath = strPath & "\"
  
   'open dialog box to get new FileName
76:   CommonDialog1.Flags = cdlOFNHideReadOnly
77:   CommonDialog1.DefaultExt = "emf"
78:   CommonDialog1.InitDir = strPath
79:   CommonDialog1.Filter = "Windows Enhanced Metafiles (*.emf)|*.emf"
80:   CommonDialog1.DialogTitle = "Save EMF File as:"
81:   CommonDialog1.CancelError = True
'   Me.Visible = False
  
84:   err.Clear
  On Error Resume Next
86:   CommonDialog1.Parent = Me
87:   CommonDialog1.ShowOpen
  
'   MsgBox "Error = " & Err.Description & vbCrLf & Err.Number
'  Me.Visible = True
  
92:   If err.Number = 32755 Then
93:     MsgBox "Bailing out...", , "Change of Plans:"
    Exit Sub
95:   End If
    
  On Error GoTo ErrorHandler
  
  Dim strHistogramPath As String
100:   strHistogramPath = CommonDialog1.FileName
  
102:   txtOutput.Text = strHistogramPath
  
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetLocation_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler


  Dim strPath As String
116:   strPath = App.Path & "\help"
  
118:   Call Linkages.MyGeneralOperations.OpenDoc("Manual.pdf", strPath)

  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler

128:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
129:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
130:   Me.Top = (Screen.Height / 4) - (Me.Height / 4)
  Dim lngTopBar As Long
132:   lngTopBar = Me.Height - Me.ScaleHeight
133:   Me.Height = cmdClose.Top + cmdClose.Height + lngTopBar
 
135:    Set Anchors = New AnchorObjectList  ' Create new instance
136:    With Anchors
137:       With .Item(chkAddToLayout)
138:          .SetAnchors enumStartsize, enumStartsize
139:       End With
140:       With .Item(cmdCancel)
141:          .SetAnchors enumSizeEnd, enumSizeEnd
142:       End With
143:       With .Item(cmdClose)
144:          .SetAnchors enumSizeEnd, enumSizeEnd
145:       End With
146:       With .Item(cmdManual)
147:          .SetAnchors enumSizeEnd, enumSizeEnd
148:       End With
149:       With .Item(cmdGetLocation)
150:          .SetAnchors enumSizeEnd, enumStartsize
151:       End With
152:       With .Item(imgCornerBars)
153:          .SetAnchors enumSizeEnd, enumSizeEnd
154:       End With
155:       With .Item(lblSaveLocation)
156:          .SetAnchors enumStartsize, enumStartsize
157:       End With
158:       With .Item(txtOutput)
159:          .SetAnchors enumStartEnd, enumStartsize
160:       End With
161:       .Form = Me  ' Set form reference (suggested to be last step)
162:    End With


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler

173:   Set m_pModalResult = Nothing
174:   Set m_pApp = Nothing
175:   Set m_pThisExt = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
