VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmExportTables 
   Caption         =   " Export Statistical Tables:"
   ClientHeight    =   1890
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6525
   Icon            =   "frmExportTables.frx":0000
   LinkTopic       =   "Form2"
   LockControls    =   -1  'True
   ScaleHeight     =   1890
   ScaleWidth      =   6525
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdManual 
      Caption         =   "Manual"
      Height          =   300
      Left            =   3750
      TabIndex        =   9
      Top             =   1590
      Width           =   825
   End
   Begin VB.CheckBox chkAddToLayout 
      Caption         =   "Add Tables to Map Document"
      Height          =   255
      Left            =   315
      TabIndex        =   8
      Top             =   1575
      Width           =   2790
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "Cancel"
      Height          =   300
      Left            =   4620
      TabIndex        =   7
      Top             =   1590
      Width           =   825
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "OK"
      Height          =   300
      Left            =   5490
      TabIndex        =   6
      Top             =   1590
      Width           =   825
   End
   Begin VB.TextBox txtBins 
      Height          =   330
      Left            =   105
      Locked          =   -1  'True
      TabIndex        =   4
      Text            =   "txtBins"
      Top             =   1065
      Width           =   5730
   End
   Begin VB.CommandButton cmdBins 
      Height          =   360
      Left            =   5925
      Picture         =   "frmExportTables.frx":038A
      Style           =   1  'Graphical
      TabIndex        =   3
      ToolTipText     =   "Browse for Output Table..."
      Top             =   1050
      Width           =   555
   End
   Begin VB.TextBox txtGeneral 
      Height          =   330
      Left            =   105
      Locked          =   -1  'True
      TabIndex        =   1
      Text            =   "txtGeneral"
      Top             =   285
      Width           =   5730
   End
   Begin VB.CommandButton cmdGetGeneral 
      Height          =   360
      Left            =   5925
      Picture         =   "frmExportTables.frx":0400
      Style           =   1  'Graphical
      TabIndex        =   0
      ToolTipText     =   "Browse for Output Table..."
      Top             =   270
      Width           =   555
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   0
      Top             =   1485
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Image imgCornerBars 
      Height          =   225
      Left            =   6300
      Picture         =   "frmExportTables.frx":0476
      Top             =   1665
      Width           =   225
   End
   Begin VB.Label lblBins 
      BackStyle       =   0  'Transparent
      Caption         =   "Histogram Bin Statistics:"
      Height          =   195
      Left            =   90
      TabIndex        =   5
      Top             =   855
      Width           =   2415
   End
   Begin VB.Label lblOutputName 
      BackStyle       =   0  'Transparent
      Caption         =   "General Statistics:"
      Height          =   195
      Left            =   90
      TabIndex        =   2
      Top             =   75
      Width           =   2415
   End
End
Attribute VB_Name = "frmExportTables"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private m_booOutputIsFClass As Boolean

Private m_strGeneralWorkspace As String
Private m_strGeneralBasename As String
Private m_lngGeneralWSType As JenDatasetTypes
Private m_booGeneralFeatDataset As Boolean
Private m_strGeneralFeatDatasetName As String

Private m_strBinWorkspace As String
Private m_strBinBasename As String
Private m_lngBinWSType As JenDatasetTypes
Private m_booBinFeatDataset As Boolean
Private m_strBinFeatDatasetName As String

Private m_pModalResult As esriSystem.IVariantArray
Private m_pApp As IApplication
Private m_pThisExt As Linkages.clsExtension

Private Anchors As AnchorObjectList  ' Main anchor control object

Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\test_graph_form\frmExportTables.frm"

  
Public Property Set DialogOptions(pOptions As esriSystem.IVariantArray)
  On Error GoTo ErrorHandler
  
  
29:   Set m_pApp = pOptions.Element(0)
30:   Set m_pThisExt = pOptions.Element(1)
  
  Dim strDirPath As String
  Dim strBinsPath As String
  Dim strGeneralFile As String
  Dim strBinFile As String
  
37:   strDirPath = m_pThisExt.Folder_Histogram_Files
38:   If strDirPath = "" Or Not Linkages.aml_func_mod.ExistFileDir(strDirPath) Then
39:     strDirPath = Linkages.aml_func_mod.GetFullFileString(aml_func_mod.GetMxDocPath(m_pApp))
40:     strDirPath = Linkages.aml_func_mod.ReturnDir(strDirPath)
41:   End If
  
  
44:   strBinsPath = m_pThisExt.Folder_Hist_Bins_Files
45:   If strBinsPath = "" Or Not Linkages.aml_func_mod.ExistFileDir(strBinsPath) Then
46:     strBinsPath = strDirPath
47:   End If
  
  Dim boolWorkspaceExists As Boolean
50:   boolWorkspaceExists = Not Dir$(strDirPath, vbDirectory) = ""

52:   If Not boolWorkspaceExists Then
53:     strDirPath = Linkages.aml_func_mod.GetFullFileString(Linkages.aml_func_mod.TempPathLocation)
54:   End If
  
56:   If Right(strDirPath, 1) = "\" Then
57:     strGeneralFile = strDirPath & "Statistics.dbf"
58:   Else
59:     strGeneralFile = strDirPath & "\Statistics.dbf"
60:   End If
  
62:   If Right(strBinsPath, 1) = "\" Then
63:     strBinFile = strBinsPath & "Bin_Statistics.dbf"
64:   Else
65:     strBinFile = strBinsPath & "\Bin_Statistics.dbf"
66:   End If
  
68:   strGeneralFile = Linkages.aml_func_mod.MakeUniqueFilename(strGeneralFile)
69:   strBinFile = Linkages.aml_func_mod.MakeUniqueFilename(strBinFile)
  
71:   txtGeneral.Text = strGeneralFile
72:   txtBins.Text = strBinFile
  
74:   m_booOutputIsFClass = False

76:   m_strGeneralWorkspace = Linkages.aml_func_mod.ReturnDir(strGeneralFile)
77:   m_strGeneralBasename = Linkages.aml_func_mod.ReturnFilename(strGeneralFile)
78:   m_lngGeneralWSType = ENUM_Shapefile
79:   m_booGeneralFeatDataset = False
80:   m_strGeneralFeatDatasetName = ""

82:   m_strBinWorkspace = Linkages.aml_func_mod.ReturnDir(strBinFile)
83:   m_strBinBasename = Linkages.aml_func_mod.ReturnFilename(strBinFile)
84:   m_lngBinWSType = ENUM_Shapefile
85:   m_booBinFeatDataset = False
86:   m_strBinFeatDatasetName = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "DialogOptions " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Public Property Get GetModalResult() As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


97:   Set GetModalResult = m_pModalResult
  

  Exit Property
ErrorHandler:
  HandleError True, "GetModalResult " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property

Private Sub cmdBins_Click()
  On Error GoTo ErrorHandler
'
'  Dim pGxDialog As IGxDialog
'
'  ' SET DEFAULT NAME
'  Dim strDefault As String
'  strDefault = txtBins.Text
'
'  If Right(strDefault, 4) = ".dbf" Then strDefault = Left(strDefault, Len(strDefault) - 4)
'
'  ' SAMPLE CODE BELOW
'  Dim pGxDataset As IGxDataset
'  Dim pDataset As IDataset
'  Dim pWorkspace As IWorkspace
'  Dim pFeatureDataset As IFeatureDataset
'  Dim booHasFeatureDataset As Boolean
'  Dim strFeatDatasetName As String
'  Dim strCategory As String
'  Dim strBaseName As String
'  Dim strWsPathname As String
'  Dim pGxObj As IGxObject
'  Dim pGxFCFilter As IGxObjectFilter
'  Dim pFilterCol As IGxObjectFilterCollection
'  Dim pCategory As JenDatasetTypes
'  Dim lngReturn As VbMsgBoxResult
'  Dim booValidDataset As Boolean
'
''  MsgBox "m_strBinBasename = " & m_strBinBasename & vbCrLf & _
'         "m_strBinWorkspace = " & m_strBinWorkspace & vbCrLf & _
'         "m_booBinFeatDataset = " & CStr(m_booBinFeatDataset) & vbCrLf & _
'         "m_strBinFeatDatasetName = " & m_strBinFeatDatasetName
'
'  booValidDataset = False
'  Do Until booValidDataset = True
'
'    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
'    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
'    Set pGxDialog = New GxDialog
'    If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Set pFilterCol = pGxDialog
'    pFilterCol.AddFilter pGxFCFilter, True
'
'    With pGxDialog
'      .AllowMultiSelect = False
'      .StartingLocation = Replace(strDefault, ":", "\")
'      If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        .Title = "Enter the name of your new Bin Statistics Table:"            ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      .Name = m_strBinBasename
'    End With
'
'    If Not pGxDialog.DoModalSave(Me.hWnd) Then
'      Exit Sub 'Exit if user press Cancel
'    End If
'
'    Set pGxObj = pGxDialog.FinalLocation
'    strWsPathname = pGxObj.FullName
'    strBaseName = pGxDialog.Name
'    booHasFeatureDataset = False
'    strFeatDatasetName = ""
'
'    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
'    If TypeOf pGxObj Is IGxDataset Then
'      Set pGxDataset = pGxObj
'
'      Set pDataset = pGxDataset.Dataset
'      Set pWorkspace = pDataset.Workspace
'      strWsPathname = pWorkspace.PathName
'
'      booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
'      If booHasFeatureDataset Then
'        Set pFeatureDataset = pDataset
'        strFeatDatasetName = pFeatureDataset.Name
'      End If
'    End If
'
'    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    ' FOR SAMPLE; GET CATEGORY
'    strCategory = pGxObj.Category
'    Select Case strCategory
'      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        pCategory = ENUM_Shapefile
'        booValidDataset = True
'      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
'           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        pCategory = ENUM_FileGDB
'        booValidDataset = True
'        ' REMOVE ".SHP" IF PRESENT
'        If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
'        ' REPLACE ODD CHARACTERS
'        strBaseName = Linkages.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
'      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
'           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
'           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        pCategory = ENUM_PersonalGDB
'        booValidDataset = True
'        ' REMOVE ".SHP" IF PRESENT
'        If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
'        ' REPLACE ODD CHARACTERS
'        strBaseName = Linkages.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
'      Case Else
'        lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
'            "This function will only create shapefiles or feature classes in " & vbCrLf & _
'            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
'            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
'        If lngReturn = vbOK Then
'          booValidDataset = False
'        Else
'          Exit Sub
'        End If
'    End Select
'  Loop
'
'
'  m_strBinWorkspace = strWsPathname
'  m_strBinBasename = strBaseName
'  m_lngBinWSType = pCategory
'  m_booBinFeatDataset = booHasFeatureDataset
'  m_strBinFeatDatasetName = strFeatDatasetName
'
'  If m_booBinFeatDataset Then
'    txtBins.Text = strWsPathname & "\" & m_strBinFeatDatasetName & "\" & m_strBinBasename
'  Else
'    txtBins.Text = strWsPathname & "\" & m_strBinBasename
'  End If

  
  Dim strPath As String
  'strPath = Linkages.aml_func_mod.ReturnDir(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
247:   strPath = Linkages.aml_func_mod.ReturnDir(txtBins.Text)
  
249:   If Not Linkages.aml_func_mod.ExistFileDir(strPath) Then
250:     strPath = Linkages.aml_func_mod.ReturnDir(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
251:   End If
  
253:   If Right(strPath, 1) <> "\" Then strPath = strPath & "\"
  
  Dim booFileExists As Boolean
256:   booFileExists = True
  Dim pContinue As VbMsgBoxResult
258:   Do Until booFileExists = False
  
     'open dialog box to get new FileName
261:     CommonDialog1.Flags = cdlOFNHideReadOnly
262:     CommonDialog1.DefaultExt = "emf"
263:     CommonDialog1.InitDir = strPath
264:     CommonDialog1.Filter = "dBASE Tables (*.dbf)|*.dbf"
265:     CommonDialog1.DialogTitle = "Save Histogram Bins Table as:"
266:     CommonDialog1.CancelError = True
  '   Me.Visible = False
    
269:     err.Clear
    On Error Resume Next
271:     CommonDialog1.Parent = Me
272:     CommonDialog1.ShowOpen
    
  '   MsgBox "Error = " & Err.Description & vbCrLf & Err.Number
  '  Me.Visible = True
    
277:     If err.Number = 32755 Then
  '    MsgBox "Bailing out...", , "Change of Plans:"
      Exit Sub
280:     End If
      
    On Error GoTo ErrorHandler
    
    Dim strBinsPath As String
285:     strBinsPath = CommonDialog1.FileName
          
    ' MAKE SURE FILE DOES NOT ALREADY EXIST
288:     booFileExists = Linkages.aml_func_mod.ExistFileDir(strBinsPath)
289:     If booFileExists Then
290:       pContinue = MsgBox("The file '" & strBinsPath & "' already exists.  Do you wish to overwrite " & _
            "the existing file?", vbYesNoCancel, "File Already Exists:")
292:       If pContinue = vbYes Then
293:         Kill strBinsPath
294:         booFileExists = False
295:       ElseIf pContinue <> vbNo Then
        Exit Sub
297:       End If
298:     End If
299:   Loop
  
301:   txtBins.Text = strBinsPath
302:   m_pThisExt.Folder_Hist_Bins_Files = Linkages.aml_func_mod.ReturnDir(strBinsPath)

'  CheckEnable

306:   m_strBinWorkspace = Linkages.aml_func_mod.ReturnDir(strBinsPath)
307:   m_strBinBasename = Linkages.aml_func_mod.ReturnFilename(strBinsPath)
308:   If Right(m_strBinBasename, 4) = ".dbf" Then
309:     m_strBinBasename = Left(m_strBinBasename, Len(m_strBinBasename) - 4)
310:   End If
311:   m_lngBinWSType = ENUM_Shapefile
312:   m_booBinFeatDataset = False
313:   m_strBinFeatDatasetName = ""

  Exit Sub
ErrorHandler:
  HandleError True, "cmdBins_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdCancel_Click()
  On Error GoTo ErrorHandler

323:   Set m_pModalResult = Nothing
324:   Me.Visible = False

  Exit Sub
ErrorHandler:
  HandleError True, "cmdCancel_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdClose_Click()
  On Error GoTo ErrorHandler

  
335:   Set m_pModalResult = New esriSystem.VarArray
336:   m_pModalResult.Add m_strGeneralWorkspace
337:   m_pModalResult.Add m_strGeneralBasename
338:   m_pModalResult.Add m_lngGeneralWSType
339:   m_pModalResult.Add m_booGeneralFeatDataset
340:   m_pModalResult.Add m_strGeneralFeatDatasetName
341:   m_pModalResult.Add m_strBinWorkspace
342:   m_pModalResult.Add m_strBinBasename
343:   m_pModalResult.Add m_lngBinWSType
344:   m_pModalResult.Add m_booBinFeatDataset
345:   m_pModalResult.Add m_strBinFeatDatasetName
346:   m_pModalResult.Add chkAddToLayout.Value = 1
347:   Me.Visible = False
  

  Exit Sub
ErrorHandler:
  HandleError True, "cmdClose_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdGetGeneral_Click()
  On Error GoTo ErrorHandler

'
'  Dim pGxDialog As IGxDialog
'
'  ' SET DEFAULT NAME
'  Dim strDefault As String
'  strDefault = txtGeneral.Text
'
'  ' SAMPLE CODE BELOW
'  Dim pGxDataset As IGxDataset
'  Dim pDataset As IDataset
'  Dim pWorkspace As IWorkspace
'  Dim pFeatureDataset As IFeatureDataset
'  Dim booHasFeatureDataset As Boolean
'  Dim strFeatDatasetName As String
'  Dim strCategory As String
'  Dim strBaseName As String
'  Dim strWsPathname As String
'  Dim pGxObj As IGxObject
'  Dim pGxFCFilter As IGxObjectFilter
'  Dim pFilterCol As IGxObjectFilterCollection
'  Dim pCategory As JenDatasetTypes
'  Dim lngReturn As VbMsgBoxResult
'  Dim booValidDataset As Boolean
'
''  MsgBox "m_strOutputBasename = " & m_strOutputBasename & vbCrLf & _
'         "m_strOutputWorkspace = " & m_strOutputWorkspace & vbCrLf & _
'         "m_booOutputFeatDataset = " & CStr(m_booOutputFeatDataset) & vbCrLf & _
'         "m_strOutputFeatDatasetName = " & m_strOutputFeatDatasetName
'
'  booValidDataset = False
'  Do Until booValidDataset = True
'
'    ' FOR SAMPLE; QUERY USER FOR NEW FEATURE CLASS LOCATION
'    ' CAN BE A SHAPEFILE, OR IN A FILE / PERSONAL GEODATABASE
'    Set pGxDialog = New GxDialog
'    If m_booOutputIsFClass Then                                                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      Set pGxFCFilter = New GxFilterFeatureClasses                             ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    Else                                                                       ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      Set pGxFCFilter = New GxFilterTables                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    End If                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    Set pFilterCol = pGxDialog
'    pFilterCol.AddFilter pGxFCFilter, True
'
'    With pGxDialog
'      .AllowMultiSelect = False
'      .StartingLocation = Replace(strDefault, ":", "\")
'      If m_booOutputIsFClass Then                                              ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        .Title = "Enter the name of your new Feature Class or Shapefile:"      ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      Else                                                                     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        .Title = "Enter the name of your new General Statistics Table:"        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      End If                                                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      .Name = m_strGeneralBasename
'    End With
'
'    If Not pGxDialog.DoModalSave(Me.hWnd) Then
'      Exit Sub 'Exit if user press Cancel
'    End If
'
'    Set pGxObj = pGxDialog.FinalLocation
'    strWsPathname = pGxObj.FullName
'    strBaseName = pGxDialog.Name
'    booHasFeatureDataset = False
'    strFeatDatasetName = ""
'
'    ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
'    If TypeOf pGxObj Is IGxDataset Then
'      Set pGxDataset = pGxObj
'
'      Set pDataset = pGxDataset.Dataset
'      Set pWorkspace = pDataset.Workspace
'      strWsPathname = pWorkspace.PathName
'
'      booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
'      If booHasFeatureDataset Then
'        Set pFeatureDataset = pDataset
'        strFeatDatasetName = pFeatureDataset.Name
'      End If
'    End If
'
'    ' BACK OUT OF FEATURE DATASET IF CREATING A TABLE                ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    If Not m_booOutputIsFClass Then                                  ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      booHasFeatureDataset = False                                   ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'      strFeatDatasetName = ""                                        ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'    End If                                                           ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'
'    ' FOR SAMPLE; GET CATEGORY
'    strCategory = pGxObj.Category
'    Select Case strCategory
'      Case "Shapefile", "Folder", "dBASE Table"                                                 ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        pCategory = ENUM_Shapefile
'        booValidDataset = True
'      Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
'           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"     ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        pCategory = ENUM_FileGDB
'        booValidDataset = True
'        ' REMOVE ".SHP" IF PRESENT
'        If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
'        ' REPLACE ODD CHARACTERS
'        strBaseName = Linkages.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
'      Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
'           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
'           "Personal Geodatabase Table"                                                         ' --------------------- CHECK IF OUTPUT IS FEATURE CLASS
'        pCategory = ENUM_PersonalGDB
'        booValidDataset = True
'        ' REMOVE ".SHP" IF PRESENT
'        If Right(strBaseName, 4) = ".shp" Then strBaseName = Left(strBaseName, Len(strBaseName) - 4)
'        ' REPLACE ODD CHARACTERS
'        strBaseName = Linkages.MyGeneralOperations.ReplaceBadChars(strBaseName, True, True, True, True)
'      Case Else
'        lngReturn = MsgBox("Unexpected Feature Class Type (" & strCategory & ")!" & vbCrLf & _
'            "This function will only create shapefiles or feature classes in " & vbCrLf & _
'            "File or Personal GeoDatabases.  Please click 'OK' to select a " & vbCrLf & _
'            "new Feature Class Name, or 'Cancel' to bail out.", vbOKCancel, "Invalid Feature Class Type:")
'        If lngReturn = vbOK Then
'          booValidDataset = False
'        Else
'          Exit Sub
'        End If
'    End Select
'  Loop
'
'
'  m_strGeneralWorkspace = strWsPathname
'  m_strGeneralBasename = strBaseName
'  m_lngGeneralWSType = pCategory
'  m_booGeneralFeatDataset = booHasFeatureDataset
'  m_strGeneralFeatDatasetName = strFeatDatasetName
'
'  If m_booGeneralFeatDataset Then
'    txtGeneral.Text = strWsPathname & "\" & m_strGeneralFeatDatasetName & "\" & m_strGeneralBasename
'  Else
'    txtGeneral.Text = strWsPathname & "\" & m_strGeneralBasename
'  End If

'  CheckEnable
  ' GET WHERE TO SAVE HISTOGRAM DATASET
  
  Dim strPath As String
  'strPath = Linkages.aml_func_mod.ReturnDir(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
498:   strPath = Linkages.aml_func_mod.ReturnDir(txtGeneral.Text)
  
500:   If Not Linkages.aml_func_mod.ExistFileDir(strPath) Then
501:     strPath = Linkages.aml_func_mod.ReturnDir(Linkages.aml_func_mod.GetMxDocPath(m_pApp))
502:   End If
  
504:   If Right(strPath, 1) <> "\" Then strPath = strPath & "\"
  
  Dim booFileExists As Boolean
507:   booFileExists = True
  Dim pContinue As VbMsgBoxResult
509:   Do Until booFileExists = False
    
     'open dialog box to get new FileName
512:     CommonDialog1.Flags = cdlOFNHideReadOnly
513:     CommonDialog1.DefaultExt = "emf"
514:     CommonDialog1.InitDir = strPath
515:     CommonDialog1.Filter = "dBASE Tables (*.dbf)|*.dbf"
516:     CommonDialog1.DialogTitle = "Save General Statistical Table as:"
517:     CommonDialog1.CancelError = True
  '   Me.Visible = False
    
520:     err.Clear
    On Error Resume Next
522:     CommonDialog1.Parent = Me
523:     CommonDialog1.ShowOpen
    
  '   MsgBox "Error = " & Err.Description & vbCrLf & Err.Number
  '  Me.Visible = True
    
528:     If err.Number = 32755 Then
  '    MsgBox "Bailing out...", , "Change of Plans:"
      Exit Sub
531:     End If
      
    On Error GoTo ErrorHandler
    
    Dim strGeneralPath As String
536:     strGeneralPath = CommonDialog1.FileName
        
    ' MAKE SURE FILE DOES NOT ALREADY EXIST
539:     booFileExists = Linkages.aml_func_mod.ExistFileDir(strGeneralPath)
540:     If booFileExists Then
541:       pContinue = MsgBox("The file '" & strGeneralPath & "' already exists.  Do you wish to overwrite " & _
            "the existing file?", vbYesNoCancel, "File Already Exists:")
543:       If pContinue = vbYes Then
544:         Kill strGeneralPath
545:         booFileExists = False
546:       ElseIf pContinue <> vbNo Then
        Exit Sub
548:       End If
549:     End If
550:   Loop
  
552:   txtGeneral.Text = strGeneralPath
  
554:   m_pThisExt.Folder_Histogram_Files = Linkages.aml_func_mod.ReturnDir(strGeneralPath)
  
556:   m_strGeneralWorkspace = Linkages.aml_func_mod.ReturnDir(strGeneralPath)
557:   m_strGeneralBasename = Linkages.aml_func_mod.ReturnFilename(strGeneralPath)
558:   If Right(m_strGeneralBasename, 4) = ".dbf" Then
559:     m_strGeneralBasename = Left(m_strGeneralBasename, Len(m_strGeneralBasename) - 4)
560:   End If
561:   m_lngGeneralWSType = ENUM_Shapefile
562:   m_booGeneralFeatDataset = False
563:   m_strGeneralFeatDatasetName = ""
  
  Exit Sub
ErrorHandler:
  HandleError True, "cmdGetGeneral_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub cmdManual_Click()
  On Error GoTo ErrorHandler



  Dim strPath As String
576:   strPath = App.Path & "\help"
  
578:   Call Linkages.MyGeneralOperations.OpenDoc("Manual.pdf", strPath)


  Exit Sub
ErrorHandler:
  HandleError True, "cmdManual_Click " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Load()
  On Error GoTo ErrorHandler
  
589:   SetWindowPos Me.hWnd, -1, 0, 0, 0, 0, &H1 Or &H2
590:   Me.Left = (Screen.Width / 2) - (Me.Width / 2)
591:   Me.Top = (Screen.Height / 4) - (Me.Height / 4)
  Dim lngTopBar As Long
593:   lngTopBar = Me.Height - Me.ScaleHeight
594:   Me.Height = cmdClose.Top + cmdClose.Height + lngTopBar
 
596:    Set Anchors = New AnchorObjectList  ' Create new instance
597:    With Anchors
598:       With .Item(chkAddToLayout)
599:          .SetAnchors enumStartsize, enumStartsize
600:       End With
601:       With .Item(cmdBins)
602:          .SetAnchors enumSizeEnd, enumStartsize
603:       End With
604:       With .Item(cmdCancel)
605:          .SetAnchors enumSizeEnd, enumSizeEnd
606:       End With
607:       With .Item(cmdClose)
608:          .SetAnchors enumSizeEnd, enumSizeEnd
609:       End With
610:       With .Item(cmdManual)
611:          .SetAnchors enumSizeEnd, enumSizeEnd
612:       End With
613:       With .Item(cmdGetGeneral)
614:          .SetAnchors enumSizeEnd, enumStartsize
615:       End With
616:       With .Item(imgCornerBars)
617:          .SetAnchors enumSizeEnd, enumSizeEnd
618:       End With
619:       With .Item(lblBins)
620:          .SetAnchors enumStartsize, enumStartsize
621:       End With
622:       With .Item(lblOutputName)
623:          .SetAnchors enumStartsize, enumStartsize
624:       End With
625:       With .Item(txtBins)
626:          .SetAnchors enumStartEnd, enumStartsize
627:       End With
628:       With .Item(txtGeneral)
629:          .SetAnchors enumStartEnd, enumStartsize
630:       End With
631:       .Form = Me  ' Set form reference (suggested to be last step)
632:    End With


  Exit Sub
ErrorHandler:
  HandleError True, "Form_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Form_Unload(Cancel As Integer)
  On Error GoTo ErrorHandler

643:   Set m_pModalResult = Nothing
644:   Set m_pApp = Nothing
645:   Set m_pThisExt = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Form_Unload " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
