VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "toolDrawPoly"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit


Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\toolDrawPoly.cls"
Implements ICommand
Implements ITool

Private m_pApp As esriFramework.IApplication
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_ExtensionConfig As IExtensionConfig

'Private m_FrmSelScreen As Linkages.frmSelScreen

Private m_pBitmap As IPictureDisp       'Bitmap for the tool
Private m_pCursor As IPictureDisp       'Cursor for the tool
 
'Public Property Set HomeForm(ByVal pForm As Linkages.frmSelScreen)
''  Set m_FrmSelScreen = pForm
'End Property
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

23:   Set m_pBitmap = LoadResPicture(109, vbResBitmap)
24:   Set m_pCursor = LoadResPicture(101, vbResCursor)


  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

36:   Set m_pBitmap = Nothing
37:   Set m_pCursor = Nothing
'  Set m_FrmSelScreen = Nothing
39:   Set m_pMxDoc = Nothing
40:   Set m_pApp = Nothing
41:   Set m_ExtensionConfig = Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  Dim ext As Linkages.clsExtension
54:   Set ext = m_ExtensionConfig
 ' MsgBox "ext is nothing? " & CStr(ext Is Nothing) & vbCrLf & "m_ExtensionConfig is nothing? " & _
      CStr(m_ExtensionConfig Is Nothing)
  
58:   If (Not m_ExtensionConfig Is Nothing) Then
59:     If (m_ExtensionConfig.State = esriESEnabled) Then
60:       ICommand_Enabled = ext.EnableDrawTool
61:     End If
62:   Else
63:     ICommand_Enabled = False
64:   End If
'  If (ICommand_Enabled) Then
'    Set m_pBitmap = LoadResPicture(103, vbResBitmap)
'  Else
'    Set m_pBitmap = LoadResPicture(104, vbResBitmap)
'  End If
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
80:   ICommand_Checked = False
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
91:   ICommand_Name = "CorridorDesigner_DrawPolygon"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
102:   ICommand_Caption = "Draw Polygon"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
113:   ICommand_Tooltip = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
124:   ICommand_Message = "Used in conjuction with Corridor Statistics..."
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
135:   ICommand_HelpFile = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
146:   ICommand_HelpContextID = 0
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
157:   ICommand_Bitmap = m_pBitmap
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
168:   ICommand_Category = "Corridor Designer Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
179:   Set m_pApp = hook
180:   Set m_pMxDoc = m_pApp.Document
  Dim newUid As New uID
182:   newUid.Value = "Linkages.clsExtension"
183:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Property Get ITool_Cursor() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
204:   ITool_Cursor = m_pCursor
  
  Exit Property
ErrorHandler:
  HandleError True, "ITool_Cursor " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ITool_OnMouseDown(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
'  Linkages.frmSelScreen.txtCoords.Text = "X = " & x & ", Y = " & y
  Dim pMxDocument As esriArcMapUI.IMxDocument
  Dim pActiveView As esriCarto.IActiveView
  
219:   Set pMxDocument = m_pApp.Document
220:   Set pActiveView = pMxDocument.FocusMap
  Dim ext As Linkages.clsExtension
222:   Set ext = m_ExtensionConfig

  Dim theFormObject As Object
  Dim theForm As Linkages.frmSelScreen

227:   Set theFormObject = ext.aSelForm
228:   Set theForm = theFormObject
  
230:   theForm.cmdAccept.Enabled = False
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
233:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
234:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors_orig")
  
  Dim pPolygon As IPolygon
  Dim pGraCont As IGraphicsContainer
  Dim pGraContSel As IGraphicsContainerSelect
  Dim pRubberPoly As IRubberBand
  Dim pElem As IElement
  
  ' QI for the IGraphicsContainerSelect interface on the document's activeview
243:   Set pGraCont = pMxDocument.ActiveView
  
  ' Create a new RubberPolygon
246:   Set pRubberPoly = New RubberPolygon
  
  'Check which mouse button was pressed...
  
250:   If Button = 1 Then ' If button 1 (left) then create a new polygon (TrackNew)
  
    ' Return a new Polygon from the tracker object using TrackNew
253:     Set pPolygon = pRubberPoly.TrackNew(pMxDocument.ActiveView.ScreenDisplay, Nothing)
254:     If Not pPolygon Is Nothing Then
      ' Create a new PolygonElement and set its Geometry
256:       Set pElem = New PolygonElement
257:       pElem.Geometry = pPolygon
      Dim pOrigElemProps As IElementProperties
259:       Set pOrigElemProps = pElem
260:       pOrigElemProps.Name = "delete_corridors_orig"
      
      'Add the new element at Z order zero
263:       pGraCont.AddElement pElem, 0
264:     Else
      Exit Sub
266:     End If
267:   Else ' If button 2 (right) then move an existing polygon (TrackExisting)
    
    ' QI for IGraphicsContainerSelect
270:     Set pGraContSel = pGraCont
    
    ' Check that we have some selected elements
273:     If pGraContSel.ElementSelectionCount > 0 Then
      ' If there is only one selected element then get it
275:       If pGraContSel.ElementSelectionCount = 1 Then
276:         Set pElem = pGraContSel.SelectedElement(0)
        
      ' If there is more than one selected element then get the dominant one
279:       ElseIf pGraContSel.ElementSelectionCount > 1 Then
280:         Set pElem = pGraContSel.DominantElement
281:       End If
      
      ' Check that the selected element is a PolygonElement
284:       If TypeOf pElem Is IPolygonElement Then
        ' Create a new RubberPolygon
286:         Set pRubberPoly = New RubberPolygon
        ' Retrieve the current geometry of our element
288:         Set pPolygon = pElem.Geometry
        ' Use track existing, passing in the Polygon's geometry by reference
        ' NB all User input is now handled by the RubberBand until the Mouse up occurs)
291:         pRubberPoly.TrackExisting pMxDocument.ActiveView.ScreenDisplay, Nothing, pPolygon
        ' Set the Element's geometry (pPoly has been altered by TrackExisting)
293:         pElem.Geometry = pPolygon
        ' Update the element
295:         pGraCont.UpdateElement pElem
296:       End If
297:     End If
298:   End If
  
'  MsgBox "Polygon is empty? " & pPolygon.IsEmpty
  
'  ' Refresh the active view
'  pMxDocument.ActiveView.Refresh
  
  
  
'
'
'
'
'  Dim pGContainer As IGraphicsContainer
'  Set pGContainer = m_pMxDoc.FocusMap
'


  Dim pNewPoly As IPolygon
  Dim pClone As IClone
318:   Set pClone = pPolygon
319:   Set pNewPoly = pClone.Clone
  
321:   Set theForm.thePolygon = pNewPoly
322:   theForm.cmdAccept.Enabled = True

  Dim pArea As IArea
325:   Set pArea = pPolygon

  Dim pElement As IElement
  Dim pPolygonElement As IPolygonElement
  Dim pSpatialReference As ISpatialReference
  Dim pGraphicElement As IGraphicElement
  Dim pElementProperties As IElementProperties
  
  'MsgBox "Spatial Ref is nothing = " & CStr(pPolygon.SpatialReference Is Nothing)
  
  'ADD GEOMETRY, NAME AND SPATIAL REFERENCE TO GRAPHIC ELEMENT
'  Set pElement = New PolygonElement
337:   Set pNewPoly.SpatialReference = m_pMxDoc.ActiveView.FocusMap.SpatialReference
'  pElement.Geometry = pNewPoly
'  Set pGraphicElement = pElement
'  Set pNewPoly.SpatialReference = m_pMxDoc.ActiveView.FocusMap.SpatialReference
'  pElement.Geometry = pNewPoly
'  Set pGraphicElement = pElement
'  Set pSpatialReference = pPolygon.SpatialReference
'  Set pGraphicElement.SpatialReference = pSpatialReference
'  Set pElementProperties = pElement
'  pElementProperties.Name = "delete_corridors"

348:   Set pElement = pElem
349:   Set pGraphicElement = pElement
350:   Set pElementProperties = pElement
351:   pElementProperties.Name = "delete_corridors_orig"

  ' ADD SYMBOLOGY TO GRAPHIC ELEMENT

  Dim pFillShapeElement As IFillShapeElement
356:   Set pFillShapeElement = pElement

  Dim pColor As IColor
359:   Set pColor = Linkages.MyGeneralOperations.MakeColorRGB(0, 200, 100)

  Dim pCartoLine As ICartographicLineSymbol
362:   Set pCartoLine = New CartographicLineSymbol
363:   With pCartoLine
364:     .Cap = esriLCSButt
365:     .Join = esriLJSBevel
366:     .Color = pColor
367:     .Width = 1
368:   End With

  Dim pLineFill As ILineFillSymbol
371:   Set pLineFill = New LineFillSymbol
372:   With pLineFill
373:     .Angle = -30
374:     .Separation = 3
375:     .Offset = 5
376:   End With
377:   Set pLineFill.LineSymbol = pCartoLine

  Dim pLineSymbol As ISimpleLineSymbol
380:   Set pLineSymbol = New SimpleLineSymbol

  Dim pLineColor As IColor
383:   Set pLineColor = Linkages.MyGeneralOperations.MakeColorRGB(0, 250, 100)
384:   pLineSymbol.Color = pLineColor
385:   pLineSymbol.Width = 2
386:   pLineSymbol.Style = esriSLSSolid
387:   pLineFill.Outline = pLineSymbol
388:   pFillShapeElement.Symbol = pLineFill

  ' ADD GRAPHIC TO GRAPHICS CONTAINER
'  pGraCont.AddElement pFillShapeElement, 0
392:   pGraCont.UpdateElement pElement
'
'  'Draw
395:   m_pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, pPolygon.Envelope

'    MsgBox "Selecting from " + pFeatureLayer.Name & vbCrLf & _
'        "Area = " & pArea.Area
        

  
  
'  theForm.txtCoords.Text = "X: " & pPoint.x & "  Y: " & pPoint.y
'  theForm.cmdAccept.Enabled = True
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnMouseDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnMouseMove(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnMouseMove " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnMouseUp(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnMouseUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnDblClick()
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnDblClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnKeyDown(ByVal keyCode As Long, ByVal Shift As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnKeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnKeyUp(ByVal keyCode As Long, ByVal Shift As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnKeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Function ITool_OnContextMenu(ByVal X As Long, ByVal Y As Long) As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Function
ErrorHandler:
  HandleError True, "ITool_OnContextMenu " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
 
Private Sub ITool_Refresh(ByVal hdc As esriSystem.OLE_HANDLE)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_Refresh " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Function ITool_Deactivate() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
485:   ITool_Deactivate = True
  
  Exit Function
ErrorHandler:
  HandleError True, "ITool_Deactivate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function



