VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "toolReturnCoords"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit


Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\toolReturnCoords.cls"
Implements ICommand
Implements ITool

Private m_pApp As esriFramework.IApplication
Private m_pMxDoc As esriArcMapUI.IMxDocument
Private m_ExtensionConfig As IExtensionConfig

'Private m_FrmSelScreen As Linkages.frmSelScreen

Private m_pBitmap As IPictureDisp       'Bitmap for the tool
Private m_pCursor As IPictureDisp       'Cursor for the tool
 
'Public Property Set HomeForm(ByVal pForm As Linkages.frmSelScreen)
''  Set m_FrmSelScreen = pForm
'End Property
Private Sub Class_Initialize()
21:   Set m_pBitmap = LoadResPicture(108, vbResBitmap)
22:   Set m_pCursor = LoadResPicture(101, vbResCursor)

End Sub


Private Sub Class_Terminate()
28:   Set m_pBitmap = Nothing
29:   Set m_pCursor = Nothing
'  Set m_FrmSelScreen = Nothing
31:   Set m_pMxDoc = Nothing
32:   Set m_pApp = Nothing
33:   Set m_ExtensionConfig = Nothing

End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  Dim ext As Linkages.clsExtension
42:   Set ext = m_ExtensionConfig
 ' MsgBox "ext is nothing? " & CStr(ext Is Nothing) & vbCrLf & "m_ExtensionConfig is nothing? " & _
      CStr(m_ExtensionConfig Is Nothing)
  
46:   If (Not m_ExtensionConfig Is Nothing) Then
47:     If (m_ExtensionConfig.State = esriESEnabled) Then
48:       ICommand_Enabled = ext.EnableSelTool
49:     End If
50:   Else
51:     ICommand_Enabled = False
52:   End If
'  If (ICommand_Enabled) Then
'    Set m_pBitmap = LoadResPicture(103, vbResBitmap)
'  Else
'    Set m_pBitmap = LoadResPicture(104, vbResBitmap)
'  End If
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
68:   ICommand_Checked = False
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
79:   ICommand_Name = "CorridorDesigner_SelObjects"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
90:   ICommand_Caption = "Select Features"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
101:   ICommand_Tooltip = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
112:   ICommand_Message = "Used in conjuction with Corridor Statistics..."
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
123:   ICommand_HelpFile = ""
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
134:   ICommand_HelpContextID = 0
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
145:   ICommand_Bitmap = m_pBitmap
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
156:   ICommand_Category = "Corridor Designer Tools"
  
  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
167:   Set m_pApp = hook
168:   Set m_pMxDoc = m_pApp.Document
  Dim newUid As New uID
170:   newUid.Value = "Linkages.clsExtension"
171:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Property Get ITool_Cursor() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
192:   ITool_Cursor = m_pCursor
  
  Exit Property
ErrorHandler:
  HandleError True, "ITool_Cursor " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ITool_OnMouseDown(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
'  Linkages.frmSelScreen.txtCoords.Text = "X = " & x & ", Y = " & y
  Dim pMxDocument As esriArcMapUI.IMxDocument
  Dim pActiveView As esriCarto.IActiveView
 
  Dim pPoint As esriGeometry.IPoint
  
  Dim pGContainer As IGraphicsContainer
210:   Set pGContainer = m_pMxDoc.FocusMap

  Dim ext As Linkages.clsExtension
213:   Set ext = m_ExtensionConfig
  
  Dim theFormObject As Object
  Dim theForm As Linkages.frmSelScreen
  
218:   Set theFormObject = ext.aSelForm
219:   Set theForm = theFormObject
  
  ' GET SELECTED LAYER
  Dim theItemIndex As Integer
223:   theItemIndex = theForm.lbxThemes.ListIndex
224:   If theItemIndex = -1 Then
225:     MsgBox "Please select a polygon layer from the list before clicking on the screen...", vbOKOnly, _
          "Unable To Select Polygon:"
    Exit Sub
228:   End If
  
  ' Get the Active View
231:   Set pMxDocument = m_pApp.Document
232:   Set pActiveView = pMxDocument.FocusMap
        
  'Get the point location of the mouse click event
235:   Set pPoint = pActiveView.ScreenDisplay.DisplayTransformation.ToMapPoint(X, Y)

  ' FIGURE OUT WHICH LAYER IS BEING SELECTED FROM
  Dim theItemName As String
239:   theItemName = theForm.lbxThemes.List(theItemIndex)
  
  ' DELETE CURRENT GRAPHICS NAMED "DELETE_CORRIDORS"
242:   Call Linkages.MyGeneralOperations.DeleteGraphicsByName(m_pMxDoc, "delete_corridors")
  
  Dim pPolygon As IPolygon
  
246:   If (theItemName = "1] <-- Select or Draw Graphic Polygon -->") Then
    
    Dim pExistingElement As IElement
    Dim pExistingEnumElement As IEnumElement
    Dim pExistingGeometry As IGeometry
    Dim booFoundPolygon As Boolean
252:         booFoundPolygon = False
    Dim intPolyCount As Integer
254:         intPolyCount = 0
    
256:     Set pExistingEnumElement = pGContainer.LocateElements(pPoint, 0)
257:     If (Not pExistingEnumElement Is Nothing) Then
258:       pExistingEnumElement.Reset
259:       Set pExistingElement = pExistingEnumElement.Next
260:       Do Until pExistingElement Is Nothing
261:         Set pExistingGeometry = pExistingElement.Geometry
262:         If TypeOf pExistingGeometry Is IPolygon Then
263:           booFoundPolygon = True
264:           intPolyCount = intPolyCount + 1
          Dim pClone As esriSystem.IClone
266:           Set pClone = pExistingElement.Geometry
267:           Set pPolygon = pClone.Clone
268:         End If
269:         Set pExistingElement = pExistingEnumElement.Next
270:       Loop
271:     End If
    
273:     If Not booFoundPolygon Then
274:       Beep
275:       Set theForm.thePolygon = Nothing
276:       theForm.cmdAccept.Enabled = False
      Exit Sub
278:     ElseIf intPolyCount > 1 Then
279:       MsgBox "Clicked on " & CStr(intPolyCount) & " graphic polygons!  Please click on only a " & _
          "single polygon..."
281:       Set pPolygon = Nothing
      Exit Sub
283:     End If
    
285:     Set theForm.thePolygon = pPolygon
286:     theForm.cmdAccept.Enabled = True
    
288:   Else
  
    Dim pFeatureLayer As IFeatureLayer
    Dim pFeatureClass As IFeatureClass
  
    ' SELECT FROM THAT LAYER
294:     Set pFeatureLayer = theForm.GetNameCollection.Item(theItemName)
295:     Set pFeatureClass = pFeatureLayer.FeatureClass
    
    ' GET AREA FIELD
    Dim pFlds As IFields
    Dim pFld As IField
    Dim lAIndex As Long
    
302:     Set pFlds = pFeatureClass.Fields
303:     lAIndex = pFlds.FindField("shape")
304:     Set pFld = pFlds.Field(lAIndex)
    
    Dim pFilter As ISpatialFilter
307:     Set pFilter = New SpatialFilter
    
309:     With pFilter
310:       Set .Geometry = pPoint
311:       .GeometryField = "SHAPE"
312:       .SpatialRel = esriSpatialRelIntersects
313:     End With
  
    Dim pFeatureCursor As IFeatureCursor
316:     Set pFeatureCursor = pFeatureClass.Search(pFilter, False)
    
    Dim lngCount As Long
319:     lngCount = pFeatureClass.FeatureCount(pFilter)
    
321:     If lngCount = 0 Then
322:       Beep
323:       Set theForm.thePolygon = Nothing
324:       theForm.cmdAccept.Enabled = False
      Exit Sub
326:     End If
  
    Dim pFeature As IFeature
329:     Set pFeature = pFeatureCursor.NextFeature
    
331:     Set pPolygon = pFeature.ShapeCopy
332:     Set theForm.thePolygon = pPolygon
333:     theForm.cmdAccept.Enabled = True
  
335:   End If
  
  Dim pArea As IArea
338:   Set pArea = pPolygon
  
  Dim pElement As IElement
  Dim pPolygonElement As IPolygonElement
  Dim pSpatialReference As ISpatialReference
  Dim pGraphicElement As IGraphicElement
  Dim pElementProperties As IElementProperties
  
  'ADD GEOMETRY, NAME AND SPATIAL REFERENCE TO GRAPHIC ELEMENT
347:   Set pElement = New PolygonElement
348:   pElement.Geometry = pPolygon
349:   Set pGraphicElement = pElement
350:   Set pSpatialReference = pPolygon.SpatialReference
351:   Set pGraphicElement.SpatialReference = pSpatialReference
352:   Set pElementProperties = pElement
353:   pElementProperties.Name = "delete_corridors"
  
  ' ADD SYMBOLOGY TO GRAPHIC ELEMENT
  
  Dim pFillShapeElement As IFillShapeElement
358:   Set pFillShapeElement = pElement
  
  Dim pColor As IColor
361:   Set pColor = Linkages.MyGeneralOperations.MakeColorRGB(0, 200, 100)
  
  Dim pCartoLine As ICartographicLineSymbol
364:   Set pCartoLine = New CartographicLineSymbol
365:   With pCartoLine
366:     .Cap = esriLCSButt
367:     .Join = esriLJSBevel
368:     .Color = pColor
369:     .Width = 1
370:   End With
  
'  Dim pLineProperties As ILineProperties
'  Set pLineProperties = pCartoLine
'  pLineProperties.Offset = 0
'  Dim hpe(6) As Double
'  hpe(0) = 0
'  hpe(1) = 7
'  hpe(2) = 1
'  hpe(3) = 1
'  hpe(4) = 1
'  hpe(5) = 0
'  Dim eLineTemplate As ITemplate
'  Set eLineTemplate = New Template
'  eLineTemplate.Interval = 10
'  Dim ix As Integer, jx As Integer
'  jx = 0
'  For ix = 1 To 3
'    eLineTemplate.AddPatternElement hpe(jx), hpe(jx + 1)
'    jx = jx + 2
'  Next ix
'  Set pLineProperties.Template = eLineTemplate
  
  Dim pLineFill As ILineFillSymbol
394:   Set pLineFill = New LineFillSymbol
395:   With pLineFill
396:     .Angle = -30
397:     .Separation = 3
398:     .Offset = 5
399:   End With
400:   Set pLineFill.LineSymbol = pCartoLine
    
  Dim pLineSymbol As ISimpleLineSymbol
403:   Set pLineSymbol = New SimpleLineSymbol
  
  Dim pLineColor As IColor
406:   Set pLineColor = Linkages.MyGeneralOperations.MakeColorRGB(0, 250, 100)
407:   pLineSymbol.Color = pLineColor
408:   pLineSymbol.Width = 2
409:   pLineSymbol.Style = esriSLSSolid
410:   pLineFill.Outline = pLineSymbol
411:   pFillShapeElement.Symbol = pLineFill
  
  ' ADD GRAPHIC TO GRAPHICS CONTAINER
414:   pGContainer.AddElement pFillShapeElement, 0

  'Draw
417:   m_pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, pPolygon.Envelope

'    MsgBox "Selecting from " + pFeatureLayer.Name & vbCrLf & _
'        "Area = " & pArea.Area
        

  
  
'  theForm.txtCoords.Text = "X: " & pPoint.x & "  Y: " & pPoint.y
'  theForm.cmdAccept.Enabled = True
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnMouseDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnMouseMove(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnMouseMove " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnMouseUp(ByVal Button As Long, ByVal Shift As Long, ByVal X As Long, ByVal Y As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnMouseUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnDblClick()
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnDblClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnKeyDown(ByVal keyCode As Long, ByVal Shift As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnKeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ITool_OnKeyUp(ByVal keyCode As Long, ByVal Shift As Long)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_OnKeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Function ITool_OnContextMenu(ByVal X As Long, ByVal Y As Long) As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Function
ErrorHandler:
  HandleError True, "ITool_OnContextMenu " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
 
Private Sub ITool_Refresh(ByVal hdc As esriSystem.OLE_HANDLE)
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
  
  Exit Sub
ErrorHandler:
  HandleError True, "ITool_Refresh " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Function ITool_Deactivate() As Boolean
  On Error GoTo ErrorHandler
  
  ' TODO: Add your implementation here
507:   ITool_Deactivate = True
  
  Exit Function
ErrorHandler:
  HandleError True, "ITool_Deactivate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

